function [halfwidth,peaksize,peakdist,animalTmatrix,xtime,selection] = andor_INC_CTRLSTIM_main_f1(arena,selection)

load(['INC_' arena '_CTRL_MATRIX.mat'])

halfwidth = NaN(size(speedCTRLmatrix,1),numel(selection));
peaksize = NaN(size(speedCTRLmatrix,1),numel(selection));
peakdist = NaN(size(speedCTRLmatrix,1),numel(selection));
for k = 1:size(speedCTRLmatrix,1)
    Tmatrix = speedCTRLmatrix{k,1};
%     Tselect = ismember(cellfun(@(x) str2num(x(1:4)),speedCTRLname{k,1}(:,1)), cellfun(@str2num,selection));
%     Tmatrix = Tmatrix(Tselect,:);
    
    for nn = 1:numel(selection)
        animalName{k,nn} = selection{nn};
        T = cellfun(@(x) ~isempty(strfind(x,selection{nn})),speedCTRLname{k,1}(:,1));
        animalTmatrix{k,nn} = Tmatrix(T,:);
        
        t = animalTmatrix{k,nn};
        if size(t,1) > 1
            temp = mean(t);
            if ~isempty(temp)
                tempCUT = temp(:,2:end-1);
                
                % baseline measured between PRE STIM from -3 s to -2 s (total matrix size: +-9s):
                baseline = mean(tempCUT(round(6*end/18):round(7*end/18)));
                % max calculated +-2 s around artificial STIM:
                tht = temp(round(7*end/18:round(11*end/18)));
                % threshold at 75% between baseline and max:
                threshold = (3*max(tht) + baseline)/4;
                
                if threshold > 1.1*baseline
                    [xint{k,nn}, yint{k,nn}] = polyxpoly(1:size(tht,2),tht,1:size(tht,2),repmat(threshold,1,size(tht,2)));
                    %             xint{k,nn} = xint{k,nn} + 1;
                    
                    if numel(xint{k,nn}) == 2
                        halfwidth(k,nn) = diff(xint{k,nn});
                        peaksize(k,nn) = max(tht);
                        peakdist(k,nn) = find(tht == max(tht))-(fix(length(tht)/2)+1);
                    end
                end
            end
        end
    end
    xtime{k,1} = ((1:size(Tmatrix,2)) - (maxPRE+1))./120;
end

halfwidth(halfwidth==0) = NaN;