function [domfreq_pre,domfreq_stim,domfreq_pre_CTRL,domfreq_stim_CTRL] = andor_INC_step4_DRAWdomfreq(pWelch_pre, pWelch_stim, pWelch_pre_CTRL, pWelch_stim_CTRL, freqwelch, freq1, freq2)

INCcolor = [0 51 204]./255;

f1 = knnsearch(freqwelch',freq1);
f2 = knnsearch(freqwelch',freq2);
if freq1 == 8
    f2 = f2+1;
end

domfreq_pre = NaN(size(pWelch_pre,1),1);
for k = 1:size(pWelch_pre,1)
    [pks, locs] = findpeaks(pWelch_pre(k,f1:f2));
    if ~isempty(pks)
        [~,pksi] = max(pks);
        domfreq_pre(k,1) = freqwelch(locs(pksi)+f1-1);
    end
end

domfreq_stim = NaN(size(pWelch_pre,1),1);
for k = 1:size(pWelch_pre,1)
    [pks, locs] = findpeaks(pWelch_stim(k,f1:f2));
    if ~isempty(pks)
        [~,pksi] = max(pks);
        domfreq_stim(k,1) = freqwelch(locs(pksi)+f1-1);
    end
end



domfreq_pre_CTRL = NaN(size(pWelch_pre_CTRL,1),1);
for k = 1:size(pWelch_pre_CTRL,1)
    [pks, locs] = findpeaks(pWelch_pre_CTRL(k,f1:f2));
    if ~isempty(pks)
        [~,pksi] = max(pks);
        domfreq_pre_CTRL(k,1) = freqwelch(locs(pksi)+f1-1);
    end
end

domfreq_stim_CTRL = NaN(size(pWelch_pre_CTRL,1),1);
for k = 1:size(pWelch_pre_CTRL,1)
    [pks, locs] = findpeaks(pWelch_stim_CTRL(k,f1:f2));
    if ~isempty(pks)
        [~,pksi] = max(pks);
        domfreq_stim_CTRL(k,1) = freqwelch(locs(pksi)+f1-1);
    end
end
% 
% figure; hold on
% for k = 1:size(domfreq_pre,1)
%     plot([1 1.4],[domfreq_pre(k,1), domfreq_stim(k,1)],'Color',INCcolor,'Marker','o','MarkerEdgeColor',INCcolor,'MarkerFaceColor',INCcolor,'MarkerSize',8,'LineWidth',.3)
% 
% end
% 
% set(gca,'XLim',[0.8 1.6],'XTick',[],'YLim',[freq1 freq2],'YTick',[freq1 freq2],'YTickLabel',{num2str(freq1),num2str(freq2)},'FontSize',20)
% 
% line([0.9 1.1],[median(domfreq_pre) median(domfreq_pre)],'LineWidth',6,'Color',[.5 .5 .5])
% line([1.3 1.5],[median(domfreq_stim) median(domfreq_stim)],'LineWidth',6,'Color',[.5 .5 .5])
% 
% set(gca,'Position',[0.1 0.1 0.3 0.4])
% text(1,5,num2str(signrank(domfreq_pre, domfreq_stim)),'FontSize',20)
% 
% %
% figure; hold on
% for k = 1:size(domfreq_pre_CTRL,1)
%     plot([1 1.4],[domfreq_pre_CTRL(k,1), domfreq_stim_CTRL(k,1)],'Color','k','Marker','o','MarkerEdgeColor','k','MarkerFaceColor','k','MarkerSize',8,'LineWidth',.3)
% 
% end
% 
% set(gca,'XLim',[0.8 1.6],'XTick',[],'YLim',[freq1 freq2],'YTick',[freq1 freq2],'YTickLabel',{num2str(freq1),num2str(freq2)},'FontSize',20)
% 
% line([0.9 1.1],[median(domfreq_pre_CTRL) median(domfreq_pre_CTRL)],'LineWidth',6,'Color',[.5 .5 .5])
% line([1.3 1.5],[median(domfreq_stim_CTRL) median(domfreq_stim_CTRL)],'LineWidth',6,'Color',[.5 .5 .5])
% 
% set(gca,'Position',[0.1 0.1 0.3 0.4])
% text(1,5,num2str(signrank(domfreq_pre_CTRL, domfreq_stim_CTRL)),'FontSize',20)
