function andor_INC_step4_DRAWpowerdots(pWelch_pre, pWelch_stim, pWelch_pre_CTRL, pWelch_stim_CTRL, freqwelch, freq1, freq2,maxp)

INCcolor = [0 51 204]./255;

f1 = knnsearch(freqwelch',freq1);
f2 = knnsearch(freqwelch',freq2);
if freq1 == 8
    f1 = f1+1;
end

power_pre = sum(pWelch_pre(:,f1:f2),2);
power_stim = sum(pWelch_stim(:,f1:f2),2);

power_pre_CTRL = sum(pWelch_pre_CTRL(:,f1:f2),2);
power_stim_CTRL = sum(pWelch_stim_CTRL(:,f1:f2),2);


figure; hold on
for k = 1:size(power_pre,1)
    plot([1 1.4],[power_pre(k,1), power_stim(k,1)],'Color',INCcolor,'Marker','o','MarkerEdgeColor',INCcolor,'MarkerFaceColor',INCcolor,'MarkerSize',8,'LineWidth',.3)

end

set(gca,'XLim',[0.8 1.6],'XTick',[],'YLim',[0 maxp],'YTick',[0 maxp],'YTickLabel',{'0',num2str(maxp/100000)},'FontSize',20)

line([0.9 1.1],[median(power_pre) median(power_pre)],'LineWidth',6,'Color',[.5 .5 .5])
line([1.3 1.5],[median(power_stim) median(power_stim)],'LineWidth',6,'Color',[.5 .5 .5])

set(gca,'Position',[0.1 0.1 0.3 0.8])
text(1,1,num2str(signrank(power_pre, power_stim)),'FontSize',20)

%
figure; hold on
for k = 1:size(power_pre_CTRL,1)
    plot([1 1.4],[power_pre_CTRL(k,1), power_stim_CTRL(k,1)],'Color','k','Marker','o','MarkerEdgeColor','k','MarkerFaceColor','k','MarkerSize',8,'LineWidth',.3)

end

set(gca,'XLim',[0.8 1.6],'XTick',[],'YLim',[0 maxp],'YTick',[0 maxp],'YTickLabel',{'0',num2str(maxp/100000)},'FontSize',20)

line([0.9 1.1],[median(power_pre_CTRL) median(power_pre_CTRL)],'LineWidth',6,'Color',[.5 .5 .5])
line([1.3 1.5],[median(power_stim_CTRL) median(power_stim_CTRL)],'LineWidth',6,'Color',[.5 .5 .5])

set(gca,'Position',[0.1 0.1 0.3 0.8])
text(1,1,num2str(signrank(power_pre_CTRL, power_stim_CTRL)),'FontSize',20)
