function [res_pre, res_stim] = andor_INC_step4_layers(freqwelch,freq1,freq2,data_pre,data_stim,columns,CHANNEL)

f1 = knnsearch(freqwelch',freq1);
f2 = knnsearch(freqwelch',freq2);
if freq1 == 8
    f1 = f1+1;
end

res_pre = [];
res_stim = [];
for k = 1:length(columns)
    PREsumpower = squeeze(sum(data_pre{columns(k)}(:,f1:f2,:),2));
    STIMsumpower = squeeze(sum(data_stim{columns(k)}(:,f1:f2,:),2));
    
    PRE = [];
    PRE(:,1) = mean(PREsumpower(:,CHANNEL.pyrCh{columns(k)}),2);
    PRE(:,2) = mean(PREsumpower(:,CHANNEL.radCh{columns(k)}),2);
    PRE(:,3) = mean(PREsumpower(:,CHANNEL.lamCh{columns(k)}),2);
    PRE(:,4) = mean(PREsumpower(:,CHANNEL.molCh{columns(k)}),2);
    PRE(:,5) = mean(PREsumpower(:,CHANNEL.hilCh{columns(k)}),2);
    
    STIM = [];
    STIM(:,1) = mean(STIMsumpower(:,CHANNEL.pyrCh{columns(k)}),2);
    STIM(:,2) = mean(STIMsumpower(:,CHANNEL.radCh{columns(k)}),2);
    STIM(:,3) = mean(STIMsumpower(:,CHANNEL.lamCh{columns(k)}),2);
    STIM(:,4) = mean(STIMsumpower(:,CHANNEL.molCh{columns(k)}),2);
    STIM(:,5) = mean(STIMsumpower(:,CHANNEL.hilCh{columns(k)}),2);
    
    res_pre = [res_pre; PRE];
    res_stim = [res_stim; STIM];
end