function    [XLS,data_camCh,camW, camS, camE, camM, data_stim, startloc, pulseW,stim_Start] = andor_INCfreemov_STEP1;

% get stim and camera times

[datName, datPath, ~] = uigetfile({'*.dat', 'Amplipex data (*.dat)'}, 'Select .dat file(s)', 'MultiSelect', 'on');
if isequal(datName,0)
    if ~isempty(mfilename)
        disphelp = ':   ';
    else
        disphelp = '';
    end
    disp([mfilename disphelp 'No file has been selected'])
    return
end

if ~iscell(datName)
    datName = cellstr(datName);
end

filelist = sortrows(strtok(datName, '.')');
datfile = strcat(filelist, '.dat');
metafile = strcat(filelist, '.meta');

[a,b] = uigetfile({'*.xlsx;','excel file (*.xlsx)'}, 'Select excel file for all experiments');
excelfileName = fullfile(b,a);

[fileALL, typeALL, elphysALL, accessoryALL, motiveALL, notesALL, tpALL] = andor_read_behaviorXLS(excelfileName,filelist);
XLS.file = fileALL; XLS.type = typeALL; XLS.elphys = elphysALL; XLS.accessory = accessoryALL; XLS.motive = motiveALL; XLS.notes = notesALL; XLS.tp = tpALL;
for k = 1:length(datfile)
    metafileName = [datPath metafile{k}];
    datfileName = [datPath datfile{k}];
    
    if iscell(fileALL)
        file = fileALL{k,1}; type = typeALL{k,1}; elphys = elphysALL{k,1};
        accessory = accessoryALL{k,1}; motive = motiveALL{k,1}; notes = notesALL{k,1}; TP = tpALL{k,1};
    end

    chNo = andor_metafile(metafileName, 'recorded channel');
    
    data = memmapfile(datfileName,'Format', 'int16');
    data = reshape(data.Data, chNo, [])';
    
    % channelOrder = andor_channelOrder(elphys.headstage,elphys.connector,elphys.probe,elphys.direction);
    
    % data_ordered = cell(size(channelOrder,1));
    % for k = 1:size(data_ordered,1)
    %     data_ordered{k,1} = channelOrder{k,1};
    %     data_ordered{k,2} = data(:,channelOrder{k,2});
    % end
    if str2double(accessory.camChN{1,1}) < 1
        accessory.camChN{1,1} = num2str(chNo + str2double(accessory.camChN{1,1}));
        XLS.accessory{k,1}.camChN{1,1} = accessory.camChN{1,1};
    end
    
    % camera pulses
    data_camCh{k,1} = data(:,str2double(accessory.camChN{1,1}));
    if max(abs(double(data_camCh{k,1}))) > 2*mean(abs(double(data_camCh{k,1})))
        [camW{k,1}, camS{k,1}, camE{k,1}, camM{k,1}] = pulsewidth(double(data_camCh{k,1}),'Tolerance',30);
    else
        camW{k,1} = [];
        camS{k,1} = [];
        camE{k,1} = [];
        camM{k,1} = [];
    end
    
    % stimulation
    for kk = 1:numel(accessory.stimChN)
        if str2double(accessory.stimChN{kk}) < 1
            accessory.stimChN{kk} = num2str(chNo + str2double(accessory.stimChN{kk}));
            XLS.accessory{k,1}.stimChN{kk} = accessory.stimChN{kk};
        end
        data_stim{k,kk} = data(:,str2double(accessory.stimChN{kk}));
        if max(abs(double(data_stim{k,kk}))) > 2*mean(abs(double(data_stim{k,kk})))
            [pulseW{k,kk}, startloc{k,kk}, ~, ~] = pulsewidth(double(data_stim{k,kk}),'Tolerance',5,'StateLevels',[mean(double(data_stim{k,kk})) mean(double(data_stim{k,kk}))+7*std(double(data_stim{k,kk}))]);
            stim_Start{k,kk}(:,1) = round(startloc{k,kk});
        else
            startloc{k,kk} = [];
            stim_Start{k,kk} = [];
        end
    end
end



