% load experiment data
experiment = '1943';
folder = uigetdir;
load(['INC_' experiment '_1116_csv.mat']);
load(['INC_' experiment '_pulsedetect.mat']);
harmhalf = 5;

infoCell = cell(size(XLS.file,1),3);
for k = 1:size(infoCell,1)
    disp(num2str(k))
    infoCell{k,1} = XLS.file{k,1};
    infoCell{k,2} = XLS.type{k,1};
    datfileName = fullfile(folder,[infoCell{k,1} '.dat']);
    metafileName = fullfile(folder,[infoCell{k,1} '.meta']);
    
    [csvSample{k,1},csvIndex{k,1},csvIndexREL{k,1},...
        eegSample{k,1},stimIndex{k,1},stimIndexREL{k,1},stimIndexDS{k,1},stimIndexRELDS{k,1},...
        pulseSample{k,1},pulseSampleDS{k,1},pulseSampleRELDS{k,1},...
        channelOrder{k,1}] = andor_INCfreemov_getSamples(infoCell{k,1},datfileName,metafileName,XLS,epochStart,epochEnd,startloc,camS,data);
    
    infoCell{k,3} = size(csvSample{k,1},1);
    
    if ~isempty(XLS.accessory{k,1}.stimMode{1})
        infoCell{k,4} = strjoin(XLS.accessory{k,1}.stimMode,' ');
    else
        infoCell{k,4} = [];
    end
    if ~isempty(XLS.accessory{k,1}.stimPower{1})
        infoCell{k,5} = str2num(strjoin(XLS.accessory{k,1}.stimPower,' '));
        infoCell{k,5} = round(infoCell{k,5}(1));
    else
        infoCell{k,5} = [];
    end
    if ~isempty(strfind(infoCell{k,2}{1},'urethane'))
        infoCell{k,6} = XLS.tp{k,1};
    else
        infoCell{k,6} = [];
    end
    
    if ~isempty(csvSample{k,1})
        for kk = 1:size(csvSample{k,1},1)
            tempdata = csvSample{k,1}{kk,1};
            tempheading = heading{k,1};
            if ~isempty(tempdata)
                if ~all(all(isnan(tempdata)))
                    [tempdata_res, tempheading_res] = andor_read3_motiveCSV(tempdata, tempheading, 'all', true);
                    tempspeed = andor_read4_motiveCSV(tempdata_res, tempheading_res, 'speed');
                    speed3{k,kk} = tempspeed{1,2}.speed3;
                    speed2{k,kk} = tempspeed{1,2}.speed2;
                    speedH3{k,kk} = NaN(size(speed3{k,kk}));
                    tempNaN = false(size(speed3{k,kk}));
                    for ss = 3:length(speed3{k,kk})-1
                        if all(~isnan(speed3{k,kk}(ss-2:ss+1)))
                            if diff(speed3{k,kk}(ss:ss+1)) > 5*diff(speed3{k,kk}(ss-2:ss-1))
                                tempNaN(ss) = true;
                            end
                        end
                    end
                    tempspeed3 = speed3{k,kk};
                    tempspeed3(tempNaN) = NaN;
                    for ss = 1+harmhalf:length(speedH3{k,kk})-harmhalf
                        speedH3{k,kk}(ss) = harmmean(tempspeed3(ss-harmhalf:ss+harmhalf));
                    end
                    speedH3SG{k,kk} = sgolayfilt(speedH3{k,kk},3,101);
                    speedH3SG{k,kk}(speedH3SG{k,kk}<=0) = NaN;
                    
                    % linear interpolation where in  prev. step deleted
                    tempa = isnan(speedH3SG{k,kk});
                    tempb = diff(tempa);
                    tempc = find(tempb == 1); tempcx = find(tempb == -1);
                    tempc = tempc(1:end-1); tempcx = tempcx(2:end);
                    for cc = 1:length(tempc)
                        speedH3SG{k,kk}(tempc(cc)+1:tempcx(cc)) = linspace(speedH3SG{k,kk}(tempc(cc)),speedH3SG{k,kk}(tempcx(cc)+1),tempcx(cc)-tempc(cc));
                    end
                else
                    speed3{k,kk} = [];
                    speed2{k,kk} = [];
                    speedH3{k,kk} = [];
                    speedH3SG{k,kk} = [];
                end
            else
                speed3{k,kk} = [];
                speed2{k,kk} = [];
                speedH3{k,kk} = [];
                speedH3SG{k,kk} = [];
            end
        end
    else
        speed3{k,1} = [];
        speed2{k,1} = [];
        speedH3{k,1} = [];
        speedH3SG{k,1} = [];
    end
end

save(['INC_' experiment '_speed.mat'],'speed3','speed2','speedH3','speedH3SG','infoCell','csvSample','csvIndex','csvIndexREL','eegSample','stimIndex','stimIndexREL','stimIndexDS','stimIndexRELDS','pulseSample','pulseSampleDS','pulseSampleRELDS','channelOrder','-v7.3')


