% Experiment = {'1943','1957','1985','2017','2022','2026','2027','2040','2045','2046'};
Experiment = {'1868'};
Stim = {'INC','INC alu','SEPTUM','SEPTUM alu','BLIND'};
Arena = {'home cage','linear track','new box','hole box','urethane'};
Freq = {'1Hz','5Hz','10Hz','15Hz','25Hz','30Hz','50Hz','TH 3-20-5','TH 3-25-5','TH 3-50-5','TH 5-50-5','TH 3-50-10'};

for ee = 1:numel(Experiment)
    experiment = Experiment{ee};
    disp(experiment)
    load(['INC_' experiment '_speed.mat']);
    freqName = {'1Hz','5Hz','10Hz','15Hz','25Hz','30Hz','50Hz','TH 3-20-5','TH 3-25-5','TH 3-50-5','TH 5-50-5','TH 3-50-10',};
    freqBase =    {[1],[5],[10],[15],[25],[30],[50],    [20],[25,8],[50,6],[50,8],[50,17]};
    freqBaseNOT = {[0],[0],[20],[0], [8], [0], [6,8,17],[0] ,[0],   [0],   [0],   [0]};
    %
    stimFreq = [];
    stimName = [];
    for k = 1:size(pulseSampleRELDS,1)
        for a = 1:size(pulseSampleRELDS{k,1},1)
            for kk = 1:size(pulseSampleRELDS{k,1}{a,1},1)
                pulseSampleRELDS{k,1}{a,1}{kk,1} = round(pulseSampleRELDS{k,1}{a,1}{kk,1});
                stimFreq{k,1}{a,1}{kk,1} = unique(round(1./(diff(pulseSampleRELDS{k,1}{a,1}{kk,1})./1000)));
                temp = false(size(freqName));
                for xx = 1:length(temp)
                    temp(xx) = and(all(ismember(freqBase{xx},stimFreq{k,1}{a,1}{kk,1})),~any(ismember(freqBaseNOT{xx},stimFreq{k,1}{a,1}{kk,1})));
                end
                stimName{k,1}{a,1}{kk,1} = freqName(temp);
            end
        end
    end
    
    for ss = 1:numel(Stim)
        disp(['stim: ' Stim{ss}])
        for aa = 1:numel(Arena)
            for ff = 1:numel(Freq)
                askStim = Stim{ss};
                askArena = Arena{aa};
                askFreq = Freq{ff};

% get list of related stims
arenaOK = false(size(infoCell,1),1);

filestimOK = zeros(size(infoCell,1),1);
stimList = [];
for k  =1:size(infoCell,1)
    if ~isempty(infoCell{k,4})
        arenaOK(k) = isequal(askArena,infoCell{k,2}{1});
        if arenaOK(k)
            if and(isequal(askStim,infoCell{k,4}{1,1}),infoCell{k,3}(1,1)>0)
                filestimOK(k) = 1;
                for kk = 1:size(stimName{k,1}{1,1},1)
                    stimList{k,1}(kk,1) = isequal(stimName{k,1}{1,1}{kk,1}{1},askFreq);
                end
            elseif and(isequal(askStim,infoCell{k,4}{1,2}),infoCell{k,3}(1,2)>0)
                filestimOK(k) = 2;
                for kk = 1:size(stimName{k,1}{2,1},1)
                    stimList{k,1}(kk,1) = isequal(stimName{k,1}{2,1}{kk,1}{1},askFreq);
                end
            else
                stimList{k,1} = [];
                
            end
        end
    end
end

% get indexes (csvLimitREL) for speed samples
for k = 1:size(csvIndexREL,1)
    if ~isempty(csvIndexREL{k,1}{1,1})
        tempDiff = diff(csvIndexREL{k,1}{1,1},1,2);
        tempDiff = tempDiff == 2;
        csvIndexREL{k,1}{1,1}(tempDiff) = csvIndexREL{k,1}{1,1}(tempDiff)+1;
    end
    if ~isempty(csvIndexREL{k,1}{2,1})
        tempDiff = diff(csvIndexREL{k,1}{2,1},1,2);
        tempDiff = tempDiff == 2;
        csvIndexREL{k,1}{2,1}(tempDiff) = csvIndexREL{k,1}{2,1}(tempDiff)+1;
    end
end

% get speed and eeg
a=1;
GETcsvIndex = []; GETspeed = []; GETfile_stim = []; GETeeg = []; GETspeed2 = []; GETstimIndex = []; GETpulseIndex = [];
for k = 1:size(stimList,1)
    if ~isempty(stimList{k,1})
        for kk = 1:size(stimList{k,1},1)
            if stimList{k,1}(kk,1)
                GETfile_stim{a,1} = infoCell{k,1};
                GETfile_stim{a,2} = kk;
                GETfile_stim{a,3} = infoCell{k,5};
                GETfile_stim{a,4} = filestimOK(k);
                GETstimIndex(a,:) = stimIndexRELDS{k,1}{filestimOK(k),1}(kk,:);
                GETpulseIndex{a,1} = pulseSampleRELDS{k,1}{filestimOK(k),1}{kk,1};
                GETeeg{a,1} = eegSample{k,1}{filestimOK(k),1}{kk,1};
                
                if ~isempty(csvIndexREL{k,1}{filestimOK(k),1})
                    GETcsvIndex(a,:) = csvIndexREL{k,1}{filestimOK(k),1}(kk,:);
                    GETspeed{a,1} = speedH3SG{filestimOK(k),1}{k,kk};
                    GETspeed2{a,1} = speed2{filestimOK(k),1}{k,kk};
                end

                a = a+1;
            end
        end
    end
end

% E = matlab.lang.makeValidName(experiment,'Prefix','e');
S = matlab.lang.makeValidName(askStim,'Prefix','s');
A = matlab.lang.makeValidName(askArena,'Prefix','a');
F = matlab.lang.makeValidName(askFreq,'Prefix','f');

result.(S).(A).(F).csvIndex = GETcsvIndex;
result.(S).(A).(F).speed = GETspeed;
result.(S).(A).(F).rowInfo = GETfile_stim; %file name, No of stim in this file, power of laser in this file
result.(S).(A).(F).eeg = GETeeg;
result.(S).(A).(F).speed2 = GETspeed2;
result.(S).(A).(F).stimIndex = GETstimIndex;
result.(S).(A).(F).pulseIndex = GETpulseIndex;
            end
        end
    end
    save(['INC_res1_' experiment],'result','-v7.3')
end

