% load experiment data
experiment = '1868';
load(['INC_' experiment '_1116_csv.mat'],'heading');
load(['INC_' experiment '_speed.mat']);
harmhalf = 5;

for k = 1:size(infoCell,1)
    disp(num2str(k))
    
    if ~isempty(csvSample{k,1})
        for kk = 1:size(csvSample{k,1},1)
            
            if isempty(speedH3SG{k,kk})
                tempdata = csvSample{k,1}{kk,1};
                tempheading = heading{k,1};
                if ~isempty(tempdata)
                    if ~all(all(isnan(tempdata)))
                        [tempdata_res, tempheading_res] = andor_read3_motiveCSV(tempdata, tempheading, 'all', true);
                        tempspeed = andor_read4_motiveCSV(tempdata_res, tempheading_res, 'speed');
                        speed3{k,kk} = tempspeed{1,2}.speed3;
                        speed2{k,kk} = tempspeed{1,2}.speed2;
                        speedH3{k,kk} = NaN(size(speed3{k,kk}));
                        tempNaN = false(size(speed3{k,kk}));
                        for ss = 3:length(speed3{k,kk})-1
                            if all(~isnan(speed3{k,kk}(ss-2:ss+1)))
                                if diff(speed3{k,kk}(ss:ss+1)) > 5*diff(speed3{k,kk}(ss-2:ss-1))
                                    tempNaN(ss) = true;
                                end
                            end
                        end
                        tempspeed3 = speed3{k,kk};
                        tempspeed3(tempNaN) = NaN;
                        for ss = 1+harmhalf:length(speedH3{k,kk})-harmhalf
                            speedH3{k,kk}(ss) = harmmean(tempspeed3(ss-harmhalf:ss+harmhalf));
                        end
                        speedH3SG{k,kk} = sgolayfilt(speedH3{k,kk},3,101);
                        speedH3SG{k,kk}(speedH3SG{k,kk}<=0) = NaN;
                        
                        % linear interpolation where in  prev. step deleted
                        tempa = isnan(speedH3SG{k,kk});
                        tempb = diff(tempa);
                        tempc = find(tempb == 1); tempcx = find(tempb == -1);
                        tempc = tempc(1:end-1); tempcx = tempcx(2:end);
                        for cc = 1:length(tempc)
                            speedH3SG{k,kk}(tempc(cc)+1:tempcx(cc)) = linspace(speedH3SG{k,kk}(tempc(cc)),speedH3SG{k,kk}(tempcx(cc)+1),tempcx(cc)-tempc(cc));
                        end
                    end
                end
            end
        end
    end
end

save(['INC_' experiment '_speed.mat'],'-append','speed3','speed2','speedH3','speedH3SG','-v7.3')
    
    
    