function [matrix, index, index2, selectName, selectMatrix, selectIndex] = andor_INCfreemov_STEP3_f1(stim, arena, freq, select, selectname)

% load data
filename = ['INC_res2_' stim '_' arena '_' freq '.mat'];
load(filename);

% remove NAN rows
toremove = false(size(csvIndex,1),1);
for k = 1:size(csvIndex,1)
    if isempty(speed{k,1})
        toremove(k) = true;
    else
        if all(isnan(speed{k,1}(csvIndex(k,3):csvIndex(k,4))))
            toremove(k) = true;
        end
    end
end
speed = speed(~toremove,:);
speed2 = speed2(~toremove,:);
pulseIndex = pulseIndex(~toremove,:);
eeg = eeg(~toremove,:);
rowInfo = rowInfo(~toremove,:);
csvIndex = csvIndex(~toremove,:);
stimIndex = stimIndex(~toremove,:);

% select good files
selectindex = false(size(rowInfo,1),1);
for k = 1:length(selectindex)
    temp = NaN(1,numel(select));
    for xx = 1:numel(select)
        a = strfind(rowInfo{k,1},select{xx});
        if ~isempty(a); temp(xx) = a; end
    end
    if any(~isnan(temp)); selectindex(k) = true; end
end

if ~all(~selectindex)
    speed = speed(selectindex,:);
    speed2 = speed2(selectindex,:);
    pulseIndex = pulseIndex(selectindex,:);
    eeg = eeg(selectindex,:);
    rowInfo = rowInfo(selectindex,:);
    csvIndex = csvIndex(selectindex,:);
    stimIndex = stimIndex(selectindex,:);
    
    %
    
    ind2max = max(csvIndex(:,2));
    csvIndex2 = [];
    for k = 1:size(csvIndex,1)
        if csvIndex(k,2)<ind2max
            csvIndex2(k,:) = csvIndex(k,:)+(ind2max-csvIndex(k,2));
        else
            csvIndex2(k,:) = csvIndex(k,:);
        end
    end
    
    % create matrix
    matrix = NaN(size(csvIndex2,1),max(csvIndex2(:,end)));
    for k =1:size(matrix,1)
        temp = speed{k,1};
        if length(temp)>csvIndex2(k,end)-csvIndex2(k,1)
            temp = temp(1:(csvIndex2(k,end)-csvIndex2(k,1)));
        end
        matrix(k,csvIndex2(k,1):csvIndex2(k,end)-1)=temp;
    end
    
    average = mean(matrix);
    stderror = std(matrix);
    stderror = stderror./sqrt(size(matrix,1));
    index = csvIndex2(:,3);
    index2 = csvIndex2(:,4);
    
    % select data only from one animal
    for nn = 1:numel(select)
        selectName{nn,1} = select{nn};
        T = cellfun(@(x) ~isempty(strfind(x,select{nn})),rowInfo(:,1));
        selectMatrix{nn,1} = matrix(T,:);
        selectIndex{nn,1} = index(T,:);
    end
    
%     imageNAN = true(size(matrix));
%     imageNAN(isnan(matrix)) = false;
%     figure('NumberTitle','off','Name',[filename(10:end-4) ' ' selectname]);
%     
%     ax(1) = subplot(2,1,1);
%     imagesc([1:size(matrix,2)]/120,1:size(matrix,1),matrix,'AlphaData',imageNAN); hold on
%     line(repmat(min(csvIndex2(:,3))/120,1,2),[0.5 size(csvIndex2,1)+0.5],'LineWidth',3,'Color','r')
%     line(repmat(max(csvIndex2(:,4))/120,1,2),[0.5 size(csvIndex2,1)+0.5],'LineWidth',3,'Color','r')
%     
%     
% %     stimspeed = matrix(:,min(csvIndex2(:,3)));
%     
%     ax(2) = subplot(2,1,2); hold on
%     plot([1:size(matrix,2)]/120,mean(matrix),'Color','k','LineWidth',2)
%     plot([1:size(matrix,2)]/120,average+stderror,'LineStyle','--','Color','k')
%     plot([1:size(matrix,2)]/120,average-stderror,'LineStyle','--','Color','k')
%     
%     line(repmat(min(csvIndex2(:,3))/120,1,2),[min(mean(matrix)) max(mean(matrix))],'LineWidth',3,'Color','r')
%     line(repmat(max(csvIndex2(:,4))/120,1,2),[min(mean(matrix)) max(mean(matrix))],'LineWidth',3,'Color','r')
%     
%     
%     linkaxes(ax,'x')
else
    matrix = [];
    index = [];
    index2 = [];
    selectName = [];
    selectMatrix = [];
    selectIndex = [];
end
