function [halfwidth,peaksize,peakdist,Tmatrix,xtime,selection] = andor_INCfreemov_STEP3_f2(animalName, animalMatrix, animalIndex,speedlimits)

if ~isempty(animalMatrix)
    selection = animalName;
    
    halfwidth = NaN(length(speedlimits),size(animalMatrix,1));
    peaksize = NaN(length(speedlimits),size(animalMatrix,1));
    peakdist = NaN(length(speedlimits),size(animalMatrix,1));
    for k = 1:size(animalMatrix,1)
        if ~isempty(animalMatrix{k,1})
            % bin animal data by speed
            for m = 1:size(animalMatrix{k,1},1)
                stimspeed{k,1}(m,1) = animalMatrix{k,1}(m,animalIndex{k,1}(m,1));
            end
            
            for s = 1:length(speedlimits)
                speedselect = false(size(stimspeed{k,1}));
                speedselect(stimspeed{k,1} >= speedlimits(s)) = true;
                
                ss = s;
                
                if ~all(~speedselect)
                    Tmatrix{ss,k} = animalMatrix{k,1}(speedselect,:);
                    if size(Tmatrix{ss,k},1) > 1
                        temp = mean(Tmatrix{ss,k});
                        
                        
                        % baseline measured between PRE STIM from -3 s to -2 s:
                        baseline = mean(temp((min(animalIndex{k,1})-3*120):(min(animalIndex{k,1})-2*120)));
                        % max calculated +-2 s around STIM:
                        tht = temp((min(animalIndex{k,1})-2*120):(min(animalIndex{k,1})+2*120));
                        % threshold at 75% between baseline and max:
                        threshold = (3*max(tht) + baseline)/4;
                        
                        if threshold > 1.1*baseline
                            [xint{ss,k}, yint{ss,k}] = polyxpoly(1:size(tht,2),tht,1:size(tht,2),repmat(threshold,1,size(tht,2)));
%                             figure; hold on; plot(temp); title([num2str(ss) '   ' num2str(k)]); line(xint{ss,k}+min(animalIndex{k,1})-2*120,yint{ss,k},'Color','r','LineWidth',2);
                            if numel(xint{ss,k}) == 2
                                halfwidth(ss,k) = diff(xint{ss,k});
                                peaksize(ss,k) = max(tht);
                                peakdist(ss,k) = find(tht == max(tht))-(fix(length(tht)/2)+1);
                            end
                        end
                    end
                    xtime{ss,k} = ((1:size(Tmatrix{ss,k},2)) - min(animalIndex{k,1}))./120;
                    
                end
            end
        end
    end
    
    halfwidth(halfwidth==0) = NaN;
else
    halfwidth = [];
    peaksize = [];
    peakdist = [];
    Tmatrix = [];
    xtime = [];
    selection = [];
end
