function [speedmatrix,eegmatrix,speedindex,speedindex2,eegindex,eegindex2,rowdata,fr,wave,power,scale,pulseIndex,eeg,pyrN,stimIndexA,stimIndexB,posX,posY,posZ,rotX,rotY,rotZ,rotW] = andor_INCfreemov_STEP4_eeg(stim, arena, freq, select)

% get pyr channel numbers:
pyrCh(:,1) = {'1868'          ,'1943'       ,'1957'       ,'1985'       ,'2017'          ,'2022A','2022B','2026' ,'2027','2040','2045','2046'};
pyrCh(:,2) = { 4              , 12          , 20          , 7           , 9              , 6     , 23    , 6     , 4    , 11   , 1    , 4    };

% radCh(:,1) = {'1868'          ,'1943'       ,'1957'       ,'1985'       ,'2017'          ,'2022A','2022B','2026' ,'2027','2040','2045','2046'};
% radCh(:,2) = {[5,6,7,8]       ,[14,15]      ,[21,22,23,24],[9,12]       ,[12,14]         ,[]     ,[]     ,[7,8]  ,      ,      ,[3,4] ,      };
% 
% lamCh(:,1) = {'1868'          ,'1943'       ,'1957'       ,'1985'       ,'2017'          ,'2022A','2022B','2026' ,'2027','2040','2045','2046'};
% lamCh(:,2) = {[11,12]         ,[17,18,19,20],[25,26,27,28],[14,15,16,17],[16,17,18,19,20],[]     ,[]     ,[9,10] ,      ,      ,[8,9] ,      };
% 
% molCh(:,1) = {'1868'          ,'1943'       ,'1957'       ,'1985'       ,'2017'          ,'2022A','2022B','2026' ,'2027','2040','2045','2046'};
% molCh(:,2) = {[13,14,15]      ,[22]         ,[31]         ,[19,21]      ,[21,22]         ,[]     ,[]     ,[11,12],      ,      ,      ,      };

% hilCh(:,1) = {'1868'          ,'1943'       ,'1957'       ,'1985'       ,'2017'          ,'2022A','2022B','2026' ,'2027','2040','2045','2046'};
% hilCh(:,2) = {[16,17,18,19,20],[27,28]      ,[]           ,[]           ,[24,25,26]      ,       ,       ,[13,14],      ,      ,[]    ,      };
% 
% badCh(:,1) = {'1868'          ,'1943'       ,'1957'       ,'1985'       ,'2017'          ,'2022A','2022B','2026' ,'2027','2040','2045','2046'};
% badCh(:,2) = {                ,             ,             ,             ,[]              ,       ,       ,[]     ,      ,      ,      , 8    };


% load data
filename = ['INC_res2_' stim '_' arena '_' freq '.mat'];
load(filename);

% remove NAN rows
if ~strcmp(arena,'urethane')
    toremove = false(size(csvIndex,1),1);
    for k = 1:size(csvIndex,1)
        if isempty(speed{k,1})
            toremove(k) = true;
        else
            if all(isnan(speed{k,1}(csvIndex(k,3):csvIndex(k,4))))
                toremove(k) = true;
            end
        end
    end
    speed = speed(~toremove,:);
    speed2 = speed2(~toremove,:);
    pulseIndex = pulseIndex(~toremove,:);
    eeg = eeg(~toremove,:);
    rowInfo = rowInfo(~toremove,:);
    csvIndex = csvIndex(~toremove,:);
    stimIndex = stimIndex(~toremove,:);
end

% select good files
selectindex = false(size(rowInfo,1),1);
for k = 1:length(selectindex)
    temp = NaN(1,numel(select));
    for xx = 1:numel(select)
        a = strfind(rowInfo{k,1},select{xx});
        if ~isempty(a); temp(xx) = a; end
    end
    if any(~isnan(temp)); selectindex(k) = true; end
end


% remove noisy (above No 28) and bad (2ms stim length: files No 14-22) files of 1868
if ismember('1868',select)
    for r = 1:size(rowInfo,1)
        if isequal('1868',rowInfo{r,1}(1:4))
            temp = str2num(rowInfo{r,1}(6:end));
            if temp > 28
                selectindex(r) = false;
            elseif and(temp >= 14, temp <= 22)
                selectindex(r) = false;
            end
        end
    end
end
    

if ~all(~selectindex)
    if ~strcmp(arena,'urethane')
        speed = speed(selectindex,:);
        speed2 = speed2(selectindex,:);
        csvIndex = csvIndex(selectindex,:);
    else
        speed = [];
        speed2 = [];
        csvIndex = [];
    end
    pulseIndex = pulseIndex(selectindex,:);
    eeg = eeg(selectindex,:);
    rowInfo = rowInfo(selectindex,:);
    
    stimIndex = stimIndex(selectindex,:);
    
    rowdata = rowInfo;
    if ismember('2022',select)
        fileHelp = cellfun(@(x) str2num(x(6:end)),rowInfo(:,1));
    end
    
    %%
    if ~strcmp(arena,'urethane')
        ind2max = max(csvIndex(:,2));
    end
    ind2maxEEG = max(stimIndex(:,2));
    csvIndex2 = [];
    stimIndex2 = [];
    for k = 1:size(stimIndex,1)
        % speed
        if ~strcmp(arena,'urethane')
            if csvIndex(k,2)<ind2max
                csvIndex2(k,:) = csvIndex(k,:)+(ind2max-csvIndex(k,2));
            else
                csvIndex2(k,:) = csvIndex(k,:);
            end
        end
        
        % eeg
        if stimIndex(k,2)<ind2maxEEG
            stimIndex2(k,:) = stimIndex(k,:)+(ind2maxEEG-stimIndex(k,2));
        else
            stimIndex2(k,:) = stimIndex(k,:);
        end
    end
    
    % create matrix
    if ~strcmp(arena,'urethane')
        speedmatrix = NaN(size(csvIndex2,1),max(csvIndex2(:,end)));
    else
        speedmatrix = [];
    end
    eegmatrix = NaN(size(stimIndex2,1),max(stimIndex2(:,end)));
    
    pyrN = NaN(size(eegmatrix,1),1);
    for k =1:size(eegmatrix,1)
        if ~strcmp(arena,'urethane')
            % speed
            temp = speed{k,1};
            if length(temp)>csvIndex2(k,end)-csvIndex2(k,1)
                temp = temp(1:(csvIndex2(k,end)-csvIndex2(k,1)));
            end
            speedmatrix(k,csvIndex2(k,1):csvIndex2(k,end)-1) = temp;
        end
        
        % eeg
        tempeeg = eeg{k,1};
        temprowdata = rowdata{k,1}(1:4);
        if isequal(temprowdata,'2022')
            if fileHelp(k,1) < 25
                temprowdata = [temprowdata 'A'];
            elseif fileHelp(k,1) >= 25
                temprowdata = [temprowdata 'B'];
            end
        end
        pyrN(k,1) = pyrCh{ismember(pyrCh(:,1),temprowdata),2};
        tempeegPyr = tempeeg(:,pyrN(k,1));
        bvar = fir1(2048, 1/(1000/2),'high'); % filter the eeg <1Hz
        tempeegPyr = filtfilt(bvar,1,tempeegPyr);
        
        if length(tempeegPyr)>stimIndex2(k,end)-stimIndex2(k,1)+1
            tempeegPyr = tempeegPyr(1:(stimIndex2(k,end)-stimIndex2(k,1))+1);
        end
        eegmatrix(k,stimIndex2(k,1):stimIndex2(k,end)) = tempeegPyr;
        
        
        [frT, waveT, powerT, scaleT] = wavecall_andor(reshape(tempeegPyr,1,[]), 1000, 'no');
        powerT = bsxfun(@rdivide, powerT, scaleT');
        
        % wavelet
        lpTH = knnsearch(frT',250);
        hpTH = knnsearch(frT',0.9);
        fr(k,:) = frT(lpTH:hpTH);
        scale(k,:) = scaleT(lpTH:hpTH);
        
        waveT = waveT(lpTH:hpTH,:);
        powerT = powerT(lpTH:hpTH,:);
        
        power(:,:,k) = NaN(size(powerT,1),size(eegmatrix,2));
        power(:,stimIndex2(k,1):stimIndex2(k,end),k) = powerT;
        
        wave(:,:,k) = NaN(size(waveT,1),size(eegmatrix,2));
        wave(:,stimIndex2(k,1):stimIndex2(k,end),k) = waveT;
        
        
       
       
            
%     %% detect big artifacts
%     artifact = andor_detectBigArtifact(powerTH);
%     
%     % detect strong theta presence
%     thetaPRIM = andor_waveStateDef(powerTH,freqTH,2.5,6,'low');
%     thetaPRIM(artifact) = false;
%     
%     % connect short gaps between theta segments:
%     th0gap = 200; % ms
%     th0gap = (th0gap/1000)*downSamplingRate; % datapoints
%     
%     Q = diff([0 ~thetaPRIM 0]);
%     theta0GAPstart = find(Q == 1);
%     theta0GAPlength = find(Q == -1) - find(Q == 1);
%     
%     shortThetaGAPstart = theta0GAPstart(theta0GAPlength < th0gap);
%     if ~isempty(shortThetaGAPstart)
%         shortThetaGAPend = shortThetaGAPstart + theta0GAPlength(theta0GAPlength < th0gap) - 1;
%         
%         for xx = 1:length(shortThetaGAPstart)
%             thetaPRIM(shortThetaGAPstart(xx):shortThetaGAPend(xx)) = true;
%         end
%     end
%     
%     % remove short theta segments:
%     th1gap = 400; % ms
%     th1gap = (th1gap/1000)*downSamplingRate;
%     
%     Q = diff([0 thetaPRIM 0]);
%     theta1GAPstart = find(Q == 1);
%     theta1GAPlength = find(Q == -1) - find(Q == 1);
%     
%     shortTHETAstart = theta1GAPstart(theta1GAPlength < th1gap);
%     if ~isempty(shortTHETAstart)
%         shortTHETAend = shortTHETAstart + theta1GAPlength(theta1GAPlength < th1gap) - 1;
%         
%         for xx = 1:length(shortTHETAstart)
%             thetaPRIM(shortTHETAstart(xx):shortTHETAend(xx)) = false;
%         end
%     end
%     
%     
%     % detect strong delta presence
%     deltaPRIM = andor_waveStateDef(powerTH,freqTH,0,2.5,'high');
%     deltaPRIM(artifact) = false;
%     
%     % connect short gaps between delta segments:
%     d0gap = 1000; % ms
%     d0gap = (d0gap/1000)*downSamplingRate; % datapoints
%     
%     Q = diff([0 ~deltaPRIM 0]);
%     deltaGAPstart = find(Q == 1);
%     deltaGAPlength = find(Q == -1) - find(Q == 1);
%     
%     shortDeltaGAPstart = deltaGAPstart(deltaGAPlength < d0gap);
%     if ~isempty(shortDeltaGAPstart)
%         shortDeltaGAPend = shortDeltaGAPstart + deltaGAPlength(deltaGAPlength < d0gap) - 1;
%         
%         for xx = 1:length(shortDeltaGAPstart)
%             deltaPRIM(shortDeltaGAPstart(xx):shortDeltaGAPend(xx)) = true;
%         end
%     end
%     
%     % remove short delta segments:
%     d1gap = 1500; % ms
%     d1gap = (d1gap/1000)*downSamplingRate;
%     
%     Q = diff([0 deltaPRIM 0]);
%     delta1GAPstart = find(Q == 1);
%     delta1GAPlength = find(Q == -1) - find(Q == 1);
%     
%     shortDELTAstart = delta1GAPstart(delta1GAPlength < d1gap);
%     if ~isempty(shortDELTAstart)
%         shortDELTAend = shortDELTAstart + delta1GAPlength(delta1GAPlength < d1gap) - 1;
%         
%         for xx = 1:length(shortDELTAstart)
%             deltaPRIM(shortDELTAstart(xx):shortDELTAend(xx)) = false;
%         end
%     end
%     
%     % theta/delta ratio
%     thetaLim = sort([knnsearch(freqTH',2.5), knnsearch(freqTH',6)]);
%     deltaLim = sort([knnsearch(freqTH',0),knnsearch(freqTH',2.5)]);
%     TDratio = sumskipnan(powerTH(thetaLim(1):thetaLim(2),:))./sumskipnan(powerTH(deltaLim(1):deltaLim(2),:));
%     
%     % compare theta and delta:
%     theta = thetaPRIM;
%     theta(deltaPRIM) = false;
        
    end
    
    if ~strcmp(arena,'urethane')
        speedindex = csvIndex2(:,3);
        speedindex2 = csvIndex2(:,4);
    else
        speedindex = [];
        speedindex2 = [];
    end
    
    eegindex = stimIndex2(:,3);
    eegindex2 = stimIndex2(:,4);
    
    stimIndexA = stimIndex(:,3);
    stimIndexB = stimIndex(:,4);
    
    
    if ~strcmp(arena,'urethane')
        posY = cell(size(rowdata,1),1);posX = cell(size(rowdata,1),1);posZ = cell(size(rowdata,1),1);
        rotX = cell(size(rowdata,1),1);rotY = cell(size(rowdata,1),1);rotZ = cell(size(rowdata,1),1);rotW = cell(size(rowdata,1),1);
%         folder = '/Volumes/G31_invivo_data2$/projekt/incertus/analysis';
%         for k = 1:size(rowdata,1)
%             filename2 = rowdata{k,1};
%             load(fullfile(folder,['INC_' filename2(1:4) '_speed.mat']),'infoCell','csvSample')
%             temprow = find(cellfun(@(x) isequal(filename2,x),infoCell(:,1)));
%             tempstimno = rowdata{k,2};
%             if ~isequal('1868',filename2(1:4))
%                 posY{k,1} = csvSample{temprow,1}{tempstimno,1}(:,6);
%                 posX{k,1} = csvSample{temprow,1}{tempstimno,1}(:,5);
%                 posZ{k,1} = csvSample{temprow,1}{tempstimno,1}(:,7);
%                 rotX{k,1} = csvSample{temprow,1}{tempstimno,1}(:,1);
%                 rotY{k,1} = csvSample{temprow,1}{tempstimno,1}(:,2);
%                 rotZ{k,1} = csvSample{temprow,1}{tempstimno,1}(:,3);
%                 rotW{k,1} = csvSample{temprow,1}{tempstimno,1}(:,4);
%             else
%                 posY{k,1} = csvSample{temprow,1}{rowdata{k,4},1}{tempstimno,1}(:,6);
%                 posX{k,1} = csvSample{temprow,1}{rowdata{k,4},1}{tempstimno,1}(:,5);
%                 posZ{k,1} = csvSample{temprow,1}{rowdata{k,4},1}{tempstimno,1}(:,7);
%                 rotX{k,1} = csvSample{temprow,1}{rowdata{k,4},1}{tempstimno,1}(:,1);
%                 rotY{k,1} = csvSample{temprow,1}{rowdata{k,4},1}{tempstimno,1}(:,2);
%                 rotZ{k,1} = csvSample{temprow,1}{rowdata{k,4},1}{tempstimno,1}(:,3);
%                 rotW{k,1} = csvSample{temprow,1}{rowdata{k,4},1}{tempstimno,1}(:,4);
%             end
%         end
    else
        posY = []; posX = []; posZ = [];
        rotX = []; rotY = []; rotZ = []; rotW = [];
    end
        
    
%     % select data only from one animal
%     for nn = 1:numel(select)
%         selectName{nn,1} = select{nn};
%         T = cellfun(@(x) ~isempty(strfind(x,select{nn})),rowInfo(:,1));
%         selectMatrix{nn,1} = speedmatrix(T,:);
%         selectIndex{nn,1} = index(T,:);
%     end
    

else
    speedmatrix = [];
    eegmatrix = [];
    speedindex = [];
    speedindex2 = [];
    eegindex = [];
    eegindex2 = [];
    rowdata = [];
    fr = [];
    wave = [];
    power = [];
    scale = [];
    pulseIndex = [];
    eeg = [];
    pyrN = [];
    stimIndexA = [];
    stimIndexB = [];
    posY = []; posX = []; posZ = [];
    rotX = []; rotY = []; rotZ = []; rotW = [];
end