function andor_INCfreemov_STEP4_f1(power,speedmatrix,eegindex, eegindex2,speedindex,speedindex2,dataselection,index,freq,animals,title)

if any(and(dataselection,index))
    tempPower = power(:,:,and(dataselection,index));
    tempEEGindex = eegindex(and(dataselection,index));
    tempEEGindex2 = eegindex2(and(dataselection,index));
    tempSPEED = speedmatrix(and(dataselection,index),:);
    
    
    figure('Name',[animals '  ' title],'NumberTitle','off');
    ytick = fliplr([0.9 5 12 30 60 150 250]);
    ytickloc = arrayfun(@(x) knnsearch(freq(1,:)',x),ytick);
    
    subplot(3,1,1);
    ax{1} = imagesc((1:size(power,2))./1000-min(eegindex)/1000,1:size(power,1),mean(tempPower,3));
    set(gca,'CLim',[0 400],'YTick',ytickloc,'YTickLabel',arrayfun(@num2str,ytick,'UniformOutput',false),'FontSize',20,'XLim',[-4 (max(eegindex2)/1000-min(eegindex)/1000)+4])
    set(gca,'XTick',[])
    line([0 0],[0.5 size(power,1)+0.5],'Color','w','LineWidth',2,'LineStyle','--')
    line(repmat(max(eegindex2)/1000-min(eegindex)/1000,1,2),[0.5 size(power,1)+0.5],'Color','w','LineWidth',2,'LineStyle','--')
%     xlabel(gca,'time (s)','FontSize',20)
    ylabel(gca,'frequency (Hz)','FontSize',20)
    
    
    
    subplot(3,1,2)
    ax{2} = plot(((1:size(tempSPEED,2))-min(speedindex))/120,tempSPEED'); hold on
    plot(((1:size(tempSPEED,2))-min(speedindex))/120,mean(tempSPEED),'LineWidth',2,'Color','r')
    set(gca,'YLim',[0, 80],'YTick',[0 20 40 60 80],'YTickLabel',{'0','20','40','60','80'},'LineWidth',2,'XLim',[-4 (max(eegindex2)/1000-min(eegindex)/1000)+4])
    set(gca,'FontSize',20,'Box','off')
    line([0 0],[0 80],'Color','r','LineWidth',2,'LineStyle','--')
    line(repmat((max(speedindex2)-min(speedindex))/120,1,2),[0 80],'Color','r','LineWidth',2,'LineStyle','--')
    xlabel(gca,'time (s)','FontSize',20)
    ylabel(gca,'speed (cm/s)','FontSize',20)
    
    
    
    sumpowerPRE = NaN(size(tempPower,1),size(tempPower,3));
    sumpowerSTIM = NaN(size(tempPower,1),size(tempPower,3));
    sumpowerPOST = NaN(size(tempPower,1),size(tempPower,3));
    for xx = 1:size(tempPower,3)
        sumpowerPRE(:,xx) = sumskipnan(tempPower(:,1:tempEEGindex(xx)-1,xx),2);
        sumpowerSTIM(:,xx) = sumskipnan(tempPower(:,tempEEGindex(xx):tempEEGindex2(xx),xx),2);
        sumpowerPOST(:,xx) = sumskipnan(tempPower(:,tempEEGindex2(xx)+1:end,xx),2);
    end
    subplot(3,1,3);
%     ax{3} = plot(sumpowerPRE); hold on;
    plot(mean(sumpowerPRE,2),'LineWidth',2,'Color','k'); hold on
    
    plot(mean(sumpowerSTIM,2),'LineWidth',2,'Color','b');
    
    plot(mean(sumpowerPOST,2),'LineWidth',2,'Color',[0.8 0.8 0.8]);
    
    set(gca,'YLim',[0 3000000],'XTick',ytickloc,'XTickLabel',arrayfun(@num2str,ytick,'UniformOutput',false),'XLim',[1 size(sumpowerPRE,1)])
    set(gca,'FontSize',20,'LineWidth',2,'Box','off')
    xlabel(gca,'frequency (Hz)','FontSize',20)
    ylabel(gca,'power','FontSize',20)
end