function [powerM,power_pre,power_stim,power_post,powerratio,power_preShort,power_stimShort,powerratioShort,...
    pWelch_pre,fWelch_pre,pWelch_stim,fWelch_stim,pWelch_post,fWelch_post,welchdiff,...
    domfreq_pre,domfreq_stim,domfreq_preShort,domfreq_stimShort,...com_PRE,com_STIM,
    amplHist_PRE,amplHist_STIM,...
    FreqTick,FreqTickloc,TimeX,pyrN] ...
    = andor_INCfreemov_STEP4_f2(thSearchBef,speedmatrix,eegmatrix,speedindex,speedindex2,eegindex,eegindex2,rowdata,stimFlag,freq,wave,power,scale,pulseIndex,eeg,pyrN,stimindexA,stimindexB)

% power = power(:,:,index);
% eegindex = eegindex(index);
% eegindex2 = eegindex2(index);
% freq = freq(index,:);
% wave = wave(:,:,index);
% eeg = eeg(index,1);
% pyrN = pyrN(index,1);
% stimindexA = stimindexA(index,1);
% stimindexB = stimindexB(index,1);

WelchWindow = 1000;
WelchNoverlap = 500;
WelchNfft = 2048;

FontSize = 20;
CLimPower = [0 400];
if ~isempty(freq)
%% wavelet power average
FreqTick = fliplr([1 5 12 30 60 150 250]);
FreqTickloc = arrayfun(@(x) knnsearch(freq(1,:)',x),FreqTick);
TimeX = (1:size(power,2))./1000-min(eegindex)/1000;
powerM = mean(power,3);

%                     imagesc(TimeX,1:size(power,1),powerM)
%                     set(gca,'CLim',CLimPower,'YTick',FreqTickloc,'YTickLabel',arrayfun(@num2str,FreqTick,'UniformOutput',false),'FontSize',FontSize)
%                     line([0 0],[0.5 size(power,1)+0.5],'Color','w','LineWidth',2,'LineStyle','--')
%                     line(repmat(max(eegindex2)/1000,1,2)-min(eegindex)/1000,[0.5 size(power,1)+0.5],'Color','w','LineWidth',2,'LineStyle','--')
%                     xlabel(gca,'time (s)','FontSize',FontSize)
%                     ylabel(gca,'frequency (Hz)','FontSize',FontSize)

%% wavelet power before,during and after stim, POWERRATIO
power_pre = NaN(size(power,3),size(power,1));
power_stim = NaN(size(power,3),size(power,1));
power_post = NaN(size(power,3),size(power,1));

power_preShort = NaN(size(power,3),size(power,1));
power_stimShort = NaN(size(power,3),size(power,1));

powerratio = NaN(size(power,3),size(power,1));
powerratioShort = NaN(size(power,3),size(power,1));

for k = 1:size(power,3)
    prestart = 2*eegindex(k) - eegindex2(k);
    if eegindex(k)-prestart > 10000 % limit to 10 s eeg before stim
        prestart = eegindex(k)-10000;
    end
    if prestart < 1; prestart = 1; end
    postend = 2*eegindex2(k)-eegindex(k)+1;
    if postend>size(power,2); postend = size(power,2); end
    
    
    power_pre(k,:) = sumskipnan(power(:,prestart:(eegindex(k)-1),k),2)/(eegindex(k)-prestart);
    power_stim(k,:) = sumskipnan(power(:,eegindex(k):eegindex2(k),k),2)/(eegindex2(k)-eegindex(k)+1);
    power_post(k,:) = sumskipnan(power(:,(eegindex2(k)+1):postend,k),2)/(postend-eegindex2(k)+1);
    
    powerratio(k,:) = power_stim(k,:)./power_pre(k,:);
    
    power_preShort(k,:) = sumskipnan(power(:,eegindex(k)-thSearchBef-1:eegindex(k)-1,k),2)/thSearchBef;
    power_stimShort(k,:) = sumskipnan(power(:,eegindex(k):eegindex(k)+thSearchBef,k),2)/thSearchBef;
    
    powerratioShort(k,:) = power_stimShort(k,:)./power_preShort(k,:);
end

powerratio = 10*log10(powerratio);
powerratioShort = 10*log10(powerratioShort);

%                     imagesc(power_pre)
%                     set(gca,'CLim',CLimPower,'XTick',FreqTickloc,'XTickLabel',arrayfun(@num2str,FreqTick,'UniformOutput',false),'FontSize',FontSize)
%                     title(gca,'power before stim','FontSize',FontSize)
%                     ylabel(gca,'stim No.','FontSize',FontSize)
%                     
%                     imagesc(power_stim)
%                     set(gca,'CLim',CLimPower,'XTick',FreqTickloc,'XTickLabel',arrayfun(@num2str,FreqTick,'UniformOutput',false),'FontSize',FontSize)
%                     title(gca,'power during stim','FontSize',FontSize)
% 
%                     imagesc(powerratio)
%                     set(gca,'CLim',[-10 10],'XTick',FreqTickloc,'XTickLabel',arrayfun(@num2str,FreqTick,'UniformOutput',false),'FontSize',20)
%                     title(gca,{'stim/before'; 'power change (dB)'},'FontSize',20)
% 
%                     plot(mean(powerratio),'Color','b','LineWidth',2)
%                     set(gca,'FontSize',20,'XTick',FreqTickloc,'XTickLabel',arrayfun(@num2str,FreqTick,'UniformOutput',false),'XLim',[1 163],'YLim',[-5 5])
%                     line([1 163],[0 0],'Color','r','LineStyle','--','LineWidth',1.5)
%                     xlabel(gca,'frequency (Hz)','FontSize',20)
%                     title(gca,'mean power change (dB)','FontSize',20)           
%% welch before,during and after stim
pWelch_pre = cell(size(eeg,1),max(cellfun(@(x) size(x,2),eeg)));
fWelch_pre = cell(size(eeg,1),max(cellfun(@(x) size(x,2),eeg)));
pWelch_stim = cell(size(eeg,1),max(cellfun(@(x) size(x,2),eeg)));
fWelch_stim = cell(size(eeg,1),max(cellfun(@(x) size(x,2),eeg)));
pWelch_post = cell(size(eeg,1),max(cellfun(@(x) size(x,2),eeg)));
fWelch_post = cell(size(eeg,1),max(cellfun(@(x) size(x,2),eeg)));
welchdiff = cell(size(eeg,1),max(cellfun(@(x) size(x,2),eeg)));
for k = 1:size(eeg,1)
    prestart = 2*stimindexA(k) - stimindexB(k);
    if stimindexA(k)-prestart > 10000 % limit to 10 s eeg before stim
        prestart = stimindexA(k)-10000;
    end
    if prestart < 1; prestart = 1; end
    postend = 2*stimindexB(k)-stimindexA(k)+1;
    if postend>size(eeg{k,1},1); postend = size(eeg{k,1},1); end
    
    for kk = pyrN(k):size(eeg{k,1},2)
        tempEEG = eeg{k,1}(:,kk);
        
        try
            [pWelch_pre{k,kk}, fWelch_pre{k,kk}] = pwelch(tempEEG(prestart:(stimindexA(k)-1)),WelchWindow,WelchNoverlap,WelchNfft,1000);
        catch
        end
        try
            [pWelch_stim{k,kk}, fWelch_stim{k,kk}] = pwelch(tempEEG(stimindexA(k):stimindexB(k)),WelchWindow,WelchNoverlap,WelchNfft,1000);
        catch
        end
        try
            [pWelch_post{k,kk}, fWelch_post{k,kk}] = pwelch(tempEEG((stimindex(B)+1):postend),WelchWindow,WelchNoverlap,WelchNfft,1000);
        catch
        end
        
        try
            welchdiff{k,kk} = 10*log10(pWelch_stim{k,kk})-10*log10(pWelch_pre{k,kk});
        catch
        end
    end
end
%% dom freq shift
% for theta range
t1 = knnsearch(freq(1,:)',5);
t2 = knnsearch(freq(1,:)',12);
domfreq_pre = NaN(size(power_pre,1),1);
domfreq_stim = NaN(size(power_stim,1),1);
domfreq_preShort = NaN(size(power_preShort,1),1);
domfreq_stimShort = NaN(size(power_stimShort,1),1);
for k = 1:size(power_pre,1)
    [~, loc] = max(power_pre(k,t2:t1));
    domfreq_pre(k,1) = freq(1,loc+t2-1);
    
    [~, loc] = max(power_stim(k,t2:t1));
    domfreq_stim(k,1) = freq(1,loc+t2-1);
    
    [~, loc] = max(power_preShort(k,t2:t1));
    domfreq_preShort(k,1) = freq(1,loc+t2-1);
    
    [~, loc] = max(power_stimShort(k,t2:t1));
    domfreq_stimShort(k,1) = freq(1,loc+t2-1);
end
%% CFC
gamma1_CMD = 250;
gamma2_CMD = 15;
th1_CMD = 35;
th2_CMD = 0.9;
g1 = knnsearch(freq(1,:)',gamma1_CMD);
g2 = knnsearch(freq(1,:)',gamma2_CMD);
t1 = knnsearch(freq(1,:)',th1_CMD);
t2 = knnsearch(freq(1,:)',th2_CMD);

w1 = 5;
w2 = 12;

amplitudeHist_PRE = cell(size(power,3),1);
comodulo_PRE = cell(size(power,3),1);
amplitudeHist_STIM = cell(size(power,3),1);
comodulo_STIM = cell(size(power,3),1);
for k = 1:size(power,3)
    prestart = 2*eegindex(k) - eegindex2(k);
    if eegindex(k)-prestart > 10000 % limit to 10 s eeg before stim
        prestart = eegindex(k)-10000;
    end
    if prestart < 1; prestart = 1; end
    
    tempGammaWave = wave(g1:g2,:,k);
    tempThetaWave = wave(t1:t2,:,k);
    thetaPhase = radtodeg(angle(tempThetaWave));
    gammaAmpl = abs(tempGammaWave);
    
    thetaPhase_PRE = thetaPhase(:,prestart:eegindex(k)-1);
    gammaAmpl_PRE = gammaAmpl(:,prestart:eegindex(k)-1);
    
    tempEEG = eeg{k,1}(:,pyrN(k));
    waveforphase = radtodeg(angle(hilbert(filtfilt(fir1(2048,[w1/(1000/2) w2/(1000/2)]),1,tempEEG))));
    
    waveforphase_PRE = waveforphase(prestart:eegindex(k)-1);
    
    for x = 1:size(gammaAmpl_PRE,1)
        [amplHist_PRE{k,1}(x,:), ~] = andor_phase_ampl_comodulogram(waveforphase_PRE,gammaAmpl_PRE(x,:),linspace(-180,180,51));
    end
    
%     amplitudeHist_PRE{k,1} = cell(size(gammaAmpl_PRE,1),size(thetaPhase_PRE,1));
%     comodulo_PRE{k,1} = NaN(size(gammaAmpl_PRE,1),size(thetaPhase_PRE,1));
%     for kk = 1:size(thetaPhase_PRE,1)
%         for kkk = 1:size(gammaAmpl_PRE,1)
%             [amplitudeHist_PRE{k,1}{kkk,kk}, comodulo_PRE{k,1}(kkk,kk)] = andor_phase_ampl_comodulogram(thetaPhase_PRE(kk,:),gammaAmpl_PRE(kkk,:),linspace(-180,180,51));
%         end
%     end
    
    thetaPhase_STIM = thetaPhase(:,eegindex(k):eegindex2(k));
    gammaAmpl_STIM = gammaAmpl(:,eegindex(k):eegindex2(k));
    
    waveforphase_STIM = waveforphase(eegindex(k):eegindex2(k));
    
    for x = 1:size(gammaAmpl_STIM,1)
        [amplHist_STIM{k,1}(x,:), ~] = andor_phase_ampl_comodulogram(waveforphase_STIM,gammaAmpl_STIM(x,:),linspace(-180,180,51));
    end
    
%     amplitudeHist_STIM{k,1} = cell(size(gammaAmpl_STIM,1),size(thetaPhase_STIM,1));
%     comodulo_STIM{k,1} = NaN(size(gammaAmpl_STIM,1),size(thetaPhase_STIM,1));
%     for kk = 1:size(thetaPhase_STIM,1)
%         for kkk = 1:size(gammaAmpl_STIM,1)
%             [amplitudeHist_STIM{k,1}{kkk,kk}, comodulo_STIM{k,1}(kkk,kk)] = andor_phase_ampl_comodulogram(thetaPhase_STIM(kk,:),gammaAmpl_STIM(kkk,:),linspace(-180,180,51));
%         end
%     end
end
% com_PRE = NaN(g2-g1+1,t2-t1+1,size(power,3));
% com_STIM = NaN(g2-g1+1,t2-t1+1,size(power,3));
% for k = 1:size(power,3)
%     com_PRE(:,:,k) = comodulo_PRE{k,1};
%     com_STIM(:,:,k) = comodulo_STIM{k,1};
% end







else
    powerM=[];power_pre=[];power_stim=[];power_post=[];powerratio=[];power_preShort=[];power_stimShort=[];powerratioShort=[];...
    pWelch_pre=[];fWelch_pre=[];pWelch_stim=[];fWelch_stim=[];pWelch_post=[];fWelch_post=[];welchdiff=[];...
    domfreq_pre=[];domfreq_stim=[];domfreq_preShort=[];domfreq_stimShort=[];...com_PRE,com_STIM,
    FreqTick=[];FreqTickloc=[];TimeX=[];pyrN=[];
end


    

%%

% figure('Name',[stim '  ' arena '  ' sfreq '   RATIO'],'NumberTitle','off'); hold on
% X = freq(1,t1:t2);
% xtick = fliplr([0.9 5 12 23 35]);
% Y = freq(1,g1:g2);
% ytick = fliplr([15 35 50 100 150 250]);
% subplot(2,1,1)
% imagesc(mean(com_PRE,3))
% set(gca,'CLim',[0 0.01],'FontSize',20,'XTick',arrayfun(@(x) knnsearch(X',x),xtick),'XTickLabel',arrayfun(@num2str,xtick,'UniformOutput',false))
% set(gca,'YTick',arrayfun(@(x) knnsearch(Y',x),ytick),'YTickLabel',arrayfun(@num2str,ytick,'UniformOutput',false))
% 
% subplot(2,1,2)
% imagesc(mean(com_STIM,3))
% set(gca,'CLim',[0 0.01],'FontSize',20,'XTick',arrayfun(@(x) knnsearch(X',x),xtick),'XTickLabel',arrayfun(@num2str,xtick,'UniformOutput',false))
% set(gca,'YTick',arrayfun(@(x) knnsearch(Y',x),ytick),'YTickLabel',arrayfun(@num2str,ytick,'UniformOutput',false))
% 
% 
% figure;
% imagesc(mean(com_STIM,3)-mean(com_PRE,3))
% set(gca,'CLim',[0 0.005],'FontSize',20,'XTick',arrayfun(@(x) knnsearch(X',x),xtick),'XTickLabel',arrayfun(@num2str,xtick,'UniformOutput',false))
% set(gca,'YTick',arrayfun(@(x) knnsearch(Y',x),ytick),'YTickLabel',arrayfun(@num2str,ytick,'UniformOutput',false))
