Stim = {'INC','SEPTUM','BLIND'};
Arena = {'holeBox','linearTrack','newBox','homeCage','urethane'};
Freq = {'f5Hz','f10Hz','f15Hz','f25Hz','f30Hz','f50Hz','TH3_25_5','TH3_50_5','TH3_50_10','TH5_50_5'};
Select = {{'1868','2017','2026','2027','2046'},{'1868','2022','2026','2046'},{'1868','2017','2022','2026','2027','2046'}};
Control = {'1943','1957','1985','2040','2045'};

welchtime = 2000;
[animalIndex, rowdata, stimIndex2, csvIndex2, speedmatrix, eegPyrmatrix, eegmatrix, power,  fr, ...powerALL,...
    pWelch_pre, pWelch_stim, pWelch_post, fWelch, pWelchALL_pre, pWelchALL_stim, pWelchALL_post, lagDiff_pre, lagDiff_stimpost, rcor_pre, rcor_stimpost] = andor_INCfreemov_STEP5_eeg('BLIND','urethane','f25Hz',Control,welchtime);
%% runindex, stillindex
stillindex = false(size(speedmatrix,1),1);
runindex = false(size(speedmatrix,1),1);
for k = 1:size(speedmatrix,1)
    for x = 1:4
        meanprespeed(1,x) = mean(speedmatrix(k,(csvIndex2(k,3)-x*60):(csvIndex2(k,3)-(x-1)*60)));
    end
    if meanprespeed(1) < 4
        stillindex(k,1) = true;
    end
    if all(meanprespeed > 4)
        runindex(k,1) = true;
    end
end
%% thetaindex
urethane = true;
if urethane
    th1 = knnsearch(fWelch(1,:)',2.5);
    th2 = knnsearch(fWelch(1,:)',6);
else
    th1 = knnsearch(fWelch(1,:)',5);
    th2 = knnsearch(fWelch(1,:)',12);
end
L = knnsearch(fWelch(1,:)',1);
H = knnsearch(fWelch(1,:)',16);
thetaindex = false(size(pWelch_pre,1),1);
for k = 1:size(pWelch_pre,1)
    Lt = mean(10*log10(pWelch_pre(k,L:th1-1)));
    th = mean(10*log10(pWelch_pre(k,th1:th2)));
    Ht = mean(10*log10(pWelch_pre(k,th2+1:H)));
    if and(th>Lt,th>Ht)
        thetaindex(k,1) = true;
    end
end
%% remindex
xcorindex = false(size(rcor_pre,1),1);
for k = 1:size(rcor_pre,1)
    temp = mean(rcor_pre{k,1},2);
    for x = 1:4
        temp4(1,x) = mean(temp(((x-1)*20+1):(x*20)));
    end
    if all(temp4 < 0.5)
        xcorindex(k,1) = true;
    end
end
remindex = and(and(thetaindex,stillindex),xcorindex);
nonremindex = and(~thetaindex,stillindex);
%% #1


fontsize = 30;
INCcolor = [0 102 255]./255;
xtick = [1 5 12 20 30 40 50 60];
index = thetaindex;
a = 1;
data = [];
for k = 1:size(animalIndex,1)
    if ~isempty(animalIndex{k,1})
        temp = false(size(pWelch_pre,1),1);
        temp(animalIndex{k,1}) = true;
        temp = and(temp,index);
        data(a,:) = mean(10*log10(pWelch_pre(temp,:)));
        a = a+1;
    end
end
figure; hold on
% plot(fWelch(1,:),data,'Color',[0 0 0],'LineWidth',2)
shadedErrorBar(fWelch(1,:),mean(data),std(data),'lineProps',{'Color',[0.5 0.5 0.5],'LineWidth',1.2})
set(gca,'XLim',[1 60],'LineWidth',1,'Box','off','XTick',xtick,'XTickLabel',arrayfun(@num2str,xtick,'UniformOutput',false))
set(gca,'LineWidth',1,'FontSize',fontsize,'YLim',[20 50])
xlabel(gca,'frequency (Hz)','FontSize',fontsize)
ylabel(gca,'power','FontSize',fontsize)

a = 1;
data = [];
for k = 1:size(animalIndex,1)
    if ~isempty(animalIndex{k,1})
        temp = false(size(pWelch_stim,1),1);
        temp(animalIndex{k,1}) = true;
        temp = and(temp,index);
        data(a,:) = mean(10*log10(pWelch_stim(temp,:)));
        a = a+1;
    end
end
% plot(fWelch(1,:),data,'Color',INCcolor,'LineWidth',2)
shadedErrorBar(fWelch(1,:),mean(data),std(data),'lineProps',{'Color',INCcolor,'LineWidth',1.2})

% a = 1;
% data = [];
% for k = 1:size(animalIndex,1)
%     if ~isempty(animalIndex{k,1})
%         temp = false(size(pWelch_post,1),1);
%         temp(animalIndex{k,1}) = true;
%         temp = and(temp,index);
%         data(a,:) = mean(10*log10(pWelch_post(temp,:)));
%         a = a+1;
%     end
% end
% shadedErrorBar(fWelch(1,:),mean(data),std(data),'lineProps',{'Color',[0.5 0.5 0.5]})
%      
%% #2
a = 1;
welchratio = [];
d_pre = [];
d_stim = [];
welch_diff = [];
welch_diffmean = [];
for k = 1:size(animalIndex,1)
    if ~isempty(animalIndex{k,1})
        temp = false(size(pWelch_stim,1),1);
        temp(animalIndex{k,1}) = true;
        temp = and(temp,index);
        d_diff = [];
        b = 1;
        for d = 1:length(temp)
            if temp(d)
                d_pre = (pWelch_pre(d,:));
                d_stim = (pWelch_stim(d,:));
                welch_diff{a,1}(b,:) = 10*log10(d_stim./d_pre);
                b = b+1;
            end
        end
        welch_diffmean(a,:) = mean(welch_diff{a,1});
        a = a+1;
    end
end
figure;
shadedErrorBar(fWelch(1,:),mean(welch_diffmean),std(welch_diffmean),'lineProps',{'Color',INCcolor,'LineWidth',1.2})
set(gca,'XLim',[1 60],'LineWidth',1,'Box','off','XTick',xtick,'XTickLabel',arrayfun(@num2str,xtick,'UniformOutput',false))
set(gca,'LineWidth',1,'FontSize',fontsize,'YLim',[-15 15],'YTick',[-15 0 15],'YTickLabel',{'-15','0','15'})
xlabel(gca,'frequency (Hz)','FontSize',fontsize)
ylabel(gca,'power difference','FontSize',fontsize)
%%
welch_diffmeanINC_25_LT = welch_diffmean;
%%
welch_diffmeanINC_25_LT_CTRL = welch_diffmean;
%%
welch_diffmeanBLIND_25_LT = welch_diffmean;
%%
welch_diffmeanBLIND_25_LT_CTRL = welch_diffmean;
%%
welch_diffmeanINC_25_LT_BLCTRL = [welch_diffmeanINC_25_LT_CTRL; welch_diffmeanBLIND_25_LT; welch_diffmeanBLIND_25_LT_CTRL];
%%
welch_diff_RANKSUM = NaN(1,size(welch_diffmeanINC_25_LT,2));
for k = 1:size(welch_diffmeanINC_25_LT,2)
    welch_diff_RANKSUM(1,k) = ranksum(welch_diffmeanINC_25_LT(:,k),welch_diffmeanINC_25_LT_BLCTRL(:,k));
end

%% midfreqs
starts = [];
ends = [];
for k = 2:length(welch_diff_RANKSUM)-1
    if and((welch_diff_RANKSUM(k-1) >= 0.05),(welch_diff_RANKSUM(k) < 0.05))
        ss = fWelch(1,k);
        starts = [starts ss];
    end
    if and((welch_diff_RANKSUM(k) < 0.05),(welch_diff_RANKSUM(k+1) >= 0.05))
        ee = fWelch(1,k);
        ends = [ends ee];
    end
end
midfreqs = (starts+ends)./2;

CTRLcolor = [0.5 0.5 0.5];
figure; hold on
shadedErrorBar(fWelch(1,:),mean(welch_diffmeanINC_25_LT_BLCTRL),std(welch_diffmeanINC_25_LT_BLCTRL),'lineProps',{'Color',CTRLcolor,'LineWidth',1.2})

shadedErrorBar(fWelch(1,:),mean(welch_diffmeanINC_25_LT),std(welch_diffmeanINC_25_LT),'lineProps',{'Color',INCcolor,'LineWidth',1.2})

tempW = mean(welch_diffmeanINC_25_LT);
tempW(welch_diff_RANKSUM >= 0.05) = NaN;
plot(fWelch(1,:),tempW,'Color','r','LineWidth',1.2)


set(gca,'XLim',[1 60],'LineWidth',1,'Box','off','XTick',xtick,'XTickLabel',arrayfun(@num2str,xtick,'UniformOutput',false))
set(gca,'LineWidth',1,'FontSize',fontsize,'YLim',[-15 15],'YTick',[-15 0 15],'YTickLabel',{'-15','0','15'})

line([1 60],[0 0],'Color','k')

xlabel(gca,'frequency (Hz)','FontSize',fontsize)
ylabel(gca,'power difference','FontSize',fontsize)
%%
%%
            welch_diffmeanINC_25_HC = welch_diffmean;
            %%
            welch_diffmeanINC_25_HC_CTRL = welch_diffmean;
            %%
            welch_diffmeanBLIND_25_HC = welch_diffmean;
            %%
            welch_diffmeanBLIND_25_HC_CTRL = welch_diffmean;
            %%
            welch_diffmeanINC_25_HC_BLCTRL = [welch_diffmeanINC_25_HC_CTRL; welch_diffmeanBLIND_25_HC; welch_diffmeanBLIND_25_HC_CTRL];
            
            welch_diff_RANKSUM = NaN(1,size(welch_diffmeanINC_25_HC,2));
            for k = 1:size(welch_diffmeanINC_25_HC,2)
                welch_diff_RANKSUM(1,k) = ranksum(welch_diffmeanINC_25_HC(:,k),welch_diffmeanINC_25_HC_BLCTRL(:,k));
            end



            %% midfreqs
            starts = [];
            ends = [];
            for k = 2:length(welch_diff_RANKSUM)-1
                if and((welch_diff_RANKSUM(k-1) >= 0.05),(welch_diff_RANKSUM(k) < 0.05))
                    ss = fWelch(1,k);
                    starts = [starts ss];
                end
                if and((welch_diff_RANKSUM(k) < 0.05),(welch_diff_RANKSUM(k+1) >= 0.05))
                    ee = fWelch(1,k);
                    ends = [ends ee];
                end
            end
            midfreqs = (starts+ends)./2;

            CTRLcolor = [0.5 0.5 0.5];
            figure; hold on
            shadedErrorBar(fWelch(1,:),mean(welch_diffmeanINC_25_HC_BLCTRL),std(welch_diffmeanINC_25_HC_BLCTRL),'lineProps',{'Color',CTRLcolor,'LineWidth',1.2})

            shadedErrorBar(fWelch(1,:),mean(welch_diffmeanINC_25_HC),std(welch_diffmeanINC_25_HC),'lineProps',{'Color',INCcolor,'LineWidth',1.2})

            tempW = mean(welch_diffmeanINC_25_HC);
            tempW(welch_diff_RANKSUM >= 0.05) = NaN;
            plot(fWelch(1,:),tempW,'Color','r','LineWidth',1.2)


            set(gca,'XLim',[1 60],'LineWidth',1,'Box','off','XTick',xtick,'XTickLabel',arrayfun(@num2str,xtick,'UniformOutput',false))
            set(gca,'LineWidth',1,'FontSize',fontsize,'YLim',[-15 15],'YTick',[-15 0 15],'YTickLabel',{'-15','0','15'})

            line([1 60],[0 0],'Color','k')

            xlabel(gca,'frequency (Hz)','FontSize',fontsize)
            ylabel(gca,'power difference','FontSize',fontsize)

%%
                        welch_diffmeanINC_25_HCN = welch_diffmean;
                        %%
                        welch_diffmeanINC_25_HCN_CTRL = welch_diffmean;
                        %%
                        welch_diffmeanBLIND_25_HCN = welch_diffmean;
                        %%
                        welch_diffmeanBLIND_25_HCN_CTRL = welch_diffmean;
                        %%
                        welch_diffmeanINC_25_HCN_BLCTRL = [welch_diffmeanINC_25_HCN_CTRL; welch_diffmeanBLIND_25_HCN; welch_diffmeanBLIND_25_HCN_CTRL];

                        welch_diff_RANKSUM = NaN(1,size(welch_diffmeanINC_25_HCN,2));
                        for k = 1:size(welch_diffmeanINC_25_HCN,2)
                            welch_diff_RANKSUM(1,k) = ranksum(welch_diffmeanINC_25_HCN(:,k),welch_diffmeanINC_25_HCN_BLCTRL(:,k));
                        end



                        %% midfreqs
                        starts = [];
                        ends = [];
                        for k = 2:length(welch_diff_RANKSUM)-1
                            if and((welch_diff_RANKSUM(k-1) >= 0.05),(welch_diff_RANKSUM(k) < 0.05))
                                ss = fWelch(1,k);
                                starts = [starts ss];
                            end
                            if and((welch_diff_RANKSUM(k) < 0.05),(welch_diff_RANKSUM(k+1) >= 0.05))
                                ee = fWelch(1,k);
                                ends = [ends ee];
                            end
                        end
                        midfreqs = (starts+ends)./2;

                        CTRLcolor = [0.5 0.5 0.5];
                        figure; hold on
                        shadedErrorBar(fWelch(1,:),mean(welch_diffmeanINC_25_HCN_BLCTRL),std(welch_diffmeanINC_25_HCN_BLCTRL),'lineProps',{'Color',CTRLcolor,'LineWidth',1.2})

                        shadedErrorBar(fWelch(1,:),mean(welch_diffmeanINC_25_HCN),std(welch_diffmeanINC_25_HCN),'lineProps',{'Color',INCcolor,'LineWidth',1.2})

                        tempW = mean(welch_diffmeanINC_25_HCN);
                        tempW(welch_diff_RANKSUM >= 0.05) = NaN;
                        plot(fWelch(1,:),tempW,'Color','r','LineWidth',1.2)


                        set(gca,'XLim',[1 60],'LineWidth',1,'Box','off','XTick',xtick,'XTickLabel',arrayfun(@num2str,xtick,'UniformOutput',false))
                        set(gca,'LineWidth',1,'FontSize',fontsize,'YLim',[-15 15],'YTick',[-15 0 15],'YTickLabel',{'-15','0','15'})

                        line([1 60],[0 0],'Color','k')

                        xlabel(gca,'frequency (Hz)','FontSize',fontsize)
                        ylabel(gca,'power difference','FontSize',fontsize)


%%
                                    welch_diffmeanINC_25_U = welch_diffmean;
                                    %%
                                    welch_diffmeanINC_25_U_CTRL = welch_diffmean;
                                    %%
                                    welch_diffmeanBLIND_25_U = welch_diffmean;
                                    %%
                                    welch_diffmeanBLIND_25_U_CTRL = welch_diffmean;
                                    %%
                                    welch_diffmeanINC_25_U_BLCTRL = [welch_diffmeanINC_25_U_CTRL; welch_diffmeanBLIND_25_U; welch_diffmeanBLIND_25_U_CTRL];

                                    welch_diff_RANKSUM = NaN(1,size(welch_diffmeanINC_25_U,2));
                                    for k = 1:size(welch_diffmeanINC_25_U,2)
                                        welch_diff_RANKSUM(1,k) = ranksum(welch_diffmeanINC_25_U(:,k),welch_diffmeanINC_25_U_BLCTRL(:,k));
                                    end



                                    %% midfreqs
                                    starts = [];
                                    ends = [];
                                    for k = 2:length(welch_diff_RANKSUM)-1
                                        if and((welch_diff_RANKSUM(k-1) >= 0.05),(welch_diff_RANKSUM(k) < 0.05))
                                            ss = fWelch(1,k);
                                            starts = [starts ss];
                                        end
                                        if and((welch_diff_RANKSUM(k) < 0.05),(welch_diff_RANKSUM(k+1) >= 0.05))
                                            ee = fWelch(1,k);
                                            ends = [ends ee];
                                        end
                                    end
                                    midfreqs = (starts+ends)./2;

                                    CTRLcolor = [0.5 0.5 0.5];
                                    figure; hold on
                                    shadedErrorBar(fWelch(1,:),mean(welch_diffmeanINC_25_U_BLCTRL),std(welch_diffmeanINC_25_U_BLCTRL),'lineProps',{'Color',CTRLcolor,'LineWidth',1.2})

                                    shadedErrorBar(fWelch(1,:),mean(welch_diffmeanINC_25_U),std(welch_diffmeanINC_25_U),'lineProps',{'Color',INCcolor,'LineWidth',1.2})

                                    tempW = mean(welch_diffmeanINC_25_U);
                                    tempW(welch_diff_RANKSUM >= 0.05) = NaN;
                                    plot(fWelch(1,:),tempW,'Color','r','LineWidth',1.2)


                                    set(gca,'XLim',[1 60],'LineWidth',1,'Box','off','XTick',xtick,'XTickLabel',arrayfun(@num2str,xtick,'UniformOutput',false))
                                    set(gca,'LineWidth',1,'FontSize',fontsize,'YLim',[-15 15],'YTick',[-15 0 15],'YTickLabel',{'-15','0','15'})

                                    line([1 60],[0 0],'Color','k')

                                    xlabel(gca,'frequency (Hz)','FontSize',fontsize)
                                    ylabel(gca,'power difference','FontSize',fontsize)
%% #3
index = and(runindex,thetaindex); %%%%

thetadom_pre = NaN(size(pWelch_pre,1),1);
thetadom_stim = NaN(size(pWelch_pre,1),1);
thetashift = NaN(size(pWelch_pre,1),1);

urethane = false; %%%%
if ~urethane
    th1 = knnsearch(fWelch(1,:)',5);
    th2 = knnsearch(fWelch(1,:)',12);
else
    th1 = knnsearch(fWelch(1,:)',2.5);
    th2 = knnsearch(fWelch(1,:)',6);
end
for k = 1:size(pWelch_pre,1)
    [pks, locs] = findpeaks(pWelch_pre(k,th1:th2));
    if ~isempty(pks)
        [~,pksi] = max(pks);
        thetadom_pre(k,1) = fWelch(1,locs(pksi)+th1-1);
    end
    
    [pks, locs] = findpeaks(pWelch_stim(k,th1:th2));
    if ~isempty(pks)
        [~,pksi] = max(pks);
        thetadom_stim(k,1) = fWelch(1,locs(pksi)+th1-1);
    end
    
    thetashift(k,1) = thetadom_stim(k,1)-thetadom_pre(k,1);
end  

a = 1;
data = [];
for k = 1:size(animalIndex,1)
    if ~isempty(animalIndex{k,1})
        temp = false(size(pWelch_pre,1),1);
        temp(animalIndex{k,1}) = true;
        temp = and(temp,index);
        data(a,:) = mean(thetashift(temp,:));
        a = a+1;
    end
end

thetadom_PRE = thetadom_pre(index);
thetadom_STIM = thetadom_stim(index);
%%
INCcolor = [0 102 255]./255;
figure; hold on
scatter(thetadom_PRE,1:length(thetadom_PRE),120,[0.5 0.5 0.5],'LineWidth',1.2)
scatter(thetadom_STIM,1:length(thetadom_STIM),120,INCcolor,'LineWidth',1.2)

xtick = [5 12];
set(gca,'XLim',[5 12],'LineWidth',1,'Box','off','XTick',xtick,'XTickLabel',arrayfun(@num2str,xtick,'UniformOutput',false))
set(gca,'LineWidth',1,'FontSize',20)
set(gca,'Position',[0.15 0.25 0.2 0.7])

xlabel(gca,{'dominant';'frequency (Hz)'},'FontSize',20)
ylabel(gca,'stim No.','FontSize',20)
%%
thetaSHIFT = thetashift(index);
figure; hold on
scatter(thetaSHIFT,1:length(thetaSHIFT),120,[204 51 255]./255,'LineWidth',1.2)

xtick = [-7 0 7];
set(gca,'XLim',[-7 7],'LineWidth',1,'Box','off','XTick',xtick,'XTickLabel',arrayfun(@num2str,xtick,'UniformOutput',false))
set(gca,'LineWidth',1,'FontSize',20)
set(gca,'Position',[0.15 0.25 0.2 0.7])

line([0 0],[0 30],'LineWidth',1,'Color','k')

xlabel(gca,{'frequency';'shift (Hz)'},'FontSize',20)
ylabel(gca,'stim No.','FontSize',20)

%%
figure; plot(fWelch(1,:),mean(10*log10(pWelch_pre(~thetaindex,:)))); set(gca,'XLim',[1 60])

%% filtered pyramidal eeg, hilbert ampl, phase average; 5-12 Hz, 23-36 Hz, 23-27 Hz, 29-36 Hz + speed?
stim = 1;
select = Select{stim};
stim = Stim{stim};

pretime = 4000;
stimtime = 8000;

% 25 Hz, linear track
[speedmatrix,speedindex,speedindex2,speedindexA,rowdata,stimindexA,stimindexB,...
    pWelch_pre,pWelch_stim,pWelch_post,fWelch,...
    amplT,phaseT,amplB,phaseB,amplS,phaseS,amplB2,phaseB2,eegFilt,lagDiff,THDr,selectIndex] = andor_INCfreemov_STEP5_f1(stim,Arena{2},Freq{4},select,pretime,stimtime);

% 25 Hz, home cage
[speedmatrix_HC,speedindex_HC,speedindex2_HC,speedindexA_HC,rowdata_HC,stimindexA_HC,stimindexB_HC,...
    pWelch_pre_HC,pWelch_stim_HC,pWelch_post_HC,fWelch_HC,...
    amplT_HC,phaseT_HC,amplB_HC,phaseB_HC,amplS_HC,phaseS_HC,amplB2_HC,phaseB2_HC,eegFilt_HC,lagDiff_HC,THDr_HC,selectIndex_HC] = andor_INCfreemov_STEP5_f1(stim,Arena{4},Freq{4},select,pretime,stimtime);
%% get rearing index
[resultPosRot, allPosRot, allPosRotName] = andor_INCfreemov_STEP5_getCSV(rowdata);
allPosRot = allPosRot(~cellfun(@isempty,allPosRot));
allPosRotName = allPosRotName(~cellfun(@isempty,allPosRotName));
allPosYmean = cellfun(@(x) mean(x(:,6)),allPosRot);
posYmean = NaN(size(rowdata,1),1);
for k = 1:size(rowdata,1)
    posYmean(k,1) = allPosYmean(cellfun(@(x) isequal(x,rowdata{k,1}),allPosRotName));
end
rearingindex = false(size(resultPosRot,1),1);
for k = 1:size(resultPosRot,1)
    if resultPosRot{k,1}(speedindexA(k,1),6) > posYmean(k,1) + 0.025
        rearingindex(k,1) = true;
    end
end

%%
figure; hold on
plot(fWelch(1,:),mean(10*log10(pWelch_stim(runpreindex,:))),'Color','b','LineWidth',2)
plot(fWelch(1,:),mean(10*log10(pWelch_stim(stillindex,:))),'Color','k','LineWidth',2)
plot(fWelch(1,:),mean(10*log10(pWelch_stim(and(~runpreindex,~stillindex),:))),'Color','r','LineWidth',2)

plot(fWelch(1,:),mean(10*log10(pWelch_pre(runpreindex,:))),'Color','b','LineStyle','--','LineWidth',2)
plot(fWelch(1,:),mean(10*log10(pWelch_pre(stillindex,:))),'Color','k','LineStyle','--','LineWidth',2)
plot(fWelch(1,:),mean(10*log10(pWelch_pre(and(~runpreindex,~stillindex),:))),'Color','r','LineStyle','--','LineWidth',2)
set(gca,'XLim',[1 60])
%%
figure; hold on
plot(fWelch(1,:),mean(10*log10(pWelch_stim(runstimindex,:))),'Color','b','LineWidth',2)
plot(fWelch(1,:),mean(10*log10(pWelch_stim(runstimlongindex,:))),'Color','g','LineWidth',2)
plot(fWelch(1,:),mean(10*log10(pWelch_stim(~runstimindex,:))),'Color','r','LineWidth',2)

plot(fWelch(1,:),mean(10*log10(pWelch_pre(runstimindex,:))),'Color','b','LineStyle',':','LineWidth',2)
plot(fWelch(1,:),mean(10*log10(pWelch_pre(runstimlongindex,:))),'Color','g','LineStyle',':','LineWidth',2)
plot(fWelch(1,:),mean(10*log10(pWelch_pre(~runstimindex,:))),'Color','r','LineStyle',':','LineWidth',2)
set(gca,'XLim',[1 60])
%%
figure; hold on
plot(fWelch(1,:),mean(10*log10(pWelch_stim(rearingindex,:))),'Color','c','LineWidth',2)
plot(fWelch(1,:),mean(10*log10(pWelch_stim(runpreindex,:))),'Color','r','LineWidth',2)

plot(fWelch(1,:),mean(10*log10(pWelch_pre(rearingindex,:))),'Color','c','LineStyle',':','LineWidth',2)
plot(fWelch(1,:),mean(10*log10(pWelch_pre(runpreindex,:))),'Color','r','LineStyle',':','LineWidth',2)
set(gca,'XLim',[1 60])




