function [animalIndex, rowdata, stimIndex2, csvIndex2, speedmatrix, eegPyrmatrix, eegmatrix, power,  fr, ...powerALL,...
    pWelch_pre, pWelch_stim, pWelch_post, fWelch, pWelchALL_pre, pWelchALL_stim, pWelchALL_post, lagDiff_pre, lagDiff_stimpost, rcor_pre, rcor_stimpost] = andor_INCfreemov_STEP5_eeg(stim,arena,freq,select,welchtime)

WelchWindow = 1000;
WelchNoverlap = 500;
WelchNfft = 2048;

% get pyr channel numbers:
pyrCh(:,1) = {'1868'          ,'1943'       ,'1957'       ,'1985'       ,'2017'          ,'2022A','2022B','2026' ,'2027','2040','2045','2046'};
pyrCh(:,2) = { 4              , 12          , 20          , 7           , 9              , 6     , 23    , 6     , 4    , 11   , 1    , 4    };

% radCh(:,1) = {'1868'          ,'1943'       ,'1957'       ,'1985'       ,'2017'          ,'2022A','2022B','2026' ,'2027','2040','2045','2046'};
% radCh(:,2) = {[5,6,7,8]       ,[14,15]      ,[21,22,23,24],[9,12]       ,[12,14]         ,[]     ,[]     ,[7,8]  ,      ,      ,[3,4] ,      };
% 
% lamCh(:,1) = {'1868'          ,'1943'       ,'1957'       ,'1985'       ,'2017'          ,'2022A','2022B','2026' ,'2027','2040','2045','2046'};
% lamCh(:,2) = {[11,12]         ,[17,18,19,20],[25,26,27,28],[14,15,16,17],[16,17,18,19,20],[]     ,[]     ,[9,10] ,      ,      ,[8,9] ,      };
% 
% molCh(:,1) = {'1868'          ,'1943'       ,'1957'       ,'1985'       ,'2017'          ,'2022A','2022B','2026' ,'2027','2040','2045','2046'};
% molCh(:,2) = {[13,14,15]      ,[22]         ,[31]         ,[19,21]      ,[21,22]         ,[]     ,[]     ,[11,12],      ,      ,      ,      };

% hilCh(:,1) = {'1868'          ,'1943'       ,'1957'       ,'1985'       ,'2017'          ,'2022A','2022B','2026' ,'2027','2040','2045','2046'};
% hilCh(:,2) = {[16,17,18,19,20],[27,28]      ,[]           ,[]           ,[24,25,26]      ,       ,       ,[13,14],      ,      ,[]    ,      };
% 
% badCh(:,1) = {'1868'          ,'1943'       ,'1957'       ,'1985'       ,'2017'          ,'2022A','2022B','2026' ,'2027','2040','2045','2046'};
% badCh(:,2) = {                ,             ,             ,             ,[]              ,       ,       ,[]     ,      ,      ,      , 8    };


% load data
filename = ['INC_res2_' stim '_' arena '_' freq '.mat'];
load(filename);

% remove NAN rows
if ~strcmp(arena,'urethane')
    toremove = false(size(csvIndex,1),1);
    for k = 1:size(csvIndex,1)
        if isempty(speed{k,1})
            toremove(k) = true;
        else
            if all(isnan(speed{k,1}(csvIndex(k,3):csvIndex(k,4))))
                toremove(k) = true;
            end
        end
    end
    speed = speed(~toremove,:);
    speed2 = speed2(~toremove,:);
    pulseIndex = pulseIndex(~toremove,:);
    eeg = eeg(~toremove,:);
    rowInfo = rowInfo(~toremove,:);
    csvIndex = csvIndex(~toremove,:);
    stimIndex = stimIndex(~toremove,:);
end

% select good files
selectindex = false(size(rowInfo,1),1);
for k = 1:length(selectindex)
    temp = NaN(1,numel(select));
    for xx = 1:numel(select)
        a = strfind(rowInfo{k,1},select{xx});
        if ~isempty(a); temp(xx) = a; end
    end
    if any(~isnan(temp)); selectindex(k) = true; end
end


% 1868: remove noisy (above No 28) and bad (2ms stim length: files No 14-22) files
if ismember('1868',select)
    for r = 1:size(rowInfo,1)
        if isequal('1868',rowInfo{r,1}(1:4))
            temp = str2num(rowInfo{r,1}(6:end));
            if temp > 28
                selectindex(r) = false;
            elseif and(temp >= 14, temp <= 22)
                selectindex(r) = false;
            end
        end
    end
end
    

if ~all(~selectindex)
    if ~strcmp(arena,'urethane')
        speed = speed(selectindex,:);
        speed2 = speed2(selectindex,:);
        csvIndex = csvIndex(selectindex,:);
    else
        speed = [];
        speed2 = [];
        csvIndex = [];
    end
    pulseIndex = pulseIndex(selectindex,:);
    eeg = eeg(selectindex,:);
    rowInfo = rowInfo(selectindex,:);
    
    stimIndex = stimIndex(selectindex,:);
    
    % select data only from one animal
    for nn = 1:numel(select)
        T = cellfun(@(x) ~isempty(strfind(x,select{nn})),rowInfo(:,1));
        animalIndex{nn,1} = find(T);
    end
    
    rowdata = rowInfo;
    if ismember('2022',select)
        fileHelp = cellfun(@(x) str2num(x(6:end)),rowInfo(:,1));
    end
    
    %
    if ~strcmp(arena,'urethane')
        ind2max = max(csvIndex(:,2));
    end
    ind2maxEEG = max(stimIndex(:,2));
    csvIndex2 = [];
    stimIndex2 = [];
    for k = 1:size(stimIndex,1)
        % speed
        if ~strcmp(arena,'urethane')
            if csvIndex(k,2)<ind2max
                csvIndex2(k,:) = csvIndex(k,:)+(ind2max-csvIndex(k,2));
            else
                csvIndex2(k,:) = csvIndex(k,:);
            end
        end
        
        % eeg
        if stimIndex(k,2)<ind2maxEEG
            stimIndex2(k,:) = stimIndex(k,:)+(ind2maxEEG-stimIndex(k,2));
        else
            stimIndex2(k,:) = stimIndex(k,:);
        end
    end
    
    % create matrix
    if ~strcmp(arena,'urethane')
        speedmatrix = NaN(size(csvIndex2,1),max(csvIndex2(:,end)));
    else
        speedmatrix = [];
    end
    
    eegPyrmatrix = NaN(size(stimIndex2,1),max(stimIndex2(:,end)));
    eegmatrix{k,1} = NaN(max(stimIndex2(:,end)),size(eeg{k,1},2));
    
    pyrN = NaN(size(eegPyrmatrix,1),1);
    for k =1:size(eegPyrmatrix,1)
        % speed
        if ~strcmp(arena,'urethane')
            temp = speed{k,1};
            if length(temp)>csvIndex2(k,end)-csvIndex2(k,1)
                temp = temp(1:(csvIndex2(k,end)-csvIndex2(k,1)));
            end
            speedmatrix(k,csvIndex2(k,1):csvIndex2(k,end)-1) = temp;
        end
        
        % eeg
        tempeeg = eeg{k,1};
        temprowdata = rowdata{k,1}(1:4);
        if isequal(temprowdata,'2022')
            if fileHelp(k,1) < 25
                temprowdata = [temprowdata 'A'];
            elseif fileHelp(k,1) >= 25
                temprowdata = [temprowdata 'B'];
            end
        end
        pyrN(k,1) = pyrCh{ismember(pyrCh(:,1),temprowdata),2};
        bvar = fir1(2048, 1/(1000/2),'high'); % filter the eeg <1Hz
        tempeeg = filtfilt(bvar,1,tempeeg);
        
        if size(tempeeg,1) > stimIndex2(k,end)-stimIndex2(k,1)+1
            tempeeg = tempeeg(1:(stimIndex2(k,end)-stimIndex2(k,1))+1,:);
        end
        
        tempeegPyr = tempeeg(:,pyrN(k,1));
        eegPyrmatrix(k,stimIndex2(k,1):stimIndex2(k,end)) = tempeegPyr;
        for nn = 1:size(tempeeg,2)
            eegmatrix{k,1}(stimIndex2(k,1):stimIndex2(k,end),nn) = tempeeg(:,nn);
        end
        
        % wavelet (pyramidale)
        [frT, waveT, powerT, scaleT] = wavecall_andor(reshape(tempeegPyr,1,[]), 1000, 'no');
        powerT = bsxfun(@rdivide, powerT, scaleT');
        
        lpTH = knnsearch(frT',250);
        hpTH = knnsearch(frT',1);
        fr(k,:) = frT(lpTH:hpTH);
        
        waveT = waveT(lpTH:hpTH,:);
        powerT = powerT(lpTH:hpTH,:);
        
        power(:,:,k) = NaN(size(powerT,1),size(eegPyrmatrix,2));
        power(:,stimIndex2(k,1):stimIndex2(k,end),k) = powerT;
        
        % wavelet (all)
%         for nn = 1:size(tempeeg,2)
%             tempeegCh = tempeeg(:,nn);
%             [frT, ~, powerT, scaleT] = wavecall_andor(reshape(tempeegCh,1,[]), 1000, 'no');
%             powerT = bsxfun(@rdivide, powerT, scaleT');
%             
%             lpTH = knnsearch(frT',250);
%             hpTH = knnsearch(frT',1);
%             
%             powerT = powerT(lpTH:hpTH,:);
%             
%             powerALL{k,1}(:,:,nn) = NaN(size(powerT,1),size(eegmatrix{k,1},1));
%             powerALL{k,1}(:,stimIndex2(k,1):stimIndex2(k,end),nn) = powerT;
%         end
        
        % welch periodogram (pyramidale)
        [pWelch_pre(k,:), fWelch(k,:)] = pwelch(eegPyrmatrix(k,(stimIndex2(k,3)-welchtime-1):(stimIndex2(k,3)-1)),WelchWindow,WelchNoverlap,WelchNfft,1000);
        [pWelch_stim(k,:), ~] = pwelch(eegPyrmatrix(k,stimIndex2(k,3):stimIndex2(k,4)),WelchWindow,WelchNoverlap,WelchNfft,1000);
        [pWelch_post(k,:), ~] = pwelch(eegPyrmatrix(k,(stimIndex2(k,4)+1):(stimIndex2(k,4)+welchtime+1)),WelchWindow,WelchNoverlap,WelchNfft,1000);
        
        % welch periodogram (all)
        for nn = 1:size(tempeeg,2)
            [pWelchALL_pre(k,:,nn), ~] = pwelch(eegmatrix{k,1}((stimIndex2(k,3)-welchtime-1):(stimIndex2(k,3)-1),nn),WelchWindow,WelchNoverlap,WelchNfft,1000);
            [pWelchALL_stim(k,:,nn), ~] = pwelch(eegmatrix{k,1}(stimIndex2(k,3):stimIndex2(k,4),nn),WelchWindow,WelchNoverlap,WelchNfft,1000);
            [pWelchALL_post(k,:,nn), ~] = pwelch(eegmatrix{k,1}((stimIndex2(k,4)+1):(stimIndex2(k,4)+welchtime+1),nn),WelchWindow,WelchNoverlap,WelchNfft,1000);
        end
        
        % phase lag (for REM detection)
        bvar = fir1(2048,300/(1000/2),'high');
        tempeegREM = filtfilt(bvar,1,tempeeg);
        
        remmatrix = NaN(max(stimIndex2(:,end)),size(eeg{k,1},2));
        for nn = 1:size(tempeegREM,2)
            remmatrix(stimIndex2(k,1):stimIndex2(k,end),nn) = tempeegREM(:,nn);
        end
        
        step = 25;
        stepNo_pre = fix((stimIndex2(k,3)-1)/step);
        stepNo_stimpost = fix((stimIndex2(k,end)-stimIndex2(k,3)+1)/step);
        for nn = 1:size(remmatrix,2)
            for eee = fliplr(1:stepNo_pre)
                if all(~isnan(remmatrix((stimIndex2(k,3)-eee*step):(stimIndex2(k,3)-(eee-1)*step-1),nn)))
                    [acor, lag] = xcorr(remmatrix((stimIndex2(k,3)-eee*step):(stimIndex2(k,3)-(eee-1)*step-1),nn),remmatrix((stimIndex2(k,3)-eee*step):(stimIndex2(k,3)-(eee-1)*step-1),pyrN(k,1)),'coeff');
                    [~, tempI] = max(abs(acor));
                    templag = lag(tempI);
                    lagDiff_pre{k,1}(eee,nn) = max(templag); % reversed order: eee
                    rcor_pre{k,1}(eee,nn) = acor(lag == 0);
                else
                    lagDiff_pre{k,1}(eee,nn) = NaN;
                    rcor_pre{k,1}(eee,nn) = NaN;
                end
            end
        end
        
        for nn = 1:size(remmatrix,2)
            for eee = 1:stepNo_stimpost
                if all(~isnan(remmatrix((stimIndex2(k,3)+(eee-1)*step):(stimIndex2(k,3)+eee*step-1),nn)))
                    [acor, lag] = xcorr(remmatrix((stimIndex2(k,3)+(eee-1)*step):(stimIndex2(k,3)+eee*step-1),nn),remmatrix((stimIndex2(k,3)+(eee-1)*step):(stimIndex2(k,3)+eee*step-1),pyrN(k,1)),'coeff');
                    [~, tempI] = max(abs(acor));
                    templag = lag(tempI);
                    lagDiff_stimpost{k,1}(eee,nn) = max(templag);
                    rcor_stimpost{k,1}(eee,nn) = acor(lag == 0);
                else
                    lagDiff_Stimpost{k,1}(eee,nn) = NaN;
                    rcor_stimpost{k,1}(eee,nn) = NaN;
                end
            end
        end

        
    end
    
    if ~strcmp(arena,'urethane')
        speedindex = csvIndex2(:,3);
        speedindex2 = csvIndex2(:,4);
    else
        speedindex = [];
        speedindex2 = [];
    end
    
    eegindex = stimIndex2(:,3);
    eegindex2 = stimIndex2(:,4);
    
    stimIndexA = stimIndex(:,3);
    stimIndexB = stimIndex(:,4);
    

else
    speedmatrix = [];
    eegPyrmatrix = [];
    speedindex = [];
    speedindex2 = [];
    eegindex = [];
    eegindex2 = [];
    rowdata = [];
    fr = [];
    wave = [];
    power = [];
    scale = [];
    pulseIndex = [];
    eeg = [];
    pyrN = [];
    stimIndexA = [];
    stimIndexB = [];
    posY = []; posX = []; posZ = [];
    rotX = []; rotY = []; rotZ = []; rotW = [];
end