function [pWelchALL_pre, pWelchALL_stim, pWelchALL_post,power,wave,fr,powerPyrD,powerRadD,powerLamD,powerMolD,powerHilD,...
          wavePyrD,waveRadD,waveLamD,waveMolD,waveHilD] = andor_INCfreemov_STEP5_eeg_fast4_allperiodo(stim,arena,freq,select,welchtime)

WelchWindow = 1000;
WelchNoverlap = 500;
WelchNfft = 2048;

% get pyr channel numbers:
pyrCh(:,1) = {'1868'          ,'1943'       ,'1957'       ,'1985'       ,'2017'          ,'2022A','2022B','2026' ,'2027','2040','2045','2046'};
pyrCh(:,2) = { 3              , 12          , 20          , 7           , 8              , 6     , 23    , 5     , 4    , 11   , 1    , 4    };

% radCh(:,1) = {'1868'          ,'1943'       ,'1957'       ,'1985'       ,'2017'          ,'2022A','2022B','2026' ,'2027','2040','2045','2046'};
% radCh(:,2) = {[5,6,7,8]       ,[14,15]      ,[21,22,23,24],[9,12]       ,[12,14]         ,[]     ,[]     ,[7,8]  ,      ,      ,[3,4] ,      };
% 
% lamCh(:,1) = {'1868'          ,'1943'       ,'1957'       ,'1985'       ,'2017'          ,'2022A','2022B','2026' ,'2027','2040','2045','2046'};
% lamCh(:,2) = {[11,12]         ,[17,18,19,20],[25,26,27,28],[14,15,16,17],[16,17,18,19,20],[]     ,[]     ,[9,10] ,      ,      ,[8,9] ,      };
% 
% molCh(:,1) = {'1868'          ,'1943'       ,'1957'       ,'1985'       ,'2017'          ,'2022A','2022B','2026' ,'2027','2040','2045','2046'};
% molCh(:,2) = {[13,14,15]      ,[22]         ,[31]         ,[19,21]      ,[21,22]         ,[]     ,[]     ,[11,12],      ,      ,      ,      };

% hilCh(:,1) = {'1868'          ,'1943'       ,'1957'       ,'1985'       ,'2017'          ,'2022A','2022B','2026' ,'2027','2040','2045','2046'};
% hilCh(:,2) = {[16,17,18,19,20],[27,28]      ,[]           ,[]           ,[24,25,26]      ,       ,       ,[13,14],      ,      ,[]    ,      };
% 
% badCh(:,1) = {'1868'          ,'1943'       ,'1957'       ,'1985'       ,'2017'          ,'2022A','2022B','2026' ,'2027','2040','2045','2046'};
% badCh(:,2) = {                ,             ,             ,             ,[]              ,       ,       ,[]     ,      ,      ,      , 8    };


% load data
filename = ['INC_res2_' stim '_' arena '_' freq '.mat'];
load(filename);

% remove NAN rows
if ~strcmp(arena,'urethane')
    toremove = false(size(csvIndex,1),1);
    for k = 1:size(csvIndex,1)
        if isempty(speed{k,1})
            toremove(k) = true;
        else
            if all(isnan(speed{k,1}(csvIndex(k,3):csvIndex(k,4))))
                toremove(k) = true;
            end
        end
    end
    speed = speed(~toremove,:);
    speed2 = speed2(~toremove,:);
    pulseIndex = pulseIndex(~toremove,:);
    eeg = eeg(~toremove,:);
    rowInfo = rowInfo(~toremove,:);
    csvIndex = csvIndex(~toremove,:);
    stimIndex = stimIndex(~toremove,:);
end

% select good files
selectindex = false(size(rowInfo,1),1);
for k = 1:length(selectindex)
    temp = NaN(1,numel(select));
    for xx = 1:numel(select)
        a = strfind(rowInfo{k,1},select{xx});
        if ~isempty(a); temp(xx) = a; end
    end
    if any(~isnan(temp)); selectindex(k) = true; end
end


% 1868: remove noisy (above No 28) and bad (2ms stim length: files No 14-22) files
if ismember('1868',select)
    for r = 1:size(rowInfo,1)
        if isequal('1868',rowInfo{r,1}(1:4))
            temp = str2num(rowInfo{r,1}(6:end));
            if temp > 28
                selectindex(r) = false;
            elseif and(temp >= 14, temp <= 22)
                selectindex(r) = false;
            end
        end
    end
end
    

if ~all(~selectindex)
    if ~strcmp(arena,'urethane')
        speed = speed(selectindex,:);
        speed2 = speed2(selectindex,:);
        csvIndex = csvIndex(selectindex,:);
    else
        speed = [];
        speed2 = [];
        csvIndex = [];
    end
    pulseIndex = pulseIndex(selectindex,:);
    eeg = eeg(selectindex,:);
    rowInfo = rowInfo(selectindex,:);
    
    stimIndex = stimIndex(selectindex,:);
    
    % select data only from one animal
    for nn = 1:numel(select)
        T = cellfun(@(x) ~isempty(strfind(x,select{nn})),rowInfo(:,1));
        animalIndex{nn,1} = find(T);
    end
    
    rowdata = rowInfo;
    if ismember('2022',select)
        fileHelp = cellfun(@(x) str2num(x(6:end)),rowInfo(:,1));
    end
    
    %
    if ~strcmp(arena,'urethane')
        ind2max = max(csvIndex(:,2));
    end
    ind2maxEEG = max(stimIndex(:,2));
    csvIndex2 = [];
    stimIndex2 = [];
    for k = 1:size(stimIndex,1)
        % speed
        if ~strcmp(arena,'urethane')
            if csvIndex(k,2)<ind2max
                csvIndex2(k,:) = csvIndex(k,:)+(ind2max-csvIndex(k,2));
            else
                csvIndex2(k,:) = csvIndex(k,:);
            end
        end
        
        % eeg
        if stimIndex(k,2)<ind2maxEEG
            stimIndex2(k,:) = stimIndex(k,:)+(ind2maxEEG-stimIndex(k,2));
        else
            stimIndex2(k,:) = stimIndex(k,:);
        end
    end
    
    % create matrix
    if ~strcmp(arena,'urethane')
        speedmatrix = NaN(size(csvIndex2,1),max(csvIndex2(:,end)));
    else
        speedmatrix = [];
    end
    
    eegPyrmatrix = NaN(size(stimIndex2,1),max(stimIndex2(:,end)));
   
    pyrN = NaN(size(eegPyrmatrix,1),1);
    for k =1:size(eegPyrmatrix,1)
         eegmatrix{k,1} = NaN(max(stimIndex2(:,end)),size(eeg{k,1},2));
    
        % speed
        if ~strcmp(arena,'urethane')
            temp = speed{k,1};
            if length(temp)>csvIndex2(k,end)-csvIndex2(k,1)
                temp = temp(1:(csvIndex2(k,end)-csvIndex2(k,1)));
            end
            speedmatrix(k,csvIndex2(k,1):csvIndex2(k,end)-1) = temp;
        end
        
        % eeg
        tempeeg = eeg{k,1};
        temprowdata = rowdata{k,1}(1:4);
        if isequal(temprowdata,'2022')
            if fileHelp(k,1) < 25
                temprowdata = [temprowdata 'A'];
            elseif fileHelp(k,1) >= 25
                temprowdata = [temprowdata 'B'];
            end
        end
        pyrN(k,1) = pyrCh{ismember(pyrCh(:,1),temprowdata),2};
        bvar = fir1(2048, 1/(1000/2),'high'); % filter the eeg <1Hz
        tempeeg = filtfilt(bvar,1,tempeeg);
        
        if size(tempeeg,1) > stimIndex2(k,end)-stimIndex2(k,1)+1
            tempeeg = tempeeg(1:(stimIndex2(k,end)-stimIndex2(k,1))+1,:);
        end
        
        tempeegPyr = tempeeg(:,pyrN(k,1));
        eegPyrmatrix(k,stimIndex2(k,1):stimIndex2(k,end)) = tempeegPyr;
        for nn = 1:size(tempeeg,2)
            eegmatrix{k,1}(stimIndex2(k,1):stimIndex2(k,end),nn) = tempeeg(:,nn);
        end
        
        % wavelet of non-modified pyr eeg
        [frT, waveT, powerT, scaleT] = wavecall_andor(reshape(tempeegPyr,1,[]), 1000, 'no');
        powerT = bsxfun(@rdivide, powerT, scaleT');
        
        lpTH = knnsearch(frT',250);
        hpTH = knnsearch(frT',1);
        fr(k,:) = frT(lpTH:hpTH);
        
        waveT = waveT(lpTH:hpTH,:);
        powerT = powerT(lpTH:hpTH,:);
        
        power(:,:,k) = NaN(size(powerT,1),size(eegPyrmatrix,2));
        power(:,stimIndex2(k,1):stimIndex2(k,end),k) = powerT;
        
        wave(:,:,k) = NaN(size(waveT,1),size(eegPyrmatrix,2));
        wave(:,stimIndex2(k,1):stimIndex2(k,end),k) = waveT;
        
        
        % pwelch for all channels (csd)
        if isequal(temprowdata,'2017')
            badCh =    [ 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 1, 0, 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0];
            distance =   [50,50,50,100  ,50,50,50,50,100,  100,  100,  50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50];
            
            goodCh =   [ 1, 2, 3, 4, 5, 6, 7, 8, 9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32];
        elseif isequal(temprowdata,'2026')
            badCh =    [   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0];
            distance =     [100,100,100,100,100,100,100,100,100,100,100,100,100,100,100];
            goodCh =   [   1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15, 16];
        elseif isequal(temprowdata,'2046')
            badCh =    [   0,  0,  0,  0,  0,  0,  0,  1,  0,  0,  0,  0,  0,  0,  0,  0];
            distance =     [100,100,100,100,100,100,200    ,100,100,100,100,100,100,100];
            goodCh =   [   1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15, 16];
        elseif isequal(temprowdata,'2027')
            badCh =    [   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0];
            distance =     [100,100,100,100,100,100,100,100,100,100,100,100,100,100,100];
            goodCh =   [   1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15, 16];
        elseif isequal(temprowdata,'1868')
            badCh =    [ 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1, 1, 1];
            distance =   [50,50,50,50,50,100  ,50,50,50,50,50,50,50,50,50,50,100  ,50,50,50,50,50,50,50,100];
            goodCh =   [ 1, 2, 3, 4, 5, 6, 7, 8, 9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32];
        end
        
%         eegA = eegmatrix{k,1};
%         eegA = eegA(:,~badCh);
%         eegmatrixDERIV{k,1} = NaN(max(stimIndex2(:,end)),size(eegA,2));
% 
%         eegmatrixDERIV{k,1}(stimIndex2(k,1):stimIndex2(k,end),:) = andor_CSDnotrig(eegA(stimIndex2(k,1):stimIndex2(k,end),:),1000,distance);
%         
        
        eegA = tempeeg(:,~badCh);
        eegDERIV = andor_CSDnotrig(eegA,1000,distance);
        
        for nn = 1:size(eegA,2)
            if or(nn == 1, nn == size(eegA,2))
                pWelchALL_pre(k,:,nn) = NaN(1025,1);
                pWelchALL_stim(k,:,nn) = NaN(1025,1);
                pWelchALL_post(k,:,nn) = NaN(1025,1);
            else
                if (stimIndex(k,3) - welchtime - 1) > 0
                    [pWelchALL_pre(k,:,nn), ~] = pwelch(eegDERIV((stimIndex(k,3)-welchtime-1):(stimIndex(k,3)-1),nn),WelchWindow,WelchNoverlap,WelchNfft,1000);
                    [pWelchALL_stim(k,:,nn), ~] = pwelch(eegDERIV(stimIndex(k,3):stimIndex(k,4),nn),WelchWindow,WelchNoverlap,WelchNfft,1000);
                    [pWelchALL_post(k,:,nn), ~] = pwelch(eegDERIV((stimIndex(k,4)+1):(stimIndex(k,4)+welchtime+1),nn),WelchWindow,WelchNoverlap,WelchNfft,1000);
                else
                    pWelchALL_pre(k,:,nn) = NaN(1025,1);
                    pWelchALL_stim(k,:,nn) = NaN(1025,1);
                    pWelchALL_post(k,:,nn) = NaN(1025,1);
                end
            end
        end
        
        % select 1 channel for pyr, rad, lam, mol, hil from eegDERIV
        if isequal(temprowdata,'2017')
            pyrDERIV = eegDERIV(:,7);
            radDERIV = eegDERIV(:,10);
            lamDERIV = eegDERIV(:,14);
            molDERIV = eegDERIV(:,18);
            hilDERIV = eegDERIV(:,21);
        elseif isequal(temprowdata,'2026')
            pyrDERIV = eegDERIV(:,5);
            radDERIV = eegDERIV(:,7);
            lamDERIV = eegDERIV(:,10);
            molDERIV = eegDERIV(:,12);
            hilDERIV = eegDERIV(:,14);
        elseif isequal(temprowdata,'2046')
            pyrDERIV = eegDERIV(:,4);
            radDERIV = eegDERIV(:,6);
            lamDERIV = eegDERIV(:,8);
            molDERIV = eegDERIV(:,10);
            hilDERIV = eegDERIV(:,11);
        elseif isequal(temprowdata,'2027')
            pyrDERIV = eegDERIV(:,4);
            radDERIV = eegDERIV(:,6);
            lamDERIV = eegDERIV(:,8);
            molDERIV = eegDERIV(:,10);
            hilDERIV = eegDERIV(:,11);
        elseif isequal(temprowdata,'1868')
            pyrDERIV = eegDERIV(:,3);
            radDERIV = eegDERIV(:,6);
            lamDERIV = eegDERIV(:,10);
            molDERIV = eegDERIV(:,13);
            hilDERIV = eegDERIV(:,16);
        end
        
        % wavelet for eegDERIV pyramidale
        [frT, waveT, powerT, scaleT] = wavecall_andor(reshape(pyrDERIV,1,[]), 1000, 'no');
        powerT = bsxfun(@rdivide, powerT, scaleT');
        
        lpTH = knnsearch(frT',250);
        hpTH = knnsearch(frT',1);
        
        waveT = waveT(lpTH:hpTH,:);
        powerT = powerT(lpTH:hpTH,:);
        
        powerPyrD(:,:,k) = NaN(size(powerT,1),size(eegPyrmatrix,2));
        powerPyrD(:,stimIndex2(k,1):stimIndex2(k,end),k) = powerT;
        
        wavePyrD(:,:,k) = NaN(size(waveT,1),size(eegPyrmatrix,2));
        wavePyrD(:,stimIndex2(k,1):stimIndex2(k,end),k) = waveT;
        
        % wavelet for eegDERIV radiatum
        [frT, waveT, powerT, scaleT] = wavecall_andor(reshape(radDERIV,1,[]), 1000, 'no');
        powerT = bsxfun(@rdivide, powerT, scaleT');
        
        lpTH = knnsearch(frT',250);
        hpTH = knnsearch(frT',1);
        
        waveT = waveT(lpTH:hpTH,:);
        powerT = powerT(lpTH:hpTH,:);
        
        powerRadD(:,:,k) = NaN(size(powerT,1),size(eegPyrmatrix,2));
        powerRadD(:,stimIndex2(k,1):stimIndex2(k,end),k) = powerT;
        
        waveRadD(:,:,k) = NaN(size(waveT,1),size(eegPyrmatrix,2));
        waveRadD(:,stimIndex2(k,1):stimIndex2(k,end),k) = waveT;
        
        % wavelet for eegDERIV lac-mol
        [frT, waveT, powerT, scaleT] = wavecall_andor(reshape(lamDERIV,1,[]), 1000, 'no');
        powerT = bsxfun(@rdivide, powerT, scaleT');
        
        lpTH = knnsearch(frT',250);
        hpTH = knnsearch(frT',1);
        
        waveT = waveT(lpTH:hpTH,:);
        powerT = powerT(lpTH:hpTH,:);
        
        powerLamD(:,:,k) = NaN(size(powerT,1),size(eegPyrmatrix,2));
        powerLamD(:,stimIndex2(k,1):stimIndex2(k,end),k) = powerT;
        
        waveLamD(:,:,k) = NaN(size(waveT,1),size(eegPyrmatrix,2));
        waveLamD(:,stimIndex2(k,1):stimIndex2(k,end),k) = waveT;
        
        % wavelet for eegDERIV moleculare
        [frT, waveT, powerT, scaleT] = wavecall_andor(reshape(molDERIV,1,[]), 1000, 'no');
        powerT = bsxfun(@rdivide, powerT, scaleT');
        
        lpTH = knnsearch(frT',250);
        hpTH = knnsearch(frT',1);
        
        waveT = waveT(lpTH:hpTH,:);
        powerT = powerT(lpTH:hpTH,:);
        
        powerMolD(:,:,k) = NaN(size(powerT,1),size(eegPyrmatrix,2));
        powerMolD(:,stimIndex2(k,1):stimIndex2(k,end),k) = powerT;
        
        waveMolD(:,:,k) = NaN(size(waveT,1),size(eegPyrmatrix,2));
        waveMolD(:,stimIndex2(k,1):stimIndex2(k,end),k) = waveT;
        
        % wavelet for eegDERIV hilus
        [frT, waveT, powerT, scaleT] = wavecall_andor(reshape(hilDERIV,1,[]), 1000, 'no');
        powerT = bsxfun(@rdivide, powerT, scaleT');
        
        lpTH = knnsearch(frT',250);
        hpTH = knnsearch(frT',1);
        
        waveT = waveT(lpTH:hpTH,:);
        powerT = powerT(lpTH:hpTH,:);
        
        powerHilD(:,:,k) = NaN(size(powerT,1),size(eegPyrmatrix,2));
        powerHilD(:,stimIndex2(k,1):stimIndex2(k,end),k) = powerT;
        
        waveHilD(:,:,k) = NaN(size(waveT,1),size(eegPyrmatrix,2));
        waveHilD(:,stimIndex2(k,1):stimIndex2(k,end),k) = waveT;
        
        
      
    end
    

else
    
end