function [csvSample,csvIndex,csvIndexREL,...
          eegSample,stimIndex,stimIndexREL,stimIndexDS,stimIndexRELDS,...
          pulseSample,pulseSampleDS,pulseSampleRELDS,...
          channelOrder] = andor_INCfreemov_getSamples(filename,datfileName,metafileName,XLS,epochStart,epochEnd,startloc,camS,data);

extraWINDOW = 2;
samplingRate = 20000;
extraWINDOW = extraWINDOW*samplingRate;

downSamplingRate = 1000;
% get row number from XLS.file
row = find(strcmp(XLS.file,filename));

type = XLS.type{row};

probe = XLS.elphys{row}.probe;
connector = XLS.elphys{row}.connector;
headstage = XLS.elphys{row}.headstage;

direction = XLS.elphys{row}.direction;

stimMode = XLS.accessory{row}.stimMode;
stimPower = XLS.accessory{row}.stimPower;
stimType = XLS.accessory{row}.stimType;

frame = XLS.motive{row}.frame;

% get arena borders

% get first and last good frame

% load eeg
channelOrder = andor_channelOrder(headstage,connector,probe,direction);
eeg = memmapfile(datfileName,'Format', 'int16');
if ~isempty(andor_metafile(metafileName, 'recorded channel'))
    eeg = reshape(eeg.Data, andor_metafile(metafileName, 'recorded channel'), [])';
    
    
    % stim borders
    if ~isempty(epochStart{row,1})
        
        stimNo = length(epochStart{row,1});
        
        for k = 1:stimNo
            preBlueSTART(k,1) = epochStart{row,1}(k)-1-(epochEnd{row,1}(k)-epochStart{row,1}(k))-extraWINDOW;
            preBlueEND(k,1) = epochStart{row,1}(k)-1;
            
            BlueSTART(k,1) = epochStart{row,1}(k);
            BlueEND(k,1) = epochEnd{row,1}(k);
            
            postBlueSTART(k,1) = epochEnd{row,1}(k)+1;
            postBlueEND(k,1) = epochEnd{row,1}(k)+1+(epochEnd{row,1}(k)-epochStart{row,1}(k))+extraWINDOW;
        end
        for k = 1:stimNo
            if preBlueSTART(k,1) < 1; preBlueSTART(k,1) = 1; end
            if k>1; if preBlueSTART(k,1)<=BlueEND(k-1,1); preBlueSTART(k,1) = BlueEND(k-1,1)+1; end; end
            if postBlueEND(k,1)>size(eeg,1); postBlueEND(k,1) = size(eeg,1); end
            if k<stimNo; if postBlueEND(k,1)>=BlueSTART(k+1,1); postBlueEND(k,1) = BlueSTART(k+1,1)-1; end; end
        end
        
        stimIndex = [preBlueSTART,preBlueEND,BlueSTART,BlueEND,postBlueSTART,postBlueEND];
        stimIndexREL = bsxfun(@minus,stimIndex,stimIndex(:,1))+1;
        
        stimIndexDS(:,1) = ceil(stimIndex(:,1)./(samplingRate/downSamplingRate));
        stimIndexDS(:,2) = fix(stimIndex(:,2)./(samplingRate/downSamplingRate));
        stimIndexDS(:,3) = ceil(stimIndex(:,3)./(samplingRate/downSamplingRate));
        stimIndexDS(:,4) = fix(stimIndex(:,4)./(samplingRate/downSamplingRate));
        stimIndexDS(:,5) = ceil(stimIndex(:,5)./(samplingRate/downSamplingRate));
        stimIndexDS(:,6) = fix(stimIndex(:,6)./(samplingRate/downSamplingRate));
        
        stimIndexRELDS = bsxfun(@minus,stimIndexDS,stimIndexDS(:,1))+1;
        
        pulses = round(startloc{row,1});
        for k = 1:stimNo
            pulseSample{k,1} = pulses(and(pulses>=BlueSTART(k,1),pulses<=BlueEND(k,1)));
            pulseSampleDS{k,1} = pulseSample{k,1}./(samplingRate/downSamplingRate);
            pulseSampleRELDS{k,1} = pulseSampleDS{k,1}-stimIndexDS(k,3)+1;
        end
        
        for k = 1:size(stimIndex,1)
            for kk = 1:size(channelOrder,1)
                eegSample{k,kk} = eeg(stimIndex(k,1):stimIndex(k,6),channelOrder{kk,2});
                eegSample{k,kk} = resample(double(eegSample{k,kk}),downSamplingRate,samplingRate);
            end
        end
        
        if ~isempty(camS{row,1})
            if ~isempty(data{row,1})
                for k = 1:size(stimIndex,1)
                    
                    tempCamS = round(camS{row,1}/(samplingRate/downSamplingRate));
                    
                    if ~isempty(find(and(tempCamS>=stimIndexDS(k,1),tempCamS<stimIndexDS(k,2)),1))
                        csvIndex(k,1) = find(and(tempCamS>=stimIndexDS(k,1),tempCamS<stimIndexDS(k,2)),1);
                        csvIndex(k,2) = find(and(tempCamS>=stimIndexDS(k,1),tempCamS<stimIndexDS(k,2)),1,'last');
                        csvIndex(k,3) = find(and(tempCamS>=stimIndexDS(k,3),tempCamS<stimIndexDS(k,4)),1);
                        csvIndex(k,4) = find(and(tempCamS>=stimIndexDS(k,3),tempCamS<stimIndexDS(k,4)),1,'last');
                        csvIndex(k,5) = find(and(tempCamS>=stimIndexDS(k,5),tempCamS<stimIndexDS(k,6)),1);
                        csvIndex(k,6) = find(and(tempCamS>=stimIndexDS(k,5),tempCamS<stimIndexDS(k,6)),1,'last');
                        
                        csvSample{k,1} = data{row,1}(csvIndex(k,1):csvIndex(k,6),:);
                    else
                        csvIndex(k,:) = NaN(1,6);
                        csvSample{k,1} = NaN(1,1);
                    end
                end
                csvIndexREL = bsxfun(@minus,csvIndex,csvIndex(:,1))+1;
            else
                csvIndex = [];
                csvSample = [];
                csvIndexREL=[];
            end
        else
            csvIndex = [];
            csvSample = [];
            csvIndexREL=[];
        end
    else
        pulseSample = [];
        pulseSampleDS = [];
        pulseSampleRELDS = [];
        csvIndex = [];
        csvSample = [];
        csvIndexREL=[];
        eegSample = [];
        stimIndex = [];
        stimIndexREL=[];
        stimIndexDS=[];
        stimIndexRELDS=[]; 
    end
else
    pulseSample = [];
    pulseSampleDS = [];
    pulseSampleRELDS = [];
    csvIndex = [];
    csvSample = [];
    csvIndexREL=[];
    eegSample = [];
    stimIndex = [];
    stimIndexREL=[];
    stimIndexDS=[];
    stimIndexRELDS=[];
end




