function [csvSample,csvIndex,csvIndexREL,...
    eegSample,stimIndex,stimIndexREL,stimIndexDS,stimIndexRELDS,...
    pulseSample,pulseSampleDS,pulseSampleRELDS,...
    channelOrder] = andor_INCfreemov_getSamples_for1868(filename,datfileName,metafileName,XLS,epochStart,epochEnd,startloc,camS,data);

extraWINDOW = 2;
samplingRate = 20000;
extraWINDOW = extraWINDOW*samplingRate;

downSamplingRate = 1000;
% get row number from XLS.file
row = find(strcmp(XLS.file,filename));

type = XLS.type{row};

probe = XLS.elphys{row}.probe;
connector = XLS.elphys{row}.connector;
headstage = XLS.elphys{row}.headstage;

direction = XLS.elphys{row}.direction;

stimMode = XLS.accessory{row}.stimMode;
stimPower = XLS.accessory{row}.stimPower;
stimType = XLS.accessory{row}.stimType;

frame = XLS.motive{row}.frame;

% get arena borders

% get first and last good frame

% load eeg
channelOrder = andor_channelOrder(headstage,connector,probe,direction);
eeg = memmapfile(datfileName,'Format', 'int16');
if ~isempty(andor_metafile(metafileName, 'recorded channel'))
    eeg = reshape(eeg.Data, andor_metafile(metafileName, 'recorded channel'), [])';
    
    % stim borders
    for kk = 1:size(epochStart,2)
        if ~isempty(epochStart{row,kk})
            
            stimNo = length(epochStart{row,kk});
            
            for k = 1:stimNo
                preBlueSTART{kk,1}(k,1) = epochStart{row,kk}(k)-1-(epochEnd{row,kk}(k)-epochStart{row,kk}(k))-extraWINDOW;
                preBlueEND{kk,1}(k,1) = epochStart{row,kk}(k)-1;
                
                BlueSTART{kk,1}(k,1) = epochStart{row,kk}(k);
                BlueEND{kk,1}(k,1) = epochEnd{row,kk}(k);
                
                postBlueSTART{kk,1}(k,1) = epochEnd{row,kk}(k)+1;
                postBlueEND{kk,1}(k,1) = epochEnd{row,kk}(k)+1+(epochEnd{row,kk}(k)-epochStart{row,kk}(k))+extraWINDOW;
            end
            
            for k = 1:stimNo
                if preBlueSTART{kk,1}(k,1) < 1; preBlueSTART{kk,1}(k,1) = 1; end
                if k>1; if preBlueSTART{kk,1}(k,1)<=BlueEND{kk,1}(k-1,1); preBlueSTART{kk,1}(k,1) = BlueEND{kk,1}(k-1,1)+1; end; end
                if postBlueEND{kk,1}(k,1)>size(eeg,1); postBlueEND{kk,1}(k,1) = size(eeg,1); end
                if k<stimNo; if postBlueEND{kk,1}(k,1)>=BlueSTART{kk,1}(k+1,1); postBlueEND{kk,1}(k,1) = BlueSTART{kk,1}(k+1,1)-1; end; end
            end
        end
    end
    
    for kk = 1:size(epochStart,2)
        if ~isempty(epochStart{row,kk})
            
            stimNo = length(epochStart{row,kk});
            for k = 1:stimNo
                tempBlueEND = BlueEND;%
                tempBlueEND{kk,1} = [];
                tempBlueEND = cell2mat(tempBlueEND);
                tempBlueEND(tempBlueEND>=BlueSTART{kk,1}(k,1)) = [];
                tempBlueEND(tempBlueEND<preBlueSTART{kk,1}(k,1)) = [];
                if ~isempty(tempBlueEND)
                    if preBlueSTART{kk,1}(k,1)<=max(tempBlueEND); preBlueSTART{kk,1}(k,1) = max(tempBlueEND)+1; end
                end
            end
            for k = 1:stimNo
                tempBlueSTART = BlueSTART;%
                tempBlueSTART{kk,1} = [];
                tempBlueSTART = cell2mat(tempBlueSTART);
                tempBlueSTART(tempBlueSTART<=BlueEND{kk,1}(k,1)) = [];
                tempBlueSTART(tempBlueSTART>postBlueEND{kk,1}(k,1)) = [];
                if ~isempty(tempBlueSTART)
                    if postBlueEND{kk,1}(k,1)>=min(tempBlueSTART); postBlueEND{kk,1}(k,1) = min(tempBlueSTART)-1; end
                end
            end
        end
    end
    
    for kk = 1:size(epochStart,2)
        if ~isempty(epochStart{row,kk})
            stimIndex{kk,1} = [preBlueSTART{kk,1},preBlueEND{kk,1},BlueSTART{kk,1},BlueEND{kk,1},postBlueSTART{kk,1},postBlueEND{kk,1}];
            %
            stimIndexREL{kk,1} = bsxfun(@minus,stimIndex{kk,1},stimIndex{kk,1}(:,1))+1;
            
            stimIndexDS{kk,1}(:,1) = ceil(stimIndex{kk,1}(:,1)./(samplingRate/downSamplingRate));
            stimIndexDS{kk,1}(:,2) = fix(stimIndex{kk,1}(:,2)./(samplingRate/downSamplingRate));
            stimIndexDS{kk,1}(:,3) = ceil(stimIndex{kk,1}(:,3)./(samplingRate/downSamplingRate));
            stimIndexDS{kk,1}(:,4) = fix(stimIndex{kk,1}(:,4)./(samplingRate/downSamplingRate));
            stimIndexDS{kk,1}(:,5) = ceil(stimIndex{kk,1}(:,5)./(samplingRate/downSamplingRate));
            stimIndexDS{kk,1}(:,6) = fix(stimIndex{kk,1}(:,6)./(samplingRate/downSamplingRate));
            
            stimIndexRELDS{kk,1} = bsxfun(@minus,stimIndexDS{kk,1},stimIndexDS{kk,1}(:,1))+1;
            
            pulses{kk,1} = round(startloc{row,kk});
            stimNo = length(epochStart{row,kk});
            for k = 1:stimNo
                pulseSample{kk,1}{k,1} = pulses{kk,1}(and(pulses{kk,1}>=BlueSTART{kk,1}(k,1),pulses{kk,1}<=BlueEND{kk,1}(k,1)));
                pulseSampleDS{kk,1}{k,1} = pulseSample{kk,1}{k,1}./(samplingRate/downSamplingRate);
                pulseSampleRELDS{kk,1}{k,1} = pulseSampleDS{kk,1}{k,1}-stimIndexDS{kk,1}(k,3)+1;
            end
            
            for k = 1:size(stimIndex{kk,1},1)
                for kkk = 1:size(channelOrder,1)
                    eegSample{kk,1}{k,kkk} = eeg(stimIndex{kk,1}(k,1):stimIndex{kk,1}(k,6),channelOrder{kkk,2});
                    eegSample{kk,1}{k,kkk} = resample(double(eegSample{kk,1}{k,kkk}),downSamplingRate,samplingRate);
                end
            end
            
            if ~isempty(camS{row,1})
                if ~isempty(data{row,1})
                    for k = 1:size(stimIndex{kk,1},1)
                        
                        tempCamS = round(camS{row,1}/(samplingRate/downSamplingRate));
                        
                        if ~isempty(find(and(tempCamS>=stimIndexDS{kk,1}(k,1),tempCamS<stimIndexDS{kk,1}(k,2)),1))
                            csvIndex{kk,1}(k,1) = find(and(tempCamS>=stimIndexDS{kk,1}(k,1),tempCamS<stimIndexDS{kk,1}(k,2)),1);
                            csvIndex{kk,1}(k,2) = find(and(tempCamS>=stimIndexDS{kk,1}(k,1),tempCamS<stimIndexDS{kk,1}(k,2)),1,'last');
                            csvIndex{kk,1}(k,3) = find(and(tempCamS>=stimIndexDS{kk,1}(k,3),tempCamS<stimIndexDS{kk,1}(k,4)),1);
                            csvIndex{kk,1}(k,4) = find(and(tempCamS>=stimIndexDS{kk,1}(k,3),tempCamS<stimIndexDS{kk,1}(k,4)),1,'last');
                            csvIndex{kk,1}(k,5) = find(and(tempCamS>=stimIndexDS{kk,1}(k,5),tempCamS<stimIndexDS{kk,1}(k,6)),1);
                            csvIndex{kk,1}(k,6) = find(and(tempCamS>=stimIndexDS{kk,1}(k,5),tempCamS<stimIndexDS{kk,1}(k,6)),1,'last');
                            
                            csvSample{kk,1}{k,1} = data{row,1}(csvIndex{kk,1}(k,1):csvIndex{kk,1}(k,6),:);
                        else
                            csvIndex{kk,1}(k,:) = NaN(1,6);
                            csvSample{kk,1}{k,1} = NaN(1,1);
                        end
                    end
                    csvIndexREL{kk,1} = bsxfun(@minus,csvIndex{kk,1},csvIndex{kk,1}(:,1))+1;
                    
                else
                    csvIndex{kk,1} = [];
                    csvSample{kk,1} = [];
                    csvIndexREL{kk,1} = [];
                end
            else
                csvIndex{kk,1} = [];
                csvSample{kk,1} = [];
                csvIndexREL{kk,1} = [];
            end
        else
            pulseSample{kk,1} = [];
            pulseSampleDS{kk,1} = [];
            pulseSampleRELDS{kk,1} = [];
            csvIndex{kk,1} = [];
            csvSample{kk,1} = [];
            csvIndexREL{kk,1}=[];
            eegSample{kk,1} = [];
            stimIndex{kk,1} = [];
            stimIndexREL{kk,1}=[];
            stimIndexDS{kk,1}=[];
            stimIndexRELDS{kk,1}=[];
        end
    end
end




