function [eegSample,channelOrder] = andor_INCfreemov_getSamples_repair(filename,datfileName,metafileName,XLS,epochStart,stimIndex);

samplingRate = 20000;
downSamplingRate = 1000;

% get row number from XLS.file
row = find(strcmp(XLS.file,filename));

% load eeg
channelOrder = andor_channelOrder(XLS.elphys{row}.headstage,XLS.elphys{row}.connector,XLS.elphys{row}.probe,XLS.elphys{row}.direction);
eeg = memmapfile(datfileName,'Format', 'int16');
if ~isempty(andor_metafile(metafileName, 'recorded channel'))
    eeg = reshape(eeg.Data, andor_metafile(metafileName, 'recorded channel'), [])';
    if ~isempty(epochStart{row,1})
        for k = 1:size(stimIndex,1)
            for kk = 1:size(channelOrder,1)
                eegSample{k,kk} = eeg(stimIndex(k,1):stimIndex(k,6),channelOrder{kk,2});
                eegSample{k,kk} = resample(double(eegSample{k,kk}),downSamplingRate,samplingRate);
            end
        end
    else
        eegSample = [];
    end
else
    eegSample = [];
end




