Experiment = {'1868','1943','1957','1985','2017','2022','2026','2027','2040','2045','2046'};
Stim = {'INC','INCAlu','SEPTUM','SEPTUMAlu','BLIND'};
Arena = {'homeCage','linearTrack','newBox','holeBox','urethane'};
Freq = {'f1Hz','f5Hz','f10Hz','f15Hz','f25Hz','f30Hz','f50Hz','TH3_20_5','TH3_25_5','TH3_50_5','TH5_50_5','TH3_50_10'};

for ee = 1:numel(Experiment)
    S{ee} = load(['INC_res1_' Experiment{ee} '.mat']);
end 

for ss = 1:numel(Stim)
    for aa  = 1:numel(Arena)
        for ff = 1:numel(Freq)
            stim = Stim{ss};
            arena = Arena{aa};
            freq = Freq{ff};
            csvIndex = [];
            speed = [];%3D, SG-filtered
            speed2 = []; %2D
            rowInfo = [];
            eeg = [];
            stimIndex = [];
            pulseIndex = [];
            for ee = 1:numel(Experiment)
                
                csvIndex = [csvIndex; S{ee}.result.(stim).(arena).(freq).csvIndex];
                speed = [speed; S{ee}.result.(stim).(arena).(freq).speed];
                speed2 = [speed2; S{ee}.result.(stim).(arena).(freq).speed2];
                temprowInfo = S{ee}.result.(stim).(arena).(freq).rowInfo;
                if size(temprowInfo,2) == 3;
                    temprowInfo = [temprowInfo cell(size(temprowInfo,1),1)];
                end
                rowInfo = [rowInfo; temprowInfo];
                eeg = [eeg; S{ee}.result.(stim).(arena).(freq).eeg];
                stimIndex = [stimIndex; S{ee}.result.(stim).(arena).(freq).stimIndex];
                pulseIndex = [pulseIndex; S{ee}.result.(stim).(arena).(freq).pulseIndex];
            end
            save(['INC_res2_' stim '_' arena '_' freq],'csvIndex','speed','speed2','rowInfo','eeg','stimIndex','pulseIndex','-v7.3')
        end
    end
end
%% BAD FILES
%% INC holeBox 5Hz: 1985_28: bad motive file (6,:)
X=6;
rowInfo(X,:) = [];
eeg(X,:) = [];
pulseIndex(X,:) = [];
stimIndex(X,:) = [];
%% INC holeBox 10Hz: 1985_28: bad motive file (5,:)
X=5;
rowInfo(X,:) = [];
eeg(X,:) = [];
pulseIndex(X,:) = [];
stimIndex(X,:) = [];
%% INC holeBox 50Hz: 1985_28 (3,:)
X=3;
rowInfo(X,:) = [];
eeg(X,:) = [];
pulseIndex(X,:) = [];
stimIndex(X,:) = [];
csvIndex(X,:) = [];
speed(X,:) = [];
speed2(X,:) = [];
%% INC urethane 5Hz: 2045_51: urethane + video (5,:)
csvIndex = [NaN(4,6); csvIndex; NaN(6,6)];
speed = [cell(4,1); speed; cell(6,1)];
speed2 = [cell(4,1); speed2; cell(6,1)];
%% INC urethane 15Hz: 2045_51 (14:19,:)
csvIndex = [NaN(13,6); csvIndex; NaN(10,6)];
speed = [cell(13,1); speed; cell(10,1)];
speed2 = [cell(13,1); speed2; cell(10,1)];
%% INC urethane 25Hz: 2045_51 (86:99,:)
csvIndex = [NaN(85,6); csvIndex; NaN(30,6)];
speed = [cell(85,1); speed; cell(30,1)];
speed2 = [cell(85,1); speed2; cell(30,1)];
%% INC urethane 50Hz: 2045_51 (47:54,:)
csvIndex = [NaN(46,6); csvIndex; NaN(17,6)];
speed = [cell(46,1); speed; cell(17,1)];
speed2 = [cell(46,1); speed2; cell(17,1)];
%% INC urethane TH3_25_5: 2045_51 (7:9,:)
csvIndex = [NaN(6,6); csvIndex; NaN(5,6)];
speed = [cell(6,1); speed; cell(5,1)];
speed2 = [cell(6,1); speed2; cell(5,1)];
%% INC urethane TH3_50_5: 2045_51 (6,:)
csvIndex = [NaN(5,6); csvIndex; NaN(8,6)];
speed = [cell(5,1); speed; cell(8,1)];
speed2 = [cell(5,1); speed2; cell(8,1)];
%% INC urethane TH3_50_10: 2045_51 (7:9,:)
csvIndex = [NaN(6,6); csvIndex; NaN(12,6)];
speed = [cell(6,1); speed; cell(12,1)];
speed2 = [cell(6,1); speed2; cell(12,1)];
%% INC urethane TH5_50_5: 2045_51 (20:25,:)
csvIndex = [NaN(19,6); csvIndex; NaN(17,6)];
speed = [cell(19,1); speed; cell(17,1)];
speed2 = [cell(19,1); speed2; cell(17,1)];
%% SEPTUM homeCage 5Hz: 1943_3: bad motive file (17,:)
X=17;
rowInfo(X,:) = [];
eeg(X,:) = [];
pulseIndex(X,:) = [];
stimIndex(X,:) = [];
%% SEPTUM homeCage 50Hz: 1943_3 (23:25,:)
X=23:25;
rowInfo(X,:) = [];
eeg(X,:) = [];
pulseIndex(X,:) = [];
stimIndex(X,:) = [];




%% repair res2 files (bad eeg channel order in LinProbe16 experiments: 2026, 2027, 2045, 2046)
toRepair = {'2026','2027','2045','2046'};

[res2file, path] = uigetfile('MultiSelect','on');

if ~iscell(res2file)
    res2file = cellstr(res2file);
end

for x = 1:size(res2file,2)
    disp(res2file{1,x})
    load(fullfile(path,res2file{1,x}),'rowInfo','eeg')
    
    if ~isempty(rowInfo)
        for k = 1:size(rowInfo,1)
            if ismember(rowInfo{k,1}(1:4),toRepair)
                disp(num2str(k))
                experiment = toRepair{ismember(toRepair,rowInfo{k,1}(1:4))};
                load(['INC_' experiment '_speed.mat'],'eegSample','infoCell')
                row = cellfun(@(x) isequal(x,rowInfo{k,1}),infoCell(:,1));
                sampleNo = rowInfo{k,2};
                eeg{k,1} = eegSample{row,1}{sampleNo,1};
            end
        end
    end
    
    save(fullfile(path,res2file{1,x}),'eeg','-append')
end


        

















                