%% INC
Stim = {'BLIND','INC','INCAlu','SEPTUM','SEPTUMAlu'};
Arena = {'holeBox','homeCage','linearTrack','newBox','urethane'};
Freq = {'f1Hz','f5Hz','f10Hz','f15Hz','f25Hz','f30Hz','f50Hz','TH3_20_5','TH3_25_5','TH3_50_5','TH3_50_10','TH5_50_5'};
Select = {{'1868','2017','2026','2027','2046'},{'1868','2022','2026','2046'},{'2040','2045'},{'1943','1957','1985'}...
    {'1868','2017','2022','2026','2027','2046'},{'1868','1943','1957','1985','2017','2022','2026','2027','2040','2045','2046'}};
Selectname = {'goodINC','goodSEPTUM','control','novirus','all','full'};
%%
Stim = {'INC','SEPTUM','BLIND'};
Arena = {'holeBox','linearTrack','newBox','homeCage','urethane'};
Freq = {'f5Hz','f10Hz','f15Hz','f25Hz','f30Hz','f50Hz','TH3_25_5','TH3_50_5','TH3_50_10','TH5_50_5'};
Select = {{'1868','2017','2026','2027','2046'},{'1868','2022','2026','2046'},{'1868','2017','2026','2027','2046'}};
Control = {'1943','1957','1985','2040','2045'};

F = Freq{4};
A = Arena{4};

stim = Stim{2};
arena = A;
sfreq = F;
select = {'1868','2026','2046'}; %
ARENA = arena;
fstim = 25;
INDEX = 'and(runindex,thetaindex)';

% get data from files
[pyrN,pulseIndex,stimIndex,animalIndex, rowdata, stimIndex2, csvIndex2, speedmatrix, eegPyrmatrix, eegmatrix, power, wave, fr, ...powerALL,...
    pWelch_pre, pWelch_stim, pWelch_post, fWelch, pWelchALL_pre, pWelchALL_stim, pWelchALL_post, lagDiff_pre, lagDiff_stimpost, rcor_pre, rcor_stimpost] = andor_INCfreemov_STEP5_eeg_fast4(stim,arena,sfreq,select,2000);
if ~isempty(pWelch_pre)
% runindex, stillindex
stillindex = false(size(speedmatrix,1),1);
runindex = false(size(speedmatrix,1),1);
runstimindex = false(size(speedmatrix,1),1);
speedav = NaN(size(speedmatrix,1),1);
for k = 1:size(speedmatrix,1)
    for x = 1:4
        meanprespeed(1,x) = mean(speedmatrix(k,(csvIndex2(k,3)-x*60):(csvIndex2(k,3)-(x-1)*60-1)));
        meanpostspeed(1,x) = mean(speedmatrix(k,(csvIndex2(k,5)+(x-1)*60):(csvIndex2(k,5)+x*60-1)));
    end
    if meanprespeed(1) < 4
        stillindex(k,1) = true;
    end
    if all(meanprespeed > 4)
        runindex(k,1) = true;
    end
    speedav(k,1) = mean(meanprespeed);
    speedav_stim(k,1) = mean(speedmatrix(k,csvIndex2(k,3):csvIndex2(k,4)));
    speedav_post(k,1) = mean(meanpostspeed);
    if speedav_stim(k,1) > 4
        runstimindex(k,1) = true;
    end
end

thetadom_pre = NaN(size(pWelch_pre,1),1);
thetadom_stim = NaN(size(pWelch_pre,1),1);
thetadom_post = NaN(size(pWelch_pre,1),1);
thetashift = NaN(size(pWelch_pre,1),1);

SP_stimF_pre = NaN(size(pWelch_pre,1),1);
SP_stimF_stim = NaN(size(pWelch_pre,1),1);
SP_stimF_post = NaN(size(pWelch_pre,1),1);

SP_bgLOW_pre = NaN(size(pWelch_pre,1),1);
SP_bgLOW_stim = NaN(size(pWelch_pre,1),1);
SP_bgLOW_post = NaN(size(pWelch_pre,1),1);
SP_bgHIGH_pre = NaN(size(pWelch_pre,1),1);
SP_bgHIGH_stim = NaN(size(pWelch_pre,1),1);
SP_bgHIGH_post = NaN(size(pWelch_pre,1),1);

bg1 = knnsearch(fWelch(1,:)',22);
bg2 = knnsearch(fWelch(1,:)',35);
bgX = knnsearch(fWelch(1,:)',28);
fstim1 = knnsearch(fWelch(1,:)',fstim-2);
fstim2 = knnsearch(fWelch(1,:)',fstim+2);

if ~strcmp(ARENA,'urethane')
    th1 = knnsearch(fWelch(1,:)',5);
    thx = knnsearch(fWelch(1,:)',8);
    th2 = knnsearch(fWelch(1,:)',12);
    d1 = knnsearch(fWelch(1,:)',1);
    d2 = knnsearch(fWelch(1,:)',4);
else
    th1 = knnsearch(fWelch(1,:)',2.5);
    th2 = knnsearch(fWelch(1,:)',6);
    d1 = knnsearch(fWelch(1,:)',1);
    d2 = knnsearch(fWelch(1,:)',2);
end
X = knnsearch(fWelch(1,:)',16);
for k = 1:size(pWelch_pre,1)
    if ~all(isnan(pWelch_pre(k,:)))
        Wdiff(k,:) = 10*log10(pWelch_stim(k,:)./pWelch_pre(k,:));
        
        [pks, locs] = findpeaks(pWelch_pre(k,th1:th2));
        if ~isempty(pks)
            [~,pksi] = max(pks);
            thetadom_pre(k,1) = fWelch(1,locs(pksi)+th1-1);
        end
        
        [pks, locs] = findpeaks(pWelch_stim(k,th1:th2));
        if ~isempty(pks)
            [~,pksi] = max(pks);
            thetadom_stim(k,1) = fWelch(1,locs(pksi)+th1-1);
        end
        
        thetashift(k,1) = thetadom_stim(k,1)-thetadom_pre(k,1);
        
%         [pks, locs] = findpeaks(pWelch_post(k,th1:th2));
%         if ~isempty(pks)
%             [~,pksi] = max(pks);
%             thetadom_post(k,1) = fWelch(1,locs(pksi)+th1-1);
%         end
        
        SP_th_pre(k,1) = sum(pWelch_pre(k,th1:th2));
        SP_th_stim(k,1) = sum(pWelch_stim(k,th1:th2));
        SP_th_post(k,1) = sum(pWelch_post(k,th1:th2));
        
        if ~strcmp('urethane',ARENA)
            SP_th1_pre(k,1) = sum(pWelch_pre(k,th1:thx));
            SP_th1_stim(k,1) = sum(pWelch_stim(k,th1:thx));
            
            SP_th2_pre(k,1) = sum(pWelch_pre(k,thx+1:th2));
            SP_th2_stim(k,1) = sum(pWelch_stim(k,thx+1:th2));
        else
            SP_th1_pre(k,1) = NaN;
            SP_th1_stim(k,1) = NaN;
            
            SP_th2_pre(k,1) = NaN;
            SP_th2_stim(k,1) = NaN;
        end
        
        SP_d_pre(k,1) = sum(pWelch_pre(k,d1:d2));
        SP_d_stim(k,1) = sum(pWelch_stim(k,d1:d2));
        SP_d_post(k,1) = sum(pWelch_post(k,d1:d2));

        TDR_pre(k,1) = SP_th_pre(k,1)/SP_d_pre(k,1);
        TDR_stim(k,1) = SP_th_stim(k,1)/SP_d_stim(k,1);
        TDR_post(k,1) = SP_th_post(k,1)/SP_d_post(k,1);
        
        SP_X_pre(k,1) = sum(pWelch_pre(k,th2+1:X));
        
        TXR_pre(k,1) = SP_th_pre(k,1)/SP_X_pre(k,1);
        
        TDRshift(k,1) = TDR_stim(k,1)-TDR_pre(k,1);
        
        SP_stimF_pre(k,1) = sum(pWelch_pre(k,fstim1:fstim2));
        SP_stimF_stim(k,1) = sum(pWelch_stim(k,fstim1:fstim2));
        SP_stimF_post(k,1) = sum(pWelch_post(k,fstim1:fstim2));
        
        SP_bgLOW_pre(k,1) = sum(pWelch_pre(k,bg1:bgX-1));
        SP_bgLOW_stim(k,1) = sum(pWelch_stim(k,bg1:bgX-1));
        SP_bgLOW_post(k,1) = sum(pWelch_post(k,bg1:bgX-1));
        
        SP_bgHIGH_pre(k,1) = sum(pWelch_pre(k,bgX:bg2));
        SP_bgHIGH_stim(k,1) = sum(pWelch_stim(k,bgX:bg2));
        SP_bgHIGH_post(k,1) = sum(pWelch_post(k,bgX:bg2));
        
        R_d(k,1) = SP_d_stim(k,1)/SP_d_pre(k,1);
        R_th(k,1) = SP_th_stim(k,1)/SP_th_pre(k,1);
        R_th1(k,1) = SP_th1_stim(k,1)/SP_th1_pre(k,1);
        R_th2(k,1) = SP_th2_stim(k,1)/SP_th2_pre(k,1);
        R_stimF(k,1) = SP_stimF_stim(k,1)/SP_stimF_pre(k,1);
        R_bgLOW(k,1) = SP_bgLOW_stim(k,1)/SP_bgLOW_pre(k,1);
        R_bgHIGH(k,1) = SP_bgHIGH_stim(k,1)/ SP_bgHIGH_pre(k,1);
        R_bg(k,1) = (SP_bgHIGH_stim(k,1)+SP_bgLOW_stim(k,1))/(SP_bgHIGH_pre(k,1)+SP_bgLOW_pre(k,1));
    end
end

% thetaindex
thetaindex = false(size(pWelch_pre,1),1);
nonthetaindex = false(size(pWelch_pre,1),1);
for k = 1:size(pWelch_pre,1)
    if and(TDR_pre(k,1)>1,TXR_pre(k,1)>1)
        thetaindex(k,1) = true;
    end
    if TDR_pre(k,1)<1
        nonthetaindex(k,1) = true;
    end
end


% remindex, nonremindex
if ~strcmp(ARENA,'urethane')
    xcorindex = false(size(rcor_pre,1),1);
    for k = 1:size(rcor_pre,1)
        temp = mean(rcor_pre{k,1},2);
        for x = 1:4
            temp4(1,x) = mean(temp(((x-1)*20+1):(x*20)));
        end
        if all(temp4 < 0.5)
            xcorindex(k,1) = true;
        end
    end
    remindex = and(and(thetaindex,stillindex),xcorindex);
    nonremindex = and(nonthetaindex,stillindex);
end

index = eval(INDEX);
end
% [powerM_INC,power_pre_INC,power_stim_INC,power_post_INC,powerratio_INC,power_preShort_INC,power_stimShort_INC,powerratioShort_INC,...
%     pWelch_pre_INC,fWelch_pre_INC,pWelch_stim_INC,fWelch_stim_INC,pWelch_post_INC,fWelch_post_INC,welchdiff_INC,...
%     domfreq_pre_INC,domfreq_stim_INC,domfreq_preShort_INC,domfreq_stimShort_INC,com_PRE_INC,com_STIM_INC,...
%     FreqTick_INC,FreqTickloc_INC,TimeX_INC,pyrN_INC] ...
% = andor_INCfreemov_STEP4_f2(2000,speedmatrix,eegmatrix,speedindex,speedindex2,eegindex,eegindex2,rowdata,stim,freq,wave,power,scale,pulseIndex,eeg,pyrN,stimIndexA,stimIndexB);
%% load csv data timepoints
% load infoCell and csvIndex, load camS

% experiments: '1868','2017','2026','2027','2046'

foldername = '/Volumes/G31_invivo_data2$/projekt/incertus/analysis/';

temp = load(fullfile(foldername,'INC_1868_speed.mat'),'infoCell','csvIndex');
infoCell_1868 = temp.infoCell;
csvIndex_1868 = temp.csvIndex;
temp = load(fullfile(foldername,'INC_1868_pulsedetect.mat'),'camS');
camS_1868 = temp.camS;

temp = load(fullfile(foldername,'INC_2017_speed.mat'),'infoCell','csvIndex');
infoCell_2017 = temp.infoCell;
csvIndex_2017 = temp.csvIndex;
temp = load(fullfile(foldername,'INC_2017_pulsedetect.mat'),'camS');
camS_2017 = temp.camS;

temp = load(fullfile(foldername,'INC_2026_speed.mat'),'infoCell','csvIndex');
infoCell_2026 = temp.infoCell;
csvIndex_2026 = temp.csvIndex;
temp = load(fullfile(foldername,'INC_2026_pulsedetect.mat'),'camS');
camS_2026 = temp.camS;

temp = load(fullfile(foldername,'INC_2027_speed.mat'),'infoCell','csvIndex');
infoCell_2027 = temp.infoCell;
csvIndex_2027 = temp.csvIndex;
temp = load(fullfile(foldername,'INC_2027_pulsedetect.mat'),'camS');
camS_2027 = temp.camS;

temp = load(fullfile(foldername,'INC_2046_speed.mat'),'infoCell','csvIndex');
infoCell_2046 = temp.infoCell;
csvIndex_2046 = temp.csvIndex;
temp = load(fullfile(foldername,'INC_2046_pulsedetect.mat'),'camS');
camS_2046 = temp.camS;

save('INC_FINAL_camSdata','infoCell_1868','csvIndex_1868','camS_1868',...
                          'infoCell_2017','csvIndex_2017','camS_2017',...
                          'infoCell_2026','csvIndex_2026','camS_2026',...
                          'infoCell_2027','csvIndex_2027','camS_2027',...
                          'infoCell_2046','csvIndex_2046','camS_2046','-v7.3')
%% panelA: pre-stim-post wavelet average for 1 animal during RUNNING, REM, URETHANE THETA and NONREM; INC STIM + CTRL STIM

% INC RUNNING
filename = '2026';
LT = load('INCSEPTUMbase_linearTrack_f25Hz','power','fr','stimIndex2','rowdata','runindex','thetaindex','csvIndex2','speedmatrix');
indexArena = repmat({'linearTrack'},size(LT.power,3),1);
indexLT = and(LT.runindex,LT.thetaindex);

rowdataLT = LT.rowdata(indexLT,:);
powerLT = LT.power(:,:,indexLT);
frLT = LT.fr(indexLT,:);
stimIndexLT = LT.stimIndex2(indexLT,:);
indexArenaLT = indexArena(indexLT,:);
csvIndexLT = LT.csvIndex2(indexLT,:);
speedLT = LT.speedmatrix(indexLT,:);

HB = load('INCSEPTUMbase_holeBox_f25Hz','power','fr','stimIndex2','rowdata','runindex','thetaindex','csvIndex2','speedmatrix');
indexArena = repmat({'holeBox'},size(HB.power,3),1);
indexHB = and(HB.runindex,HB.thetaindex);

rowdataHB = HB.rowdata(indexHB,:);
powerHB = HB.power(:,:,indexHB);
frHB = HB.fr(indexHB,:);
stimIndexHB = HB.stimIndex2(indexHB,:);
indexArenaHB = indexArena(indexHB,:);
csvIndexHB = HB.csvIndex2(indexHB,:);
speedHB = HB.speedmatrix(indexHB,:);

indexArena = [indexArenaLT; indexArenaHB];
rowdata = [rowdataLT; rowdataHB];
fr = [frLT; frHB];
stimIndex = [stimIndexLT; stimIndexHB];
csvIndex = [csvIndexLT; csvIndexHB];
speed = [speedLT; speedHB];

power = cat(3,powerLT(:,(stimIndex(1,3)-4000):(stimIndex(1,3)+8000),:),powerHB(:,(stimIndex(1,3)-4000):(stimIndex(1,3)+8000),:));

% theta-acceleration correlation
freq = fr(1,:);
th1 = knnsearch(freq',12);
thX = knnsearch(freq',8);
th2 = knnsearch(freq',5);
for k = 1:size(power,3)
    theta1bandpower(k,:) = sum(power(thX:th2,:,k));
    theta2bandpower(k,:) = sum(power(th1:(thX-1),:,k));
end

% % acceler = NaN(size(speed));
% % for k = 2:size(speed,2)
% %     acceler(:,k) = (speed(:,k)-speed(:,k-1)).*120;
% % end
% % acceler = speed;
% % 
load('INC_FINAL_camSdata.mat')
pretime = 480;
stimtime = 960;
for k = 1:size(rowdata,1)
    filenum = rowdata{k,1}(1:4);
    if isequal(filenum,'1868')
        row = strcmp(infoCell_1868(:,1),rowdata{k,1});
        stimnum = rowdata{k,2};
        camindex = csvIndex_1868{row,1}(stimnum,:);
        camPos = camS_1868{row,1}(camindex(3)-pretime:camindex(3)+stimtime);
        camPos = round(camPos/(20000/1000));
        camPos = camPos-camPos(pretime+1);
        camPos = camPos + 4001;
        
        for x = 1:length(camPos)
            theta1Data(k,x) = mean(theta1bandpower(k,(camPos(x)-5):(camPos(x)+5)));
            theta2Data(k,x) = mean(theta2bandpower(k,(camPos(x)-5):(camPos(x)+5)));
        end
        
        speedData(k,:) = speed(k,(csvIndex(k,3)-pretime):(csvIndex(k,3)+stimtime));
        
    elseif isequal(filenum,'2017')
        row = strcmp(infoCell_2017(:,1),rowdata{k,1});
        stimnum = rowdata{k,2};
        camindex = csvIndex_2017{row,1}(stimnum,:);
        camPos = camS_2017{row,1}(camindex(3)-pretime:camindex(3)+stimtime);
        camPos = round(camPos/(20000/1000));
        camPos = camPos-camPos(pretime+1);
        camPos = camPos + 4001;
        
        for x = 1:length(camPos)
            theta1Data(k,x) = mean(theta1bandpower(k,(camPos(x)-5):(camPos(x)+5)));
            theta2Data(k,x) = mean(theta2bandpower(k,(camPos(x)-5):(camPos(x)+5)));
        end
        
        speedData(k,:) = speed(k,(csvIndex(k,3)-pretime):(csvIndex(k,3)+stimtime));
        
    elseif isequal(filenum,'2026')
        row = strcmp(infoCell_2026(:,1),rowdata{k,1});
        stimnum = rowdata{k,2};
        camindex = csvIndex_2026{row,1}(stimnum,:);
        camPos = camS_2026{row,1}(camindex(3)-pretime:camindex(3)+stimtime);
        camPos = round(camPos/(20000/1000));
        camPos = camPos-camPos(pretime+1);
        camPos = camPos + 4001;
        
        for x = 1:length(camPos)
            theta1Data(k,x) = mean(theta1bandpower(k,(camPos(x)-5):(camPos(x)+5)));
            theta2Data(k,x) = mean(theta2bandpower(k,(camPos(x)-5):(camPos(x)+5)));
        end
        
        speedData(k,:) = speed(k,(csvIndex(k,3)-pretime):(csvIndex(k,3)+stimtime));
        
    elseif isequal(filenum,'2027')
        row = strcmp(infoCell_2027(:,1),rowdata{k,1});
        stimnum = rowdata{k,2};
        camindex = csvIndex_2027{row,1}(stimnum,:);
        camPos = camS_2027{row,1}(camindex(3)-pretime:camindex(3)+stimtime);
        camPos = round(camPos/(20000/1000));
        camPos = camPos-camPos(pretime+1);
        camPos = camPos + 4001;
        
        for x = 1:length(camPos)
            theta1Data(k,x) = mean(theta1bandpower(k,(camPos(x)-5):(camPos(x)+5)));
            theta2Data(k,x) = mean(theta2bandpower(k,(camPos(x)-5):(camPos(x)+5)));
        end
        
        speedData(k,:) = speed(k,(csvIndex(k,3)-pretime):(csvIndex(k,3)+stimtime));
        
    elseif isequal(filenum,'2046')
        row = strcmp(infoCell_2046(:,1),rowdata{k,1});
        stimnum = rowdata{k,2};
        camindex = csvIndex_2046{row,1}(stimnum,:);
        camPos = camS_2046{row,1}(camindex(3)-pretime:camindex(3)+stimtime);
        camPos = round(camPos/(20000/1000));
        camPos = camPos-camPos(pretime+1);
        camPos = camPos + 4001;
        
        for x = 1:length(camPos)
            theta1Data(k,x) = mean(theta1bandpower(k,(camPos(x)-5):(camPos(x)+5)));
            theta2Data(k,x) = mean(theta2bandpower(k,(camPos(x)-5):(camPos(x)+5)));
        end
        
        speedData(k,:) = speed(k,(csvIndex(k,3)-pretime):(csvIndex(k,3)+stimtime));
        
    end
end

% speed - theta relationship
% bins: 0-4 cm/s; 4-8 cm/s; 8-12 cm/s; 12-16 cm/s; 16-inf cm/s
stim25time = 474;

speedDataPRE = speedData(:,1:pretime);
theta1DataPRE = theta1Data(:,1:pretime);
theta2DataPRE = theta2Data(:,1:pretime);

speedDataSTIM = speedData(:,(pretime+1):(pretime+1+stim25time));
theta1DataSTIM = theta1Data(:,(pretime+1):(pretime+1+stim25time));
theta2DataSTIM = theta2Data(:,(pretime+1):(pretime+1+stim25time));

speedDataPOST = speedData(:,(pretime+2+stim25time):end);
theta1DataPOST = theta1Data(:,(pretime+2+stim25time):end);
theta2DataPOST = theta2Data(:,(pretime+2+stim25time):end);

% speed change
INCcolor = [0 51 204]./255;
CTRLcolor = [102 153 255]./255;
% % % figure; hold on
% % % line([1-0.4 1+0.4],repmat(median(mean(speedDataPRE,2)),1,2),'LineWidth',1.5,'Color',[.3 .3 .3])
% % % line([1-0.4 1+0.4],repmat(median(mean(speedDataPRE,2))+prctile(mean(speedDataPRE,2),75),1,2),'LineWidth',1.5,'Color',[.3 .3 .3])
% % % line([1-0.4 1+0.4],repmat(median(mean(speedDataPRE,2))-prctile(mean(speedDataPRE,2),25),1,2),'LineWidth',1.5,'Color',[.3 .3 .3])
% % % 
% % % line([1-0.4 1-0.4],[median(mean(speedDataPRE,2))-prctile(mean(speedDataPRE,2),25) median(mean(speedDataPRE,2))+prctile(mean(speedDataPRE,2),75)],'LineWidth',1.5,'Color',[.3 .3 .3])
% % % line([1+0.4 1+0.4],[median(mean(speedDataPRE,2))-prctile(mean(speedDataPRE,2),25) median(mean(speedDataPRE,2))+prctile(mean(speedDataPRE,2),75)],'LineWidth',1.5,'Color',[.3 .3 .3])
% % % 
% % % 
% % % line([2-0.4 2+0.4],repmat(median(mean(speedDataSTIM,2)),1,2),'LineWidth',1.5,'Color',INCcolor)
% % % line([2-0.4 2+0.4],repmat(median(mean(speedDataSTIM,2))+prctile(mean(speedDataSTIM,2),75),1,2),'LineWidth',1.5,'Color',INCcolor)
% % % line([2-0.4 2+0.4],repmat(median(mean(speedDataSTIM,2))-prctile(mean(speedDataSTIM,2),25),1,2),'LineWidth',1.5,'Color',INCcolor)
% % % 
% % % line([2-0.4 2-0.4],[median(mean(speedDataSTIM,2))-prctile(mean(speedDataSTIM,2),25) median(mean(speedDataSTIM,2))+prctile(mean(speedDataSTIM,2),75)],'LineWidth',1.5,'Color',INCcolor)
% % % line([2+0.4 2+0.4],[median(mean(speedDataSTIM,2))-prctile(mean(speedDataSTIM,2),25) median(mean(speedDataSTIM,2))+prctile(mean(speedDataSTIM,2),75)],'LineWidth',1.5,'Color',INCcolor)
% % %     
% % % 
% % % line([3-0.4 3+0.4],repmat(median(mean(speedDataPOST,2)),1,2),'LineWidth',1.5,'Color',[.5 .5 .5])
% % % line([3-0.4 3+0.4],repmat(median(mean(speedDataPOST,2))+prctile(mean(speedDataPOST,2),75),1,2),'LineWidth',1.5,'Color',[.5 .5 .5])
% % % line([3-0.4 3+0.4],repmat(median(mean(speedDataPOST,2))-prctile(mean(speedDataPOST,2),25),1,2),'LineWidth',1.5,'Color',[.5 .5 .5])
% % % 
% % % line([3-0.4 3-0.4],[median(mean(speedDataPOST,2))-prctile(mean(speedDataPOST,2),25) median(mean(speedDataPOST,2))+prctile(mean(speedDataPOST,2),75)],'LineWidth',1.5,'Color',[.5 .5 .5])
% % % line([3+0.4 3+0.4],[median(mean(speedDataPOST,2))-prctile(mean(speedDataPOST,2),25) median(mean(speedDataPOST,2))+prctile(mean(speedDataPOST,2),75)],'LineWidth',1.5,'Color',[.5 .5 .5])
% % %  title(gca, 'INC STIM','FontSize',20)
% % % set(gca,'YLim',[0 30],'YTick',[0 30],'YTickLabel',{'0';'30'},'XTick',[],'LineWidth',1,'FontSize',20,'XLim',[0.4 3.6])
% % % ylabel(gca,'average speed (cm/s)','FontSize',20)
% % % 
% % % p = signrank(mean(speedDataPRE,2), mean(speedDataSTIM,2));
% % % text(1,10,num2str(p),'FontSize',20)
% % % 
% % % p = signrank(mean(speedDataSTIM,2), mean(speedDataPOST,2));
% % % text(2.5,11,num2str(p),'FontSize',20)

% speed bins + theta2 and theta1
   
binstart = [0 4];
binend =   [4 inf];

theta1BarPRE = cell(1,length(binstart));
theta2BarPRE = cell(1,length(binstart));
theta1BarSTIM = cell(1,length(binstart));
theta2BarSTIM = cell(1,length(binstart));
theta1BarPOST = cell(1,length(binstart));
theta2BarPOST = cell(1,length(binstart));

for k = 1:length(binstart)
    for kk = 1:size(theta2DataPRE,1)
        if ~isempty(theta1DataPRE(kk,speedDataPRE(kk,:) >= binstart(k) & speedDataPRE(kk,:) < binend(k)))
            theta1BarPRE{1,k}(kk) = mean(theta1DataPRE(kk,speedDataPRE(kk,:) >= binstart(k) & speedDataPRE(kk,:) < binend(k)));
        else
            theta1BarPRE{1,k}(kk) = NaN;
        end
        if ~isempty(theta2DataPRE(kk,speedDataPRE(kk,:) >= binstart(k) & speedDataPRE(kk,:) < binend(k)))
            theta2BarPRE{1,k}(kk) = mean(theta2DataPRE(kk,speedDataPRE(kk,:) >= binstart(k) & speedDataPRE(kk,:) < binend(k)));
        else
            theta2BarPRE{1,k}(kk) = NaN;
        end
        
        if ~isempty(theta1DataSTIM(kk,speedDataSTIM(kk,:) >= binstart(k) & speedDataSTIM(kk,:) < binend(k)))
            theta1BarSTIM{1,k}(kk) = mean(theta1DataSTIM(kk,speedDataSTIM(kk,:) >= binstart(k) & speedDataSTIM(kk,:) < binend(k)));
        else
            theta1BarSTIM{1,k}(kk) = NaN;
        end
        if ~isempty(theta2DataSTIM(kk,speedDataSTIM(kk,:) >= binstart(k) & speedDataSTIM(kk,:) < binend(k)))
            theta2BarSTIM{1,k}(kk) = mean(theta2DataSTIM(kk,speedDataSTIM(kk,:) >= binstart(k) & speedDataSTIM(kk,:) < binend(k)));
        else
            theta2BarSTIM{1,k}(kk) = NaN;
        end
        
        if ~isempty(theta1DataPOST(kk,speedDataPOST(kk,:) >= binstart(k) & speedDataPOST(kk,:) < binend(k)))
            theta1BarPOST{1,k}(kk) = mean(theta1DataPOST(kk,speedDataPOST(kk,:) >= binstart(k) & speedDataPOST(kk,:) < binend(k)));
        else
            theta1BarPOST{1,k}(kk) = NaN;
        end
        if ~isempty(theta2DataPOST(kk,speedDataPOST(kk,:) >= binstart(k) & speedDataPOST(kk,:) < binend(k)))
            theta2BarPOST{1,k}(kk) = mean(theta2DataPOST(kk,speedDataPOST(kk,:) >= binstart(k) & speedDataPOST(kk,:) < binend(k)));
        else
            theta2BarPOST{1,k}(kk) = NaN;
        end
    end
end

INCcolor = [0 51 204]./255;
CTRLcolor = 'k';
figure('Position',[25 25 560 1.5*420]) ; hold on
subplot('Position',[.1 .525 .85 0.425])

A1 = 2.4;
A2 = 3.6;
A3 = 4.8;
B = 5.3;
C = 0.5;
for k = 1:length(binstart)
    tempmedian = median(theta2BarPRE{1,k});
    temp75 = prctile(theta2BarPRE{1,k},75);
    temp25 = prctile(theta2BarPRE{1,k},25);
    
    line([A1+(k-1)*B-C A1+(k-1)*B+C],[tempmedian tempmedian],'LineWidth',.5,'Color',[.3 .3 .3])
    line([A1+(k-1)*B-C A1+(k-1)*B+C],[temp75 temp75],'LineWidth',.5,'Color',[.3 .3 .3])
    line([A1+(k-1)*B-C A1+(k-1)*B+C],[temp25 temp25],'LineWidth',.5,'Color',[.3 .3 .3])
    
    line([A1+(k-1)*B-C A1+(k-1)*B-C],[temp25 temp75],'LineWidth',.5,'Color',[.3 .3 .3])
    line([A1+(k-1)*B+C A1+(k-1)*B+C],[temp25 temp75],'LineWidth',.5,'Color',[.3 .3 .3])
    
    
    tempmedian = median(theta2BarSTIM{1,k});
    temp75 = prctile(theta2BarSTIM{1,k},75);
    temp25 = prctile(theta2BarSTIM{1,k},25);
    
    line([A2+(k-1)*B-C A2+(k-1)*B+C],[tempmedian tempmedian],'LineWidth',.5,'Color',INCcolor)
    line([A2+(k-1)*B-C A2+(k-1)*B+C],[temp75 temp75],'LineWidth',.5,'Color',INCcolor)
    line([A2+(k-1)*B-C A2+(k-1)*B+C],[temp25 temp25],'LineWidth',.5,'Color',INCcolor)
    
    line([A2+(k-1)*B-C A2+(k-1)*B-C],[temp25 temp75],'LineWidth',.5,'Color',INCcolor)
    line([A2+(k-1)*B+C A2+(k-1)*B+C],[temp25 temp75],'LineWidth',.5,'Color',INCcolor)
    
    
    tempmedian = median(theta2BarPOST{1,k});
    temp75 = prctile(theta2BarPOST{1,k},75);
    temp25 = prctile(theta2BarPOST{1,k},25);
    
    line([A3+(k-1)*B-C A3+(k-1)*B+C],[tempmedian tempmedian],'LineWidth',.5,'Color',[.5 .5 .5])
    line([A3+(k-1)*B-C A3+(k-1)*B+C],[temp75 temp75],'LineWidth',.5,'Color',[.5 .5 .5])
    line([A3+(k-1)*B-C A3+(k-1)*B+C],[temp25 temp25],'LineWidth',.5,'Color',[.5 .5 .5])
    
    line([A3+(k-1)*B-C A3+(k-1)*B-C],[temp25 temp75],'LineWidth',.5,'Color',[.5 .5 .5])
    line([A3+(k-1)*B+C A3+(k-1)*B+C],[temp25 temp75],'LineWidth',.5,'Color',[.5 .5 .5])
    
    p = signrank(theta2BarPRE{1,k},theta2BarSTIM{1,k});
    text(A1+(k-1)*B-C,8000,num2str(p),'FontSize',20)
    
    p = signrank(theta2BarSTIM{1,k},theta2BarPOST{1,k});
    text(A3+(k-1)*B-C,5000,num2str(p),'FontSize',20)
    
end
% title(gca,'BLIND STIM','FontSize',20)
ylabel(gca,'high theta power (x10^{3})','FontSize',20)
% xlabel(gca,'speed range (cm/s)','FontSize',20)
set(gca,'XTick',A2:B:10,'XLim',[0 10.6+1.9],'XTickLabel',{'still';'moving'},'YLim',[0 8000],'YTick',[0 8000],'YTickLabel',{'0';'8'})
set(gca,'LineWidth',.5,'FontSize',20)
set(gca,'XTick',[])

% figure; hold on
subplot('Position',[.1 .05 .85 0.425])
for k = 1:length(binstart)
    tempmedian = median(theta1BarPRE{1,k});
    temp75 = prctile(theta1BarPRE{1,k},75);
    temp25 = prctile(theta1BarPRE{1,k},25);
    
    line([A1+(k-1)*B-C A1+(k-1)*B+C],[tempmedian tempmedian],'LineWidth',.5,'Color',[.3 .3 .3])
    line([A1+(k-1)*B-C A1+(k-1)*B+C],[temp75 temp75],'LineWidth',.5,'Color',[.3 .3 .3])
    line([A1+(k-1)*B-C A1+(k-1)*B+C],[temp25 temp25],'LineWidth',.5,'Color',[.3 .3 .3])
    
    line([A1+(k-1)*B-C A1+(k-1)*B-C],[temp25 temp75],'LineWidth',.5,'Color',[.3 .3 .3])
    line([A1+(k-1)*B+C A1+(k-1)*B+C],[temp25 temp75],'LineWidth',.5,'Color',[.3 .3 .3])
    
    
    tempmedian = median(theta1BarSTIM{1,k});
    temp75 = prctile(theta1BarSTIM{1,k},75);
    temp25 = prctile(theta1BarSTIM{1,k},25);
    
    line([A2+(k-1)*B-C A2+(k-1)*B+C],[tempmedian tempmedian],'LineWidth',.5,'Color',INCcolor)
    line([A2+(k-1)*B-C A2+(k-1)*B+C],[temp75 temp75],'LineWidth',.5,'Color',INCcolor)
    line([A2+(k-1)*B-C A2+(k-1)*B+C],[temp25 temp25],'LineWidth',.5,'Color',INCcolor)
    
    line([A2+(k-1)*B-C A2+(k-1)*B-C],[temp25 temp75],'LineWidth',.5,'Color',INCcolor)
    line([A2+(k-1)*B+C A2+(k-1)*B+C],[temp25 temp75],'LineWidth',.5,'Color',INCcolor)
    
    
    tempmedian = median(theta1BarPOST{1,k});
    temp75 = prctile(theta1BarPOST{1,k},75);
    temp25 = prctile(theta1BarPOST{1,k},25);
    
    line([A3+(k-1)*B-C A3+(k-1)*B+C],[tempmedian tempmedian],'LineWidth',.5,'Color',[.5 .5 .5])
    line([A3+(k-1)*B-C A3+(k-1)*B+C],[temp75 temp75],'LineWidth',.5,'Color',[.5 .5 .5])
    line([A3+(k-1)*B-C A3+(k-1)*B+C],[temp25 temp25],'LineWidth',.5,'Color',[.5 .5 .5])
    
    line([A3+(k-1)*B-C A3+(k-1)*B-C],[temp25 temp75],'LineWidth',.5,'Color',[.5 .5 .5])
    line([A3+(k-1)*B+C A3+(k-1)*B+C],[temp25 temp75],'LineWidth',.5,'Color',[.5 .5 .5])
    
    p = signrank(theta1BarPRE{1,k},theta1BarSTIM{1,k});
    text(A1+(k-1)*B-C,8000,num2str(p),'FontSize',20)
    
    p = signrank(theta1BarSTIM{1,k},theta1BarPOST{1,k});
    text(A3+(k-1)*B-C,5000,num2str(p),'FontSize',20)
    
end
% title(gca,'BLIND STIM','FontSize',20)
ylabel(gca,'low theta power (x10^{3})','FontSize',20)
xlabel(gca,'speed range (cm/s)','FontSize',20)
set(gca,'XTick',A2:B:10,'XLim',[0 10.6+1.9],'XTickLabel',{'still';'moving'},'YLim',[0 8000],'YTick',[0 8000],'YTickLabel',{'0';'8'})
set(gca,'LineWidth',.5,'FontSize',20)



%%
% wavelet average for selected file:
filerows = cellfun(@(x) isequal(filename,x(1:4)),rowdata(:,1));

indexArenaF = indexArena(filerows,:);
rowdataF = rowdata(filerows,:);
powerF = power(:,:,filerows);
frF = fr(filerows,:);
stimIndexF = stimIndex(filerows,:);

figure('Name',[filename ' wavelet power average RUNNING'],'NumberTitle','off'); hold on
imagesc(-4000:8000,1:size(powerF,1),mean(powerF,3))
ytick = [2, 5, 12, 20, 100];
ytick = fliplr(ytick);
ytickPos = arrayfun(@(x) knnsearch(freq',x),ytick);
set(gca,'XLim',[-4000 8000])
set(gca,'YTick',ytickPos,'YTickLabel',arrayfun(@num2str,ytick,'UniformOutput',false),'YDir','reverse')
set(gca,'YLim',[ytickPos(1) ytickPos(end)])
set(gca,'XTick',[-4000 0 4000 8000],'XTickLabel',{'-4','0','4','8'})

line([0 0],[ytickPos(1) ytickPos(end)],'Color','w','LineStyle','--','LineWidth',2)
line([4000 4000],[ytickPos(1) ytickPos(end)],'Color','w','LineStyle','--','LineWidth',2)

set(gca,'FontSize',20)
xlabel(gca,'peristimulus time (s)','FontSize',20)
ylabel(gca,'frequency (Hz)','FontSize',20)

set(gca,'CLim',[0 500])
set(gca,'Box','off')

title('INC RUNNING','FontSize',20)

%% periodograms
% running
LT = load('INCbase_linearTrack_f25Hz','fWelch','pWelch_pre','pWelch_stim','pWelch_post','rowdata','runindex','thetaindex');
indexArena = repmat({'linearTrack'},size(LT.fWelch,1),1);
indexLT = and(LT.runindex,LT.thetaindex);

pWelch_preLT = LT.pWelch_pre(indexLT,:);
pWelch_stimLT = LT.pWelch_stim(indexLT,:);
pWelch_postLT = LT.pWelch_post(indexLT,:);
rowdataLT = LT.rowdata(indexLT,:);
indexArenaLT = indexArena(indexLT,:);

HB = load('INCbase_holeBox_f25Hz','fWelch','pWelch_pre','pWelch_stim','pWelch_post','rowdata','runindex','thetaindex');
indexArena = repmat({'holeBox'},size(HB.fWelch,1),1);
indexHB = and(HB.runindex,HB.thetaindex);

pWelch_preHB = HB.pWelch_pre(indexHB,:);
pWelch_stimHB = HB.pWelch_stim(indexHB,:);
pWelch_postHB = HB.pWelch_post(indexHB,:);
rowdataHB = HB.rowdata(indexHB,:);
indexArenaHB = indexArena(indexHB,:);

indexArenaRUN = [indexArenaLT; indexArenaHB];
rowdataRUN = [rowdataLT; rowdataHB];
pWelch_preRUN = [pWelch_preLT; pWelch_preHB];
pWelch_stimRUN = [pWelch_stimLT; pWelch_stimHB];
pWelch_postRUN = [pWelch_postLT; pWelch_postHB];

% rem
REM = load('INCbase_homeCage_f25Hz','fWelch','pWelch_pre','pWelch_stim','pWelch_post','rowdata','remindex');
indexArena = repmat({'homeCage'},size(REM.fWelch,1),1);
indexREM = REM.remindex;

pWelch_preREM = REM.pWelch_pre(indexREM,:);
pWelch_stimREM = REM.pWelch_stim(indexREM,:);
pWelch_postREM = REM.pWelch_post(indexREM,:);
rowdataREM = REM.rowdata(indexREM,:);
indexArenaREM = indexArena(indexREM,:);

% nonrem
NONREM = load('INCbase_homeCage_f25Hz','fWelch','pWelch_pre','pWelch_stim','pWelch_post','rowdata','nonremindex');
indexArena = repmat({'homeCage'},size(REM.fWelch,1),1);
indexNONREM = NONREM.nonremindex;

pWelch_preNONREM = NONREM.pWelch_pre(indexNONREM,:);
pWelch_stimNONREM = NONREM.pWelch_stim(indexNONREM,:);
pWelch_postNONREM = NONREM.pWelch_post(indexNONREM,:);
rowdataNONREM = NONREM.rowdata(indexNONREM,:);
indexArenaNONREM = indexArena(indexNONREM,:);

% urethane theta
U = load('INCbase_urethane_f25Hz','fWelch','pWelch_pre','pWelch_stim','pWelch_post','rowdata','thetaindex');
indexArena = repmat({'urethane'},size(U.fWelch,1),1);
indexU = U.thetaindex;

pWelch_preU = U.pWelch_pre(indexU,:);
pWelch_stimU = U.pWelch_stim(indexU,:);
pWelch_postU = U.pWelch_post(indexU,:);
rowdataU = U.rowdata(indexU,:);
indexArenaU = indexArena(indexU,:);

% ########  CTRL  #########
% running
LT = load('INCBLINDbase_linearTrack_f25Hz','fWelch','pWelch_pre','pWelch_stim','pWelch_post','rowdata','runindex','thetaindex');
indexArena = repmat({'linearTrack'},size(LT.fWelch,1),1);
indexLT = and(LT.runindex,LT.thetaindex);

pWelch_preLT = LT.pWelch_pre(indexLT,:);
pWelch_stimLT = LT.pWelch_stim(indexLT,:);
pWelch_postLT = LT.pWelch_post(indexLT,:);
rowdataLT = LT.rowdata(indexLT,:);
indexArenaLT = indexArena(indexLT,:);

HB = load('INCBLINDbase_holeBox_f25Hz','fWelch','pWelch_pre','pWelch_stim','pWelch_post','rowdata','runindex','thetaindex');
indexArena = repmat({'holeBox'},size(HB.fWelch,1),1);
indexHB = and(HB.runindex,HB.thetaindex);

pWelch_preHB = HB.pWelch_pre(indexHB,:);
pWelch_stimHB = HB.pWelch_stim(indexHB,:);
pWelch_postHB = HB.pWelch_post(indexHB,:);
rowdataHB = HB.rowdata(indexHB,:);
indexArenaHB = indexArena(indexHB,:);

indexArenaRUN_CTRL = [indexArenaLT; indexArenaHB];
rowdataRUN_CTRL = [rowdataLT; rowdataHB];
pWelch_preRUN_CTRL = [pWelch_preLT; pWelch_preHB];
pWelch_stimRUN_CTRL = [pWelch_stimLT; pWelch_stimHB];
pWelch_postRUN_CTRL = [pWelch_postLT; pWelch_postHB];

% rem
REM = load('INCBLINDbase_homeCage_f25Hz','fWelch','pWelch_pre','pWelch_stim','pWelch_post','rowdata','remindex');
indexArena = repmat({'homeCage'},size(REM.fWelch,1),1);
indexREM = REM.remindex;

pWelch_preREM_CTRL = REM.pWelch_pre(indexREM,:);
pWelch_stimREM_CTRL = REM.pWelch_stim(indexREM,:);
pWelch_postREM_CTRL = REM.pWelch_post(indexREM,:);
rowdataREM_CTRL = REM.rowdata(indexREM,:);
indexArenaREM_CTRL = indexArena(indexREM,:);

% nonrem
NONREM = load('INCBLINDbase_homeCage_f25Hz','fWelch','pWelch_pre','pWelch_stim','pWelch_post','rowdata','nonremindex');
indexArena = repmat({'homeCage'},size(REM.fWelch,1),1);
indexNONREM = NONREM.nonremindex;

pWelch_preNONREM_CTRL = NONREM.pWelch_pre(indexNONREM,:);
pWelch_stimNONREM_CTRL = NONREM.pWelch_stim(indexNONREM,:);
pWelch_postNONREM_CTRL = NONREM.pWelch_post(indexNONREM,:);
rowdataNONREM_CTRL = NONREM.rowdata(indexNONREM,:);
indexArenaNONREM_CTRL = indexArena(indexNONREM,:);

% urethane theta
U = load('INCBLINDbase_urethane_f25Hz','fWelch','pWelch_pre','pWelch_stim','pWelch_post','rowdata','thetaindex');
indexArena = repmat({'urethane'},size(U.fWelch,1),1);
indexU = U.thetaindex;

pWelch_preU_CTRL = U.pWelch_pre(indexU,:);
pWelch_stimU_CTRL = U.pWelch_stim(indexU,:);
pWelch_postU_CTRL = U.pWelch_post(indexU,:);
rowdataU_CTRL = U.rowdata(indexU,:);
indexArenaU_CTRL = indexArena(indexU,:);


%
freqwelch = LT.fWelch(1,:);
INCcolor = [0 51 204]./255;
CTRLcolor = [102 153 255]./255;

xtick = [1 5 12 30 45 60 100];
fontsize = 20;

% inc running STIM vs PRE
figure; hold on
shadedErrorBar(freqwelch,mean(10*log10(pWelch_preRUN)),std(10*log10(pWelch_preRUN))/sqrt(size(pWelch_preRUN,1)),'lineProps',{'Color',[0.5 0.5 0.5],'LineWidth',0.5})

shadedErrorBar(freqwelch,mean(10*log10(pWelch_stimRUN)),std(10*log10(pWelch_stimRUN))/sqrt(size(pWelch_stimRUN,1)),'lineProps',{'Color',INCcolor,'LineWidth',0.5})

set(gca,'XLim',[1 100],'LineWidth',.5,'Box','off','XTick',xtick,'XTickLabel',arrayfun(@num2str,xtick,'UniformOutput',false))
set(gca,'FontSize',fontsize,'YLim',[15 45])
set(gca,'YTick',[15 30 45],'YTickLabel',{'15';'30';'45'})
xlabel(gca,'frequency (Hz)','FontSize',fontsize)
ylabel(gca,'power (log)','FontSize',fontsize)

% BLIND running STIM vs PRE
figure; hold on
shadedErrorBar(freqwelch,mean(10*log10(pWelch_preRUN_CTRL)),std(10*log10(pWelch_preRUN_CTRL))/sqrt(size(pWelch_preRUN_CTRL,1)),'lineProps',{'Color',[0.5 0.5 0.5],'LineWidth',0.5})

shadedErrorBar(freqwelch,mean(10*log10(pWelch_stimRUN_CTRL)),std(10*log10(pWelch_stimRUN_CTRL))/sqrt(size(pWelch_stimRUN_CTRL,1)),'lineProps',{'Color','k','LineWidth',0.5})

set(gca,'XLim',[1 100],'LineWidth',.5,'Box','off','XTick',xtick,'XTickLabel',arrayfun(@num2str,xtick,'UniformOutput',false))
set(gca,'FontSize',fontsize,'YLim',[15 45])
set(gca,'YTick',[15 30 45],'YTickLabel',{'15';'30';'45'})
xlabel(gca,'frequency (Hz)','FontSize',fontsize)
ylabel(gca,'power (log)','FontSize',fontsize)
% running inc - ctrl
andor_INC_step4_DRAWperiodo(pWelch_preRUN, pWelch_stimRUN, pWelch_preRUN_CTRL, pWelch_stimRUN_CTRL, freqwelch)

andor_INC_step4_DRAWpowerdots(pWelch_preRUN, pWelch_stimRUN, pWelch_preRUN_CTRL, pWelch_stimRUN_CTRL, freqwelch, 1, 4)
andor_INC_step4_DRAWpowerdots(pWelch_preRUN, pWelch_stimRUN, pWelch_preRUN_CTRL, pWelch_stimRUN_CTRL, freqwelch, 5, 8,250000)
andor_INC_step4_DRAWpowerdots(pWelch_preRUN, pWelch_stimRUN, pWelch_preRUN_CTRL, pWelch_stimRUN_CTRL, freqwelch, 8, 12,250000)
andor_INC_step4_DRAWpowerdots(pWelch_preRUN, pWelch_stimRUN, pWelch_preRUN_CTRL, pWelch_stimRUN_CTRL, freqwelch, 30, 45,40000)
andor_INC_step4_DRAWpowerdots(pWelch_preRUN, pWelch_stimRUN, pWelch_preRUN_CTRL, pWelch_stimRUN_CTRL, freqwelch, 60, 100,60000)
% rem inc - ctrl
andor_INC_step4_DRAWperiodo(pWelch_preREM, pWelch_stimREM, pWelch_preREM_CTRL, pWelch_stimREM_CTRL, freqwelch)

andor_INC_step4_DRAWpowerdots(pWelch_preREM, pWelch_stimREM, pWelch_preREM_CTRL, pWelch_stimREM_CTRL, freqwelch, 1, 4)
andor_INC_step4_DRAWpowerdots(pWelch_preREM, pWelch_stimREM, pWelch_preREM_CTRL, pWelch_stimREM_CTRL, freqwelch, 5, 8,400000)
andor_INC_step4_DRAWpowerdots(pWelch_preREM, pWelch_stimREM, pWelch_preREM_CTRL, pWelch_stimREM_CTRL, freqwelch, 8, 12,400000)
andor_INC_step4_DRAWpowerdots(pWelch_preREM, pWelch_stimREM, pWelch_preREM_CTRL, pWelch_stimREM_CTRL, freqwelch, 30, 45,30000)
andor_INC_step4_DRAWpowerdots(pWelch_preREM, pWelch_stimREM, pWelch_preREM_CTRL, pWelch_stimREM_CTRL, freqwelch, 60, 100,20000)

% nrem inc - ctrl
andor_INC_step4_DRAWperiodo(pWelch_preNONREM, pWelch_stimNONREM, pWelch_preNONREM_CTRL, pWelch_stimNONREM_CTRL, freqwelch)

andor_INC_step4_DRAWpowerdots(pWelch_preNONREM, pWelch_stimNONREM, pWelch_preNONREM_CTRL, pWelch_stimNONREM_CTRL, freqwelch, 1, 4)
andor_INC_step4_DRAWpowerdots(pWelch_preNONREM, pWelch_stimNONREM, pWelch_preNONREM_CTRL, pWelch_stimNONREM_CTRL, freqwelch, 5, 8,250000)
andor_INC_step4_DRAWpowerdots(pWelch_preNONREM, pWelch_stimNONREM, pWelch_preNONREM_CTRL, pWelch_stimNONREM_CTRL, freqwelch, 8, 12,250000)
andor_INC_step4_DRAWpowerdots(pWelch_preNONREM, pWelch_stimNONREM, pWelch_preNONREM_CTRL, pWelch_stimNONREM_CTRL, freqwelch, 30, 45,30000)
andor_INC_step4_DRAWpowerdots(pWelch_preNONREM, pWelch_stimNONREM, pWelch_preNONREM_CTRL, pWelch_stimNONREM_CTRL, freqwelch, 60, 100,20000)

% urethane inc - ctrl
andor_INC_step4_DRAWperiodo(pWelch_preU, pWelch_stimU, pWelch_preU_CTRL, pWelch_stimU_CTRL, freqwelch)

andor_INC_step4_DRAWpowerdots(pWelch_preU, pWelch_stimU, pWelch_preU_CTRL, pWelch_stimU_CTRL, freqwelch, 1, 4)
andor_INC_step4_DRAWpowerdots(pWelch_preU, pWelch_stimU, pWelch_preU_CTRL, pWelch_stimU_CTRL, freqwelch, 2.5, 6,500000)
andor_INC_step4_DRAWpowerdots(pWelch_preU, pWelch_stimU, pWelch_preU_CTRL, pWelch_stimU_CTRL, freqwelch, 30, 45,30000)
andor_INC_step4_DRAWpowerdots(pWelch_preU, pWelch_stimU, pWelch_preU_CTRL, pWelch_stimU_CTRL, freqwelch, 60, 100,10000)


% theta dom freq
% [df_preRUN,df_stimRUN,df_preRUN_CTRL,df_stimRUN_CTRL] = andor_INC_step4_DRAWdomfreq(pWelch_preRUN, pWelch_stimRUN, pWelch_preRUN_CTRL, pWelch_stimRUN_CTRL, freqwelch, 5, 12);
% pRUN = signrank(df_preRUN,df_stimRUN);
% pRUN_CTRL = signrank(df_preRUN_CTRL,df_stimRUN_CTRL);
% [df_preREM,df_stimREM,df_preREM_CTRL,df_stimREM_CTRL] = andor_INC_step4_DRAWdomfreq(pWelch_preREM, pWelch_stimREM, pWelch_preREM_CTRL, pWelch_stimREM_CTRL, freqwelch, 5, 12);
% pREM = signrank(df_preREM,df_stimREM);
% pREM_CTRL = signrank(df_preREM_CTRL,df_stimREM_CTRL);
% [df_preNONREM,df_stimNONREM,df_preNONREM_CTRL,df_stimNONREM_CTRL] = andor_INC_step4_DRAWdomfreq(pWelch_preNONREM, pWelch_stimNONREM, real(pWelch_preNONREM_CTRL), real(pWelch_stimNONREM_CTRL), freqwelch, 5, 12);
% pNONREM = signrank(df_preNONREM,df_stimNONREM);
% pNONREM_CTRL = signrank(df_preNONREM_CTRL,df_stimNONREM_CTRL);
% [df_preU,df_stimU,df_preU_CTRL,df_stimU_CTRL] = andor_INC_step4_DRAWdomfreq(pWelch_preU, pWelch_stimU, pWelch_preU_CTRL, pWelch_stimU_CTRL, freqwelch, 2.5, 6);
% pU = signrank(df_preU,df_stimU);
% pU_CTRL = signrank(df_preU_CTRL,df_stimU_CTRL);
% 
% df = {df_stimRUN-df_preRUN, df_stimREM-df_preREM,df_stimU-df_preU};
% df_CTRL = {df_stimRUN_CTRL-df_preRUN_CTRL, df_stimREM_CTRL-df_preREM_CTRL,df_stimU_CTRL-df_preU_CTRL};
% 
% save('INC_df_transfer.mat','df','df_CTRL','pRUN','pRUN_CTRL','pREM','pREM_CTRL','pU','pU_CTRL','-v7.3')
% 
% figure; hold on
% plot(cellfun(@median, df_CTRL),[3 2 1],'LineWidth',.5,'Color','k')
% plot(cellfun(@median, df),[3 2 1],'LineWidth',.5,'Color',INCcolor)
% 
% if pRUN < 0.05
%     scatter(median(df{1}),3,80,INCcolor,'filled')
% else
%     scatter(median(df{1}),3,80,INCcolor)
% end
% if pRUN_CTRL < 0.05
%     scatter(median(df_CTRL{1}),3,80,'k','filled')
% else
%     scatter(median(df_CTRL{1}),3,80,'k')
% end
% if pREM < 0.05
%     scatter(median(df{2}),2,80,INCcolor,'filled')
% else
%     scatter(median(df{2}),2,80,INCcolor)
% end
% if pREM_CTRL < 0.05
%     scatter(median(df_CTRL{2}),2,80,'k','filled')
% else
%     scatter(median(df_CTRL{2}),2,80,'k')
% end
% if pU < 0.05
%     scatter(median(df{3}),1,80,INCcolor,'filled')
% else
%     scatter(median(df{3}),1,80,INCcolor)
% end
% if pU_CTRL < 0.05
%     scatter(median(df_CTRL{3}),1,80,'k','filled')
% else
%     scatter(median(df_CTRL{3}),1,80,'k')
% end
%% all stim freqs in running (pwelch_pre and _stim)
load('INCbase_linearTrack_f25Hz','fWelch');
t1 = knnsearch(fWelch(1,:)',5);
t2 = knnsearch(fWelch(1,:)',12);
tx = knnsearch(fWelch(1,:)',8);

[pWelch_preRUN5, pWelch_stimRUN5] = andor_INC_step4_periodo_allstimfreq('f5Hz','');
[pWelch_preRUN15, pWelch_stimRUN15] = andor_INC_step4_periodo_allstimfreq('f15Hz','');
[pWelch_preRUN25, pWelch_stimRUN25] = andor_INC_step4_periodo_allstimfreq('f25Hz','');
[pWelch_preRUN50, pWelch_stimRUN50] = andor_INC_step4_periodo_allstimfreq('f50Hz','');
[pWelch_preRUN5505, pWelch_stimRUN5505] = andor_INC_step4_periodo_allstimfreq('TH5_50_5','');
[pWelch_preRUN3255, pWelch_stimRUN3255] = andor_INC_step4_periodo_allstimfreq('TH3_25_5','');
[pWelch_preRUN3505, pWelch_stimRUN3505] = andor_INC_step4_periodo_allstimfreq('TH3_50_5','');
[pWelch_preRUN35010, pWelch_stimRUN35010] = andor_INC_step4_periodo_allstimfreq('TH3_50_10','');

[pWelch_preRUN5c, pWelch_stimRUN5c] = andor_INC_step4_periodo_allstimfreq('f5Hz','BLIND');
[pWelch_preRUN15c, pWelch_stimRUN15c] = andor_INC_step4_periodo_allstimfreq('f15Hz','BLIND');
[pWelch_preRUN25c, pWelch_stimRUN25c] = andor_INC_step4_periodo_allstimfreq('f25Hz','BLIND');
[pWelch_preRUN50c, pWelch_stimRUN50c] = andor_INC_step4_periodo_allstimfreq('f50Hz','BLIND');
[pWelch_preRUN5505c, pWelch_stimRUN5505c] = andor_INC_step4_periodo_allstimfreq('TH5_50_5','BLIND');
[pWelch_preRUN3255c, pWelch_stimRUN3255c] = andor_INC_step4_periodo_allstimfreq('TH3_25_5','BLIND');
[pWelch_preRUN3505c, pWelch_stimRUN3505c] = andor_INC_step4_periodo_allstimfreq('TH3_50_5','BLIND');
[pWelch_preRUN35010c, pWelch_stimRUN35010c] = andor_INC_step4_periodo_allstimfreq('TH3_50_10','BLIND');

matrix(1,:) = mean(10*log10(pWelch_stimRUN5./pWelch_preRUN5));
matrix(2,:) = mean(10*log10(pWelch_stimRUN15./pWelch_preRUN15));
matrix(3,:) = mean(10*log10(pWelch_stimRUN25./pWelch_preRUN25));
matrix(6,:) = mean(10*log10(pWelch_stimRUN5505./pWelch_preRUN5505));
matrix(4,:) = mean(10*log10(pWelch_stimRUN3255./pWelch_preRUN3255));
matrix(5,:) = mean(10*log10(pWelch_stimRUN3505./pWelch_preRUN3505));
matrix(7,:) = mean(10*log10(pWelch_stimRUN35010./pWelch_preRUN35010));

matrix2(1,:) = mean(10*log10(pWelch_stimRUN5c./pWelch_preRUN5c));
matrix2(2,:) = mean(10*log10(pWelch_stimRUN15c./pWelch_preRUN15c));
matrix2(3,:) = mean(10*log10(pWelch_stimRUN25c./pWelch_preRUN25c));
matrix2(6,:) = mean(10*log10(pWelch_stimRUN5505c./pWelch_preRUN5505c));
matrix2(4,:) = mean(10*log10(pWelch_stimRUN3255c./pWelch_preRUN3255c));
matrix2(5,:) = mean(10*log10(pWelch_stimRUN3505c./pWelch_preRUN3505c));
matrix2(7,:) = mean(10*log10(pWelch_stimRUN35010c./pWelch_preRUN35010c));

A1 = sum(pWelch_stimRUN5(:,t1:tx),2)./sum(pWelch_preRUN5(:,t1:tx),2);
B1 = sum(pWelch_stimRUN15(:,t1:tx),2)./sum(pWelch_preRUN15(:,t1:tx),2);
C1 = sum(pWelch_stimRUN25(:,t1:tx),2)./sum(pWelch_preRUN25(:,t1:tx),2);
D1 = sum(pWelch_stimRUN3255(:,t1:tx),2)./sum(pWelch_preRUN3255(:,t1:tx),2);
E1 = sum(pWelch_stimRUN3505(:,t1:tx),2)./sum(pWelch_preRUN3505(:,t1:tx),2);
F1 = sum(pWelch_stimRUN5505(:,t1:tx),2)./sum(pWelch_preRUN5505(:,t1:tx),2);
G1 = sum(pWelch_stimRUN35010(:,t1:tx),2)./sum(pWelch_preRUN35010(:,t1:tx),2);
A1cat1 = repmat({'5'},size(A1));
B1cat1 = repmat({'15'},size(B1));
C1cat1 = repmat({'25'},size(C1));
D1cat1 = repmat({'3255'},size(D1));
E1cat1 = repmat({'3505'},size(E1));
F1cat1 = repmat({'5505'},size(F1));
G1cat1 = repmat({'35010'},size(G1));

A1cat2 = repmat({'S'},size(A1));
B1cat2 = repmat({'S'},size(B1));
C1cat2 = repmat({'S'},size(C1));
D1cat2 = repmat({'S'},size(D1));
E1cat2 = repmat({'S'},size(E1));
F1cat2 = repmat({'S'},size(F1));
G1cat2 = repmat({'S'},size(G1));

A1c = sum(pWelch_stimRUN5c(:,t1:tx),2)./sum(pWelch_preRUN5c(:,t1:tx),2);
B1c = sum(pWelch_stimRUN15c(:,t1:tx),2)./sum(pWelch_preRUN15c(:,t1:tx),2);
C1c = sum(pWelch_stimRUN25c(:,t1:tx),2)./sum(pWelch_preRUN25c(:,t1:tx),2);
D1c = sum(pWelch_stimRUN3255c(:,t1:tx),2)./sum(pWelch_preRUN3255c(:,t1:tx),2);
E1c = sum(pWelch_stimRUN3505c(:,t1:tx),2)./sum(pWelch_preRUN3505c(:,t1:tx),2);
F1c = sum(pWelch_stimRUN5505c(:,t1:tx),2)./sum(pWelch_preRUN5505c(:,t1:tx),2);
G1c = sum(pWelch_stimRUN35010c(:,t1:tx),2)./sum(pWelch_preRUN35010c(:,t1:tx),2);
A1ccat1 = repmat({'5'},size(A1c));
B1ccat1 = repmat({'15'},size(B1c));
C1ccat1 = repmat({'25'},size(C1c));
D1ccat1 = repmat({'3255'},size(D1c));
E1ccat1 = repmat({'3505'},size(E1c));
F1ccat1 = repmat({'5505'},size(F1c));
G1ccat1 = repmat({'35010'},size(G1c));

A1ccat2 = repmat({'C'},size(A1c));
B1ccat2 = repmat({'C'},size(B1c));
C1ccat2 = repmat({'C'},size(C1c));
D1ccat2 = repmat({'C'},size(D1c));
E1ccat2 = repmat({'C'},size(E1c));
F1ccat2 = repmat({'C'},size(F1c));
G1ccat2 = repmat({'C'},size(G1c));

A2 = sum(pWelch_stimRUN5(:,(tx+1):t2),2)./sum(pWelch_preRUN5(:,(tx+1):t2),2);
B2 = sum(pWelch_stimRUN15(:,(tx+1):t2),2)./sum(pWelch_preRUN15(:,(tx+1):t2),2);
C2 = sum(pWelch_stimRUN25(:,(tx+1):t2),2)./sum(pWelch_preRUN25(:,(tx+1):t2),2);
D2 = sum(pWelch_stimRUN3255(:,(tx+1):t2),2)./sum(pWelch_preRUN3255(:,(tx+1):t2),2);
E2 = sum(pWelch_stimRUN3505(:,(tx+1):t2),2)./sum(pWelch_preRUN3505(:,(tx+1):t2),2);
F2 = sum(pWelch_stimRUN5505(:,(tx+1):t2),2)./sum(pWelch_preRUN5505(:,(tx+1):t2),2);
G2 = sum(pWelch_stimRUN35010(:,(tx+1):t2),2)./sum(pWelch_preRUN35010(:,(tx+1):t2),2);
A2cat1 = repmat({'5'},size(A2));
B2cat1 = repmat({'15'},size(B2));
C2cat1 = repmat({'25'},size(C2));
D2cat1 = repmat({'3255'},size(D2));
E2cat1 = repmat({'3505'},size(E2));
F2cat1 = repmat({'5505'},size(F2));
G2cat1 = repmat({'35010'},size(G2));

A2cat2 = repmat({'S'},size(A2));
B2cat2 = repmat({'S'},size(B2));
C2cat2 = repmat({'S'},size(C2));
D2cat2 = repmat({'S'},size(D2));
E2cat2 = repmat({'S'},size(E2));
F2cat2 = repmat({'S'},size(F2));
G2cat2 = repmat({'S'},size(G2));

A2c = sum(pWelch_stimRUN5c(:,(tx+1):t2),2)./sum(pWelch_preRUN5c(:,(tx+1):t2),2);
B2c = sum(pWelch_stimRUN15c(:,(tx+1):t2),2)./sum(pWelch_preRUN15c(:,(tx+1):t2),2);
C2c = sum(pWelch_stimRUN25c(:,(tx+1):t2),2)./sum(pWelch_preRUN25c(:,(tx+1):t2),2);
D2c = sum(pWelch_stimRUN3255c(:,(tx+1):t2),2)./sum(pWelch_preRUN3255c(:,(tx+1):t2),2);
E2c = sum(pWelch_stimRUN3505c(:,(tx+1):t2),2)./sum(pWelch_preRUN3505c(:,(tx+1):t2),2);
F2c = sum(pWelch_stimRUN5505c(:,(tx+1):t2),2)./sum(pWelch_preRUN5505c(:,(tx+1):t2),2);
G2c = sum(pWelch_stimRUN35010c(:,(tx+1):t2),2)./sum(pWelch_preRUN35010c(:,(tx+1):t2),2);
A2ccat1 = repmat({'5'},size(A2c));
B2ccat1 = repmat({'15'},size(B2c));
C2ccat1 = repmat({'25'},size(C2c));
D2ccat1 = repmat({'3255'},size(D2c));
E2ccat1 = repmat({'3505'},size(E2c));
F2ccat1 = repmat({'5505'},size(F2c));
G2ccat1 = repmat({'35010'},size(G2c));

A2ccat2 = repmat({'C'},size(A2c));
B2ccat2 = repmat({'C'},size(B2c));
C2ccat2 = repmat({'C'},size(C2c));
D2ccat2 = repmat({'C'},size(D2c));
E2ccat2 = repmat({'C'},size(E2c));
F2ccat2 = repmat({'C'},size(F2c));
G2ccat2 = repmat({'C'},size(G2c));

theta1 = [A1; B1; C1; D1; E1; F1; G1];
theta1cat1 = [A1cat1; B1cat1; C1cat1; D1cat1; E1cat1; F1cat1; G1cat1];
theta1cat2 = [A1cat2; B1cat2; C1cat2; D1cat2; E1cat2; F1cat2; G1cat2];

theta2 = [A2; B2; C2; D2; E2; F2; G2];
theta2cat1 = [A2cat1; B2cat1; C2cat1; D2cat1; E2cat1; F2cat1; G2cat1];
theta2cat2 = [A2cat2; B2cat2; C2cat2; D2cat2; E2cat2; F2cat2; G2cat2];

theta1c = [A1c; B1c; C1c; D1c; E1c; F1c; G1c];
theta1ccat1 = [A1ccat1; B1ccat1; C1ccat1; D1ccat1; E1ccat1; F1ccat1; G1ccat1];
theta1ccat2 = [A1ccat2; B1ccat2; C1ccat2; D1ccat2; E1ccat2; F1ccat2; G1ccat2];

theta2c = [A2c; B2c; C2c; D2c; E2c; F2c; G2c];
theta2ccat1 = [A2ccat1; B2ccat1; C2ccat1; D2ccat1; E2ccat1; F2ccat1; G2ccat1];
theta2ccat2 = [A2ccat2; B2ccat2; C2ccat2; D2ccat2; E2ccat2; F2ccat2; G2ccat2];

[p1,tbl1,stat1] = kruskalwallis(theta1,theta1cat1,'off');
[p2,tbl2,stat2] = kruskalwallis(theta2,theta2cat1,'off');
[p1c,tbl1c,stat1c] = kruskalwallis(theta1c,theta1ccat1,'off');
[p2c,tbl2c,stat2c] = kruskalwallis(theta2c,theta2ccat1,'off');


figure; hold on
plot([median(10*log10(A2c)) median(10*log10(B2c)) median(10*log10(C2c)) median(10*log10(D2c)) median(10*log10(E2c)) median(10*log10(F2c)) median(10*log10(G2c))],1:7,'Color','k','Marker','o','MarkerFaceColor','w')

plot([median(10*log10(A2)) median(10*log10(B2)) median(10*log10(C2)) median(10*log10(D2)) median(10*log10(E2)) median(10*log10(F2)) median(10*log10(G2))],1:7,'Color','b','Marker','o','MarkerFaceColor','w')
set(gca,'XLim',[-6 6],'XTick',[-6, 0, 6],'XTicklabel',{'-6';'0';'6'},'LineWidth',0.5,'YLim',[0.5 7.5])
set(gcf,'Position',[1 1 200 420])
text(-5,5,['chi2 = ' num2str(tbl2{2,5})]);
text(-5,4,['DF = ' num2str(tbl2{2,3})]);
text(-5,3,['pKW = ' num2str(tbl2{2,6})]);

text(-6,5,['chi2ctrl = ' num2str(tbl2c{2,5})]);
text(-6,4,['DFctrl = ' num2str(tbl2c{2,3})]);
text(-6,3,['pKWctrl = ' num2str(tbl2c{2,6})]);

figure; hold on
plot([median(10*log10(A1c)) median(10*log10(B1c)) median(10*log10(C1c)) median(10*log10(D1c)) median(10*log10(E1c)) median(10*log10(F1c)) median(10*log10(G1c))],1:7,'Color','k','Marker','o','MarkerFaceColor','w')

plot([median(10*log10(A1)) median(10*log10(B1)) median(10*log10(C1)) median(10*log10(D1)) median(10*log10(E1)) median(10*log10(F1)) median(10*log10(G1))],1:7,'Color','b','Marker','o','MarkerFaceColor','w')
set(gca,'XLim',[-6 6],'XTick',[-6, 0, 6],'XTicklabel',{'-6';'0';'6'},'LineWidth',0.5,'YLim',[0.5 7.5])
set(gcf,'Position',[1 1 200 420])
text(-5,5,['chi2 = ' num2str(tbl1{2,5})]);
text(-5,4,['DF = ' num2str(tbl1{2,3})]);
text(-5,3,['pKW = ' num2str(tbl1{2,6})]);

text(-6,5,['chi2ctrl = ' num2str(tbl1c{2,5})]);
text(-6,4,['DFctrl = ' num2str(tbl1c{2,3})]);
text(-6,3,['pKWctrl = ' num2str(tbl1c{2,6})]);



freqtick = [1 5 12 20];
figure; hold on
imagesc(matrix);
set(gca,'CLim',[-6 6])
set(gca,'XTick',arrayfun(@(x) knnsearch(fWelch(1,:)',x),freqtick),'XTickLabel',arrayfun(@num2str,freqtick,'UniformOutput',false))
set(gca,'YTick',1:7,'YTickLabel',{'5';'15';'25';'3255';'3505';'5505';'35010'})
set(gca,'XLim',[knnsearch(fWelch(1,:)',1) knnsearch(fWelch(1,:)',20)])
set(gca,'YLim',[0.5 7.5])

figure; hold on
imagesc(matrix2);
set(gca,'CLim',[-6 6])
set(gca,'XTick',arrayfun(@(x) knnsearch(fWelch(1,:)',x),freqtick),'XTickLabel',arrayfun(@num2str,freqtick,'UniformOutput',false))
set(gca,'YTick',1:7,'YTickLabel',{'5';'15';'25';'3255';'3505';'5505';'35010'})
set(gca,'XLim',[knnsearch(fWelch(1,:)',1) knnsearch(fWelch(1,:)',20)])
set(gca,'YLim',[0.5 7.5])

%% pwelch for all channels

% get data from files
tic
[pWelchALL_preLT, pWelchALL_stimLT, pWelchALL_postLT,powerLT,waveLT,frLT,powerPyrDLT,powerRadDLT,powerLamDLT,powerMolDLT,powerHilDLT,...
    wavePyrDLT,waveRadDLT,waveLamDLT,waveMolDLT,waveHilDLT] = ...
    andor_INCfreemov_STEP5_eeg_fast4_allperiodo('INC','linearTrack','f25Hz',{'1868','2017','2026','2027','2046'},2000);
toc
D = whos;
sum(cell2mat({D.bytes}))
save('/Volumes/TimeMachine/formatlab/INC_layers_LT.mat','-v7.3')
clear all
tic
[pWelchALL_preHB, pWelchALL_stimHB, pWelchALL_postHB,powerHB,waveHB,frHB,powerPyrDHB,powerRadDHB,powerLamDHB,powerMolDHB,powerHilDHB,...
    wavePyrDHB,waveRadDHB,waveLamDHB,waveMolDHB,waveHilDHB] = ...
    andor_INCfreemov_STEP5_eeg_fast4_allperiodo('INC','holeBox','f25Hz',{'1868','2017','2026','2027','2046'},2000);
toc
D = whos;
sum(cell2mat({D.bytes}))
save('/Volumes/TimeMachine/formatlab/INC_layers_HB.mat','-v7.3')
clear all
tic
[pWelchALL_preHC, pWelchALL_stimHC, pWelchALL_postHC,powerHC,waveHC,frHC,powerPyrDHC,powerRadDHC,powerLamDHC,powerMolDHC,powerHilDHC,...
    wavePyrDHC,waveRadDHC,waveLamDHC,waveMolDHC,waveHilDHC] = ...
    andor_INCfreemov_STEP5_eeg_fast4_allperiodo('INC','homeCage','f25Hz',{'1868','2017','2026','2027','2046'},2000);
toc
D = whos;
sum(cell2mat({D.bytes}))
save('/Volumes/TimeMachine/formatlab/INC_layers_HC.mat','-v7.3')
clear all
tic
[pWelchALL_preLT_CTRL, pWelchALL_stimLT_CTRL, pWelchALL_postLT_CTRL,powerLT_CTRL,waveLT_CTRL,frLT_CTRL,powerPyrDLT_CTRL,powerRadDLT_CTRL,powerLamDLT_CTRL,powerMolDLT_CTRL,powerHilDLT_CTRL,...
    wavePyrDLT_CTRL,waveRadDLT_CTRL,waveLamDLT_CTRL,waveMolDLT_CTRL,waveHilDLT_CTRL] = ...
    andor_INCfreemov_STEP5_eeg_fast4_allperiodo('BLIND','linearTrack','f25Hz',{'1868','2017','2026','2027','2046'},2000);
toc
D = whos;
sum(cell2mat({D.bytes}))
save('/Volumes/TimeMachine/formatlab/INC_layers_LT_CTRL.mat','-v7.3')
clear all
tic
[pWelchALL_preHB_CTRL, pWelchALL_stimHB_CTRL, pWelchALL_postHB_CTRL,powerHB_CTRL,waveHB_CTRL,frHB_CTRL,powerPyrDHB_CTRL,powerRadDHB_CTRL,powerLamDHB_CTRL,powerMolDHB_CTRL,powerHilDHB_CTRL,...
    wavePyrDHB_CTRL,waveRadDHB_CTRL,waveLamDHB_CTRL,waveMolDHB_CTRL,waveHilDHB_CTRL] = ...
    andor_INCfreemov_STEP5_eeg_fast4_allperiodo('BLIND','holeBox','f25Hz',{'1868','2017','2026','2027','2046'},2000);
toc
D = whos;
sum(cell2mat({D.bytes}))
save('/Volumes/TimeMachine/formatlab/INC_layers_HB_CTRL.mat','-v7.3')
clear all
tic
[pWelchALL_preHC_CTRL, pWelchALL_stimHC_CTRL, pWelchALL_postHC_CTRL,powerHC_CTRL,waveHC_CTRL,frHC_CTRL,powerPyrDHC_CTRL,powerRadDHC_CTRL,powerLamDHC_CTRL,powerMolDHC_CTRL,powerHilDHC_CTRL,...
    wavePyrDHC_CTRL,waveRadDHC_CTRL,waveLamDHC_CTRL,waveMolDHC_CTRL,waveHilDHC_CTRL] = ...
    andor_INCfreemov_STEP5_eeg_fast4_allperiodo('BLIND','homeCage','f25Hz',{'1868','2017','2026','2027','2046'},2000);
toc
D = whos;
sum(cell2mat({D.bytes}))
save('/Volumes/TimeMachine/formatlab/INC_layers_HC_CTRL.mat','-v7.3')
clear all

%% CFC for all layers - pyramidale deriv eeg
load('/Volumes/TimeMachine/formatlab/INC_layers_HB.mat','waveHB','wavePyrDHB','frHB');
HB = load('INCbase_holeBox_f25Hz','stimIndex2','rowdata','runindex','thetaindex');
indexHB = and(HB.runindex,HB.thetaindex);

rowdataHB = HB.rowdata(indexHB,:);
waveHB = waveHB(:,:,indexHB);
wavePyrDHB = wavePyrDHB(:,:,indexHB);
frHB = frHB(indexHB,:);
stimIndexHB = HB.stimIndex2(indexHB,:);

load('/Volumes/TimeMachine/formatlab/INC_layers_LT.mat','waveLT','wavePyrDLT','frLT');
LT = load('INCbase_linearTrack_f25Hz','stimIndex2','rowdata','runindex','thetaindex');
indexLT = and(LT.runindex,LT.thetaindex);

rowdataLT = LT.rowdata(indexLT,:);
waveLT = waveLT(:,:,indexLT);
wavePyrDLT = wavePyrDLT(:,:,indexLT);
stimIndexLT = LT.stimIndex2(indexLT,:);


rowdata = [rowdataLT; rowdataHB];
fr = frHB;
stimIndex = [stimIndexLT; stimIndexHB];

wave = cat(3,waveLT(:,(stimIndex(1,3)-4000):(stimIndex(1,3)+8000),:),waveHB(:,(stimIndex(1,3)-4000):(stimIndex(1,3)+8000),:));
waveD = cat(3,wavePyrDLT(:,(stimIndex(1,3)-4000):(stimIndex(1,3)+8000),:),wavePyrDHB(:,(stimIndex(1,3)-4000):(stimIndex(1,3)+8000),:));
eegindex = stimIndex(:,3);
eegindex2 = stimIndex(:,4);

[com_PRE,com_STIM] = andor_CFCDeriv(45,1,250,5,fr,wave,waveD,eegindex,eegindex2);
%%
save('INC_CFC_running_PyrD_25.mat','com_PRE','com_STIM','rowdata','fr','-v7.3')
%%
figure; hold on
FR = fr(1,:)';
freqX = [1 5 12 30 45];
freqXpos = arrayfun(@(x) knnsearch(FR,x),freqX)-knnsearch(FR,freqX(end))+1;

freqY = [5 12 30 45 60 100 250];
freqYpos = arrayfun(@(x) knnsearch(FR,x),freqY)-knnsearch(FR,freqY(end))+1;
temp = mean(com_STIM-com_PRE,3);
imagesc(temp)
set(gca,'YTick',flip(freqYpos),'YTickLabel',flip(arrayfun(@num2str,freqY,'UniformOutput',false)))
set(gca,'YDir','reverse')
set(gca,'YLim',[freqYpos(end) freqYpos(1)])

set(gca,'XTick',flip(freqXpos),'XTickLabel',flip(arrayfun(@num2str,freqX,'UniformOutput',false)))
set(gca,'XDir','reverse')
set(gca,'XLim',[freqXpos(end) freqXpos(1)])
%% CFC for all layers - radiatum deriv eeg
load('/Volumes/TimeMachine/formatlab/INC_layers_HB.mat','waveHB','waveRadDHB','frHB');
HB = load('INCbase_holeBox_f25Hz','stimIndex2','rowdata','runindex','thetaindex');
indexHB = and(HB.runindex,HB.thetaindex);

rowdataHB = HB.rowdata(indexHB,:);
waveHB = waveHB(:,:,indexHB);
waveRadDHB = waveRadDHB(:,:,indexHB);
frHB = frHB(indexHB,:);
stimIndexHB = HB.stimIndex2(indexHB,:);

load('/Volumes/TimeMachine/formatlab/INC_layers_LT.mat','waveLT','waveRadDLT','frLT');
LT = load('INCbase_linearTrack_f25Hz','stimIndex2','rowdata','runindex','thetaindex');
indexLT = and(LT.runindex,LT.thetaindex);

rowdataLT = LT.rowdata(indexLT,:);
waveLT = waveLT(:,:,indexLT);
waveRadDLT = waveRadDLT(:,:,indexLT);
stimIndexLT = LT.stimIndex2(indexLT,:);


rowdata = [rowdataLT; rowdataHB];
fr = frHB;
stimIndex = [stimIndexLT; stimIndexHB];

wave = cat(3,waveLT(:,(stimIndex(1,3)-4000):(stimIndex(1,3)+8000),:),waveHB(:,(stimIndex(1,3)-4000):(stimIndex(1,3)+8000),:));
waveD = cat(3,waveRadDLT(:,(stimIndex(1,3)-4000):(stimIndex(1,3)+8000),:),waveRadDHB(:,(stimIndex(1,3)-4000):(stimIndex(1,3)+8000),:));
eegindex = stimIndex(:,3);
eegindex2 = stimIndex(:,4);

[com_PRE,com_STIM] = andor_CFCDeriv(45,1,250,5,fr,wave,waveD,eegindex,eegindex2);
%%
save('INC_CFC_running_RadD_25.mat','com_PRE','com_STIM','rowdata','fr','-v7.3')
%% CFC for all layers - lac-molderiv eeg
load('/Volumes/TimeMachine/formatlab/INC_layers_HB.mat','waveHB','waveLamDHB','frHB');
HB = load('INCbase_holeBox_f25Hz','stimIndex2','rowdata','runindex','thetaindex');
indexHB = and(HB.runindex,HB.thetaindex);

rowdataHB = HB.rowdata(indexHB,:);
waveHB = waveHB(:,:,indexHB);
waveLamDHB = waveLamDHB(:,:,indexHB);
frHB = frHB(indexHB,:);
stimIndexHB = HB.stimIndex2(indexHB,:);

load('/Volumes/TimeMachine/formatlab/INC_layers_LT.mat','waveLT','waveLamDLT','frLT');
LT = load('INCbase_linearTrack_f25Hz','stimIndex2','rowdata','runindex','thetaindex');
indexLT = and(LT.runindex,LT.thetaindex);

rowdataLT = LT.rowdata(indexLT,:);
waveLT = waveLT(:,:,indexLT);
waveLamDLT = waveLamDLT(:,:,indexLT);
stimIndexLT = LT.stimIndex2(indexLT,:);


rowdata = [rowdataLT; rowdataHB];
fr = frHB;
stimIndex = [stimIndexLT; stimIndexHB];

wave = cat(3,waveLT(:,(stimIndex(1,3)-4000):(stimIndex(1,3)+8000),:),waveHB(:,(stimIndex(1,3)-4000):(stimIndex(1,3)+8000),:));
waveD = cat(3,waveLamDLT(:,(stimIndex(1,3)-4000):(stimIndex(1,3)+8000),:),waveLamDHB(:,(stimIndex(1,3)-4000):(stimIndex(1,3)+8000),:));
eegindex = stimIndex(:,3);
eegindex2 = stimIndex(:,4);

[com_PRE,com_STIM] = andor_CFCDeriv(45,1,250,5,fr,wave,waveD,eegindex,eegindex2);
%%
save('INC_CFC_running_LamD_25.mat','com_PRE','com_STIM','rowdata','fr','-v7.3')
%% CFC for all layers - moleculare deriv eeg
load('/Volumes/TimeMachine/formatlab/INC_layers_HB.mat','waveHB','frHB');
HB = load('INCbase_holeBox_f25Hz','stimIndex2','rowdata','runindex','thetaindex');
indexHB = and(HB.runindex,HB.thetaindex);

rowdataHB = HB.rowdata(indexHB,:);
waveHB = waveHB(:,:,indexHB);
frHB = frHB(indexHB,:);
stimIndexHB = HB.stimIndex2(indexHB,:);

load('/Volumes/TimeMachine/formatlab/INC_layers_LT.mat','waveLT','frLT');
LT = load('INCbase_linearTrack_f25Hz','stimIndex2','rowdata','runindex','thetaindex');
indexLT = and(LT.runindex,LT.thetaindex);

rowdataLT = LT.rowdata(indexLT,:);
waveLT = waveLT(:,:,indexLT);
stimIndexLT = LT.stimIndex2(indexLT,:);


rowdata = [rowdataLT; rowdataHB];
fr = frHB;
stimIndex = [stimIndexLT; stimIndexHB];

wave = cat(3,waveLT(:,(stimIndex(1,3)-4000):(stimIndex(1,3)+8000),:),waveHB(:,(stimIndex(1,3)-4000):(stimIndex(1,3)+8000),:));
eegindex = stimIndex(:,3);
eegindex2 = stimIndex(:,4);

[com_PRE,com_STIM] = andor_CFCDeriv(45,1,250,5,fr,wave,wave,eegindex,eegindex2);
%%
save('INC_CFC_running_pLFP_25.mat','com_PRE','com_STIM','rowdata','fr','-v7.3')
%% CFC for all layers - moleculare CTRL deriv eeg
load('/Volumes/TimeMachine/formatlab/INC_layers_HB_CTRL.mat','waveHB_CTRL','waveRadDHB_CTRL','frHB_CTRL');
HB = load('INCBLINDbase_holeBox_f25Hz','stimIndex2','rowdata','runindex','thetaindex');
indexHB = and(HB.runindex,HB.thetaindex);

rowdataHB = HB.rowdata(indexHB,:);
waveHB_CTRL = waveHB_CTRL(:,:,indexHB);
waveRadDHB_CTRL = waveRadDHB_CTRL(:,:,indexHB);
frHB_CTRL = frHB_CTRL(indexHB,:);
stimIndexHB = HB.stimIndex2(indexHB,:);

load('/Volumes/TimeMachine/formatlab/INC_layers_LT_CTRL.mat','waveLT_CTRL','waveRadDLT_CTRL','frLT_CTRL');
LT = load('INCBLINDbase_linearTrack_f25Hz','stimIndex2','rowdata','runindex','thetaindex');
indexLT = and(LT.runindex,LT.thetaindex);

rowdataLT = LT.rowdata(indexLT,:);
waveLT_CTRL = waveLT_CTRL(:,:,indexLT);
waveRadDLT_CTRL = waveRadDLT_CTRL(:,:,indexLT);
stimIndexLT = LT.stimIndex2(indexLT,:);


rowdata = [rowdataLT; rowdataHB];
fr = frHB_CTRL;
stimIndex = [stimIndexLT; stimIndexHB];

wave = cat(3,waveLT_CTRL(:,(stimIndex(1,3)-4000):(stimIndex(1,3)+8000),:),waveHB_CTRL(:,(stimIndex(1,3)-4000):(stimIndex(1,3)+8000),:));
waveD = cat(3,waveRadDLT_CTRL(:,(stimIndex(1,3)-4000):(stimIndex(1,3)+8000),:),waveRadDHB_CTRL(:,(stimIndex(1,3)-4000):(stimIndex(1,3)+8000),:));
eegindex = stimIndex(:,3);
eegindex2 = stimIndex(:,4);

[com_PRE_CTRL,com_STIM_CTRL] = andor_CFCDeriv(45,1,250,5,fr,wave,waveD,eegindex,eegindex2);
%%
save('INC_CFC_running_RadD_CTRL_25.mat','com_PRE_CTRL','com_STIM_CTRL','rowdata','fr','-v7.3')
%% CFC for all layers - pyramidale deriv eeg REM
load('/Volumes/TimeMachine/formatlab/INC_layers_HC_CTRL.mat','waveHC_CTRL','frHC_CTRL');
HC = load('INCBLINDbase_homeCage_f25Hz','stimIndex2','rowdata','remindex');
indexHC = HC.remindex;

rowdata = HC.rowdata(indexHC,:);
wave = waveHC_CTRL(:,:,indexHC);
fr = frHC_CTRL(indexHC,:);
stimIndex = HC.stimIndex2(indexHC,:);

eegindex = stimIndex(:,3);
eegindex2 = stimIndex(:,4);

[com_PRE_CTRL,com_STIM_CTRL] = andor_CFCDeriv(45,1,250,5,fr,wave,wave,eegindex,eegindex2);
%%
save('INC_CFC_rem_pLFP_CTRL_25.mat','com_PRE_CTRL','com_STIM_CTRL','rowdata','fr','-v7.3')
%% CFC figures

fileType = 'running';
fr = load('INC_CFC_rem_pLFP_25.mat','fr');
fr = fr.fr;

figure; hold on
FR = fr(1,:)';
FRY = FR(knnsearch(FR,250):knnsearch(FR,5));
FRX = FR(knnsearch(FR,45):knnsearch(FR,1));
freqX = [1 5 12 30 45];
freqXpos = arrayfun(@(x) knnsearch(FRX,x),freqX)-knnsearch(FRX,freqX(end))+1;

xfreq1 = knnsearch(FRX,12);
xfreq2 = knnsearch(FRX,5);

fastg1 = knnsearch(FRY,150);
fastg2 = knnsearch(FRY,100);
midg1 = knnsearch(FRY,100);
midg2 = knnsearch(FRY,60);
slowg1 = knnsearch(FRY,45);
slowg2 = knnsearch(FRY,30);




freqY = [5 12 30 60 100 200 250];
freqYpos = arrayfun(@(x) knnsearch(FR,x),freqY)-knnsearch(FR,freqY(end))+1;
CLim = [0 0.005];

load(['INC_CFC_' fileType '_pLFP_25.mat']);
P1 = mean(com_PRE,3);
S1 = mean(com_STIM,3);
D1 = mean(com_STIM-com_PRE,3);

load(['INC_CFC_' fileType '_PyrD_25.mat']);
P2 = mean(com_PRE,3);
S2 = mean(com_STIM,3);
D2 = mean(com_STIM-com_PRE,3);

for k = 1:size(com_PRE,3)
    temp = com_PRE(fastg1:fastg2,xfreq1:xfreq2,k);
    fastg_PREpyr(k,1) = mean(temp(:));
    
    temp = com_STIM(fastg1:fastg2,xfreq1:xfreq2,k);
    fastg_STIMpyr(k,1) = mean(temp(:));
    
    temp = com_PRE(midg1:midg2,xfreq1:xfreq2,k);
    midg_PREpyr(k,1) = mean(temp(:));
    
    temp = com_STIM(midg1:midg2,xfreq1:xfreq2,k);
    midg_STIMpyr(k,1) = mean(temp(:));
    
    temp = com_PRE(slowg1:slowg2,xfreq1:xfreq2,k);
    slowg_PREpyr(k,1) = mean(temp(:));
    
    temp = com_STIM(slowg1:slowg2,xfreq1:xfreq2,k);
    slowg_STIMpyr(k,1) = mean(temp(:));
end

load(['INC_CFC_' fileType '_RadD_25.mat']);
P3 = mean(com_PRE,3);
S3 = mean(com_STIM,3);
D3 = mean(com_STIM-com_PRE,3);
for k = 1:size(com_PRE,3)
    temp = com_PRE(fastg1:fastg2,xfreq1:xfreq2,k);
    fastg_PRErad(k,1) = mean(temp(:));
    
    temp = com_STIM(fastg1:fastg2,xfreq1:xfreq2,k);
    fastg_STIMrad(k,1) = mean(temp(:));
    
    temp = com_PRE(midg1:midg2,xfreq1:xfreq2,k);
    midg_PRErad(k,1) = mean(temp(:));
    
    temp = com_STIM(midg1:midg2,xfreq1:xfreq2,k);
    midg_STIMrad(k,1) = mean(temp(:));
    
    temp = com_PRE(slowg1:slowg2,xfreq1:xfreq2,k);
    slowg_PRErad(k,1) = mean(temp(:));
    
    temp = com_STIM(slowg1:slowg2,xfreq1:xfreq2,k);
    slowg_STIMrad(k,1) = mean(temp(:));
end

load(['INC_CFC_' fileType '_LamD_25.mat']);
P4 = mean(com_PRE,3);
S4 = mean(com_STIM,3);
D4 = mean(com_STIM-com_PRE,3);
for k = 1:size(com_PRE,3)
    temp = com_PRE(fastg1:fastg2,xfreq1:xfreq2,k);
    fastg_PRElam(k,1) = mean(temp(:));
    
    temp = com_STIM(fastg1:fastg2,xfreq1:xfreq2,k);
    fastg_STIMlam(k,1) = mean(temp(:));
    
    temp = com_PRE(midg1:midg2,xfreq1:xfreq2,k);
    midg_PRElam(k,1) = mean(temp(:));
    
    temp = com_STIM(midg1:midg2,xfreq1:xfreq2,k);
    midg_STIMlam(k,1) = mean(temp(:));
    
    temp = com_PRE(slowg1:slowg2,xfreq1:xfreq2,k);
    slowg_PRElam(k,1) = mean(temp(:));
    
    temp = com_STIM(slowg1:slowg2,xfreq1:xfreq2,k);
    slowg_STIMlam(k,1) = mean(temp(:));
end

load(['INC_CFC_' fileType '_MolD_25.mat']);
P5 = mean(com_PRE,3);
S5 = mean(com_STIM,3);
D5 = mean(com_STIM-com_PRE,3);
for k = 1:size(com_PRE,3)
    temp = com_PRE(fastg1:fastg2,xfreq1:xfreq2,k);
    fastg_PREmol(k,1) = mean(temp(:));
    
    temp = com_STIM(fastg1:fastg2,xfreq1:xfreq2,k);
    fastg_STIMmol(k,1) = mean(temp(:));
    
    temp = com_PRE(midg1:midg2,xfreq1:xfreq2,k);
    midg_PREmol(k,1) = mean(temp(:));
    
    temp = com_STIM(midg1:midg2,xfreq1:xfreq2,k);
    midg_STIMmol(k,1) = mean(temp(:));
    
    temp = com_PRE(slowg1:slowg2,xfreq1:xfreq2,k);
    slowg_PREmol(k,1) = mean(temp(:));
    
    temp = com_STIM(slowg1:slowg2,xfreq1:xfreq2,k);
    slowg_STIMmol(k,1) = mean(temp(:));
end

load(['INC_CFC_' fileType '_HilD_25.mat']);
P6 = mean(com_PRE,3);
S6 = mean(com_STIM,3);
D6 = mean(com_STIM-com_PRE,3);
for k = 1:size(com_PRE,3)
    temp = com_PRE(fastg1:fastg2,xfreq1:xfreq2,k);
    fastg_PREhil(k,1) = mean(temp(:));
    
    temp = com_STIM(fastg1:fastg2,xfreq1:xfreq2,k);
    fastg_STIMhil(k,1) = mean(temp(:));
    
    temp = com_PRE(midg1:midg2,xfreq1:xfreq2,k);
    midg_PREhil(k,1) = mean(temp(:));
    
    temp = com_STIM(midg1:midg2,xfreq1:xfreq2,k);
    midg_STIMhil(k,1) = mean(temp(:));
    
    temp = com_PRE(slowg1:slowg2,xfreq1:xfreq2,k);
    slowg_PREhil(k,1) = mean(temp(:));
    
    temp = com_STIM(slowg1:slowg2,xfreq1:xfreq2,k);
    slowg_STIMhil(k,1) = mean(temp(:));
end

andor_INCfreemov_STEP4_helpSUBPLOT(6,3,1,P1,freqYpos,freqY,freqXpos,freqX,CLim)
andor_INCfreemov_STEP4_helpSUBPLOT(6,3,4,P2,freqYpos,freqY,freqXpos,freqX,CLim)
andor_INCfreemov_STEP4_helpSUBPLOT(6,3,7,P3,freqYpos,freqY,freqXpos,freqX,CLim)
andor_INCfreemov_STEP4_helpSUBPLOT(6,3,10,P4,freqYpos,freqY,freqXpos,freqX,CLim)
andor_INCfreemov_STEP4_helpSUBPLOT(6,3,13,P5,freqYpos,freqY,freqXpos,freqX,CLim)
andor_INCfreemov_STEP4_helpSUBPLOT(6,3,16,P6,freqYpos,freqY,freqXpos,freqX,CLim)

andor_INCfreemov_STEP4_helpSUBPLOT(6,3,2,S1,freqYpos,freqY,freqXpos,freqX,CLim)
andor_INCfreemov_STEP4_helpSUBPLOT(6,3,5,S2,freqYpos,freqY,freqXpos,freqX,CLim)
andor_INCfreemov_STEP4_helpSUBPLOT(6,3,8,S3,freqYpos,freqY,freqXpos,freqX,CLim)
andor_INCfreemov_STEP4_helpSUBPLOT(6,3,11,S4,freqYpos,freqY,freqXpos,freqX,CLim)
andor_INCfreemov_STEP4_helpSUBPLOT(6,3,14,S5,freqYpos,freqY,freqXpos,freqX,CLim)
andor_INCfreemov_STEP4_helpSUBPLOT(6,3,17,S6,freqYpos,freqY,freqXpos,freqX,CLim)

andor_INCfreemov_STEP4_helpSUBPLOT(6,3,3,D1,freqYpos,freqY,freqXpos,freqX,[-0.003 0.003])
andor_INCfreemov_STEP4_helpSUBPLOT(6,3,6,D2,freqYpos,freqY,freqXpos,freqX,[-0.003 0.003])
andor_INCfreemov_STEP4_helpSUBPLOT(6,3,9,D3,freqYpos,freqY,freqXpos,freqX,[-0.003 0.003])
andor_INCfreemov_STEP4_helpSUBPLOT(6,3,12,D4,freqYpos,freqY,freqXpos,freqX,[-0.003 0.003])
andor_INCfreemov_STEP4_helpSUBPLOT(6,3,15,D5,freqYpos,freqY,freqXpos,freqX,[-0.003 0.003])
andor_INCfreemov_STEP4_helpSUBPLOT(6,3,18,D6,freqYpos,freqY,freqXpos,freqX,[-0.003 0.003])

set(gcf,'Position',[1 1 420 1000])

save('INC_CFC_forstat_running.mat','slowg_PREpyr','slowg_STIMpyr','midg_PREpyr','midg_STIMpyr','fastg_PREpyr','fastg_STIMpyr',...
    'slowg_PRErad','slowg_STIMrad','midg_PRErad','midg_STIMrad','fastg_PRErad','fastg_STIMrad',...
    'slowg_PRElam','slowg_STIMlam','midg_PRElam','midg_STIMlam','fastg_PRElam','fastg_STIMlam',...
    'slowg_PREmol','slowg_STIMmol','midg_PREmol','midg_STIMmol','fastg_PREmol','fastg_STIMmol',...
    'slowg_PREhil','slowg_STIMhil','midg_PREhil','midg_STIMhil','fastg_PREhil','fastg_STIMhil','-v7.3')
%% ctrl
fileType = 'rem';
fr = load('INC_CFC_rem_pLFP_25.mat','fr');
fr = fr.fr;

figure; hold on
FR = fr(1,:)';
FRY = FR(knnsearch(FR,250):knnsearch(FR,5));
FRX = FR(knnsearch(FR,45):knnsearch(FR,1));
freqX = [1 5 12 30 45];
freqXpos = arrayfun(@(x) knnsearch(FRX,x),freqX)-knnsearch(FRX,freqX(end))+1;

xfreq1 = knnsearch(FRX,12);
xfreq2 = knnsearch(FRX,5);

fastg1 = knnsearch(FRY,150);
fastg2 = knnsearch(FRY,100);
midg1 = knnsearch(FRY,100);
midg2 = knnsearch(FRY,60);
slowg1 = knnsearch(FRY,45);
slowg2 = knnsearch(FRY,30);




freqY = [5 12 30 60 100 200 250];
freqYpos = arrayfun(@(x) knnsearch(FR,x),freqY)-knnsearch(FR,freqY(end))+1;
CLim = [0 0.005];

load(['INC_CFC_' fileType '_pLFP_CTRL_25.mat']);
P1 = mean(com_PRE_CTRL,3);
S1 = mean(com_STIM_CTRL,3);
D1 = mean(com_STIM_CTRL-com_PRE_CTRL,3);

load(['INC_CFC_' fileType '_PyrD_CTRL_25.mat']);
P2 = mean(com_PRE_CTRL,3);
S2 = mean(com_STIM_CTRL,3);
D2 = mean(com_STIM_CTRL-com_PRE_CTRL,3);

for k = 1:size(com_PRE_CTRL,3)
    temp = com_PRE_CTRL(fastg1:fastg2,xfreq1:xfreq2,k);
    fastg_PREpyr_CTRL(k,1) = mean(temp(:));
    
    temp = com_STIM_CTRL(fastg1:fastg2,xfreq1:xfreq2,k);
    fastg_STIMpyr_CTRL(k,1) = mean(temp(:));
    
    temp = com_PRE_CTRL(midg1:midg2,xfreq1:xfreq2,k);
    midg_PREpyr_CTRL(k,1) = mean(temp(:));
    
    temp = com_STIM_CTRL(midg1:midg2,xfreq1:xfreq2,k);
    midg_STIMpyr_CTRL(k,1) = mean(temp(:));
    
    temp = com_PRE_CTRL(slowg1:slowg2,xfreq1:xfreq2,k);
    slowg_PREpyr_CTRL(k,1) = mean(temp(:));
    
    temp = com_STIM_CTRL(slowg1:slowg2,xfreq1:xfreq2,k);
    slowg_STIMpyr_CTRL(k,1) = mean(temp(:));
end

load(['INC_CFC_' fileType '_RadD_CTRL_25.mat']);
P3 = mean(com_PRE_CTRL,3);
S3 = mean(com_STIM_CTRL,3);
D3 = mean(com_STIM_CTRL-com_PRE_CTRL,3);

for k = 1:size(com_PRE_CTRL,3)
    temp = com_PRE_CTRL(fastg1:fastg2,xfreq1:xfreq2,k);
    fastg_PRErad_CTRL(k,1) = mean(temp(:));
    
    temp = com_STIM_CTRL(fastg1:fastg2,xfreq1:xfreq2,k);
    fastg_STIMrad_CTRL(k,1) = mean(temp(:));
    
    temp = com_PRE_CTRL(midg1:midg2,xfreq1:xfreq2,k);
    midg_PRErad_CTRL(k,1) = mean(temp(:));
    
    temp = com_STIM_CTRL(midg1:midg2,xfreq1:xfreq2,k);
    midg_STIMrad_CTRL(k,1) = mean(temp(:));
    
    temp = com_PRE_CTRL(slowg1:slowg2,xfreq1:xfreq2,k);
    slowg_PRErad_CTRL(k,1) = mean(temp(:));
    
    temp = com_STIM_CTRL(slowg1:slowg2,xfreq1:xfreq2,k);
    slowg_STIMrad_CTRL(k,1) = mean(temp(:));
end

load(['INC_CFC_' fileType '_LamD_CTRL_25.mat']);
P4 = mean(com_PRE_CTRL,3);
S4 = mean(com_STIM_CTRL,3);
D4 = mean(com_STIM_CTRL-com_PRE_CTRL,3);

for k = 1:size(com_PRE_CTRL,3)
    temp = com_PRE_CTRL(fastg1:fastg2,xfreq1:xfreq2,k);
    fastg_PRElam_CTRL(k,1) = mean(temp(:));
    
    temp = com_STIM_CTRL(fastg1:fastg2,xfreq1:xfreq2,k);
    fastg_STIMlam_CTRL(k,1) = mean(temp(:));
    
    temp = com_PRE_CTRL(midg1:midg2,xfreq1:xfreq2,k);
    midg_PRElam_CTRL(k,1) = mean(temp(:));
    
    temp = com_STIM_CTRL(midg1:midg2,xfreq1:xfreq2,k);
    midg_STIMlam_CTRL(k,1) = mean(temp(:));
    
    temp = com_PRE_CTRL(slowg1:slowg2,xfreq1:xfreq2,k);
    slowg_PRElam_CTRL(k,1) = mean(temp(:));
    
    temp = com_STIM_CTRL(slowg1:slowg2,xfreq1:xfreq2,k);
    slowg_STIMlam_CTRL(k,1) = mean(temp(:));
end

load(['INC_CFC_' fileType '_MolD_CTRL_25.mat']);
P5 = mean(com_PRE_CTRL,3);
S5 = mean(com_STIM_CTRL,3);
D5 = mean(com_STIM_CTRL-com_PRE_CTRL,3);

for k = 1:size(com_PRE_CTRL,3)
    temp = com_PRE_CTRL(fastg1:fastg2,xfreq1:xfreq2,k);
    fastg_PREmol_CTRL(k,1) = mean(temp(:));
    
    temp = com_STIM_CTRL(fastg1:fastg2,xfreq1:xfreq2,k);
    fastg_STIMmol_CTRL(k,1) = mean(temp(:));
    
    temp = com_PRE_CTRL(midg1:midg2,xfreq1:xfreq2,k);
    midg_PREmol_CTRL(k,1) = mean(temp(:));
    
    temp = com_STIM_CTRL(midg1:midg2,xfreq1:xfreq2,k);
    midg_STIMmol_CTRL(k,1) = mean(temp(:));
    
    temp = com_PRE_CTRL(slowg1:slowg2,xfreq1:xfreq2,k);
    slowg_PREmol_CTRL(k,1) = mean(temp(:));
    
    temp = com_STIM_CTRL(slowg1:slowg2,xfreq1:xfreq2,k);
    slowg_STIMmol_CTRL(k,1) = mean(temp(:));
end

load(['INC_CFC_' fileType '_HilD_CTRL_25.mat']);
P6 = mean(com_PRE_CTRL,3);
S6 = mean(com_STIM_CTRL,3);
D6 = mean(com_STIM_CTRL-com_PRE_CTRL,3);

for k = 1:size(com_PRE_CTRL,3)
    temp = com_PRE_CTRL(fastg1:fastg2,xfreq1:xfreq2,k);
    fastg_PREhil_CTRL(k,1) = mean(temp(:));
    
    temp = com_STIM_CTRL(fastg1:fastg2,xfreq1:xfreq2,k);
    fastg_STIMhil_CTRL(k,1) = mean(temp(:));
    
    temp = com_PRE_CTRL(midg1:midg2,xfreq1:xfreq2,k);
    midg_PREhil_CTRL(k,1) = mean(temp(:));
    
    temp = com_STIM_CTRL(midg1:midg2,xfreq1:xfreq2,k);
    midg_STIMhil_CTRL(k,1) = mean(temp(:));
    
    temp = com_PRE_CTRL(slowg1:slowg2,xfreq1:xfreq2,k);
    slowg_PREhil_CTRL(k,1) = mean(temp(:));
    
    temp = com_STIM_CTRL(slowg1:slowg2,xfreq1:xfreq2,k);
    slowg_STIMhil_CTRL(k,1) = mean(temp(:));
end

andor_INCfreemov_STEP4_helpSUBPLOT(6,3,1,P1,freqYpos,freqY,freqXpos,freqX,CLim)
andor_INCfreemov_STEP4_helpSUBPLOT(6,3,4,P2,freqYpos,freqY,freqXpos,freqX,CLim)
andor_INCfreemov_STEP4_helpSUBPLOT(6,3,7,P3,freqYpos,freqY,freqXpos,freqX,CLim)
andor_INCfreemov_STEP4_helpSUBPLOT(6,3,10,P4,freqYpos,freqY,freqXpos,freqX,CLim)
andor_INCfreemov_STEP4_helpSUBPLOT(6,3,13,P5,freqYpos,freqY,freqXpos,freqX,CLim)
andor_INCfreemov_STEP4_helpSUBPLOT(6,3,16,P6,freqYpos,freqY,freqXpos,freqX,CLim)

andor_INCfreemov_STEP4_helpSUBPLOT(6,3,2,S1,freqYpos,freqY,freqXpos,freqX,CLim)
andor_INCfreemov_STEP4_helpSUBPLOT(6,3,5,S2,freqYpos,freqY,freqXpos,freqX,CLim)
andor_INCfreemov_STEP4_helpSUBPLOT(6,3,8,S3,freqYpos,freqY,freqXpos,freqX,CLim)
andor_INCfreemov_STEP4_helpSUBPLOT(6,3,11,S4,freqYpos,freqY,freqXpos,freqX,CLim)
andor_INCfreemov_STEP4_helpSUBPLOT(6,3,14,S5,freqYpos,freqY,freqXpos,freqX,CLim)
andor_INCfreemov_STEP4_helpSUBPLOT(6,3,17,S6,freqYpos,freqY,freqXpos,freqX,CLim)

andor_INCfreemov_STEP4_helpSUBPLOT(6,3,3,D1,freqYpos,freqY,freqXpos,freqX,[-0.003 0.003])
andor_INCfreemov_STEP4_helpSUBPLOT(6,3,6,D2,freqYpos,freqY,freqXpos,freqX,[-0.003 0.003])
andor_INCfreemov_STEP4_helpSUBPLOT(6,3,9,D3,freqYpos,freqY,freqXpos,freqX,[-0.003 0.003])
andor_INCfreemov_STEP4_helpSUBPLOT(6,3,12,D4,freqYpos,freqY,freqXpos,freqX,[-0.003 0.003])
andor_INCfreemov_STEP4_helpSUBPLOT(6,3,15,D5,freqYpos,freqY,freqXpos,freqX,[-0.003 0.003])
andor_INCfreemov_STEP4_helpSUBPLOT(6,3,18,D6,freqYpos,freqY,freqXpos,freqX,[-0.003 0.003])

set(gcf,'Position',[1 1 420 1000])

save('INC_CFC_forstat_running_CTRL.mat','slowg_PREpyr_CTRL','slowg_STIMpyr_CTRL','midg_PREpyr_CTRL','midg_STIMpyr_CTRL','fastg_PREpyr_CTRL','fastg_STIMpyr_CTRL',...
    'slowg_PRErad_CTRL','slowg_STIMrad_CTRL','midg_PRErad_CTRL','midg_STIMrad_CTRL','fastg_PRErad_CTRL','fastg_STIMrad_CTRL',...
    'slowg_PRElam_CTRL','slowg_STIMlam_CTRL','midg_PRElam_CTRL','midg_STIMlam_CTRL','fastg_PRElam_CTRL','fastg_STIMlam_CTRL',...
    'slowg_PREmol_CTRL','slowg_STIMmol_CTRL','midg_PREmol_CTRL','midg_STIMmol_CTRL','fastg_PREmol_CTRL','fastg_STIMmol_CTRL',...
    'slowg_PREhil_CTRL','slowg_STIMhil_CTRL','midg_PREhil_CTRL','midg_STIMhil_CTRL','fastg_PREhil_CTRL','fastg_STIMhil_CTRL','-v7.3')
%%
load('INC_CFC_forstat_running.mat')
load('INC_CFC_forstat_running_CTRL.mat')

andor_INC_step4_DRAWcfc(fastg_PREpyr, fastg_STIMpyr, fastg_PREpyr_CTRL, fastg_STIMpyr_CTRL,0.027)
andor_INC_step4_DRAWcfc(fastg_PRErad, fastg_STIMrad, fastg_PRErad_CTRL, fastg_STIMrad_CTRL,0.027)
andor_INC_step4_DRAWcfc(fastg_PRElam, fastg_STIMlam, fastg_PRElam_CTRL, fastg_STIMlam_CTRL,0.027)
andor_INC_step4_DRAWcfc(fastg_PREmol, fastg_STIMmol, fastg_PREmol_CTRL, fastg_STIMmol_CTRL,0.027)
andor_INC_step4_DRAWcfc(fastg_PREhil, fastg_STIMhil, fastg_PREhil_CTRL, fastg_STIMhil_CTRL,0.027)
%%
load('/Volumes/TimeMachine/formatlab/INC_layers_HB.mat','waveRadDHB','frHB');
HB = load('INCbase_holeBox_f25Hz','stimIndex2','rowdata','runindex','thetaindex','eegPyrmatrix');
indexHB = and(HB.runindex,HB.thetaindex);

rowdataHB = HB.rowdata(indexHB,:);
waveHB = waveRadDHB(:,:,indexHB);
frHB = frHB(indexHB,:);
stimIndexHB = HB.stimIndex2(indexHB,:);
eegPyrmatrixHB = HB.eegPyrmatrix(indexHB,:);

load('/Volumes/TimeMachine/formatlab/INC_layers_LT.mat','waveRadDLT','frLT');
LT = load('INCbase_linearTrack_f25Hz','stimIndex2','rowdata','runindex','thetaindex','eegPyrmatrix');
indexLT = and(LT.runindex,LT.thetaindex);

rowdataLT = LT.rowdata(indexLT,:);
waveLT = waveRadDLT(:,:,indexLT);
stimIndexLT = LT.stimIndex2(indexLT,:);
eegPyrmatrixLT = LT.eegPyrmatrix(indexLT,:);

rowdata = [rowdataLT; rowdataHB];
fr = frHB;
stimIndex = [stimIndexLT; stimIndexHB];
eegPyrmatrix = [eegPyrmatrixLT(:,(stimIndex(1,3)-4000):(stimIndex(1,3)+8000)); eegPyrmatrixHB(:,(stimIndex(1,3)-4000):(stimIndex(1,3)+8000))];

wave = cat(3,waveLT(:,(stimIndex(1,3)-4000):(stimIndex(1,3)+8000),:),waveHB(:,(stimIndex(1,3)-4000):(stimIndex(1,3)+8000),:));
eegindex = stimIndex(:,3);
eegindex2 = stimIndex(:,4);

FR = fr(1,:)';
FRY = FR(knnsearch(FR,200):knnsearch(FR,5));
FRX = FR(knnsearch(FR,45):knnsearch(FR,1));

freqY = [5 12 30 60 100 200];%%%%
freqYpos = arrayfun(@(x) knnsearch(FRY,x),freqY);
[result_PRE,result_STIM] = andor_CFCDerivPHASE(5,12,200,5,FR,eegPyrmatrix,wave,eegindex,eegindex2);

figure; imagesc(mean(result_PRE,3))
set(gca,'YTick',flip(freqYpos),'YTickLabel',arrayfun(@num2str,flip(freqY),'UniformOutput',false))
set(gca,'XTick',[0.5 25 50.5],'XTickLabel',{'-180';'0';'180'})
set(gca,'Box','off','TickDir','out','TickLength',[0.03 0.025])
set(gcf,'Position',[1 1 460 400])


figure; imagesc(mean(result_STIM,3))
set(gca,'YTick',flip(freqYpos),'YTickLabel',arrayfun(@num2str,flip(freqY),'UniformOutput',false))
set(gca,'XTick',[0.5 25 50.5],'XTickLabel',{'-180';'0';'180'})
set(gca,'Box','off','TickDir','out','TickLength',[0.03 0.025])
set(gcf,'Position',[1 1 460 400])
%%
load('/Volumes/TimeMachine/formatlab/INC_layers_HB_CTRL.mat','waveHB_CTRL','frHB_CTRL');
HB = load('INCBLINDbase_holeBox_f25Hz','stimIndex2','rowdata','runindex','thetaindex','eegPyrmatrix');
indexHB = and(HB.runindex,HB.thetaindex);

rowdataHB = HB.rowdata(indexHB,:);
waveHB = waveHB_CTRL(:,:,indexHB);
frHB = frHB_CTRL(indexHB,:);
stimIndexHB = HB.stimIndex2(indexHB,:);
eegPyrmatrixHB = HB.eegPyrmatrix(indexHB,:);

load('/Volumes/TimeMachine/formatlab/INC_layers_LT_CTRL.mat','waveLT_CTRL','frLT_CTRL');
LT = load('INCBLINDbase_linearTrack_f25Hz','stimIndex2','rowdata','runindex','thetaindex','eegPyrmatrix');
indexLT = and(LT.runindex,LT.thetaindex);

rowdataLT = LT.rowdata(indexLT,:);
waveLT = waveLT_CTRL(:,:,indexLT);
stimIndexLT = LT.stimIndex2(indexLT,:);
eegPyrmatrixLT = LT.eegPyrmatrix(indexLT,:);

rowdata = [rowdataLT; rowdataHB];
fr = frHB;
stimIndex = [stimIndexLT; stimIndexHB];
eegPyrmatrix = [eegPyrmatrixLT(:,(stimIndex(1,3)-4000):(stimIndex(1,3)+8000)); eegPyrmatrixHB(:,(stimIndex(1,3)-4000):(stimIndex(1,3)+8000))];

wave = cat(3,waveLT(:,(stimIndex(1,3)-4000):(stimIndex(1,3)+8000),:),waveHB(:,(stimIndex(1,3)-4000):(stimIndex(1,3)+8000),:));
eegindex = stimIndex(:,3);
eegindex2 = stimIndex(:,4);

FR = fr(1,:)';
FRY = FR(knnsearch(FR,250):knnsearch(FR,5));
FRX = FR(knnsearch(FR,45):knnsearch(FR,1));
freqY = [5 12 30 60 100 200 250];%%%%
freqYpos = arrayfun(@(x) knnsearch(FRY,x),freqY);
[result_PRE,result_STIM] = andor_CFCDerivPHASE(5,12,200,5,FRY,eegPyrmatrix,wave,eegindex,eegindex2);


figure; imagesc(mean(result_PRE,3))
set(gca,'YTick',flip(freqYpos),'YTickLabel',arrayfun(@num2str,flip(freqY),'UniformOutput',false))
set(gca,'XTick',[0.5 25 50.5],'XTickLabel',{'-180';'0';'180'})
set(gca,'Box','off','TickDir','out','TickLength',[0.03 0.025])
set(gcf,'Position',[1 1 460 400])


figure; imagesc(mean(result_STIM,3))
set(gca,'YTick',flip(freqYpos),'YTickLabel',arrayfun(@num2str,flip(freqY),'UniformOutput',false))
set(gca,'XTick',[0.5 25 50.5],'XTickLabel',{'-180';'0';'180'})
set(gca,'Box','off','TickDir','out','TickLength',[0.03 0.025])
set(gcf,'Position',[1 1 460 400])
%% rem
load('/Volumes/TimeMachine/formatlab/INC_layers_HC.mat','waveHilDHC','frHC');
HC = load('INCbase_homeCage_f25Hz','stimIndex2','rowdata','remindex','eegPyrmatrix');
index = HC.remindex;

rowdata = HC.rowdata(index,:);
wave = waveHilDHC(:,:,index);
fr = frHC(index,:);
stimIndex = HC.stimIndex2(index,:);
eegPyrmatrix = HC.eegPyrmatrix(index,:);


eegPyrmatrix = eegPyrmatrix(:,(stimIndex(1,3)-4000):(stimIndex(1,3)+8000));

wave = wave(:,(stimIndex(1,3)-4000):(stimIndex(1,3)+8000),:);
eegindex = stimIndex(:,3);
eegindex2 = stimIndex(:,4);

ydata = fr(1,:);
ydata = ydata(knnsearch(ydata',200):knnsearch(ydata',5));
freqY = [5 12 30 60 100 200];
freqYpos = arrayfun(@(x) knnsearch(ydata',x),freqY);
[result_PRE,result_STIM] = andor_CFCDerivPHASE(5,12,200,5,fr(1,:),eegPyrmatrix,wave,eegindex,eegindex2);

figure; imagesc(mean(result_PRE,3))
set(gca,'YTick',flip(freqYpos),'YTickLabel',arrayfun(@num2str,flip(freqY),'UniformOutput',false))
set(gca,'XTick',[0.5 25 50.5],'XTickLabel',{'-180';'0';'180'})
set(gca,'Box','off','TickDir','out','TickLength',[0.03 0.025])
set(gcf,'Position',[1 1 460 400])


figure; imagesc(mean(result_STIM,3))
set(gca,'YTick',flip(freqYpos),'YTickLabel',arrayfun(@num2str,flip(freqY),'UniformOutput',false))
set(gca,'XTick',[0.5 25 50.5],'XTickLabel',{'-180';'0';'180'})
set(gca,'Box','off','TickDir','out','TickLength',[0.03 0.025])
set(gcf,'Position',[1 1 460 400])
%%

load('INC_allWelch_base.mat')
% running
indexLT = load('INCbase_linearTrack_f25Hz','runindex','thetaindex','rowdata');
rowdata = indexLT.rowdata;
indexLT = and(indexLT.runindex,indexLT.thetaindex);
rowdataLT = rowdata(indexLT,:);
pWelchALL_preLT = pWelchALL_preLT(indexLT,:,:);
pWelchALL_stimLT = pWelchALL_stimLT(indexLT,:,:);
pWelchALL_postLT = pWelchALL_postLT(indexLT,:,:);

indexHB = load('INCbase_holeBox_f25Hz','runindex','thetaindex','rowdata');
rowdata = indexHB.rowdata;
indexHB = and(indexHB.runindex,indexHB.thetaindex);
rowdataHB = rowdata(indexHB,:);
pWelchALL_preHB = pWelchALL_preHB(indexHB,:,:);
pWelchALL_stimHB = pWelchALL_stimHB(indexHB,:,:);
pWelchALL_postHB = pWelchALL_postHB(indexHB,:,:);

pWelchALL_preRUN = cat(1,pWelchALL_preLT,pWelchALL_preHB);
pWelchALL_stimRUN = cat(1,pWelchALL_stimLT,pWelchALL_stimHB);
pWelchALL_postRUN = cat(1,pWelchALL_postLT,pWelchALL_postHB);
rowdataRUN = [rowdataLT; rowdataHB];

% rem
indexREM = load('INCbase_homeCage_f25Hz','fWelch','remindex','rowdata');
rowdata = indexREM.rowdata;
freqwelch = indexREM.fWelch(1,:);
indexREM = indexREM.remindex;
rowdataREM = rowdata(indexREM,:);
pWelchALL_preREM = pWelchALL_preHC(indexREM,:,:);
pWelchALL_stimREM = pWelchALL_stimHC(indexREM,:,:);
pWelchALL_postREM = pWelchALL_postHC(indexREM,:,:);

% blind running
indexLT_CTRL = load('INCBLINDbase_linearTrack_f25Hz','runindex','thetaindex','rowdata');
rowdata = indexLT_CTRL.rowdata;
indexLT_CTRL = and(indexLT_CTRL.runindex,indexLT_CTRL.thetaindex);
rowdataLT_CTRL = rowdata(indexLT_CTRL,:);
pWelchALL_preLT_CTRL = pWelchALL_preLT_CTRL(indexLT_CTRL,:,:);
pWelchALL_stimLT_CTRL = pWelchALL_stimLT_CTRL(indexLT_CTRL,:,:);
pWelchALL_postLT_CTRL = pWelchALL_postLT_CTRL(indexLT_CTRL,:,:);

indexHB_CTRL = load('INCBLINDbase_holeBox_f25Hz','runindex','thetaindex','rowdata');
rowdata = indexHB_CTRL.rowdata;
indexHB_CTRL = and(indexHB_CTRL.runindex,indexHB_CTRL.thetaindex);
rowdataHB_CTRL = rowdata(indexHB_CTRL,:);
pWelchALL_preHB_CTRL = pWelchALL_preHB_CTRL(indexHB_CTRL,:,:);
pWelchALL_stimHB_CTRL = pWelchALL_stimHB_CTRL(indexHB_CTRL,:,:);
pWelchALL_postHB_CTRL = pWelchALL_postHB_CTRL(indexHB_CTRL,:,:);

pWelchALL_preRUN_CTRL = cat(1,pWelchALL_preLT_CTRL,pWelchALL_preHB_CTRL);
pWelchALL_stimRUN_CTRL = cat(1,pWelchALL_stimLT_CTRL,pWelchALL_stimHB_CTRL);
pWelchALL_postRUN_CTRL = cat(1,pWelchALL_postLT_CTRL,pWelchALL_postHB_CTRL);
rowdataRUN_CTRL = [rowdataLT_CTRL; rowdataHB_CTRL];

% rem
indexREM_CTRL = load('INCBLINDbase_homeCage_f25Hz','remindex','rowdata');
rowdata = indexREM_CTRL.rowdata;
indexREM_CTRL = indexREM_CTRL.remindex;
rowdataREM_CTRL = rowdata(indexREM_CTRL,:);
pWelchALL_preREM_CTRL = pWelchALL_preHC_CTRL(indexREM_CTRL,:,:);
pWelchALL_stimREM_CTRL = pWelchALL_stimHC_CTRL(indexREM_CTRL,:,:);
pWelchALL_postREM_CTRL = pWelchALL_postHC_CTRL(indexREM_CTRL,:,:);

% data group by animals
animal = {'1868'       ,'2017'          ,'2026' ,'2027','2046'};
pyrCh  = { 3           , 7              , 5     , 4    , 4    };

radCh  = {[5,6,7]      ,[10,11]         ,[7,8]  ,[6,7] ,[5,6] };

lamCh  = {[10,11]      ,[12,13,14,15,16],[9,10] ,[8,9] ,[7,8] };

molCh  = {[12,13,14]   ,[17,18]         ,[11,12],[10]  ,[9,10]};

hilCh  = {[15,16,17,18],[20,21,22]      ,[13,14],[11]  ,[11]  };
CHANNEL.animal = animal;
CHANNEL.pyrCh = pyrCh;
CHANNEL.radCh = radCh;
CHANNEL.lamCh = lamCh;
CHANNEL.molCh = molCh;
CHANNEL.hilCh = hilCh;
for k = 1:length(animal)
    animalName = animal{k};
    tempRD = cellfun(@(x) x(1:4),rowdataRUN(:,1),'UniformOutput',false);
    tempindex = cellfun(@(x) strcmp(x,animalName),tempRD);
    data_preRUN{k} = pWelchALL_preRUN(tempindex,:,:);
    data_stimRUN{k} = pWelchALL_stimRUN(tempindex,:,:);
    data_postRUN{k} = pWelchALL_postRUN(tempindex,:,:);
    
    
    
    tempRD = cellfun(@(x) x(1:4),rowdataREM(:,1),'UniformOutput',false);
    tempindex = cellfun(@(x) strcmp(x,animalName),tempRD);
    data_preREM{k} = pWelchALL_preREM(tempindex,:,:);
    data_stimREM{k} = pWelchALL_stimREM(tempindex,:,:);
    data_postREM{k} = pWelchALL_postREM(tempindex,:,:);
    
   
    
    tempRD = cellfun(@(x) x(1:4),rowdataRUN_CTRL(:,1),'UniformOutput',false);
    tempindex = cellfun(@(x) strcmp(x,animalName),tempRD);
    data_preRUN_CTRL{k} = pWelchALL_preRUN_CTRL(tempindex,:,:);
    data_stimRUN_CTRL{k} = pWelchALL_stimRUN_CTRL(tempindex,:,:);
    data_postRUN_CTRL{k} = pWelchALL_postRUN_CTRL(tempindex,:,:);
    

    
    tempRD = cellfun(@(x) x(1:4),rowdataREM_CTRL(:,1),'UniformOutput',false);
    tempindex = cellfun(@(x) strcmp(x,animalName),tempRD);
    data_preREM_CTRL{k} = pWelchALL_preREM_CTRL(tempindex,:,:);
    data_stimREM_CTRL{k} = pWelchALL_stimREM_CTRL(tempindex,:,:);
    data_postREM_CTRL{k} = pWelchALL_postREM_CTRL(tempindex,:,:);
    


end
columns = [2 3 4 5];
%%
freq1 = 60;
freq2 = 100;
[preRUN,stimRUN] = andor_INC_step4_layers(freqwelch,freq1,freq2,data_preRUN,data_stimRUN,columns,CHANNEL);
[preRUN_CTRL,stimRUN_CTRL] = andor_INC_step4_layers(freqwelch,freq1,freq2,data_preRUN_CTRL,data_stimRUN_CTRL,columns,CHANNEL);
INCcolor = [0 51 204]./255;
figure('Position',[25 25 200 420]); hold on
plot(mean(10*log10(stimRUN./preRUN)),[5 4 3 2 1],'Color',INCcolor,'LineWidth',.5)
for k = 1:5
    posv = [5 4 3 2 1];
    p = signrank(preRUN(:,k),stimRUN(:,k));
    if p < 0.05
        scatter(mean(10*log10(stimRUN(:,k)./preRUN(:,k))),posv(k),80,INCcolor,'filled')
    else
        scatter(mean(10*log10(stimRUN(:,k)./preRUN(:,k))),posv(k),80,INCcolor)
    end
end
plot(mean(10*log10(stimRUN_CTRL./preRUN_CTRL)),[5 4 3 2 1],'Color','k','LineWidth',.5)
for k = 1:5
    posv = [5 4 3 2 1];
    p = signrank(preRUN_CTRL(:,k),stimRUN_CTRL(:,k));
    if p < 0.05
        scatter(mean(10*log10(stimRUN_CTRL(:,k)./preRUN_CTRL(:,k))),posv(k),80,'k','filled')
    else
        scatter(mean(10*log10(stimRUN_CTRL(:,k)./preRUN_CTRL(:,k))),posv(k),80,'k')
    end
end
set(gca,'FontSize',20,'LineWidth',.5,'XLim',[-6 6],'XTick',[-6 0 6],'XTickLabel',{'-6';'0';'6'},'YLim',[0.8 5.2],'YTick',[])
line([0 0],[0.8 5.2],'LineStyle','--','Color','k','LineWidth',.5)
for k = 1:5
    posv = [5 4 3 2 1];
    p = ranksum(10*log10(stimRUN_CTRL(:,k)./preRUN_CTRL(:,k)),10*log10(stimRUN(:,k)./preRUN(:,k)));
    text(0,posv(k),num2str(p),'FontSize',20)
end
%%
% rem
freq1 = 60;
freq2 = 100;
[preREM,stimREM] = andor_INC_step4_layers(freqwelch,freq1,freq2,data_preREM,data_stimREM,columns,CHANNEL);
[preREM_CTRL,stimREM_CTRL] = andor_INC_step4_layers(freqwelch,freq1,freq2,data_preREM_CTRL,data_stimREM_CTRL,columns,CHANNEL);
INCcolor = [0 51 204]./255;
figure('Position',[25 25 200 420]); hold on
plot(mean(10*log10(stimREM./preREM)),[5 4 3 2 1],'Color',INCcolor,'LineWidth',.5)
for k = 1:5
    posv = [5 4 3 2 1];
    p = signrank(preREM(:,k),stimREM(:,k));
    if p < 0.05
        scatter(mean(10*log10(stimREM(:,k)./preREM(:,k))),posv(k),80,INCcolor,'filled')
    else
        scatter(mean(10*log10(stimREM(:,k)./preREM(:,k))),posv(k),80,INCcolor)
    end
end
plot(mean(10*log10(stimREM_CTRL./preREM_CTRL)),[5 4 3 2 1],'Color','k','LineWidth',.5)
for k = 1:5
    posv = [5 4 3 2 1];
    p = signrank(preREM_CTRL(:,k),stimREM_CTRL(:,k));
    if p < 0.05
        scatter(mean(10*log10(stimREM_CTRL(:,k)./preREM_CTRL(:,k))),posv(k),80,'k','filled')
    else
        scatter(mean(10*log10(stimREM_CTRL(:,k)./preREM_CTRL(:,k))),posv(k),80,'k')
    end
end
set(gca,'FontSize',20,'LineWidth',.5,'XLim',[-6 6],'XTick',[-6 0 6],'XTickLabel',{'-6';'0';'6'},'YLim',[0.8 5.2],'YTick',[])
line([0 0],[0.8 5.2],'LineStyle','--','Color','k','LineWidth',.5)
for k = 1:5
    posv = [5 4 3 2 1];
    p = ranksum(10*log10(stimREM_CTRL(:,k)./preREM_CTRL(:,k)),10*log10(stimREM(:,k)./preREM(:,k)));
    text(0,posv(k),num2str(p),'FontSize',20)
end


%% CFC
% INC RUNNING
filename = '2026';
LT = load('INCbase_linearTrack_f25Hz','power','wave','fr','stimIndex2','rowdata','runindex','thetaindex','csvIndex2','speedmatrix');
indexArena = repmat({'linearTrack'},size(LT.power,3),1);
indexLT = and(LT.runindex,LT.thetaindex);

rowdataLT = LT.rowdata(indexLT,:);
powerLT = LT.power(:,:,indexLT);
waveLT = LT.wave(:,:,indexLT);
frLT = LT.fr(indexLT,:);
stimIndexLT = LT.stimIndex2(indexLT,:);
indexArenaLT = indexArena(indexLT,:);

HB = load('INCbase_holeBox_f25Hz','power','wave','fr','stimIndex2','rowdata','runindex','thetaindex','csvIndex2','speedmatrix');
indexArena = repmat({'holeBox'},size(HB.power,3),1);
indexHB = and(HB.runindex,HB.thetaindex);

rowdataHB = HB.rowdata(indexHB,:);
powerHB = HB.power(:,:,indexHB);
waveHB = HB.wave(:,:,indexHB);
frHB = HB.fr(indexHB,:);
stimIndexHB = HB.stimIndex2(indexHB,:);
indexArenaHB = indexArena(indexHB,:);

indexArena = [indexArenaLT; indexArenaHB];
rowdata = [rowdataLT; rowdataHB];
fr = [frLT; frHB];
stimIndex = [stimIndexLT; stimIndexHB];

power = cat(3,powerLT(:,(stimIndex(1,3)-4000):(stimIndex(1,3)+8000),:),powerHB(:,(stimIndex(1,3)-4000):(stimIndex(1,3)+8000),:));
wave = cat(3,waveLT(:,(stimIndex(1,3)-4000):(stimIndex(1,3)+8000),:),waveHB(:,(stimIndex(1,3)-4000):(stimIndex(1,3)+8000),:));
eegindex = stimIndex(:,3);
eegindex2 = stimIndex(:,4);
%%
settime = 2000; % data points

gamma1_CMD = 250;
gamma2_CMD = 15;
th1_CMD = 45;
th2_CMD = 0.9;
g1 = knnsearch(fr(1,:)',gamma1_CMD);
g2 = knnsearch(fr(1,:)',gamma2_CMD);
t1 = knnsearch(fr(1,:)',th1_CMD);
t2 = knnsearch(fr(1,:)',th2_CMD);

% powerratio = NaN(size(power,3),size(power,1));
% power_pre = NaN(size(power,3),size(power,1));
% power_preShort = NaN(size(power,3),size(power,1));
% power_stim = NaN(size(power,3),size(power,1));
% power_post = NaN(size(power,3),size(power,1));
% power_preMax = NaN(size(power,3),1);

amplitudeHist_PRE = cell(size(power,3),1);
comodulo_PRE = cell(size(power,3),1);
amplitudeHist_STIM = cell(size(power,3),1);
comodulo_STIM = cell(size(power,3),1);
for k = 1:size(power,3)
%     prestart = 2*eegindex(k) - eegindex2(k);
%     if eegindex(k)-prestart > 10000 % limit to 10 s eeg before stim
%         prestart = eegindex(k)-10000;
%     end
%     if prestart < 1; prestart = 1; end
%     
%     postend = 2*eegindex2(k)-eegindex(k)+1;
%     if postend>size(power,2); postend = size(power,2); end
%     
%     power_pre(k,:) = sumskipnan(power(:,prestart:eegindex(k)-1,k),2)/(eegindex(k)-prestart);
%     power_preShort(k,:) = sumskipnan(power(:,eegindex(k)-settime-1:eegindex(k)-1,k),2)/settime;
%     power_stim(k,:) = sumskipnan(power(:,eegindex(k):eegindex2(k),k),2)/(eegindex2(k)-eegindex(k)+1);
%     powerratio(k,:) = power_stim(k,:)./power_pre(k,:);
%     power_post(k,:) = sumskipnan(power(:,(eegindex2(k)+1):postend,k),2)/(postend-eegindex2(k)+1);
%     
    % theta-gamma comodulogram
    tempGammaWave = wave(g1:g2,:,k);
    tempThetaWave = wave(t1:t2,:,k);
    thetaPhase = radtodeg(angle(tempThetaWave));
    gammaAmpl = abs(tempGammaWave);
    
    thetaPhase_PRE = thetaPhase(:,1:4000);
    gammaAmpl_PRE = gammaAmpl(:,1:4000);
    
    amplitudeHist_PRE{k,1} = cell(size(gammaAmpl_PRE,1),size(thetaPhase_PRE,1));
    comodulo_PRE{k,1} = NaN(size(gammaAmpl_PRE,1),size(thetaPhase_PRE,1));
    for kk = 1:size(thetaPhase_PRE,1)
        for kkk = 1:size(gammaAmpl_PRE,1)
            [amplitudeHist_PRE{k,1}{kkk,kk}, comodulo_PRE{k,1}(kkk,kk)] = andor_phase_ampl_comodulogram(thetaPhase_PRE(kk,:),gammaAmpl_PRE(kkk,:),linspace(-180,180,51));
        end
    end
    
    thetaPhase_STIM = thetaPhase(:,4001:(4001+eegindex2(k)-eegindex(k)));
    gammaAmpl_STIM = gammaAmpl(:,4001:(4001+eegindex2(k)-eegindex(k)));
    
    amplitudeHist_STIM{k,1} = cell(size(gammaAmpl_STIM,1),size(thetaPhase_STIM,1));
    comodulo_STIM{k,1} = NaN(size(gammaAmpl_STIM,1),size(thetaPhase_STIM,1));
    for kk = 1:size(thetaPhase_STIM,1)
        for kkk = 1:size(gammaAmpl_STIM,1)
            [amplitudeHist_STIM{k,1}{kkk,kk}, comodulo_STIM{k,1}(kkk,kk)] = andor_phase_ampl_comodulogram(thetaPhase_STIM(kk,:),gammaAmpl_STIM(kkk,:),linspace(-180,180,51));
        end
    end
    
end
com_PRE = [];
com_STIM = [];
for k = 1:size(power,3)
    com_PRE(:,:,k) = comodulo_PRE{k,1};
    com_STIM(:,:,k) = comodulo_STIM{k,1};
end
%%
figure; hold on
imagesc(mean(com_STIM-com_PRE,3))
%%

speed_stim = speedmatrix(:,min(speedindex):min(speedindex2));
speed_pre = speedmatrix(:,(2*min(speedindex)-min(speedindex2)-1):min(speedindex)-1);

if strcmp(arena,'urethane')
    theta1 = 2.5;
    theta2  =6;
else
    theta1 = 5;
    theta2 = 12;
end
psettime = 1000; % data points
hilPhase = NaN(size(eegmatrix));
hilPhasePulse = cell(size(eegmatrix,1),1);
for k = 1:size(eegmatrix,1)
    eegnonnan = ~isnan(eegmatrix(k,:));
    tempeeg = eegmatrix(k,eegnonnan);
    bvar = fir1(2048, [theta1/(1000/2) theta2/(1000/2)]);
    tempeegF = filtfilt(bvar, 1, tempeeg);
    hilPhase(k,eegnonnan) = rad2deg(angle(hilbert(tempeegF)));
    for x = 1:size(pulseIndex{k,1},1)
        hilPhasePulse{k,1}(x,:) = hilPhase(k,((eegindex(k)+pulseIndex{k,1}(x,1))-psettime):((eegindex(k)+pulseIndex{k,1}(x,1))+psettime));
    end
end

temphilPhasePulse = hilPhasePulse(index,1);
hilPhasePulse_matrix = cell2mat(temphilPhasePulse);

subplot(2,5,7)
imagesc(((1:size(hilPhasePulse_matrix,2))-psettime-1)./1000,1:size(hilPhasePulse_matrix,1),hilPhasePulse_matrix)
set(gca,'CLim',[-180 180],'FontSize',20)
line([0 0],[0.5 size(hilPhasePulse_matrix,1)+0.5],'Color','w','LineStyle','--','LineWidth',2)
title(gca,'theta')

beta1 = 23;
beta2 = 33;
psettimeB = 500; %data points
hilPhaseB = NaN(size(eegmatrix));
hilPhasePulseB = cell(size(eegmatrix,1),1);
for k = 1:size(eegmatrix,1)
    eegnonnan = ~isnan(eegmatrix(k,:));
    tempeeg = eegmatrix(k,eegnonnan);
    bvar = fir1(2048, [beta1/(1000/2) beta2/(1000/2)]);
    tempeegF = filtfilt(bvar, 1, tempeeg);
    hilPhaseB(k,eegnonnan) = rad2deg(angle(hilbert(tempeegF)));
    for x = 1:size(pulseIndex{k,1},1)
        hilPhasePulseB{k,1}(x,:) = hilPhaseB(k,((eegindex(k)+pulseIndex{k,1}(x,1))-psettimeB):((eegindex(k)+pulseIndex{k,1}(x,1))+psettimeB));
    end
end

%%
% BLIND RUNNING
filename = '2026';
LT = load('INCBLINDbase_linearTrack_f25Hz','power','fr','stimIndex2','rowdata','runindex','thetaindex','csvIndex2','speedmatrix');
indexArena = repmat({'linearTrack'},size(LT.power,3),1);
indexLT = and(LT.runindex,LT.thetaindex);

rowdataLT = LT.rowdata(indexLT,:);
powerLT = LT.power(:,:,indexLT);
frLT = LT.fr(indexLT,:);
stimIndexLT = LT.stimIndex2(indexLT,:);
indexArenaLT = indexArena(indexLT,:);
csvIndexLT = LT.csvIndex2(indexLT,:);
speedLT = LT.speedmatrix(indexLT,:);

HB = load('INCBLINDbase_holeBox_f25Hz','power','fr','stimIndex2','rowdata','runindex','thetaindex','csvIndex2','speedmatrix');
indexArena = repmat({'holeBox'},size(HB.power,3),1);
indexHB = and(HB.runindex,HB.thetaindex);

rowdataHB = HB.rowdata(indexHB,:);
powerHB = HB.power(:,:,indexHB);
frHB = HB.fr(indexHB,:);
stimIndexHB = HB.stimIndex2(indexHB,:);
indexArenaHB = indexArena(indexHB,:);
csvIndexHB = HB.csvIndex2(indexHB,:);
speedHB = HB.speedmatrix(indexHB,:);

indexArena = [indexArenaLT; indexArenaHB];
rowdata = [rowdataLT; rowdataHB];
fr = [frLT; frHB];
stimIndex = [stimIndexLT; stimIndexHB];
csvIndex = [csvIndexLT; csvIndexHB];
speed = [speedLT; speedHB];

power = cat(3,powerLT(:,(stimIndex(1,3)-4000):(stimIndex(1,3)+8000),:),powerHB(:,(stimIndex(1,3)-4000):(stimIndex(1,3)+8000),:));

% theta-acceleration correlation
freq = fr(1,:);
th1 = knnsearch(freq',12);
thX = knnsearch(freq',8);
th2 = knnsearch(freq',5);
for k = 1:size(power,3)
    theta1bandpower(k,:) = sum(power(thX:th2,:,k));
    theta2bandpower(k,:) = sum(power(th1:(thX-1),:,k));
end

% % acceler = NaN(size(speed));
% % for k = 2:size(speed,2)
% %     acceler(:,k) = (speed(:,k)-speed(:,k-1)).*120;
% % end
% % acceler = speed;
% % 
load('INC_FINAL_camSdata.mat')
pretime = 480;
stimtime = 960;
for k = 1:size(rowdata,1)
    filenum = rowdata{k,1}(1:4);
    if isequal(filenum,'1868')
        row = strcmp(infoCell_1868(:,1),rowdata{k,1});
        stimnum = rowdata{k,2};
        camindex = csvIndex_1868{row,1}(stimnum,:);
        camPos = camS_1868{row,1}(camindex(3)-pretime:camindex(3)+stimtime);
        camPos = round(camPos/(20000/1000));
        camPos = camPos-camPos(pretime+1);
        camPos = camPos + 4001;
        
        for x = 1:length(camPos)
            theta1Data(k,x) = mean(theta1bandpower(k,(camPos(x)-5):(camPos(x)+5)));
            theta2Data(k,x) = mean(theta2bandpower(k,(camPos(x)-5):(camPos(x)+5)));
        end
        
        speedData(k,:) = speed(k,(csvIndex(k,3)-pretime):(csvIndex(k,3)+stimtime));
        
    elseif isequal(filenum,'2017')
        row = strcmp(infoCell_2017(:,1),rowdata{k,1});
        stimnum = rowdata{k,2};
        camindex = csvIndex_2017{row,1}(stimnum,:);
        camPos = camS_2017{row,1}(camindex(3)-pretime:camindex(3)+stimtime);
        camPos = round(camPos/(20000/1000));
        camPos = camPos-camPos(pretime+1);
        camPos = camPos + 4001;
        
        for x = 1:length(camPos)
            theta1Data(k,x) = mean(theta1bandpower(k,(camPos(x)-5):(camPos(x)+5)));
            theta2Data(k,x) = mean(theta2bandpower(k,(camPos(x)-5):(camPos(x)+5)));
        end
        
        speedData(k,:) = speed(k,(csvIndex(k,3)-pretime):(csvIndex(k,3)+stimtime));
        
    elseif isequal(filenum,'2026')
        row = strcmp(infoCell_2026(:,1),rowdata{k,1});
        stimnum = rowdata{k,2};
        camindex = csvIndex_2026{row,1}(stimnum,:);
        camPos = camS_2026{row,1}(camindex(3)-pretime:camindex(3)+stimtime);
        camPos = round(camPos/(20000/1000));
        camPos = camPos-camPos(pretime+1);
        camPos = camPos + 4001;
        
        for x = 1:length(camPos)
            theta1Data(k,x) = mean(theta1bandpower(k,(camPos(x)-5):(camPos(x)+5)));
            theta2Data(k,x) = mean(theta2bandpower(k,(camPos(x)-5):(camPos(x)+5)));
        end
        
        speedData(k,:) = speed(k,(csvIndex(k,3)-pretime):(csvIndex(k,3)+stimtime));
        
    elseif isequal(filenum,'2027')
        row = strcmp(infoCell_2027(:,1),rowdata{k,1});
        stimnum = rowdata{k,2};
        camindex = csvIndex_2027{row,1}(stimnum,:);
        camPos = camS_2027{row,1}(camindex(3)-pretime:camindex(3)+stimtime);
        camPos = round(camPos/(20000/1000));
        camPos = camPos-camPos(pretime+1);
        camPos = camPos + 4001;
        
        for x = 1:length(camPos)
            theta1Data(k,x) = mean(theta1bandpower(k,(camPos(x)-5):(camPos(x)+5)));
            theta2Data(k,x) = mean(theta2bandpower(k,(camPos(x)-5):(camPos(x)+5)));
        end
        
        speedData(k,:) = speed(k,(csvIndex(k,3)-pretime):(csvIndex(k,3)+stimtime));
        
    elseif isequal(filenum,'2046')
        row = strcmp(infoCell_2046(:,1),rowdata{k,1});
        stimnum = rowdata{k,2};
        camindex = csvIndex_2046{row,1}(stimnum,:);
        camPos = camS_2046{row,1}(camindex(3)-pretime:camindex(3)+stimtime);
        camPos = round(camPos/(20000/1000));
        camPos = camPos-camPos(pretime+1);
        camPos = camPos + 4001;
        
        for x = 1:length(camPos)
            theta1Data(k,x) = mean(theta1bandpower(k,(camPos(x)-5):(camPos(x)+5)));
            theta2Data(k,x) = mean(theta2bandpower(k,(camPos(x)-5):(camPos(x)+5)));
        end
        
        speedData(k,:) = speed(k,(csvIndex(k,3)-pretime):(csvIndex(k,3)+stimtime));
        
    end
end
% speed - theta relationship
% bins: 0-4 cm/s; 4-8 cm/s; 8-12 cm/s; 12-16 cm/s; 16-inf cm/s
stim25time = 474;
pretime = 480;

speedDataPRE = speedData(:,1:pretime);
theta1DataPRE = theta1Data(:,1:pretime);
theta2DataPRE = theta2Data(:,1:pretime);

speedDataSTIM = speedData(:,(pretime+1):(pretime+1+stim25time));
theta1DataSTIM = theta1Data(:,(pretime+1):(pretime+1+stim25time));
theta2DataSTIM = theta2Data(:,(pretime+1):(pretime+1+stim25time));

speedDataPOST = speedData(:,(pretime+2+stim25time):end);
theta1DataPOST = theta1Data(:,(pretime+2+stim25time):end);
theta2DataPOST = theta2Data(:,(pretime+2+stim25time):end);

% speed change
INCcolor = [0 51 204]./255;
CTRLcolor = 'k';
% % % figure; hold on
% % % C = 0.3;
% % % 
% % % 
% % % line([1-C 1+C],repmat(median(mean(speedDataPRE,2)),1,2),'LineWidth',.5,'Color',[.3 .3 .3])
% % % line([1-C 1+C],repmat(median(mean(speedDataPRE,2))+prctile(mean(speedDataPRE,2),75),1,2),'LineWidth',.5,'Color',[.3 .3 .3])
% % % line([1-C 1+C],repmat(median(mean(speedDataPRE,2))-prctile(mean(speedDataPRE,2),25),1,2),'LineWidth',.5,'Color',[.3 .3 .3])
% % % 
% % % line([1-C 1-C],[median(mean(speedDataPRE,2))-prctile(mean(speedDataPRE,2),25) median(mean(speedDataPRE,2))+prctile(mean(speedDataPRE,2),75)],'LineWidth',.5,'Color',[.3 .3 .3])
% % % line([1+C 1+C],[median(mean(speedDataPRE,2))-prctile(mean(speedDataPRE,2),25) median(mean(speedDataPRE,2))+prctile(mean(speedDataPRE,2),75)],'LineWidth',.5,'Color',[.3 .3 .3])
% % % 
% % % 
% % % line([2-C 2+C],repmat(median(mean(speedDataSTIM,2)),1,2),'LineWidth',.5,'Color',CTRLcolor)
% % % line([2-C 2+C],repmat(median(mean(speedDataSTIM,2))+prctile(mean(speedDataSTIM,2),75),1,2),'LineWidth',.5,'Color',CTRLcolor)
% % % line([2-C 2+C],repmat(median(mean(speedDataSTIM,2))-prctile(mean(speedDataSTIM,2),25),1,2),'LineWidth',.5,'Color',CTRLcolor)
% % % 
% % % line([2-C 2-C],[median(mean(speedDataSTIM,2))-prctile(mean(speedDataSTIM,2),25) median(mean(speedDataSTIM,2))+prctile(mean(speedDataSTIM,2),75)],'LineWidth',.5,'Color',CTRLcolor)
% % % line([2+C 2+C],[median(mean(speedDataSTIM,2))-prctile(mean(speedDataSTIM,2),25) median(mean(speedDataSTIM,2))+prctile(mean(speedDataSTIM,2),75)],'LineWidth',.5,'Color',CTRLcolor)
% % %     
% % % 
% % % line([3-C 3+C],repmat(median(mean(speedDataPOST,2)),1,2),'LineWidth',.5,'Color',[.5 .5 .5])
% % % line([3-C 3+C],repmat(median(mean(speedDataPOST,2))+prctile(mean(speedDataPOST,2),75),1,2),'LineWidth',.5,'Color',[.5 .5 .5])
% % % line([3-C 3+C],repmat(median(mean(speedDataPOST,2))-prctile(mean(speedDataPOST,2),25),1,2),'LineWidth',.5,'Color',[.5 .5 .5])
% % % 
% % % line([3-C 3-C],[median(mean(speedDataPOST,2))-prctile(mean(speedDataPOST,2),25) median(mean(speedDataPOST,2))+prctile(mean(speedDataPOST,2),75)],'LineWidth',.5,'Color',[.5 .5 .5])
% % % line([3+C 3+C],[median(mean(speedDataPOST,2))-prctile(mean(speedDataPOST,2),25) median(mean(speedDataPOST,2))+prctile(mean(speedDataPOST,2),75)],'LineWidth',.5,'Color',[.5 .5 .5])
% % % %  title(gca, 'BLIND STIM','FontSize',20)
% % % set(gca,'YLim',[0 30],'YTick',[0 30],'YTickLabel',{'0';'30'},'XTick',[],'LineWidth',.5,'FontSize',20,'XLim',[0.4 3.6])
% % % ylabel(gca,'average speed (cm/s)','FontSize',20)
% % % 
% % % p = signrank(mean(speedDataPRE,2), mean(speedDataSTIM,2));
% % % text(1,10,num2str(p),'FontSize',20)
% % % 
% % % p = signrank(mean(speedDataSTIM,2), mean(speedDataPOST,2));
% % % text(2.5,11,num2str(p),'FontSize',20)

% speed bins + theta2 and theta1
   
binstart = [0 4  8 12 16];
binend =   [4 8 12 16 inf];

theta1BarPRE = cell(1,length(binstart));
theta2BarPRE = cell(1,length(binstart));
theta1BarSTIM = cell(1,length(binstart));
theta2BarSTIM = cell(1,length(binstart));
theta1BarPOST = cell(1,length(binstart));
theta2BarPOST = cell(1,length(binstart));

for k = 1:length(binstart)
    for kk = 1:size(theta2DataPRE,1)
        if ~isempty(theta1DataPRE(kk,speedDataPRE(kk,:) >= binstart(k) & speedDataPRE(kk,:) < binend(k)))
            theta1BarPRE{1,k}(kk) = mean(theta1DataPRE(kk,speedDataPRE(kk,:) >= binstart(k) & speedDataPRE(kk,:) < binend(k)));
        else
            theta1BarPRE{1,k}(kk) = NaN;
        end
        if ~isempty(theta2DataPRE(kk,speedDataPRE(kk,:) >= binstart(k) & speedDataPRE(kk,:) < binend(k)))
            theta2BarPRE{1,k}(kk) = mean(theta2DataPRE(kk,speedDataPRE(kk,:) >= binstart(k) & speedDataPRE(kk,:) < binend(k)));
        else
            theta2BarPRE{1,k}(kk) = NaN;
        end
        
        if ~isempty(theta1DataSTIM(kk,speedDataSTIM(kk,:) >= binstart(k) & speedDataSTIM(kk,:) < binend(k)))
            theta1BarSTIM{1,k}(kk) = mean(theta1DataSTIM(kk,speedDataSTIM(kk,:) >= binstart(k) & speedDataSTIM(kk,:) < binend(k)));
        else
            theta1BarSTIM{1,k}(kk) = NaN;
        end
        if ~isempty(theta2DataSTIM(kk,speedDataSTIM(kk,:) >= binstart(k) & speedDataSTIM(kk,:) < binend(k)))
            theta2BarSTIM{1,k}(kk) = mean(theta2DataSTIM(kk,speedDataSTIM(kk,:) >= binstart(k) & speedDataSTIM(kk,:) < binend(k)));
        else
            theta2BarSTIM{1,k}(kk) = NaN;
        end
        
        if ~isempty(theta1DataPOST(kk,speedDataPOST(kk,:) >= binstart(k) & speedDataPOST(kk,:) < binend(k)))
            theta1BarPOST{1,k}(kk) = mean(theta1DataPOST(kk,speedDataPOST(kk,:) >= binstart(k) & speedDataPOST(kk,:) < binend(k)));
        else
            theta1BarPOST{1,k}(kk) = NaN;
        end
        if ~isempty(theta2DataPOST(kk,speedDataPOST(kk,:) >= binstart(k) & speedDataPOST(kk,:) < binend(k)))
            theta2BarPOST{1,k}(kk) = mean(theta2DataPOST(kk,speedDataPOST(kk,:) >= binstart(k) & speedDataPOST(kk,:) < binend(k)));
        else
            theta2BarPOST{1,k}(kk) = NaN;
        end
    end
end

INCcolor = [0 51 204]./255;
CTRLcolor = 'k';
figure('Position',[25 25 560 1.5*420]) ; hold on
subplot('Position',[.1 .525 .85 0.425])

A1 = 2.4;
A2 = 3.6;
A3 = 4.8;
B = 5.3;
C = 0.5;
for k = 1:length(binstart)
    tempmedian = median(theta2BarPRE{1,k});
    temp75 = prctile(theta2BarPRE{1,k},75);
    temp25 = prctile(theta2BarPRE{1,k},25);
    
    line([A1+(k-1)*B-C A1+(k-1)*B+C],[tempmedian tempmedian],'LineWidth',.5,'Color',[.3 .3 .3])
    line([A1+(k-1)*B-C A1+(k-1)*B+C],[temp75 temp75],'LineWidth',.5,'Color',[.3 .3 .3])
    line([A1+(k-1)*B-C A1+(k-1)*B+C],[temp25 temp25],'LineWidth',.5,'Color',[.3 .3 .3])
    
    line([A1+(k-1)*B-C A1+(k-1)*B-C],[temp25 temp75],'LineWidth',.5,'Color',[.3 .3 .3])
    line([A1+(k-1)*B+C A1+(k-1)*B+C],[temp25 temp75],'LineWidth',.5,'Color',[.3 .3 .3])
    
    
    tempmedian = median(theta2BarSTIM{1,k});
    temp75 = prctile(theta2BarSTIM{1,k},75);
    temp25 = prctile(theta2BarSTIM{1,k},25);
    
    line([A2+(k-1)*B-C A2+(k-1)*B+C],[tempmedian tempmedian],'LineWidth',.5,'Color',INCcolor)
    line([A2+(k-1)*B-C A2+(k-1)*B+C],[temp75 temp75],'LineWidth',.5,'Color',INCcolor)
    line([A2+(k-1)*B-C A2+(k-1)*B+C],[temp25 temp25],'LineWidth',.5,'Color',INCcolor)
    
    line([A2+(k-1)*B-C A2+(k-1)*B-C],[temp25 temp75],'LineWidth',.5,'Color',INCcolor)
    line([A2+(k-1)*B+C A2+(k-1)*B+C],[temp25 temp75],'LineWidth',.5,'Color',INCcolor)
    
    
    tempmedian = median(theta2BarPOST{1,k});
    temp75 = prctile(theta2BarPOST{1,k},75);
    temp25 = prctile(theta2BarPOST{1,k},25);
    
    line([A3+(k-1)*B-C A3+(k-1)*B+C],[tempmedian tempmedian],'LineWidth',.5,'Color',[.5 .5 .5])
    line([A3+(k-1)*B-C A3+(k-1)*B+C],[temp75 temp75],'LineWidth',.5,'Color',[.5 .5 .5])
    line([A3+(k-1)*B-C A3+(k-1)*B+C],[temp25 temp25],'LineWidth',.5,'Color',[.5 .5 .5])
    
    line([A3+(k-1)*B-C A3+(k-1)*B-C],[temp25 temp75],'LineWidth',.5,'Color',[.5 .5 .5])
    line([A3+(k-1)*B+C A3+(k-1)*B+C],[temp25 temp75],'LineWidth',.5,'Color',[.5 .5 .5])
    
    p = signrank(theta2BarPRE{1,k},theta2BarSTIM{1,k});
    text(A1+(k-1)*B-C,8000,num2str(p),'FontSize',20)
    
    p = signrank(theta2BarSTIM{1,k},theta2BarPOST{1,k});
    text(A3+(k-1)*B-C,5000,num2str(p),'FontSize',20)
    
end
% title(gca,'BLIND STIM','FontSize',20)
ylabel(gca,'high theta power (x10^{3})','FontSize',20)
% xlabel(gca,'speed range (cm/s)','FontSize',20)
set(gca,'XTick',A2:B:30,'XLim',[0 28.4],'XTickLabel',{'0-4';'4-8';'8-12';'12-16';'16+'},'YLim',[0 8000],'YTick',[0 8000],'YTickLabel',{'0';'8'})
set(gca,'LineWidth',.5,'FontSize',20)
set(gca,'XTick',[])

% figure; hold on
subplot('Position',[.1 .05 .85 0.425])
for k = 1:length(binstart)
    tempmedian = median(theta1BarPRE{1,k});
    temp75 = prctile(theta1BarPRE{1,k},75);
    temp25 = prctile(theta1BarPRE{1,k},25);
    
    line([A1+(k-1)*B-C A1+(k-1)*B+C],[tempmedian tempmedian],'LineWidth',.5,'Color',[.3 .3 .3])
    line([A1+(k-1)*B-C A1+(k-1)*B+C],[temp75 temp75],'LineWidth',.5,'Color',[.3 .3 .3])
    line([A1+(k-1)*B-C A1+(k-1)*B+C],[temp25 temp25],'LineWidth',.5,'Color',[.3 .3 .3])
    
    line([A1+(k-1)*B-C A1+(k-1)*B-C],[temp25 temp75],'LineWidth',.5,'Color',[.3 .3 .3])
    line([A1+(k-1)*B+C A1+(k-1)*B+C],[temp25 temp75],'LineWidth',.5,'Color',[.3 .3 .3])
    
    
    tempmedian = median(theta1BarSTIM{1,k});
    temp75 = prctile(theta1BarSTIM{1,k},75);
    temp25 = prctile(theta1BarSTIM{1,k},25);
    
    line([A2+(k-1)*B-C A2+(k-1)*B+C],[tempmedian tempmedian],'LineWidth',.5,'Color',INCcolor)
    line([A2+(k-1)*B-C A2+(k-1)*B+C],[temp75 temp75],'LineWidth',.5,'Color',INCcolor)
    line([A2+(k-1)*B-C A2+(k-1)*B+C],[temp25 temp25],'LineWidth',.5,'Color',INCcolor)
    
    line([A2+(k-1)*B-C A2+(k-1)*B-C],[temp25 temp75],'LineWidth',.5,'Color',INCcolor)
    line([A2+(k-1)*B+C A2+(k-1)*B+C],[temp25 temp75],'LineWidth',.5,'Color',INCcolor)
    
    
    tempmedian = median(theta1BarPOST{1,k});
    temp75 = prctile(theta1BarPOST{1,k},75);
    temp25 = prctile(theta1BarPOST{1,k},25);
    
    line([A3+(k-1)*B-C A3+(k-1)*B+C],[tempmedian tempmedian],'LineWidth',.5,'Color',[.5 .5 .5])
    line([A3+(k-1)*B-C A3+(k-1)*B+C],[temp75 temp75],'LineWidth',.5,'Color',[.5 .5 .5])
    line([A3+(k-1)*B-C A3+(k-1)*B+C],[temp25 temp25],'LineWidth',.5,'Color',[.5 .5 .5])
    
    line([A3+(k-1)*B-C A3+(k-1)*B-C],[temp25 temp75],'LineWidth',.5,'Color',[.5 .5 .5])
    line([A3+(k-1)*B+C A3+(k-1)*B+C],[temp25 temp75],'LineWidth',.5,'Color',[.5 .5 .5])
    
    p = signrank(theta1BarPRE{1,k},theta1BarSTIM{1,k});
    text(A1+(k-1)*B-C,8000,num2str(p),'FontSize',20)
    
    p = signrank(theta1BarSTIM{1,k},theta1BarPOST{1,k});
    text(A3+(k-1)*B-C,5000,num2str(p),'FontSize',20)
    
end
% title(gca,'BLIND STIM','FontSize',20)
ylabel(gca,'low theta power (x10^{3})','FontSize',20)
xlabel(gca,'speed range (cm/s)','FontSize',20)
set(gca,'XTick',A2:B:30,'XLim',[0 28.4],'XTickLabel',{'0-4';'4-8';'8-12';'12-16';'16+'},'YLim',[0 8000],'YTick',[0 8000],'YTickLabel',{'0';'8'})
set(gca,'LineWidth',.5,'FontSize',20)


% wavelet average for selected file:
filerows = cellfun(@(x) isequal(filename,x(1:4)),rowdata(:,1));

indexArenaF = indexArena(filerows,:);
rowdataF = rowdata(filerows,:);
powerF = power(:,:,filerows);
frF = fr(filerows,:);
stimIndexF = stimIndex(filerows,:);

figure('Name',[filename ' wavelet power average RUNNING'],'NumberTitle','off'); hold on
imagesc(-4000:8000,1:size(powerF,1),mean(powerF,3))
ytick = [1, 5, 12, 30, 45, 60, 100];
ytick = fliplr(ytick);
ytickPos = arrayfun(@(x) knnsearch(freq',x),ytick);
set(gca,'XLim',[-4000 8000])
set(gca,'YTick',ytickPos,'YTickLabel',arrayfun(@num2str,ytick,'UniformOutput',false),'YDir','reverse')
set(gca,'YLim',[ytickPos(1) ytickPos(end)])
set(gca,'XTick',[-4000 0 4000 8000],'XTickLabel',{'-4','0','4','8'})

line([0 0],[ytickPos(1) ytickPos(end)],'Color','w','LineStyle','--','LineWidth',2)
line([4000 4000],[ytickPos(1) ytickPos(end)],'Color','w','LineStyle','--','LineWidth',2)

set(gca,'FontSize',20)
xlabel(gca,'peristimulus time (s)','FontSize',20)
ylabel(gca,'frequency (Hz)','FontSize',20)

set(gca,'CLim',[0 500])
set(gca,'Box','off')

title('BLIND RUNNING','FontSize',20)

%
cb = colorbar;
set(cb,'YTick',[0 500],'YTickLabel',{'0','500'},'FontSize',20)
%% rem
% INC
filename = '2026';
REM = load('INCbase_homeCage_f25Hz','power','fr','stimIndex2','rowdata','remindex');
indexArena = repmat({'linearTrack'},size(REM.power,3),1);
indexREM = REM.remindex;

rowdataREM = REM.rowdata(indexREM,:);
powerREM = REM.power(:,:,indexREM);
frREM = REM.fr(indexREM,:);
stimIndexREM = REM.stimIndex2(indexREM,:);
indexArenaREM = indexArena(indexREM,:);


powerREM = powerREM(:,(stimIndexREM(1,3)-4000):(stimIndexREM(1,3)+8000),:);


filerows = cellfun(@(x) isequal(filename,x(1:4)),rowdataREM(:,1));

indexArena = indexArenaREM(filerows,:);
rowdata = rowdataREM(filerows,:);
power = powerREM(:,:,filerows);
fr = frREM(filerows,:);
stimIndex = stimIndexREM(filerows,:);

figure('Name',[filename ' wavelet power average REM'],'NumberTitle','off'); hold on
imagesc(-4000:8000,1:size(power,1),mean(power,3))
freq = fr(1,:);
ytick = [1, 5, 12, 30, 45, 60, 100];
ytick = fliplr(ytick);
ytickPos = arrayfun(@(x) knnsearch(freq',x),ytick);
set(gca,'XLim',[-4000 8000])
set(gca,'YTick',ytickPos,'YTickLabel',arrayfun(@num2str,ytick,'UniformOutput',false),'YDir','reverse')
set(gca,'YLim',[ytickPos(1) ytickPos(end)])

line([0 0],[ytickPos(1) ytickPos(end)],'Color','w','LineStyle','--','LineWidth',2)
line([4000 4000],[ytickPos(1) ytickPos(end)],'Color','w','LineStyle','--','LineWidth',2)

set(gca,'FontSize',20)
xlabel(gca,'peristimulus time (s)','FontSize',20)
ylabel(gca,'frequency (Hz)','FontSize',20)

set(gca,'CLim',[0 500])
set(gca,'Box','off')

title('INC REM','FontSize',20)

% CTRL
REM = load('INCBLINDbase_homeCage_f25Hz','power','fr','stimIndex2','rowdata','remindex');
indexArena = repmat({'linearTrack'},size(REM.power,3),1);
indexREM = REM.remindex;

rowdataREM = REM.rowdata(indexREM,:);
powerREM = REM.power(:,:,indexREM);
frREM = REM.fr(indexREM,:);
stimIndexREM = REM.stimIndex2(indexREM,:);
indexArenaREM = indexArena(indexREM,:);


powerREM = powerREM(:,(stimIndexREM(1,3)-4000):(stimIndexREM(1,3)+8000),:);


filerows = cellfun(@(x) isequal(filename,x(1:4)),rowdataREM(:,1));

indexArena = indexArenaREM(filerows,:);
rowdata = rowdataREM(filerows,:);
power = powerREM(:,:,filerows);
fr = frREM(filerows,:);
stimIndex = stimIndexREM(filerows,:);

figure('Name',[filename ' wavelet power average REM'],'NumberTitle','off'); hold on
imagesc(-4000:8000,1:size(power,1),mean(power,3))
freq = fr(1,:);
ytick = [1, 5, 12, 30, 45, 60, 100];
ytick = fliplr(ytick);
ytickPos = arrayfun(@(x) knnsearch(freq',x),ytick);
set(gca,'XLim',[-4000 8000])
set(gca,'YTick',ytickPos,'YTickLabel',arrayfun(@num2str,ytick,'UniformOutput',false),'YDir','reverse')
set(gca,'YLim',[ytickPos(1) ytickPos(end)])

line([0 0],[ytickPos(1) ytickPos(end)],'Color','w','LineStyle','--','LineWidth',2)
line([4000 4000],[ytickPos(1) ytickPos(end)],'Color','w','LineStyle','--','LineWidth',2)

set(gca,'FontSize',20)
xlabel(gca,'peristimulus time (s)','FontSize',20)
ylabel(gca,'frequency (Hz)','FontSize',20)

set(gca,'CLim',[0 500])
set(gca,'Box','off')

title('BLIND REM','FontSize',20)
%% nonrem
% INC
filename = '2026';
REM = load('INCbase_homeCage_f25Hz','power','fr','stimIndex2','rowdata','nonremindex');
indexArena = repmat({'linearTrack'},size(REM.power,3),1);
indexREM = REM.nonremindex;

rowdataREM = REM.rowdata(indexREM,:);
powerREM = REM.power(:,:,indexREM);
frREM = REM.fr(indexREM,:);
stimIndexREM = REM.stimIndex2(indexREM,:);
indexArenaREM = indexArena(indexREM,:);


powerREM = powerREM(:,(stimIndexREM(1,3)-4000):(stimIndexREM(1,3)+8000),:);


filerows = cellfun(@(x) isequal(filename,x(1:4)),rowdataREM(:,1));

indexArena = indexArenaREM(filerows,:);
rowdata = rowdataREM(filerows,:);
power = powerREM(:,:,filerows);
fr = frREM(filerows,:);
stimIndex = stimIndexREM(filerows,:);

figure('Name',[filename ' wavelet power average NONREM'],'NumberTitle','off'); hold on
imagesc(-4000:8000,1:size(power,1),mean(power,3))
freq = fr(1,:);
ytick = [1, 5, 12, 30, 45, 60, 100];
ytick = fliplr(ytick);
ytickPos = arrayfun(@(x) knnsearch(freq',x),ytick);
set(gca,'XLim',[-4000 8000])
set(gca,'YTick',ytickPos,'YTickLabel',arrayfun(@num2str,ytick,'UniformOutput',false),'YDir','reverse')
set(gca,'YLim',[ytickPos(1) ytickPos(end)])

line([0 0],[ytickPos(1) ytickPos(end)],'Color','w','LineStyle','--','LineWidth',2)
line([4000 4000],[ytickPos(1) ytickPos(end)],'Color','w','LineStyle','--','LineWidth',2)

set(gca,'FontSize',20)
xlabel(gca,'peristimulus time (s)','FontSize',20)
ylabel(gca,'frequency (Hz)','FontSize',20)

set(gca,'CLim',[0 500])
set(gca,'Box','off')

title('INC NONREM','FontSize',20)

% CTRL
REM = load('INCBLINDbase_homeCage_f25Hz','power','fr','stimIndex2','rowdata','nonremindex');
indexArena = repmat({'linearTrack'},size(REM.power,3),1);
indexREM = REM.nonremindex;

rowdataREM = REM.rowdata(indexREM,:);
powerREM = REM.power(:,:,indexREM);
frREM = REM.fr(indexREM,:);
stimIndexREM = REM.stimIndex2(indexREM,:);
indexArenaREM = indexArena(indexREM,:);


powerREM = powerREM(:,(stimIndexREM(1,3)-4000):(stimIndexREM(1,3)+8000),:);


filerows = cellfun(@(x) isequal(filename,x(1:4)),rowdataREM(:,1));

indexArena = indexArenaREM(filerows,:);
rowdata = rowdataREM(filerows,:);
power = powerREM(:,:,filerows);
fr = frREM(filerows,:);
stimIndex = stimIndexREM(filerows,:);

figure('Name',[filename ' wavelet power average NONREM'],'NumberTitle','off'); hold on
imagesc(-4000:8000,1:size(power,1),mean(power,3))
freq = fr(1,:);
ytick = [1, 5, 12, 30, 45, 60, 100];
ytick = fliplr(ytick);
ytickPos = arrayfun(@(x) knnsearch(freq',x),ytick);
set(gca,'XLim',[-4000 8000])
set(gca,'YTick',ytickPos,'YTickLabel',arrayfun(@num2str,ytick,'UniformOutput',false),'YDir','reverse')
set(gca,'YLim',[ytickPos(1) ytickPos(end)])

line([0 0],[ytickPos(1) ytickPos(end)],'Color','w','LineStyle','--','LineWidth',2)
line([4000 4000],[ytickPos(1) ytickPos(end)],'Color','w','LineStyle','--','LineWidth',2)

set(gca,'FontSize',20)
xlabel(gca,'peristimulus time (s)','FontSize',20)
ylabel(gca,'frequency (Hz)','FontSize',20)

set(gca,'CLim',[0 500])
set(gca,'Box','off')

title('BLIND NONREM','FontSize',20)
%% urethane
% INC
filename = '2046';
REM = load('INCbase_urethane_f25Hz','power','fr','stimIndex2','rowdata','thetaindex');
indexArena = repmat({'linearTrack'},size(REM.power,3),1);
indexREM = REM.thetaindex;

rowdataREM = REM.rowdata(indexREM,:);
powerREM = REM.power(:,:,indexREM);
frREM = REM.fr(indexREM,:);
stimIndexREM = REM.stimIndex2(indexREM,:);
indexArenaREM = indexArena(indexREM,:);


powerREM = powerREM(:,(stimIndexREM(1,3)-4000):(stimIndexREM(1,3)+8000),:);


filerows = cellfun(@(x) isequal(filename,x(1:4)),rowdataREM(:,1));

indexArena = indexArenaREM(filerows,:);
rowdata = rowdataREM(filerows,:);
power = powerREM(:,:,filerows);
fr = frREM(filerows,:);
stimIndex = stimIndexREM(filerows,:);

figure('Name',[filename ' wavelet power average urethane'],'NumberTitle','off'); hold on
imagesc(-4000:8000,1:size(power,1),mean(power,3))
freq = fr(1,:);
ytick = [1, 5, 12, 30, 45, 60, 100];
ytick = fliplr(ytick);
ytickPos = arrayfun(@(x) knnsearch(freq',x),ytick);
set(gca,'XLim',[-4000 8000])
set(gca,'YTick',ytickPos,'YTickLabel',arrayfun(@num2str,ytick,'UniformOutput',false),'YDir','reverse')
set(gca,'YLim',[ytickPos(1) ytickPos(end)])

line([0 0],[ytickPos(1) ytickPos(end)],'Color','w','LineStyle','--','LineWidth',2)
line([4000 4000],[ytickPos(1) ytickPos(end)],'Color','w','LineStyle','--','LineWidth',2)

set(gca,'FontSize',20)
xlabel(gca,'peristimulus time (s)','FontSize',20)
ylabel(gca,'frequency (Hz)','FontSize',20)

set(gca,'CLim',[0 500])
set(gca,'Box','off')

title('INC URETHANE THETA','FontSize',20)

% BLIND
filename = '2046';
REM = load('INCBLINDbase_urethane_f25Hz','power','fr','stimIndex2','rowdata','thetaindex');
indexArena = repmat({'linearTrack'},size(REM.power,3),1);
indexREM = REM.thetaindex;

rowdataREM = REM.rowdata(indexREM,:);
powerREM = REM.power(:,:,indexREM);
frREM = REM.fr(indexREM,:);
stimIndexREM = REM.stimIndex2(indexREM,:);
indexArenaREM = indexArena(indexREM,:);


powerREM = powerREM(:,(stimIndexREM(1,3)-4000):(stimIndexREM(1,3)+8000),:);


filerows = cellfun(@(x) isequal(filename,x(1:4)),rowdataREM(:,1));

indexArena = indexArenaREM(filerows,:);
rowdata = rowdataREM(filerows,:);
power = powerREM(:,:,filerows);
fr = frREM(filerows,:);
stimIndex = stimIndexREM(filerows,:);

figure('Name',[filename ' wavelet power average urethane'],'NumberTitle','off'); hold on
imagesc(-4000:8000,1:size(power,1),mean(power,3))
freq = fr(1,:);
ytick = [1, 5, 12, 30, 45, 60, 100];
ytick = fliplr(ytick);
ytickPos = arrayfun(@(x) knnsearch(freq',x),ytick);
set(gca,'XLim',[-4000 8000])
set(gca,'YTick',ytickPos,'YTickLabel',arrayfun(@num2str,ytick,'UniformOutput',false),'YDir','reverse')
set(gca,'YLim',[ytickPos(1) ytickPos(end)])

line([0 0],[ytickPos(1) ytickPos(end)],'Color','w','LineStyle','--','LineWidth',2)
line([4000 4000],[ytickPos(1) ytickPos(end)],'Color','w','LineStyle','--','LineWidth',2)

set(gca,'FontSize',20)
xlabel(gca,'peristimulus time (s)','FontSize',20)
ylabel(gca,'frequency (Hz)','FontSize',20)

set(gca,'CLim',[0 500])
set(gca,'Box','off')

title('BLIND URETHANE THETA','FontSize',20)



%% CSD
goodChfile = {'1868','1943','1957','1985','2017','2022A','2022B','2026' ,'2027','2040','2045','2046'};
goodCh =     { 4    , 12   , 20   , 7    , 9    , 6     , 23    , 6     , 4    , 11   , 1    , 4    };
                                           12                     7                                       
                                           14                     8                                       
                                           16                     9                                       
                                           17                     10                                       
                                           18                     11                                       
                                           19                     12                                       
                                           20                     13                                       
                                           21                     14                                       
                                           22                                                            
                                           24                                                            
                                           25                                                            
                                           26                                                            

distance
% pyrCh(:,1) = {'1868'          ,'1943'       ,'1957'       ,'1985'       ,'2017'          ,'2022A','2022B','2026' ,'2027','2040','2045','2046'};
% pyrCh(:,2) = { 3              , 12          , 20          , 7           , 8              , 6     , 23    , 5     , 4    , 11   , 1    , 4    };
% 
% radCh(:,1) = {'1868'          ,'1943'       ,'1957'       ,'1985'       ,'2017'          ,'2022A','2022B','2026' ,'2027','2040','2045','2046'};
% radCh(:,2) = {[5,6,7,8]       ,[14,15]      ,[21,22,23,24],[9,12]       ,[12,14]         ,[]     ,[]     ,[7,8]  ,[6,7] ,      ,[2]   ,[5,6] };
% 
% lamCh(:,1) = {'1868'          ,'1943'       ,'1957'       ,'1985'       ,'2017'          ,'2022A','2022B','2026' ,'2027','2040','2045','2046'};
% lamCh(:,2) = {[11,12]         ,[17,18,19,20],[25,26,27,28],[14,15,16,17],[16,17,18,19,20],[]     ,[]     ,[9,10] ,[8,9] ,      ,[3,4,5],[7,9] };
% 
% molCh(:,1) = {'1868'          ,'1943'       ,'1957'       ,'1985'       ,'2017'          ,'2022A','2022B','2026' ,'2027','2040','2045','2046'};
% molCh(:,2) = {[13,14,15]      ,[22]         ,[31]         ,[19,21]      ,[21,22]         ,[]     ,[]     ,[11,12],[10]  ,      ,[6,7] ,[10,11]};

% hilCh(:,1) = {'1868'          ,'1943'       ,'1957'       ,'1985'       ,'2017'          ,'2022A','2022B','2026' ,'2027','2040','2045','2046'};
% hilCh(:,2) = {[16,17,18,19,20],[27,28]      ,[]           ,[]           ,[24,25,26]      ,       ,       ,[13,14],[11]  ,      ,[9,10],      };
% 
% badCh(:,1) = {'1868'          ,'1943'       ,'1957'       ,'1985'       ,'2017'          ,'2022A','2022B','2026' ,'2027','2040','2045','2046'};
% badCh(:,2) = {                ,             ,             ,             ,[]              ,       ,       ,[]     ,      ,      ,      , 8    };


%% csd
load('INCSEPTUMbase_homeCage_f25Hz.mat')
filename = '2017';
badCh =    [ 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 1, 0, 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0];
distance =   [50,50,50,100  ,50,50,50,50,100,  100,  100,  50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50];

goodCh =   [ 1, 2, 3, 4, 5, 6, 7, 8, 9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32];

filename = '2026';
badCh =    [   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0];
distance =     [100,100,100,100,100,100,100,100,100,100,100,100,100,100,100];
goodCh =   [   1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15, 16];

filename = '2046';
badCh =    [   0,  0,  0,  0,  0,  0,  0,  1,  0,  0,  0,  0,  0,  0,  0,  0];
distance =     [100,100,100,100,100,100,200    ,100,100,100,100,100,100,100];
goodCh =   [   1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15, 16];

% filename = '2027';
% badCh =    [   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0];
% distance =     [100,100,100,100,100,100,100,100,100,100,100,100,100,100,100];
% goodCh =   [   1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15, 16];

% filename = '1868';
% badCh =    [ 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1, 1, 1];
% distance =   [50,50,50,50,50,100  ,50,50,50,50,50,50,50,50,50,50,100  ,50,50,50,50,50,50,50,100];
% 
% goodCh =   [ 1, 2, 3, 4, 5, 6, 7, 8, 9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32];


% filename = '2045';
% badCh =    [   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0];
% distance =     [100,100,100,100,100,100,100,100,100,100,100,100,100,100,100];
% goodCh =   [   1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15, 16];
% % 
% filename = '2040';
% badCh =    [ 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0];
% distance =                     [50,50,50,50,50,50,50,50,50,100  ,50,50,50,50,50,50,50,50,50,50,50,50,50,50];
% 
% goodCh =   [ 1, 2, 3, 4, 5, 6, 7, 8, 9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32];


index = remindex;

rowdata2 = rowdata(index,:);
eegmatrix2 = eegmatrix(index);
pulseIndex2 = pulseIndex(index);
pyrN2 = pyrN(index);
power2 = power(:,:,index);
fr2 = fr(index,:);
eegPyrmatrix2 = eegPyrmatrix(index,:);
stimIndexQ = stimIndex(index,:);

filerows = cellfun(@(x) isequal(filename,x(1:4)),rowdata2(:,1));
eeg = eegmatrix2(filerows);
pulses = pulseIndex2(filerows);
pyrNx = pyrN2(filerows);
powerx = power2(:,:,filerows);
frx = fr2(filerows,:);
eegPyrmatrixX = eegPyrmatrix2(filerows,:);
stimIndexX = stimIndexQ(filerows,:);

csdtime = 250; % datapoints
bvarF1 = fir1(2048,[1/(1000/2), 200/(1000/2)]);
bvarT1 = fir1(2048,[8/(1000/2), 12/(1000/2)]);
csdthetaPRE = cell(size(eeg,1),1);
csdthetaSTIM = cell(size(eeg,1),1);
csdthetaPOST = cell(size(eeg,1),1);
pyrPRE = cell(size(eeg,1),1);
pyrSTIM = cell(size(eeg,1),1);
pyrPOST = cell(size(eeg,1),1);
GCN = cell(size(eeg,1),1);
eegAdata = cell(size(eeg,1),1);

eegPRE = cell(size(eeg,1),1);
eegSTIM = cell(size(eeg,1),1);
for k = 1:size(eeg,1)
%     eegA = eeg{k,1};
    eegA = filtfilt(bvarF1,1,eeg{k,1});
    
    % detect theta peaks
    thetaphase = rad2deg(angle(hilbert(filtfilt(bvarT1,1,eegA(:,pyrNx(k,1))))));
    thetapeak = find(and(thetaphase>(0-1.5),thetaphase<(0+1.5)));
    px = find(diff(thetapeak)<10)+1;
    thetapeak(px) = [];
    thetapeak(thetapeak<1+csdtime) = [];
    thetapeak(thetapeak>size(eegA,1)-csdtime) = [];
    
    % correct theta peaks by detected theta state
    [theta, TDratio] = andor_detectTheta(powerx(:,:,k),frx(k,:),5,12,1,4,1000);
    nanshift = find(~isnan(eegPyrmatrixX(k,:)),1,'first')-1;
    theta_corr = false(size(eegA,1),1);
    theta_corr(find(theta)+nanshift) = true;
    theta_corr = find(theta_corr);
    thetapeak(~ismember(thetapeak,theta_corr)) = [];
    
    % select thetapeak before, during and after stim
%     if ~isempty(thetapeak)
% %         thetapeakPRE = thetapeak;
        thetapeakPRE = pulses{k,1}+1+csdtime;%
        

        thetapeakPRE(thetapeakPRE>=stimIndexX(k,3)) = [];
        
% %         thetapeakSTIM = thetapeak;
        thetapeakSTIM = pulses{k,1} + stimIndex(k,3)+1;%
        thetapeakSTIM(thetapeakSTIM<stimIndexX(k,3)) = [];
        thetapeakSTIM(thetapeakSTIM>stimIndexX(k,4)) = [];
        
        thetapeakPOST = thetapeak;
        thetapeakPOST(thetapeakPOST<=stimIndexX(k,4)) = [];
        
        
        
        
        % detect bad channels
%         if size(eegA,2) == 16
%             distanceCh = 100;
%         elseif size(eegA,2) == 32
%             distanceCh = 50;
%         end
%         distance = repmat(distanceCh,1,size(eegA,2)-1);
%         
%         if ~isempty(thetapeakPRE)
%             tempcsd = -(andor_CSD(eegA,1000,distance,thetapeakPRE,csdtime))';
%         elseif ~isempty(thetapeakSTIM)
%             tempcsd = -(andor_CSD(eegA,1000,distance,thetapeakSTIM,csdtime))';
%         end
%         
%         csdMid = tempcsd(:,csdtime+1);
%         csdHelp = diff(csdMid);
%         csdHO = or(csdHelp<(mean(csdHelp)-1*std(csdHelp)), csdHelp>(mean(csdHelp)+1*std(csdHelp)));
%         
%         csdMid2 = tempcsd(:,csdtime+1+20);
%         csdHelp2 = diff(csdMid2);
%         csdHO2 = or(csdHelp2<(mean(csdHelp2)-1*std(csdHelp2)), csdHelp2>(mean(csdHelp2)+1*std(csdHelp2)));
        
        goodChName = 1:size(eegA,2);
%         badCh = false(1,size(eegA,2));
%         if any(csdHO)
%             for r = 1:length(csdHO)-1
%                 if csdHO(r)
%                     t = csdHO;
%                     t(1:r) = true;
%                     tr = find(~t,1,'first');
%                     if ~isempty(tr)
%                         if rem(tr-r,2) == 0
%                             badCh(r+1) = true;
%                         end
%                     end
%                 end
%             end
%         end
%         if any(csdHO2)
%             for r = 1:length(csdHO2)-1
%                 if csdHO2(r)
%                     t = csdHO2;
%                     t(1:r) = true;
%                     tr = find(~t,1,'first');
%                     if ~isempty(tr)
%                         if rem(tr-r,2) == 0
%                             badCh(r+1) = true;
%                         end
%                     end
%                 end
%             end
%         end
        goodChName = goodChName(~badCh);
        GCN{k,1} = goodChName;
        eegA = eegA(:,~badCh);
        
%         DD = diff(goodChName);
%         DDloc = find(DD>1);
%         if ~isempty(DDloc)
%             DDval = DD(DDloc);
%             for d = 1:length(DDloc)
%                 distance(DDloc(d)) = DDval(d)*distanceCh;
%             end
%         end
        
        % pre
        csdthetaPRE{k,1} = -(andor_CSD(eegA,1000,distance,thetapeakPRE,csdtime))';
        if ~isempty(thetapeakPRE)
            pyrPREtemp = NaN(2*csdtime+1,length(thetapeakPRE));
            eegPREtemp = [];
            for m = 1:length(thetapeakPRE)
                pyrPREtemp(:,m) = eegA(thetapeakPRE(m)-csdtime:thetapeakPRE(m)+csdtime,pyrNx(k,1));
                eegPREtemp(:,:,m) = eegA(thetapeakPRE(m)-csdtime:thetapeakPRE(m)+csdtime,:);
            end
            pyrPRE{k,1} = mean(pyrPREtemp,2);
            
            eegPRE{k,1} = mean(eegPREtemp,3);
        else
            pyrPRE{k,1} = [];
            eegPRE{k,1} = [];
        end
        
        % stim
        csdthetaSTIM{k,1} = -(andor_CSD(eegA,1000,distance,thetapeakSTIM,csdtime))';
        if ~isempty(thetapeakSTIM)
            pyrSTIMtemp = NaN(2*csdtime+1,length(thetapeakSTIM));
            eegSTIMtemp = [];
            for m = 1:length(thetapeakSTIM)
                pyrSTIMtemp(:,m) = eegA(thetapeakSTIM(m)-csdtime:thetapeakSTIM(m)+csdtime,pyrN(k,1));
                eegSTIMtemp(:,:,m) = eegA(thetapeakSTIM(m)-csdtime:thetapeakSTIM(m)+csdtime,:);
            end
            pyrSTIM{k,1} = mean(pyrSTIMtemp,2);
            
            eegSTIM{k,1} = mean(eegSTIMtemp,3);
        else
            pyrSTIM{k,1} = [];
            eegSTIM{k,1} = [];
        end
        
        % post
%         csdthetaPOST{k,1} = -(andor_CSD(eegA,1000,distance,thetapeakPOST,csdtime))';
%         if ~isempty(thetapeakPOST)
%             pyrPOSTtemp = NaN(2*csdtime+1,length(thetapeakPOST));
%             for m = 1:length(thetapeakPOST)
%                 pyrPOSTtemp(:,m) = eegA(thetapeakPOST(m)-csdtime:thetapeakPOST(m)+csdtime,pyrNx(k,1));
%             end
%             pyrPOST{k,1} = mean(pyrPOSTtemp,2);
%         else
%             pyrPOST{k,1} = [];
%         end
        eegAdata{k,1} = eegA;

% %     end
end
%%
k = 1;
figure('Name',[filename '  ' num2str(k) '   PRE csd'],'NumberTitle','off');
imagesc((1:size(csdthetaPRE{k,1},2))-(csdtime+1),1:size(csdthetaPRE{k,1},1),csdthetaPRE{k,1})
csdyticklabel = arrayfun(@num2str,GCN{k,1},'UniformOutput',false);
csdyticklabel{ismember(csdyticklabel,num2str(pyrNx(k,1)))} = 'PYR';
set(gca,'CLim',[-0.03 0.03],'YTick',1:size(csdthetaPRE{k,1},1),'YTickLabel',csdyticklabel)
line([0 0],[0.5 size(csdthetaPRE{k,1},1)+0.5],'Color','w','LineStyle','--','LineWidth',2)

figure('Name',[filename '  ' num2str(k) '   STIM csd'],'NumberTitle','off');
imagesc((1:size(csdthetaSTIM{k,1},2))-(csdtime+1),1:size(csdthetaSTIM{k,1},1),csdthetaSTIM{k,1})
csdyticklabel = arrayfun(@num2str,GCN{k,1},'UniformOutput',false);
csdyticklabel{ismember(csdyticklabel,num2str(pyrNx(k,1)))} = 'PYR';
set(gca,'CLim',[-0.03 0.03],'YTick',1:size(csdthetaSTIM{k,1},1),'YTickLabel',csdyticklabel)
line([0 0],[0.5 size(csdthetaSTIM{k,1},1)+0.5],'Color','w','LineStyle','--','LineWidth',2)
%%
% PULSE
% running
A = load('INC_2017_HB_PULSEcsd.mat','csdthetaPRE'); A = A.csdthetaPRE;
B = load('INC_2017_LT_PULSEcsd.mat','csdthetaPRE'); B = B.csdthetaPRE;
full2017pre = [A; B];

C = load('INC_2017_HB_PULSEcsd.mat','csdthetaSTIM'); C = C.csdthetaSTIM;
D = load('INC_2017_LT_PULSEcsd.mat','csdthetaSTIM'); D = D.csdthetaSTIM;
full2017stim = [C; D];

deleteindex = or(cellfun(@isempty,full2017pre),cellfun(@isempty,full2017stim));
full2017pre(deleteindex) = [];
full2017stim(deleteindex) = [];

pyr2017pre = []; pyr2017stim = [];
rad2017pre = []; rad2017stim = [];
lam2017pre = []; lam2017stim = [];
mol2017pre = []; mol2017stim = [];
hil2017pre = []; hil2017stim = [];
for k = 1:size(full2017stim,1)
    pyr2017pre(k,:) = full2017pre{k,1}(7,:);
    pyr2017stim(k,:) = full2017stim{k,1}(7,:);
    
    rad2017pre(k,:) = mean(full2017pre{k,1}(10:11,:));
    rad2017stim(k,:) = mean(full2017stim{k,1}(10:11,:));
    
    lam2017pre(k,:) = mean(full2017pre{k,1}(12:16,:));
    lam2017stim(k,:) = mean(full2017stim{k,1}(12:16,:));
    
    mol2017pre(k,:) = mean(full2017pre{k,1}(17:18,:));
    mol2017stim(k,:) = mean(full2017stim{k,1}(17:18,:));
    
    hil2017pre(k,:) = mean(full2017pre{k,1}(20:22,:));
    hil2017stim(k,:) = mean(full2017stim{k,1}(20:22,:));
end

A = load('INC_2026_HB_PULSEcsd.mat','csdthetaPRE'); A = A.csdthetaPRE;
B = load('INC_2026_LT_PULSEcsd.mat','csdthetaPRE'); B = B.csdthetaPRE;
full2026pre = [A; B];

C = load('INC_2026_HB_PULSEcsd.mat','csdthetaSTIM'); C = C.csdthetaSTIM;
D = load('INC_2026_LT_PULSEcsd.mat','csdthetaSTIM'); D = D.csdthetaSTIM;
full2026stim = [C; D];

deleteindex = or(cellfun(@isempty,full2026pre),cellfun(@isempty,full2026stim));
full2026pre(deleteindex) = [];
full2026stim(deleteindex) = [];

pyr2026pre = []; pyr2026stim = [];
rad2026pre = []; rad2026stim = [];
lam2026pre = []; lam2026stim = [];
mol2026pre = []; mol2026stim = [];
hil2026pre = []; hil2026stim = [];
for k = 1:size(full2026stim,1)
    pyr2026pre(k,:) = full2026pre{k,1}(5,:);
    pyr2026stim(k,:) = full2026stim{k,1}(5,:);
    
    rad2026pre(k,:) = mean(full2026pre{k,1}(7:8,:));
    rad2026stim(k,:) = mean(full2026stim{k,1}(7:8,:));
    
    lam2026pre(k,:) = mean(full2026pre{k,1}(9:10,:));
    lam2026stim(k,:) = mean(full2026stim{k,1}(9:10,:));
    
    mol2026pre(k,:) = mean(full2026pre{k,1}(11:12,:));
    mol2026stim(k,:) = mean(full2026stim{k,1}(11:12,:));
    
    hil2026pre(k,:) = mean(full2026pre{k,1}(13:14,:));
    hil2026stim(k,:) = mean(full2026stim{k,1}(13:14,:));
end

A = load('INC_2027_HB_PULSEcsd.mat','csdthetaPRE'); A = A.csdthetaPRE;
full2027pre = [A];

C = load('INC_2027_HB_PULSEcsd.mat','csdthetaSTIM'); C = C.csdthetaSTIM;
full2027stim = [C];

deleteindex = or(cellfun(@isempty,full2027pre),cellfun(@isempty,full2027stim));
full2027pre(deleteindex) = [];
full2027stim(deleteindex) = [];

pyr2027pre = []; pyr2027stim = [];
rad2027pre = []; rad2027stim = [];
lam2027pre = []; lam2027stim = [];
mol2027pre = []; mol2027stim = [];
hil2027pre = []; hil2027stim = [];
for k = 1:size(full2027stim,1)
    pyr2027pre(k,:) = full2027pre{k,1}(4,:);
    pyr2027stim(k,:) = full2027stim{k,1}(4,:);
    
    rad2027pre(k,:) = mean(full2027pre{k,1}(6:7,:));
    rad2027stim(k,:) = mean(full2027stim{k,1}(6:7,:));
    
    lam2027pre(k,:) = mean(full2027pre{k,1}(8:9,:));
    lam2027stim(k,:) = mean(full2027stim{k,1}(8:9,:));
    
    mol2027pre(k,:) = (full2027pre{k,1}(10,:));
    mol2027stim(k,:) = (full2027stim{k,1}(10,:));
    
    hil2027pre(k,:) = (full2027pre{k,1}(11,:));
    hil2027stim(k,:) = (full2027stim{k,1}(11,:));
end

A = load('INC_2046_HB_PULSEcsd.mat','csdthetaPRE'); A = A.csdthetaPRE;
B = load('INC_2046_LT_PULSEcsd.mat','csdthetaPRE'); B = B.csdthetaPRE;
full2046pre = [A; B];

C = load('INC_2046_HB_PULSEcsd.mat','csdthetaSTIM'); C = C.csdthetaSTIM;
D = load('INC_2046_LT_PULSEcsd.mat','csdthetaSTIM'); D = D.csdthetaSTIM;
full2046stim = [C; D];

deleteindex = or(cellfun(@isempty,full2046pre),cellfun(@isempty,full2046stim));
full2046pre(deleteindex) = [];
full2046stim(deleteindex) = [];

pyr2046pre = []; pyr2046stim = [];
rad2046pre = []; rad2046stim = [];
lam2046pre = []; lam2046stim = [];
mol2046pre = []; mol2046stim = [];
hil2046pre = []; hil2046stim = [];
for k = 1:size(full2046stim,1)
    pyr2046pre(k,:) = full2046pre{k,1}(4,:);
    pyr2046stim(k,:) = full2046stim{k,1}(4,:);
    
    rad2046pre(k,:) = mean(full2046pre{k,1}(6:7,:));
    rad2046stim(k,:) = mean(full2046stim{k,1}(6:7,:));
    
    lam2046pre(k,:) = mean(full2046pre{k,1}(8:9,:));
    lam2046stim(k,:) = mean(full2046stim{k,1}(8:9,:));
    
    mol2046pre(k,:) = (full2046pre{k,1}(10,:));
    mol2046stim(k,:) = (full2046stim{k,1}(10,:));
    
    hil2046pre(k,:) = (full2046pre{k,1}(11,:));
    hil2046stim(k,:) = (full2046stim{k,1}(11,:));
end

PYRprepulse = [pyr2017pre; pyr2026pre; pyr2027pre; pyr2046pre];
PYRstimpulse = [pyr2017stim; pyr2026stim; pyr2027stim; pyr2046stim];

RADprepulse = [rad2017pre; rad2026pre; rad2027pre; rad2046pre];
RADstimpulse = [rad2017stim; rad2026stim; rad2027stim; rad2046stim];

LAMprepulse = [lam2017pre; lam2026pre; lam2027pre; lam2046pre];
LAMstimpulse = [lam2017stim; lam2026stim; lam2027stim; lam2046stim];

MOLprepulse = [mol2017pre; mol2026pre; mol2027pre; mol2046pre];
MOLstimpulse = [mol2017stim; mol2026stim; mol2027stim; mol2046stim];

HILprepulse = [hil2017pre; hil2026pre; hil2027pre; hil2046pre];
HILstimpulse = [hil2017stim; hil2026stim; hil2027stim; hil2046stim];

% CTRL
A = load('INC_2017_HB_PULSEcsd CTRL.mat','csdthetaPRE'); A = A.csdthetaPRE;
B = load('INC_2017_LT_PULSEcsd CTRL.mat','csdthetaPRE'); B = B.csdthetaPRE;
full2017pre = [A; B];

C = load('INC_2017_HB_PULSEcsd CTRL.mat','csdthetaSTIM'); C = C.csdthetaSTIM;
D = load('INC_2017_LT_PULSEcsd CTRL.mat','csdthetaSTIM'); D = D.csdthetaSTIM;
full2017stim = [C; D];

deleteindex = or(cellfun(@isempty,full2017pre),cellfun(@isempty,full2017stim));
full2017pre(deleteindex) = [];
full2017stim(deleteindex) = [];

pyr2017pre = []; pyr2017stim = [];
rad2017pre = []; rad2017stim = [];
lam2017pre = []; lam2017stim = [];
mol2017pre = []; mol2017stim = [];
hil2017pre = []; hil2017stim = [];
for k = 1:size(full2017stim,1)
    pyr2017pre(k,:) = full2017pre{k,1}(7,:);
    pyr2017stim(k,:) = full2017stim{k,1}(7,:);
    
    rad2017pre(k,:) = mean(full2017pre{k,1}(10:11,:));
    rad2017stim(k,:) = mean(full2017stim{k,1}(10:11,:));
    
    lam2017pre(k,:) = mean(full2017pre{k,1}(12:16,:));
    lam2017stim(k,:) = mean(full2017stim{k,1}(12:16,:));
    
    mol2017pre(k,:) = mean(full2017pre{k,1}(17:18,:));
    mol2017stim(k,:) = mean(full2017stim{k,1}(17:18,:));
    
    hil2017pre(k,:) = mean(full2017pre{k,1}(20:22,:));
    hil2017stim(k,:) = mean(full2017stim{k,1}(20:22,:));
end

A = load('INC_2026_HB_PULSEcsd CTRL.mat','csdthetaPRE'); A = A.csdthetaPRE;
B = load('INC_2026_LT_PULSEcsd CTRL.mat','csdthetaPRE'); B = B.csdthetaPRE;
full2026pre = [A; B];

C = load('INC_2026_HB_PULSEcsd CTRL.mat','csdthetaSTIM'); C = C.csdthetaSTIM;
D = load('INC_2026_LT_PULSEcsd CTRL.mat','csdthetaSTIM'); D = D.csdthetaSTIM;
full2026stim = [C; D];

deleteindex = or(cellfun(@isempty,full2026pre),cellfun(@isempty,full2026stim));
full2026pre(deleteindex) = [];
full2026stim(deleteindex) = [];

pyr2026pre = []; pyr2026stim = [];
rad2026pre = []; rad2026stim = [];
lam2026pre = []; lam2026stim = [];
mol2026pre = []; mol2026stim = [];
hil2026pre = []; hil2026stim = [];
for k = 1:size(full2026stim,1)
    pyr2026pre(k,:) = full2026pre{k,1}(5,:);
    pyr2026stim(k,:) = full2026stim{k,1}(5,:);
    
    rad2026pre(k,:) = mean(full2026pre{k,1}(7:8,:));
    rad2026stim(k,:) = mean(full2026stim{k,1}(7:8,:));
    
    lam2026pre(k,:) = mean(full2026pre{k,1}(9:10,:));
    lam2026stim(k,:) = mean(full2026stim{k,1}(9:10,:));
    
    mol2026pre(k,:) = mean(full2026pre{k,1}(11:12,:));
    mol2026stim(k,:) = mean(full2026stim{k,1}(11:12,:));
    
    hil2026pre(k,:) = mean(full2026pre{k,1}(13:14,:));
    hil2026stim(k,:) = mean(full2026stim{k,1}(13:14,:));
end

B = load('INC_2027_LT_PULSEcsd CTRL.mat','csdthetaPRE'); B = B.csdthetaPRE;
full2027pre = [B];

D = load('INC_2027_LT_PULSEcsd CTRL.mat','csdthetaSTIM'); D = D.csdthetaSTIM;
full2027stim = [D];

deleteindex = or(cellfun(@isempty,full2027pre),cellfun(@isempty,full2027stim));
full2027pre(deleteindex) = [];
full2027stim(deleteindex) = [];

pyr2027pre = []; pyr2027stim = [];
rad2027pre = []; rad2027stim = [];
lam2027pre = []; lam2027stim = [];
mol2027pre = []; mol2027stim = [];
hil2027pre = []; hil2027stim = [];
for k = 1:size(full2027stim,1)
    pyr2027pre(k,:) = full2027pre{k,1}(4,:);
    pyr2027stim(k,:) = full2027stim{k,1}(4,:);
    
    rad2027pre(k,:) = mean(full2027pre{k,1}(6:7,:));
    rad2027stim(k,:) = mean(full2027stim{k,1}(6:7,:));
    
    lam2027pre(k,:) = mean(full2027pre{k,1}(8:9,:));
    lam2027stim(k,:) = mean(full2027stim{k,1}(8:9,:));
    
    mol2027pre(k,:) = (full2027pre{k,1}(10,:));
    mol2027stim(k,:) = (full2027stim{k,1}(10,:));
    
    hil2027pre(k,:) = (full2027pre{k,1}(11,:));
    hil2027stim(k,:) = (full2027stim{k,1}(11,:));
end

A = load('INC_2046_HB_PULSEcsd CTRL.mat','csdthetaPRE'); A = A.csdthetaPRE;
B = load('INC_2046_LT_PULSEcsd CTRL.mat','csdthetaPRE'); B = B.csdthetaPRE;
full2046pre = [A; B];

C = load('INC_2046_HB_PULSEcsd CTRL.mat','csdthetaSTIM'); C = C.csdthetaSTIM;
D = load('INC_2046_LT_PULSEcsd CTRL.mat','csdthetaSTIM'); D = D.csdthetaSTIM;
full2046stim = [C; D];

deleteindex = or(cellfun(@isempty,full2046pre),cellfun(@isempty,full2046stim));
full2046pre(deleteindex) = [];
full2046stim(deleteindex) = [];

pyr2046pre = []; pyr2046stim = [];
rad2046pre = []; rad2046stim = [];
lam2046pre = []; lam2046stim = [];
mol2046pre = []; mol2046stim = [];
hil2046pre = []; hil2046stim = [];
for k = 1:size(full2046stim,1)
    pyr2046pre(k,:) = full2046pre{k,1}(4,:);
    pyr2046stim(k,:) = full2046stim{k,1}(4,:);
    
    rad2046pre(k,:) = mean(full2046pre{k,1}(6:7,:));
    rad2046stim(k,:) = mean(full2046stim{k,1}(6:7,:));
    
    lam2046pre(k,:) = mean(full2046pre{k,1}(8:9,:));
    lam2046stim(k,:) = mean(full2046stim{k,1}(8:9,:));
    
    mol2046pre(k,:) = (full2046pre{k,1}(10,:));
    mol2046stim(k,:) = (full2046stim{k,1}(10,:));
    
    hil2046pre(k,:) = (full2046pre{k,1}(11,:));
    hil2046stim(k,:) = (full2046stim{k,1}(11,:));
end

PYRpreCpulse = [pyr2017pre; pyr2026pre; pyr2027pre; pyr2046pre];
PYRstimCpulse = [pyr2017stim; pyr2026stim; pyr2027stim; pyr2046stim];

RADpreCpulse = [rad2017pre; rad2026pre; rad2027pre; rad2046pre];
RADstimCpulse = [rad2017stim; rad2026stim; rad2027stim; rad2046stim];

LAMpreCpulse = [lam2017pre; lam2026pre; lam2027pre; lam2046pre];
LAMstimCpulse = [lam2017stim; lam2026stim; lam2027stim; lam2046stim];

MOLpreCpulse = [mol2017pre; mol2026pre; mol2027pre; mol2046pre];
MOLstimCpulse = [mol2017stim; mol2026stim; mol2027stim; mol2046stim];

HILpreCpulse = [hil2017pre; hil2026pre; hil2027pre; hil2046pre];
HILstimCpulse = [hil2017stim; hil2026stim; hil2027stim; hil2046stim];

% running theta triggered
A = load('INC_2017_HB_csd.mat','csdthetaPRE'); A = A.csdthetaPRE;
B = load('INC_2017_LT_csd.mat','csdthetaPRE'); B = B.csdthetaPRE;
full2017pre = [A; B];

C = load('INC_2017_HB_csd.mat','csdthetaSTIM'); C = C.csdthetaSTIM;
D = load('INC_2017_LT_csd.mat','csdthetaSTIM'); D = D.csdthetaSTIM;
full2017stim = [C; D];

deleteindex = or(cellfun(@isempty,full2017pre),cellfun(@isempty,full2017stim));
full2017pre(deleteindex) = [];
full2017stim(deleteindex) = [];

pyr2017pre = []; pyr2017stim = [];
rad2017pre = []; rad2017stim = [];
lam2017pre = []; lam2017stim = [];
mol2017pre = []; mol2017stim = [];
hil2017pre = []; hil2017stim = [];
for k = 1:size(full2017stim,1)
    pyr2017pre(k,:) = full2017pre{k,1}(7,:);
    pyr2017stim(k,:) = full2017stim{k,1}(7,:);
    
    rad2017pre(k,:) = mean(full2017pre{k,1}(10:11,:));
    rad2017stim(k,:) = mean(full2017stim{k,1}(10:11,:));
    
    lam2017pre(k,:) = mean(full2017pre{k,1}(12:16,:));
    lam2017stim(k,:) = mean(full2017stim{k,1}(12:16,:));
    
    mol2017pre(k,:) = mean(full2017pre{k,1}(17:18,:));
    mol2017stim(k,:) = mean(full2017stim{k,1}(17:18,:));
    
    hil2017pre(k,:) = mean(full2017pre{k,1}(20:22,:));
    hil2017stim(k,:) = mean(full2017stim{k,1}(20:22,:));
end

A = load('INC_2026_HB_csd.mat','csdthetaPRE'); A = A.csdthetaPRE;
B = load('INC_2026_LT_csd.mat','csdthetaPRE'); B = B.csdthetaPRE;
full2026pre = [A; B];

C = load('INC_2026_HB_csd.mat','csdthetaSTIM'); C = C.csdthetaSTIM;
D = load('INC_2026_LT_csd.mat','csdthetaSTIM'); D = D.csdthetaSTIM;
full2026stim = [C; D];

deleteindex = or(cellfun(@isempty,full2026pre),cellfun(@isempty,full2026stim));
full2026pre(deleteindex) = [];
full2026stim(deleteindex) = [];

pyr2026pre = []; pyr2026stim = [];
rad2026pre = []; rad2026stim = [];
lam2026pre = []; lam2026stim = [];
mol2026pre = []; mol2026stim = [];
hil2026pre = []; hil2026stim = [];
for k = 1:size(full2026stim,1)
    pyr2026pre(k,:) = full2026pre{k,1}(5,:);
    pyr2026stim(k,:) = full2026stim{k,1}(5,:);
    
    rad2026pre(k,:) = mean(full2026pre{k,1}(7:8,:));
    rad2026stim(k,:) = mean(full2026stim{k,1}(7:8,:));
    
    lam2026pre(k,:) = mean(full2026pre{k,1}(9:10,:));
    lam2026stim(k,:) = mean(full2026stim{k,1}(9:10,:));
    
    mol2026pre(k,:) = mean(full2026pre{k,1}(11:12,:));
    mol2026stim(k,:) = mean(full2026stim{k,1}(11:12,:));
    
    hil2026pre(k,:) = mean(full2026pre{k,1}(13:14,:));
    hil2026stim(k,:) = mean(full2026stim{k,1}(13:14,:));
end

A = load('INC_2027_HB_csd.mat','csdthetaPRE'); A = A.csdthetaPRE;
full2027pre = [A];

C = load('INC_2027_HB_csd.mat','csdthetaSTIM'); C = C.csdthetaSTIM;
full2027stim = [C];

deleteindex = or(cellfun(@isempty,full2027pre),cellfun(@isempty,full2027stim));
full2027pre(deleteindex) = [];
full2027stim(deleteindex) = [];

pyr2027pre = []; pyr2027stim = [];
rad2027pre = []; rad2027stim = [];
lam2027pre = []; lam2027stim = [];
mol2027pre = []; mol2027stim = [];
hil2027pre = []; hil2027stim = [];
for k = 1:size(full2027stim,1)
    pyr2027pre(k,:) = full2027pre{k,1}(4,:);
    pyr2027stim(k,:) = full2027stim{k,1}(4,:);
    
    rad2027pre(k,:) = mean(full2027pre{k,1}(6:7,:));
    rad2027stim(k,:) = mean(full2027stim{k,1}(6:7,:));
    
    lam2027pre(k,:) = mean(full2027pre{k,1}(8:9,:));
    lam2027stim(k,:) = mean(full2027stim{k,1}(8:9,:));
    
    mol2027pre(k,:) = (full2027pre{k,1}(10,:));
    mol2027stim(k,:) = (full2027stim{k,1}(10,:));
    
    hil2027pre(k,:) = (full2027pre{k,1}(11,:));
    hil2027stim(k,:) = (full2027stim{k,1}(11,:));
end

A = load('INC_2046_HB_csd.mat','csdthetaPRE'); A = A.csdthetaPRE;
B = load('INC_2046_LT_csd.mat','csdthetaPRE'); B = B.csdthetaPRE;
full2046pre = [A; B];

C = load('INC_2046_HB_csd.mat','csdthetaSTIM'); C = C.csdthetaSTIM;
D = load('INC_2046_LT_csd.mat','csdthetaSTIM'); D = D.csdthetaSTIM;
full2046stim = [C; D];

deleteindex = or(cellfun(@isempty,full2046pre),cellfun(@isempty,full2046stim));
full2046pre(deleteindex) = [];
full2046stim(deleteindex) = [];

pyr2046pre = []; pyr2046stim = [];
rad2046pre = []; rad2046stim = [];
lam2046pre = []; lam2046stim = [];
mol2046pre = []; mol2046stim = [];
hil2046pre = []; hil2046stim = [];
for k = 1:size(full2046stim,1)
    pyr2046pre(k,:) = full2046pre{k,1}(4,:);
    pyr2046stim(k,:) = full2046stim{k,1}(4,:);
    
    rad2046pre(k,:) = mean(full2046pre{k,1}(6:7,:));
    rad2046stim(k,:) = mean(full2046stim{k,1}(6:7,:));
    
    lam2046pre(k,:) = mean(full2046pre{k,1}(8:9,:));
    lam2046stim(k,:) = mean(full2046stim{k,1}(8:9,:));
    
    mol2046pre(k,:) = (full2046pre{k,1}(10,:));
    mol2046stim(k,:) = (full2046stim{k,1}(10,:));
    
    hil2046pre(k,:) = (full2046pre{k,1}(11,:));
    hil2046stim(k,:) = (full2046stim{k,1}(11,:));
end

PYRpre = [pyr2017pre; pyr2026pre; pyr2027pre; pyr2046pre];
PYRstim = [pyr2017stim; pyr2026stim; pyr2027stim; pyr2046stim];

RADpre = [rad2017pre; rad2026pre; rad2027pre; rad2046pre];
RADstim = [rad2017stim; rad2026stim; rad2027stim; rad2046stim];

LAMpre = [lam2017pre; lam2026pre; lam2027pre; lam2046pre];
LAMstim = [lam2017stim; lam2026stim; lam2027stim; lam2046stim];

MOLpre = [mol2017pre; mol2026pre; mol2027pre; mol2046pre];
MOLstim = [mol2017stim; mol2026stim; mol2027stim; mol2046stim];

HILpre = [hil2017pre; hil2026pre; hil2027pre; hil2046pre];
HILstim = [hil2017stim; hil2026stim; hil2027stim; hil2046stim];

% CTRL
A = load('INC_2017_HB_csd CTRL.mat','csdthetaPRE'); A = A.csdthetaPRE;
B = load('INC_2017_LT_csd CTRL.mat','csdthetaPRE'); B = B.csdthetaPRE;
full2017pre = [A; B];

C = load('INC_2017_HB_csd CTRL.mat','csdthetaSTIM'); C = C.csdthetaSTIM;
D = load('INC_2017_LT_csd CTRL.mat','csdthetaSTIM'); D = D.csdthetaSTIM;
full2017stim = [C; D];

deleteindex = or(cellfun(@isempty,full2017pre),cellfun(@isempty,full2017stim));
full2017pre(deleteindex) = [];
full2017stim(deleteindex) = [];

pyr2017pre = []; pyr2017stim = [];
rad2017pre = []; rad2017stim = [];
lam2017pre = []; lam2017stim = [];
mol2017pre = []; mol2017stim = [];
hil2017pre = []; hil2017stim = [];
for k = 1:size(full2017stim,1)
    pyr2017pre(k,:) = full2017pre{k,1}(7,:);
    pyr2017stim(k,:) = full2017stim{k,1}(7,:);
    
    rad2017pre(k,:) = mean(full2017pre{k,1}(10:11,:));
    rad2017stim(k,:) = mean(full2017stim{k,1}(10:11,:));
    
    lam2017pre(k,:) = mean(full2017pre{k,1}(12:16,:));
    lam2017stim(k,:) = mean(full2017stim{k,1}(12:16,:));
    
    mol2017pre(k,:) = mean(full2017pre{k,1}(17:18,:));
    mol2017stim(k,:) = mean(full2017stim{k,1}(17:18,:));
    
    hil2017pre(k,:) = mean(full2017pre{k,1}(20:22,:));
    hil2017stim(k,:) = mean(full2017stim{k,1}(20:22,:));
end

A = load('INC_2026_HB_csd CTRL.mat','csdthetaPRE'); A = A.csdthetaPRE;
B = load('INC_2026_LT_csd CTRL.mat','csdthetaPRE'); B = B.csdthetaPRE;
full2026pre = [A; B];

C = load('INC_2026_HB_csd CTRL.mat','csdthetaSTIM'); C = C.csdthetaSTIM;
D = load('INC_2026_LT_csd CTRL.mat','csdthetaSTIM'); D = D.csdthetaSTIM;
full2026stim = [C; D];

deleteindex = or(cellfun(@isempty,full2026pre),cellfun(@isempty,full2026stim));
full2026pre(deleteindex) = [];
full2026stim(deleteindex) = [];

pyr2026pre = []; pyr2026stim = [];
rad2026pre = []; rad2026stim = [];
lam2026pre = []; lam2026stim = [];
mol2026pre = []; mol2026stim = [];
hil2026pre = []; hil2026stim = [];
for k = 1:size(full2026stim,1)
    pyr2026pre(k,:) = full2026pre{k,1}(5,:);
    pyr2026stim(k,:) = full2026stim{k,1}(5,:);
    
    rad2026pre(k,:) = mean(full2026pre{k,1}(7:8,:));
    rad2026stim(k,:) = mean(full2026stim{k,1}(7:8,:));
    
    lam2026pre(k,:) = mean(full2026pre{k,1}(9:10,:));
    lam2026stim(k,:) = mean(full2026stim{k,1}(9:10,:));
    
    mol2026pre(k,:) = mean(full2026pre{k,1}(11:12,:));
    mol2026stim(k,:) = mean(full2026stim{k,1}(11:12,:));
    
    hil2026pre(k,:) = mean(full2026pre{k,1}(13:14,:));
    hil2026stim(k,:) = mean(full2026stim{k,1}(13:14,:));
end

B = load('INC_2027_LT_csd CTRL.mat','csdthetaPRE'); B = B.csdthetaPRE;
full2027pre = [B];

D = load('INC_2027_LT_csd CTRL.mat','csdthetaSTIM'); D = D.csdthetaSTIM;
full2027stim = [D];

deleteindex = or(cellfun(@isempty,full2027pre),cellfun(@isempty,full2027stim));
full2027pre(deleteindex) = [];
full2027stim(deleteindex) = [];

pyr2027pre = []; pyr2027stim = [];
rad2027pre = []; rad2027stim = [];
lam2027pre = []; lam2027stim = [];
mol2027pre = []; mol2027stim = [];
hil2027pre = []; hil2027stim = [];
for k = 1:size(full2027stim,1)
    pyr2027pre(k,:) = full2027pre{k,1}(4,:);
    pyr2027stim(k,:) = full2027stim{k,1}(4,:);
    
    rad2027pre(k,:) = mean(full2027pre{k,1}(6:7,:));
    rad2027stim(k,:) = mean(full2027stim{k,1}(6:7,:));
    
    lam2027pre(k,:) = mean(full2027pre{k,1}(8:9,:));
    lam2027stim(k,:) = mean(full2027stim{k,1}(8:9,:));
    
    mol2027pre(k,:) = (full2027pre{k,1}(10,:));
    mol2027stim(k,:) = (full2027stim{k,1}(10,:));
    
    hil2027pre(k,:) = (full2027pre{k,1}(11,:));
    hil2027stim(k,:) = (full2027stim{k,1}(11,:));
end

A = load('INC_2046_HB_csd CTRL.mat','csdthetaPRE'); A = A.csdthetaPRE;
B = load('INC_2046_LT_csd CTRL.mat','csdthetaPRE'); B = B.csdthetaPRE;
full2046pre = [A; B];

C = load('INC_2046_HB_csd CTRL.mat','csdthetaSTIM'); C = C.csdthetaSTIM;
D = load('INC_2046_LT_csd CTRL.mat','csdthetaSTIM'); D = D.csdthetaSTIM;
full2046stim = [C; D];

deleteindex = or(cellfun(@isempty,full2046pre),cellfun(@isempty,full2046stim));
full2046pre(deleteindex) = [];
full2046stim(deleteindex) = [];

pyr2046pre = []; pyr2046stim = [];
rad2046pre = []; rad2046stim = [];
lam2046pre = []; lam2046stim = [];
mol2046pre = []; mol2046stim = [];
hil2046pre = []; hil2046stim = [];
for k = 1:size(full2046stim,1)
    pyr2046pre(k,:) = full2046pre{k,1}(4,:);
    pyr2046stim(k,:) = full2046stim{k,1}(4,:);
    
    rad2046pre(k,:) = mean(full2046pre{k,1}(6:7,:));
    rad2046stim(k,:) = mean(full2046stim{k,1}(6:7,:));
    
    lam2046pre(k,:) = mean(full2046pre{k,1}(8:9,:));
    lam2046stim(k,:) = mean(full2046stim{k,1}(8:9,:));
    
    mol2046pre(k,:) = (full2046pre{k,1}(10,:));
    mol2046stim(k,:) = (full2046stim{k,1}(10,:));
    
    hil2046pre(k,:) = (full2046pre{k,1}(11,:));
    hil2046stim(k,:) = (full2046stim{k,1}(11,:));
end

PYRpreC = [pyr2017pre; pyr2026pre; pyr2027pre; pyr2046pre];
PYRstimC = [pyr2017stim; pyr2026stim; pyr2027stim; pyr2046stim];

RADpreC = [rad2017pre; rad2026pre; rad2027pre; rad2046pre];
RADstimC = [rad2017stim; rad2026stim; rad2027stim; rad2046stim];

LAMpreC = [lam2017pre; lam2026pre; lam2027pre; lam2046pre];
LAMstimC = [lam2017stim; lam2026stim; lam2027stim; lam2046stim];

MOLpreC = [mol2017pre; mol2026pre; mol2027pre; mol2046pre];
MOLstimC = [mol2017stim; mol2026stim; mol2027stim; mol2046stim];

HILpreC = [hil2017pre; hil2026pre; hil2027pre; hil2046pre];
HILstimC = [hil2017stim; hil2026stim; hil2027stim; hil2046stim];
% REM ##################
A = load('INC_2017_HC_PULSEcsd.mat','csdthetaPRE'); A = A.csdthetaPRE;
full2017pre = [A];

C = load('INC_2017_HC_PULSEcsd.mat','csdthetaSTIM'); C = C.csdthetaSTIM;
full2017stim = [C];

deleteindex = or(cellfun(@isempty,full2017pre),cellfun(@isempty,full2017stim));
full2017pre(deleteindex) = [];
full2017stim(deleteindex) = [];

pyr2017pre = []; pyr2017stim = [];
rad2017pre = []; rad2017stim = [];
lam2017pre = []; lam2017stim = [];
mol2017pre = []; mol2017stim = [];
hil2017pre = []; hil2017stim = [];
for k = 1:size(full2017stim,1)
    pyr2017pre(k,:) = full2017pre{k,1}(7,:);
    pyr2017stim(k,:) = full2017stim{k,1}(7,:);
    
    rad2017pre(k,:) = mean(full2017pre{k,1}(10:11,:));
    rad2017stim(k,:) = mean(full2017stim{k,1}(10:11,:));
    
    lam2017pre(k,:) = mean(full2017pre{k,1}(12:16,:));
    lam2017stim(k,:) = mean(full2017stim{k,1}(12:16,:));
    
    mol2017pre(k,:) = mean(full2017pre{k,1}(17:18,:));
    mol2017stim(k,:) = mean(full2017stim{k,1}(17:18,:));
    
    hil2017pre(k,:) = mean(full2017pre{k,1}(20:22,:));
    hil2017stim(k,:) = mean(full2017stim{k,1}(20:22,:));
end

A = load('INC_2026_HC_PULSEcsd.mat','csdthetaPRE'); A = A.csdthetaPRE;
full2026pre = [A];

C = load('INC_2026_HC_PULSEcsd.mat','csdthetaSTIM'); C = C.csdthetaSTIM;
full2026stim = [C];

deleteindex = or(cellfun(@isempty,full2026pre),cellfun(@isempty,full2026stim));
full2026pre(deleteindex) = [];
full2026stim(deleteindex) = [];

pyr2026pre = []; pyr2026stim = [];
rad2026pre = []; rad2026stim = [];
lam2026pre = []; lam2026stim = [];
mol2026pre = []; mol2026stim = [];
hil2026pre = []; hil2026stim = [];
for k = 1:size(full2026stim,1)
    pyr2026pre(k,:) = full2026pre{k,1}(5,:);
    pyr2026stim(k,:) = full2026stim{k,1}(5,:);
    
    rad2026pre(k,:) = mean(full2026pre{k,1}(7:8,:));
    rad2026stim(k,:) = mean(full2026stim{k,1}(7:8,:));
    
    lam2026pre(k,:) = mean(full2026pre{k,1}(9:10,:));
    lam2026stim(k,:) = mean(full2026stim{k,1}(9:10,:));
    
    mol2026pre(k,:) = mean(full2026pre{k,1}(11:12,:));
    mol2026stim(k,:) = mean(full2026stim{k,1}(11:12,:));
    
    hil2026pre(k,:) = mean(full2026pre{k,1}(13:14,:));
    hil2026stim(k,:) = mean(full2026stim{k,1}(13:14,:));
end

A = load('INC_2027_HC_PULSEcsd.mat','csdthetaPRE'); A = A.csdthetaPRE;
full2027pre = [A];

C = load('INC_2027_HC_PULSEcsd.mat','csdthetaSTIM'); C = C.csdthetaSTIM;
full2027stim = [C];

deleteindex = or(cellfun(@isempty,full2027pre),cellfun(@isempty,full2027stim));
full2027pre(deleteindex) = [];
full2027stim(deleteindex) = [];

pyr2027pre = []; pyr2027stim = [];
rad2027pre = []; rad2027stim = [];
lam2027pre = []; lam2027stim = [];
mol2027pre = []; mol2027stim = [];
hil2027pre = []; hil2027stim = [];
for k = 1:size(full2027stim,1)
    pyr2027pre(k,:) = full2027pre{k,1}(4,:);
    pyr2027stim(k,:) = full2027stim{k,1}(4,:);
    
    rad2027pre(k,:) = mean(full2027pre{k,1}(6:7,:));
    rad2027stim(k,:) = mean(full2027stim{k,1}(6:7,:));
    
    lam2027pre(k,:) = mean(full2027pre{k,1}(8:9,:));
    lam2027stim(k,:) = mean(full2027stim{k,1}(8:9,:));
    
    mol2027pre(k,:) = (full2027pre{k,1}(10,:));
    mol2027stim(k,:) = (full2027stim{k,1}(10,:));
    
    hil2027pre(k,:) = (full2027pre{k,1}(11,:));
    hil2027stim(k,:) = (full2027stim{k,1}(11,:));
end

A = load('INC_2046_HC_PULSEcsd.mat','csdthetaPRE'); A = A.csdthetaPRE;
full2046pre = [A];

C = load('INC_2046_HC_PULSEcsd.mat','csdthetaSTIM'); C = C.csdthetaSTIM;
full2046stim = [C];

deleteindex = or(cellfun(@isempty,full2046pre),cellfun(@isempty,full2046stim));
full2046pre(deleteindex) = [];
full2046stim(deleteindex) = [];

pyr2046pre = []; pyr2046stim = [];
rad2046pre = []; rad2046stim = [];
lam2046pre = []; lam2046stim = [];
mol2046pre = []; mol2046stim = [];
hil2046pre = []; hil2046stim = [];
for k = 1:size(full2046stim,1)
    pyr2046pre(k,:) = full2046pre{k,1}(4,:);
    pyr2046stim(k,:) = full2046stim{k,1}(4,:);
    
    rad2046pre(k,:) = mean(full2046pre{k,1}(6:7,:));
    rad2046stim(k,:) = mean(full2046stim{k,1}(6:7,:));
    
    lam2046pre(k,:) = mean(full2046pre{k,1}(8:9,:));
    lam2046stim(k,:) = mean(full2046stim{k,1}(8:9,:));
    
    mol2046pre(k,:) = (full2046pre{k,1}(10,:));
    mol2046stim(k,:) = (full2046stim{k,1}(10,:));
    
    hil2046pre(k,:) = (full2046pre{k,1}(11,:));
    hil2046stim(k,:) = (full2046stim{k,1}(11,:));
end

PYRprepulseREM = [pyr2017pre; pyr2026pre; pyr2027pre; pyr2046pre];
PYRstimpulseREM = [pyr2017stim; pyr2026stim; pyr2027stim; pyr2046stim];

RADprepulseREM = [rad2017pre; rad2026pre; rad2027pre; rad2046pre];
RADstimpulseREM = [rad2017stim; rad2026stim; rad2027stim; rad2046stim];

LAMprepulseREM = [lam2017pre; lam2026pre; lam2027pre; lam2046pre];
LAMstimpulseREM = [lam2017stim; lam2026stim; lam2027stim; lam2046stim];

MOLprepulseREM = [mol2017pre; mol2026pre; mol2027pre; mol2046pre];
MOLstimpulseREM = [mol2017stim; mol2026stim; mol2027stim; mol2046stim];

HILprepulseREM = [hil2017pre; hil2026pre; hil2027pre; hil2046pre];
HILstimpulseREM = [hil2017stim; hil2026stim; hil2027stim; hil2046stim];

% CTRL
A = load('INC_2017_HC_PULSEcsd CTRL.mat','csdthetaPRE'); A = A.csdthetaPRE;
full2017pre = [A];

C = load('INC_2017_HC_PULSEcsd CTRL.mat','csdthetaSTIM'); C = C.csdthetaSTIM;
full2017stim = [C];

deleteindex = or(cellfun(@isempty,full2017pre),cellfun(@isempty,full2017stim));
full2017pre(deleteindex) = [];
full2017stim(deleteindex) = [];

pyr2017pre = []; pyr2017stim = [];
rad2017pre = []; rad2017stim = [];
lam2017pre = []; lam2017stim = [];
mol2017pre = []; mol2017stim = [];
hil2017pre = []; hil2017stim = [];
for k = 1:size(full2017stim,1)
    pyr2017pre(k,:) = full2017pre{k,1}(7,:);
    pyr2017stim(k,:) = full2017stim{k,1}(7,:);
    
    rad2017pre(k,:) = mean(full2017pre{k,1}(10:11,:));
    rad2017stim(k,:) = mean(full2017stim{k,1}(10:11,:));
    
    lam2017pre(k,:) = mean(full2017pre{k,1}(12:16,:));
    lam2017stim(k,:) = mean(full2017stim{k,1}(12:16,:));
    
    mol2017pre(k,:) = mean(full2017pre{k,1}(17:18,:));
    mol2017stim(k,:) = mean(full2017stim{k,1}(17:18,:));
    
    hil2017pre(k,:) = mean(full2017pre{k,1}(20:22,:));
    hil2017stim(k,:) = mean(full2017stim{k,1}(20:22,:));
end

A = load('INC_2026_HC_PULSEcsd CTRL.mat','csdthetaPRE'); A = A.csdthetaPRE;
full2026pre = [A];

C = load('INC_2026_HC_PULSEcsd CTRL.mat','csdthetaSTIM'); C = C.csdthetaSTIM;
full2026stim = [C];

deleteindex = or(cellfun(@isempty,full2026pre),cellfun(@isempty,full2026stim));
full2026pre(deleteindex) = [];
full2026stim(deleteindex) = [];

pyr2026pre = []; pyr2026stim = [];
rad2026pre = []; rad2026stim = [];
lam2026pre = []; lam2026stim = [];
mol2026pre = []; mol2026stim = [];
hil2026pre = []; hil2026stim = [];
for k = 1:size(full2026stim,1)
    pyr2026pre(k,:) = full2026pre{k,1}(5,:);
    pyr2026stim(k,:) = full2026stim{k,1}(5,:);
    
    rad2026pre(k,:) = mean(full2026pre{k,1}(7:8,:));
    rad2026stim(k,:) = mean(full2026stim{k,1}(7:8,:));
    
    lam2026pre(k,:) = mean(full2026pre{k,1}(9:10,:));
    lam2026stim(k,:) = mean(full2026stim{k,1}(9:10,:));
    
    mol2026pre(k,:) = mean(full2026pre{k,1}(11:12,:));
    mol2026stim(k,:) = mean(full2026stim{k,1}(11:12,:));
    
    hil2026pre(k,:) = mean(full2026pre{k,1}(13:14,:));
    hil2026stim(k,:) = mean(full2026stim{k,1}(13:14,:));
end

B = load('INC_2027_HC_PULSEcsd CTRL.mat','csdthetaPRE'); B = B.csdthetaPRE;
full2027pre = [B];

D = load('INC_2027_HC_PULSEcsd CTRL.mat','csdthetaSTIM'); D = D.csdthetaSTIM;
full2027stim = [D];

deleteindex = or(cellfun(@isempty,full2027pre),cellfun(@isempty,full2027stim));
full2027pre(deleteindex) = [];
full2027stim(deleteindex) = [];

pyr2027pre = []; pyr2027stim = [];
rad2027pre = []; rad2027stim = [];
lam2027pre = []; lam2027stim = [];
mol2027pre = []; mol2027stim = [];
hil2027pre = []; hil2027stim = [];
for k = 1:size(full2027stim,1)
    pyr2027pre(k,:) = full2027pre{k,1}(4,:);
    pyr2027stim(k,:) = full2027stim{k,1}(4,:);
    
    rad2027pre(k,:) = mean(full2027pre{k,1}(6:7,:));
    rad2027stim(k,:) = mean(full2027stim{k,1}(6:7,:));
    
    lam2027pre(k,:) = mean(full2027pre{k,1}(8:9,:));
    lam2027stim(k,:) = mean(full2027stim{k,1}(8:9,:));
    
    mol2027pre(k,:) = (full2027pre{k,1}(10,:));
    mol2027stim(k,:) = (full2027stim{k,1}(10,:));
    
    hil2027pre(k,:) = (full2027pre{k,1}(11,:));
    hil2027stim(k,:) = (full2027stim{k,1}(11,:));
end

A = load('INC_2046_HC_PULSEcsd CTRL.mat','csdthetaPRE'); A = A.csdthetaPRE;
full2046pre = [A];

C = load('INC_2046_HC_PULSEcsd CTRL.mat','csdthetaSTIM'); C = C.csdthetaSTIM;
full2046stim = [C];

deleteindex = or(cellfun(@isempty,full2046pre),cellfun(@isempty,full2046stim));
full2046pre(deleteindex) = [];
full2046stim(deleteindex) = [];

pyr2046pre = []; pyr2046stim = [];
rad2046pre = []; rad2046stim = [];
lam2046pre = []; lam2046stim = [];
mol2046pre = []; mol2046stim = [];
hil2046pre = []; hil2046stim = [];
for k = 1:size(full2046stim,1)
    pyr2046pre(k,:) = full2046pre{k,1}(4,:);
    pyr2046stim(k,:) = full2046stim{k,1}(4,:);
    
    rad2046pre(k,:) = mean(full2046pre{k,1}(6:7,:));
    rad2046stim(k,:) = mean(full2046stim{k,1}(6:7,:));
    
    lam2046pre(k,:) = mean(full2046pre{k,1}(8:9,:));
    lam2046stim(k,:) = mean(full2046stim{k,1}(8:9,:));
    
    mol2046pre(k,:) = (full2046pre{k,1}(10,:));
    mol2046stim(k,:) = (full2046stim{k,1}(10,:));
    
    hil2046pre(k,:) = (full2046pre{k,1}(11,:));
    hil2046stim(k,:) = (full2046stim{k,1}(11,:));
end

PYRpreCpulseREM = [pyr2017pre; pyr2026pre; pyr2027pre; pyr2046pre];
PYRstimCpulseREM = [pyr2017stim; pyr2026stim; pyr2027stim; pyr2046stim];

RADpreCpulseREM = [rad2017pre; rad2026pre; rad2027pre; rad2046pre];
RADstimCpulseREM = [rad2017stim; rad2026stim; rad2027stim; rad2046stim];

LAMpreCpulseREM = [lam2017pre; lam2026pre; lam2027pre; lam2046pre];
LAMstimCpulseREM = [lam2017stim; lam2026stim; lam2027stim; lam2046stim];

MOLpreCpulseREM = [mol2017pre; mol2026pre; mol2027pre; mol2046pre];
MOLstimCpulseREM = [mol2017stim; mol2026stim; mol2027stim; mol2046stim];

HILpreCpulseREM = [hil2017pre; hil2026pre; hil2027pre; hil2046pre];
HILstimCpulseREM = [hil2017stim; hil2026stim; hil2027stim; hil2046stim];

% running theta triggered
A = load('INC_2017_HC_csd.mat','csdthetaPRE'); A = A.csdthetaPRE;
full2017pre = [A];

C = load('INC_2017_HC_csd.mat','csdthetaSTIM'); C = C.csdthetaSTIM;
full2017stim = [C];

deleteindex = or(cellfun(@isempty,full2017pre),cellfun(@isempty,full2017stim));
full2017pre(deleteindex) = [];
full2017stim(deleteindex) = [];

pyr2017pre = []; pyr2017stim = [];
rad2017pre = []; rad2017stim = [];
lam2017pre = []; lam2017stim = [];
mol2017pre = []; mol2017stim = [];
hil2017pre = []; hil2017stim = [];
for k = 1:size(full2017stim,1)
    pyr2017pre(k,:) = full2017pre{k,1}(7,:);
    pyr2017stim(k,:) = full2017stim{k,1}(7,:);
    
    rad2017pre(k,:) = mean(full2017pre{k,1}(10:11,:));
    rad2017stim(k,:) = mean(full2017stim{k,1}(10:11,:));
    
    lam2017pre(k,:) = mean(full2017pre{k,1}(12:16,:));
    lam2017stim(k,:) = mean(full2017stim{k,1}(12:16,:));
    
    mol2017pre(k,:) = mean(full2017pre{k,1}(17:18,:));
    mol2017stim(k,:) = mean(full2017stim{k,1}(17:18,:));
    
    hil2017pre(k,:) = mean(full2017pre{k,1}(20:22,:));
    hil2017stim(k,:) = mean(full2017stim{k,1}(20:22,:));
end

A = load('INC_2026_HC_csd.mat','csdthetaPRE'); A = A.csdthetaPRE;
full2026pre = [A];

C = load('INC_2026_HC_csd.mat','csdthetaSTIM'); C = C.csdthetaSTIM;
full2026stim = [C];

deleteindex = or(cellfun(@isempty,full2026pre),cellfun(@isempty,full2026stim));
full2026pre(deleteindex) = [];
full2026stim(deleteindex) = [];

pyr2026pre = []; pyr2026stim = [];
rad2026pre = []; rad2026stim = [];
lam2026pre = []; lam2026stim = [];
mol2026pre = []; mol2026stim = [];
hil2026pre = []; hil2026stim = [];
for k = 1:size(full2026stim,1)
    pyr2026pre(k,:) = full2026pre{k,1}(5,:);
    pyr2026stim(k,:) = full2026stim{k,1}(5,:);
    
    rad2026pre(k,:) = mean(full2026pre{k,1}(7:8,:));
    rad2026stim(k,:) = mean(full2026stim{k,1}(7:8,:));
    
    lam2026pre(k,:) = mean(full2026pre{k,1}(9:10,:));
    lam2026stim(k,:) = mean(full2026stim{k,1}(9:10,:));
    
    mol2026pre(k,:) = mean(full2026pre{k,1}(11:12,:));
    mol2026stim(k,:) = mean(full2026stim{k,1}(11:12,:));
    
    hil2026pre(k,:) = mean(full2026pre{k,1}(13:14,:));
    hil2026stim(k,:) = mean(full2026stim{k,1}(13:14,:));
end

A = load('INC_2027_HC_csd.mat','csdthetaPRE'); A = A.csdthetaPRE;
full2027pre = [A];

C = load('INC_2027_HC_csd.mat','csdthetaSTIM'); C = C.csdthetaSTIM;
full2027stim = [C];

deleteindex = or(cellfun(@isempty,full2027pre),cellfun(@isempty,full2027stim));
full2027pre(deleteindex) = [];
full2027stim(deleteindex) = [];

pyr2027pre = []; pyr2027stim = [];
rad2027pre = []; rad2027stim = [];
lam2027pre = []; lam2027stim = [];
mol2027pre = []; mol2027stim = [];
hil2027pre = []; hil2027stim = [];
for k = 1:size(full2027stim,1)
    pyr2027pre(k,:) = full2027pre{k,1}(4,:);
    pyr2027stim(k,:) = full2027stim{k,1}(4,:);
    
    rad2027pre(k,:) = mean(full2027pre{k,1}(6:7,:));
    rad2027stim(k,:) = mean(full2027stim{k,1}(6:7,:));
    
    lam2027pre(k,:) = mean(full2027pre{k,1}(8:9,:));
    lam2027stim(k,:) = mean(full2027stim{k,1}(8:9,:));
    
    mol2027pre(k,:) = (full2027pre{k,1}(10,:));
    mol2027stim(k,:) = (full2027stim{k,1}(10,:));
    
    hil2027pre(k,:) = (full2027pre{k,1}(11,:));
    hil2027stim(k,:) = (full2027stim{k,1}(11,:));
end

A = load('INC_2046_HC_csd.mat','csdthetaPRE'); A = A.csdthetaPRE;
full2046pre = [A];

C = load('INC_2046_HC_csd.mat','csdthetaSTIM'); C = C.csdthetaSTIM;
full2046stim = [C];

deleteindex = or(cellfun(@isempty,full2046pre),cellfun(@isempty,full2046stim));
full2046pre(deleteindex) = [];
full2046stim(deleteindex) = [];

pyr2046pre = []; pyr2046stim = [];
rad2046pre = []; rad2046stim = [];
lam2046pre = []; lam2046stim = [];
mol2046pre = []; mol2046stim = [];
hil2046pre = []; hil2046stim = [];
for k = 1:size(full2046stim,1)
    pyr2046pre(k,:) = full2046pre{k,1}(4,:);
    pyr2046stim(k,:) = full2046stim{k,1}(4,:);
    
    rad2046pre(k,:) = mean(full2046pre{k,1}(6:7,:));
    rad2046stim(k,:) = mean(full2046stim{k,1}(6:7,:));
    
    lam2046pre(k,:) = mean(full2046pre{k,1}(8:9,:));
    lam2046stim(k,:) = mean(full2046stim{k,1}(8:9,:));
    
    mol2046pre(k,:) = (full2046pre{k,1}(10,:));
    mol2046stim(k,:) = (full2046stim{k,1}(10,:));
    
    hil2046pre(k,:) = (full2046pre{k,1}(11,:));
    hil2046stim(k,:) = (full2046stim{k,1}(11,:));
end

PYRpreREM = [pyr2017pre; pyr2026pre; pyr2027pre; pyr2046pre];
PYRstimREM = [pyr2017stim; pyr2026stim; pyr2027stim; pyr2046stim];

RADpreREM = [rad2017pre; rad2026pre; rad2027pre; rad2046pre];
RADstimREM = [rad2017stim; rad2026stim; rad2027stim; rad2046stim];

LAMpreREM = [lam2017pre; lam2026pre; lam2027pre; lam2046pre];
LAMstimREM = [lam2017stim; lam2026stim; lam2027stim; lam2046stim];

MOLpreREM = [mol2017pre; mol2026pre; mol2027pre; mol2046pre];
MOLstimREM = [mol2017stim; mol2026stim; mol2027stim; mol2046stim];

HILpreREM = [hil2017pre; hil2026pre; hil2027pre; hil2046pre];
HILstimREM = [hil2017stim; hil2026stim; hil2027stim; hil2046stim];

% CTRL
A = load('INC_2017_HC_csd CTRL.mat','csdthetaPRE'); A = A.csdthetaPRE;
full2017pre = [A];

C = load('INC_2017_HC_csd CTRL.mat','csdthetaSTIM'); C = C.csdthetaSTIM;
full2017stim = [C];

deleteindex = or(cellfun(@isempty,full2017pre),cellfun(@isempty,full2017stim));
full2017pre(deleteindex) = [];
full2017stim(deleteindex) = [];

pyr2017pre = []; pyr2017stim = [];
rad2017pre = []; rad2017stim = [];
lam2017pre = []; lam2017stim = [];
mol2017pre = []; mol2017stim = [];
hil2017pre = []; hil2017stim = [];
for k = 1:size(full2017stim,1)
    pyr2017pre(k,:) = full2017pre{k,1}(7,:);
    pyr2017stim(k,:) = full2017stim{k,1}(7,:);
    
    rad2017pre(k,:) = mean(full2017pre{k,1}(10:11,:));
    rad2017stim(k,:) = mean(full2017stim{k,1}(10:11,:));
    
    lam2017pre(k,:) = mean(full2017pre{k,1}(12:16,:));
    lam2017stim(k,:) = mean(full2017stim{k,1}(12:16,:));
    
    mol2017pre(k,:) = mean(full2017pre{k,1}(17:18,:));
    mol2017stim(k,:) = mean(full2017stim{k,1}(17:18,:));
    
    hil2017pre(k,:) = mean(full2017pre{k,1}(20:22,:));
    hil2017stim(k,:) = mean(full2017stim{k,1}(20:22,:));
end

A = load('INC_2026_HC_csd CTRL.mat','csdthetaPRE'); A = A.csdthetaPRE;
full2026pre = [A];

C = load('INC_2026_HC_csd CTRL.mat','csdthetaSTIM'); C = C.csdthetaSTIM;
full2026stim = [C];

deleteindex = or(cellfun(@isempty,full2026pre),cellfun(@isempty,full2026stim));
full2026pre(deleteindex) = [];
full2026stim(deleteindex) = [];

pyr2026pre = []; pyr2026stim = [];
rad2026pre = []; rad2026stim = [];
lam2026pre = []; lam2026stim = [];
mol2026pre = []; mol2026stim = [];
hil2026pre = []; hil2026stim = [];
for k = 1:size(full2026stim,1)
    pyr2026pre(k,:) = full2026pre{k,1}(5,:);
    pyr2026stim(k,:) = full2026stim{k,1}(5,:);
    
    rad2026pre(k,:) = mean(full2026pre{k,1}(7:8,:));
    rad2026stim(k,:) = mean(full2026stim{k,1}(7:8,:));
    
    lam2026pre(k,:) = mean(full2026pre{k,1}(9:10,:));
    lam2026stim(k,:) = mean(full2026stim{k,1}(9:10,:));
    
    mol2026pre(k,:) = mean(full2026pre{k,1}(11:12,:));
    mol2026stim(k,:) = mean(full2026stim{k,1}(11:12,:));
    
    hil2026pre(k,:) = mean(full2026pre{k,1}(13:14,:));
    hil2026stim(k,:) = mean(full2026stim{k,1}(13:14,:));
end

B = load('INC_2027_HC_csd CTRL.mat','csdthetaPRE'); B = B.csdthetaPRE;
full2027pre = [B];

D = load('INC_2027_HC_csd CTRL.mat','csdthetaSTIM'); D = D.csdthetaSTIM;
full2027stim = [D];

deleteindex = or(cellfun(@isempty,full2027pre),cellfun(@isempty,full2027stim));
full2027pre(deleteindex) = [];
full2027stim(deleteindex) = [];

pyr2027pre = []; pyr2027stim = [];
rad2027pre = []; rad2027stim = [];
lam2027pre = []; lam2027stim = [];
mol2027pre = []; mol2027stim = [];
hil2027pre = []; hil2027stim = [];
for k = 1:size(full2027stim,1)
    pyr2027pre(k,:) = full2027pre{k,1}(4,:);
    pyr2027stim(k,:) = full2027stim{k,1}(4,:);
    
    rad2027pre(k,:) = mean(full2027pre{k,1}(6:7,:));
    rad2027stim(k,:) = mean(full2027stim{k,1}(6:7,:));
    
    lam2027pre(k,:) = mean(full2027pre{k,1}(8:9,:));
    lam2027stim(k,:) = mean(full2027stim{k,1}(8:9,:));
    
    mol2027pre(k,:) = (full2027pre{k,1}(10,:));
    mol2027stim(k,:) = (full2027stim{k,1}(10,:));
    
    hil2027pre(k,:) = (full2027pre{k,1}(11,:));
    hil2027stim(k,:) = (full2027stim{k,1}(11,:));
end

A = load('INC_2046_HC_csd CTRL.mat','csdthetaPRE'); A = A.csdthetaPRE;
full2046pre = [A];

C = load('INC_2046_HC_csd CTRL.mat','csdthetaSTIM'); C = C.csdthetaSTIM;
full2046stim = [C];

deleteindex = or(cellfun(@isempty,full2046pre),cellfun(@isempty,full2046stim));
full2046pre(deleteindex) = [];
full2046stim(deleteindex) = [];

pyr2046pre = []; pyr2046stim = [];
rad2046pre = []; rad2046stim = [];
lam2046pre = []; lam2046stim = [];
mol2046pre = []; mol2046stim = [];
hil2046pre = []; hil2046stim = [];
for k = 1:size(full2046stim,1)
    pyr2046pre(k,:) = full2046pre{k,1}(4,:);
    pyr2046stim(k,:) = full2046stim{k,1}(4,:);
    
    rad2046pre(k,:) = mean(full2046pre{k,1}(6:7,:));
    rad2046stim(k,:) = mean(full2046stim{k,1}(6:7,:));
    
    lam2046pre(k,:) = mean(full2046pre{k,1}(8:9,:));
    lam2046stim(k,:) = mean(full2046stim{k,1}(8:9,:));
    
    mol2046pre(k,:) = (full2046pre{k,1}(10,:));
    mol2046stim(k,:) = (full2046stim{k,1}(10,:));
    
    hil2046pre(k,:) = (full2046pre{k,1}(11,:));
    hil2046stim(k,:) = (full2046stim{k,1}(11,:));
end

PYRpreCREM = [pyr2017pre; pyr2026pre; pyr2027pre; pyr2046pre];
PYRstimCREM = [pyr2017stim; pyr2026stim; pyr2027stim; pyr2046stim];

RADpreCREM = [rad2017pre; rad2026pre; rad2027pre; rad2046pre];
RADstimCREM = [rad2017stim; rad2026stim; rad2027stim; rad2046stim];

LAMpreCREM = [lam2017pre; lam2026pre; lam2027pre; lam2046pre];
LAMstimCREM = [lam2017stim; lam2026stim; lam2027stim; lam2046stim];

MOLpreCREM = [mol2017pre; mol2026pre; mol2027pre; mol2046pre];
MOLstimCREM = [mol2017stim; mol2026stim; mol2027stim; mol2046stim];

HILpreCREM = [hil2017pre; hil2026pre; hil2027pre; hil2046pre];
HILstimCREM = [hil2017stim; hil2026stim; hil2027stim; hil2046stim];


% RESULTS ##################
% THETA-trig running and running CTRL
center = 251;
halfwindow = 10;
[~,PYRloc] = min(mean(PYRstim(:,center:end)));
PYRloc = PYRloc + center-1;
PYR_pre = mean(PYRpre(:,(PYRloc-halfwindow):(PYRloc+halfwindow)),2);
PYR_stim = mean(PYRstim(:,(PYRloc-halfwindow):(PYRloc+halfwindow)),2);
[~,RADloc] = min(mean(RADstim(:,center:end)));
RADloc = RADloc + center-1;
RAD_pre = mean(RADpre(:,(RADloc-halfwindow):(RADloc+halfwindow)),2);
RAD_stim = mean(RADstim(:,(RADloc-halfwindow):(RADloc+halfwindow)),2);
[~,LAMloc] = min(mean(LAMstim(:,center:end)));
LAMloc = LAMloc + center-1;
LAM_pre = mean(LAMpre(:,(LAMloc-halfwindow):(LAMloc+halfwindow)),2);
LAM_stim = mean(LAMstim(:,(LAMloc-halfwindow):(LAMloc+halfwindow)),2);
[~,MOLloc] = min(mean(MOLstim(:,center:end)));
MOLloc = MOLloc + center-1;
MOL_pre = mean(MOLpre(:,(MOLloc-halfwindow):(MOLloc+halfwindow)),2);
MOL_stim = mean(MOLstim(:,(MOLloc-halfwindow):(MOLloc+halfwindow)),2);
[~,HILloc] = min(mean(HILstim(:,center:end)));
HILloc = HILloc + center-1;
HIL_pre = mean(HILpre(:,(HILloc-halfwindow):(HILloc+halfwindow)),2);
HIL_stim = mean(HILstim(:,(HILloc-halfwindow):(HILloc+halfwindow)),2);

[~,PYRloc] = min(mean(PYRstimC(:,center:end)));
PYRloc = PYRloc + center-1;
PYR_preC = mean(PYRpreC(:,(PYRloc-halfwindow):(PYRloc+halfwindow)),2);
PYR_stimC = mean(PYRstimC(:,(PYRloc-halfwindow):(PYRloc+halfwindow)),2);
[~,RADloc] = min(mean(RADstimC(:,center:end)));
RADloc = RADloc + center-1;
RAD_preC = mean(RADpreC(:,(RADloc-halfwindow):(RADloc+halfwindow)),2);
RAD_stimC = mean(RADstimC(:,(RADloc-halfwindow):(RADloc+halfwindow)),2);
[~,LAMloc] = min(mean(LAMstimC(:,center:end)));
LAMloc = LAMloc + center-1;
LAM_preC = mean(LAMpreC(:,(LAMloc-halfwindow):(LAMloc+halfwindow)),2);
LAM_stimC = mean(LAMstimC(:,(LAMloc-halfwindow):(LAMloc+halfwindow)),2);
[~,MOLloc] = min(mean(MOLstimC(:,center:end)));
MOLloc = MOLloc + center-1;
MOL_preC = mean(MOLpreC(:,(MOLloc-halfwindow):(MOLloc+halfwindow)),2);
MOL_stimC = mean(MOLstimC(:,(MOLloc-halfwindow):(MOLloc+halfwindow)),2);
[~,HILloc] = min(mean(HILstimC(:,center:end)));
HILloc = HILloc + center-1;
HIL_preC = mean(HILpreC(:,(HILloc-halfwindow):(HILloc+halfwindow)),2);
HIL_stimC = mean(HILstimC(:,(HILloc-halfwindow):(HILloc+halfwindow)),2);

% THETA-trig rem and rem CTRL
[~,PYRloc] = min(mean(PYRstimREM(:,center:end)));
PYRloc = PYRloc + center-1;
PYR_preREM = mean(PYRpreREM(:,(PYRloc-halfwindow):(PYRloc+halfwindow)),2);
PYR_stimREM = mean(PYRstimREM(:,(PYRloc-halfwindow):(PYRloc+halfwindow)),2);
[~,RADloc] = min(mean(RADstimREM(:,center:end)));
RADloc = RADloc + center-1;
RAD_preREM = mean(RADpreREM(:,(RADloc-halfwindow):(RADloc+halfwindow)),2);
RAD_stimREM = mean(RADstimREM(:,(RADloc-halfwindow):(RADloc+halfwindow)),2);
[~,LAMloc] = min(mean(LAMstimREM(:,center:end)));
LAMloc = LAMloc + center-1;
LAM_preREM = mean(LAMpreREM(:,(LAMloc-halfwindow):(LAMloc+halfwindow)),2);
LAM_stimREM = mean(LAMstimREM(:,(LAMloc-halfwindow):(LAMloc+halfwindow)),2);
[~,MOLloc] = min(mean(MOLstimREM(:,center:end)));
MOLloc = MOLloc + center-1;
MOL_preREM = mean(MOLpreREM(:,(MOLloc-halfwindow):(MOLloc+halfwindow)),2);
MOL_stimREM = mean(MOLstimREM(:,(MOLloc-halfwindow):(MOLloc+halfwindow)),2);
[~,HILloc] = min(mean(HILstimREM(:,center:end)));
HILloc = HILloc + center-1;
HIL_preREM = mean(HILpreREM(:,(HILloc-halfwindow):(HILloc+halfwindow)),2);
HIL_stimREM = mean(HILstimREM(:,(HILloc-halfwindow):(HILloc+halfwindow)),2);

[~,PYRloc] = min(mean(PYRstimCREM(:,center:end)));
PYRloc = PYRloc + center-1;
PYR_preCREM = mean(PYRpreCREM(:,(PYRloc-halfwindow):(PYRloc+halfwindow)),2);
PYR_stimCREM = mean(PYRstimCREM(:,(PYRloc-halfwindow):(PYRloc+halfwindow)),2);
[~,RADloc] = min(mean(RADstimCREM(:,center:end)));
RADloc = RADloc + center-1;
RAD_preCREM = mean(RADpreCREM(:,(RADloc-halfwindow):(RADloc+halfwindow)),2);
RAD_stimCREM = mean(RADstimCREM(:,(RADloc-halfwindow):(RADloc+halfwindow)),2);
[~,LAMloc] = min(mean(LAMstimCREM(:,center:end)));
LAMloc = LAMloc + center-1;
LAM_preCREM = mean(LAMpreCREM(:,(LAMloc-halfwindow):(LAMloc+halfwindow)),2);
LAM_stimCREM = mean(LAMstimCREM(:,(LAMloc-halfwindow):(LAMloc+halfwindow)),2);
[~,MOLloc] = min(mean(MOLstimCREM(:,center:end)));
MOLloc = MOLloc + center-1;
MOL_preCREM = mean(MOLpreCREM(:,(MOLloc-halfwindow):(MOLloc+halfwindow)),2);
MOL_stimCREM = mean(MOLstimCREM(:,(MOLloc-halfwindow):(MOLloc+halfwindow)),2);
[~,HILloc] = min(mean(HILstimCREM(:,center:end)));
HILloc = HILloc + center-1;
HIL_preCREM = mean(HILpreCREM(:,(HILloc-halfwindow):(HILloc+halfwindow)),2);
HIL_stimCREM = mean(HILstimCREM(:,(HILloc-halfwindow):(HILloc+halfwindow)),2);


% PULSE-trig running and running CTRL
center = 251;
halfwindow = 10;
[~,PYRloc] = min(mean(PYRstimpulse(:,center:end)));
PYRloc = PYRloc + center-1;
PYR_prepulse = mean(PYRprepulse(:,(PYRloc-halfwindow):(PYRloc+halfwindow)),2);
PYR_stimpulse = mean(PYRstimpulse(:,(PYRloc-halfwindow):(PYRloc+halfwindow)),2);
[~,RADloc] = min(mean(RADstimpulse(:,center:end)));
RADloc = RADloc + center-1;
RAD_prepulse = mean(RADprepulse(:,(RADloc-halfwindow):(RADloc+halfwindow)),2);
RAD_stimpulse = mean(RADstimpulse(:,(RADloc-halfwindow):(RADloc+halfwindow)),2);
[~,LAMloc] = min(mean(LAMstimpulse(:,center:end)));
LAMloc = LAMloc + center-1;
LAM_prepulse = mean(LAMprepulse(:,(LAMloc-halfwindow):(LAMloc+halfwindow)),2);
LAM_stimpulse = mean(LAMstimpulse(:,(LAMloc-halfwindow):(LAMloc+halfwindow)),2);
[~,MOLloc] = min(mean(MOLstimpulse(:,center:end)));
MOLloc = MOLloc + center-1;
MOL_prepulse = mean(MOLprepulse(:,(MOLloc-halfwindow):(MOLloc+halfwindow)),2);
MOL_stimpulse = mean(MOLstimpulse(:,(MOLloc-halfwindow):(MOLloc+halfwindow)),2);
[~,HILloc] = min(mean(HILstimpulse(:,center:end)));
HILloc = HILloc + center-1;
HIL_prepulse = mean(HILprepulse(:,(HILloc-halfwindow):(HILloc+halfwindow)),2);
HIL_stimpulse = mean(HILstimpulse(:,(HILloc-halfwindow):(HILloc+halfwindow)),2);

[~,PYRloc] = min(mean(PYRstimCpulse(:,center:end)));
PYRloc = PYRloc + center-1;
PYR_preCpulse = mean(PYRpreCpulse(:,(PYRloc-halfwindow):(PYRloc+halfwindow)),2);
PYR_stimCpulse = mean(PYRstimCpulse(:,(PYRloc-halfwindow):(PYRloc+halfwindow)),2);
[~,RADloc] = min(mean(RADstimCpulse(:,center:end)));
RADloc = RADloc + center-1;
RAD_preCpulse = mean(RADpreCpulse(:,(RADloc-halfwindow):(RADloc+halfwindow)),2);
RAD_stimCpulse = mean(RADstimCpulse(:,(RADloc-halfwindow):(RADloc+halfwindow)),2);
[~,LAMloc] = min(mean(LAMstimCpulse(:,center:end)));
LAMloc = LAMloc + center-1;
LAM_preCpulse = mean(LAMpreCpulse(:,(LAMloc-halfwindow):(LAMloc+halfwindow)),2);
LAM_stimCpulse = mean(LAMstimCpulse(:,(LAMloc-halfwindow):(LAMloc+halfwindow)),2);
[~,MOLloc] = min(mean(MOLstimCpulse(:,center:end)));
MOLloc = MOLloc + center-1;
MOL_preCpulse = mean(MOLpreCpulse(:,(MOLloc-halfwindow):(MOLloc+halfwindow)),2);
MOL_stimCpulse = mean(MOLstimCpulse(:,(MOLloc-halfwindow):(MOLloc+halfwindow)),2);
[~,HILloc] = min(mean(HILstimCpulse(:,center:end)));
HILloc = HILloc + center-1;
HIL_preCpulse = mean(HILpreCpulse(:,(HILloc-halfwindow):(HILloc+halfwindow)),2);
HIL_stimCpulse = mean(HILstimCpulse(:,(HILloc-halfwindow):(HILloc+halfwindow)),2);

% THETA-trig rem and rem CTRL
[~,PYRloc] = min(mean(PYRstimpulseREM(:,center:end)));
PYRloc = PYRloc + center-1;
PYR_prepulseREM = mean(PYRprepulseREM(:,(PYRloc-halfwindow):(PYRloc+halfwindow)),2);
PYR_stimpulseREM = mean(PYRstimpulseREM(:,(PYRloc-halfwindow):(PYRloc+halfwindow)),2);
[~,RADloc] = min(mean(RADstimpulseREM(:,center:end)));
RADloc = RADloc + center-1;
RAD_prepulseREM = mean(RADprepulseREM(:,(RADloc-halfwindow):(RADloc+halfwindow)),2);
RAD_stimpulseREM = mean(RADstimpulseREM(:,(RADloc-halfwindow):(RADloc+halfwindow)),2);
[~,LAMloc] = min(mean(LAMstimpulseREM(:,center:end)));
LAMloc = LAMloc + center-1;
LAM_prepulseREM = mean(LAMprepulseREM(:,(LAMloc-halfwindow):(LAMloc+halfwindow)),2);
LAM_stimpulseREM = mean(LAMstimpulseREM(:,(LAMloc-halfwindow):(LAMloc+halfwindow)),2);
[~,MOLloc] = min(mean(MOLstimpulseREM(:,center:end)));
MOLloc = MOLloc + center-1;
MOL_prepulseREM = mean(MOLprepulseREM(:,(MOLloc-halfwindow):(MOLloc+halfwindow)),2);
MOL_stimpulseREM = mean(MOLstimpulseREM(:,(MOLloc-halfwindow):(MOLloc+halfwindow)),2);
[~,HILloc] = min(mean(HILstimpulseREM(:,center:end)));
HILloc = HILloc + center-1;
HIL_prepulseREM = mean(HILprepulseREM(:,(HILloc-halfwindow):(HILloc+halfwindow)),2);
HIL_stimpulseREM = mean(HILstimpulseREM(:,(HILloc-halfwindow):(HILloc+halfwindow)),2);

[~,PYRloc] = min(mean(PYRstimCpulseREM(:,center:end)));
PYRloc = PYRloc + center-1;
PYR_preCpulseREM = mean(PYRpreCpulseREM(:,(PYRloc-halfwindow):(PYRloc+halfwindow)),2);
PYR_stimCpulseREM = mean(PYRstimCpulseREM(:,(PYRloc-halfwindow):(PYRloc+halfwindow)),2);
[~,RADloc] = min(mean(RADstimCpulseREM(:,center:end)));
RADloc = RADloc + center-1;
RAD_preCpulseREM = mean(RADpreCpulseREM(:,(RADloc-halfwindow):(RADloc+halfwindow)),2);
RAD_stimCpulseREM = mean(RADstimCpulseREM(:,(RADloc-halfwindow):(RADloc+halfwindow)),2);
[~,LAMloc] = min(mean(LAMstimCpulseREM(:,center:end)));
LAMloc = LAMloc + center-1;
LAM_preCpulseREM = mean(LAMpreCpulseREM(:,(LAMloc-halfwindow):(LAMloc+halfwindow)),2);
LAM_stimCpulseREM = mean(LAMstimCpulseREM(:,(LAMloc-halfwindow):(LAMloc+halfwindow)),2);
[~,MOLloc] = min(mean(MOLstimCpulseREM(:,center:end)));
MOLloc = MOLloc + center-1;
MOL_preCpulseREM = mean(MOLpreCpulseREM(:,(MOLloc-halfwindow):(MOLloc+halfwindow)),2);
MOL_stimCpulseREM = mean(MOLstimCpulseREM(:,(MOLloc-halfwindow):(MOLloc+halfwindow)),2);
[~,HILloc] = min(mean(HILstimCpulseREM(:,center:end)));
HILloc = HILloc + center-1;
HIL_preCpulseREM = mean(HILpreCpulseREM(:,(HILloc-halfwindow):(HILloc+halfwindow)),2);
HIL_stimCpulseREM = mean(HILstimCpulseREM(:,(HILloc-halfwindow):(HILloc+halfwindow)),2);

% figure preparations #####

% theta running
r(1,:) = prctile(PYR_stim-PYR_pre,[25 50 75]); p(1) = signrank(PYR_stim,PYR_pre);
r(2,:) = prctile(RAD_stim-RAD_pre,[25 50 75]); p(2) = signrank(RAD_stim,RAD_pre);
r(3,:) = prctile(LAM_stim-LAM_pre,[25 50 75]); p(3) = signrank(LAM_stim,LAM_pre);
r(4,:) = prctile(MOL_stim-MOL_pre,[25 50 75]); p(4) = signrank(MOL_stim,MOL_pre);
r(5,:) = prctile(HIL_stim-HIL_pre,[25 50 75]); p(5) = signrank(HIL_stim,HIL_pre);



rC(1,:) = prctile(PYR_stimC-PYR_preC,[25 50 75]); pC(1) = signrank(PYR_stimC,PYR_preC);
rC(2,:) = prctile(RAD_stimC-RAD_preC,[25 50 75]); pC(2) = signrank(RAD_stimC,RAD_preC);
rC(3,:) = prctile(LAM_stimC-LAM_preC,[25 50 75]); pC(3) = signrank(LAM_stimC,LAM_preC);
rC(4,:) = prctile(MOL_stimC-MOL_preC,[25 50 75]); pC(4) = signrank(MOL_stimC,MOL_preC);
rC(5,:) = prctile(HIL_stimC-HIL_preC,[25 50 75]); pC(5) = signrank(HIL_stimC,HIL_preC);

P(1) = ranksum(PYR_stim-PYR_pre,PYR_stimC-PYR_preC);
P(2) = ranksum(RAD_stim-RAD_pre,RAD_stimC-RAD_preC);
P(3) = ranksum(LAM_stim-LAM_pre,LAM_stimC-LAM_preC);
P(4) = ranksum(MOL_stim-MOL_pre,MOL_stimC-MOL_preC);
P(5) = ranksum(HIL_stim-HIL_pre,HIL_stimC-HIL_preC);

% theta rem
rREM(1,:) = prctile(PYR_stimREM-PYR_preREM,[25 50 75]); pREM(1) = signrank(PYR_stimREM,PYR_preREM);
rREM(2,:) = prctile(RAD_stimREM-RAD_preREM,[25 50 75]); pREM(2) = signrank(RAD_stimREM,RAD_preREM);
rREM(3,:) = prctile(LAM_stimREM-LAM_preREM,[25 50 75]); pREM(3) = signrank(LAM_stimREM,LAM_preREM);
rREM(4,:) = prctile(MOL_stimREM-MOL_preREM,[25 50 75]); pREM(4) = signrank(MOL_stimREM,MOL_preREM);
rREM(5,:) = prctile(HIL_stimREM-HIL_preREM,[25 50 75]); pREM(5) = signrank(HIL_stimREM,HIL_preREM);

rCREM(1,:) = prctile(PYR_stimCREM-PYR_preCREM,[25 50 75]); pCREM(1) = signrank(PYR_stimCREM,PYR_preCREM);
rCREM(2,:) = prctile(RAD_stimCREM-RAD_preCREM,[25 50 75]); pCREM(2) = signrank(RAD_stimCREM,RAD_preCREM);
rCREM(3,:) = prctile(LAM_stimCREM-LAM_preCREM,[25 50 75]); pCREM(3) = signrank(LAM_stimCREM,LAM_preCREM);
rCREM(4,:) = prctile(MOL_stimCREM-MOL_preCREM,[25 50 75]); pCREM(4) = signrank(MOL_stimCREM,MOL_preCREM);
rCREM(5,:) = prctile(HIL_stimCREM-HIL_preCREM,[25 50 75]); pCREM(5) = signrank(HIL_stimCREM,HIL_preCREM);

PREM(1) = ranksum(PYR_stimREM-PYR_preREM,PYR_stimCREM-PYR_preCREM);
PREM(2) = ranksum(RAD_stimREM-RAD_preREM,RAD_stimCREM-RAD_preCREM);
PREM(3) = ranksum(LAM_stimREM-LAM_preREM,LAM_stimCREM-LAM_preCREM);
PREM(4) = ranksum(MOL_stimREM-MOL_preREM,MOL_stimCREM-MOL_preCREM);
PREM(5) = ranksum(HIL_stimREM-HIL_preREM,HIL_stimCREM-HIL_preCREM);

% pulse running
rpulse(1,:) = prctile(PYR_stimpulse-PYR_prepulse,[25 50 75]); ppulse(1) = signrank(PYR_stimpulse,PYR_prepulse);
rpulse(2,:) = prctile(RAD_stimpulse-RAD_prepulse,[25 50 75]); ppulse(2) = signrank(RAD_stimpulse,RAD_prepulse);
rpulse(3,:) = prctile(LAM_stimpulse-LAM_prepulse,[25 50 75]); ppulse(3) = signrank(LAM_stimpulse,LAM_prepulse);
rpulse(4,:) = prctile(MOL_stimpulse-MOL_prepulse,[25 50 75]); ppulse(4) = signrank(MOL_stimpulse,MOL_prepulse);
rpulse(5,:) = prctile(HIL_stimpulse-HIL_prepulse,[25 50 75]); ppulse(5) = signrank(HIL_stimpulse,HIL_prepulse);

rCpulse(1,:) = prctile(PYR_stimCpulse-PYR_preCpulse,[25 50 75]); pCpulse(1) = signrank(PYR_stimCpulse,PYR_preCpulse);
rCpulse(2,:) = prctile(RAD_stimCpulse-RAD_preCpulse,[25 50 75]); pCpulse(2) = signrank(RAD_stimCpulse,RAD_preCpulse);
rCpulse(3,:) = prctile(LAM_stimCpulse-LAM_preCpulse,[25 50 75]); pCpulse(3) = signrank(LAM_stimCpulse,LAM_preCpulse);
rCpulse(4,:) = prctile(MOL_stimCpulse-MOL_preCpulse,[25 50 75]); pCpulse(4) = signrank(MOL_stimCpulse,MOL_preCpulse);
rCpulse(5,:) = prctile(HIL_stimCpulse-HIL_preCpulse,[25 50 75]); pCpulse(5) = signrank(HIL_stimCpulse,HIL_preCpulse);

Ppulse(1) = ranksum(PYR_stimpulse-PYR_prepulse,PYR_stimCpulse-PYR_preCpulse);
Ppulse(2) = ranksum(RAD_stimpulse-RAD_prepulse,RAD_stimCpulse-RAD_preCpulse);
Ppulse(3) = ranksum(LAM_stimpulse-LAM_prepulse,LAM_stimCpulse-LAM_preCpulse);
Ppulse(4) = ranksum(MOL_stimpulse-MOL_prepulse,MOL_stimCpulse-MOL_preCpulse);
Ppulse(5) = ranksum(HIL_stimpulse-HIL_prepulse,HIL_stimCpulse-HIL_preCpulse);

% pulse rem
rpulseREM(1,:) = prctile(PYR_stimpulseREM-PYR_prepulseREM,[25 50 75]); ppulseREM(1) = signrank(PYR_stimpulseREM,PYR_prepulseREM);
rpulseREM(2,:) = prctile(RAD_stimpulseREM-RAD_prepulseREM,[25 50 75]); ppulseREM(2) = signrank(RAD_stimpulseREM,RAD_prepulseREM);
rpulseREM(3,:) = prctile(LAM_stimpulseREM-LAM_prepulseREM,[25 50 75]); ppulseREM(3) = signrank(LAM_stimpulseREM,LAM_prepulseREM);
rpulseREM(4,:) = prctile(MOL_stimpulseREM-MOL_prepulseREM,[25 50 75]); ppulseREM(4) = signrank(MOL_stimpulseREM,MOL_prepulseREM);
rpulseREM(5,:) = prctile(HIL_stimpulseREM-HIL_prepulseREM,[25 50 75]); ppulseREM(5) = signrank(HIL_stimpulseREM,HIL_prepulseREM);

rCpulseREM(1,:) = prctile(PYR_stimCpulseREM-PYR_preCpulseREM,[25 50 75]); pCpulseREM(1) = signrank(PYR_stimCpulseREM,PYR_preCpulseREM);
rCpulseREM(2,:) = prctile(RAD_stimCpulseREM-RAD_preCpulseREM,[25 50 75]); pCpulseREM(2) = signrank(RAD_stimCpulseREM,RAD_preCpulseREM);
rCpulseREM(3,:) = prctile(LAM_stimCpulseREM-LAM_preCpulseREM,[25 50 75]); pCpulseREM(3) = signrank(LAM_stimCpulseREM,LAM_preCpulseREM);
rCpulseREM(4,:) = prctile(MOL_stimCpulseREM-MOL_preCpulseREM,[25 50 75]); pCpulseREM(4) = signrank(MOL_stimCpulseREM,MOL_preCpulseREM);
rCpulseREM(5,:) = prctile(HIL_stimCpulseREM-HIL_preCpulseREM,[25 50 75]); pCpulseREM(5) = signrank(HIL_stimCpulseREM,HIL_preCpulseREM);

PpulseREM(1) = ranksum(PYR_stimpulseREM-PYR_prepulseREM,PYR_stimCpulseREM-PYR_preCpulseREM);
PpulseREM(2) = ranksum(RAD_stimpulseREM-RAD_prepulseREM,RAD_stimCpulseREM-RAD_preCpulseREM);
PpulseREM(3) = ranksum(LAM_stimpulseREM-LAM_prepulseREM,LAM_stimCpulseREM-LAM_preCpulseREM);
PpulseREM(4) = ranksum(MOL_stimpulseREM-MOL_prepulseREM,MOL_stimCpulseREM-MOL_preCpulseREM);
PpulseREM(5) = ranksum(HIL_stimpulseREM-HIL_prepulseREM,HIL_stimCpulseREM-HIL_preCpulseREM);
%%
% theta
INCcolor = [0 51 204]./255;
yhalf = 0.1;
figure; hold on
for k = 1:5
    andor_errorplothoriz(k,-rC(k,1),-rC(k,3),yhalf,'k')
    andor_errorplothoriz(k,-r(k,1),-r(k,3),yhalf,INCcolor)
end
plot(-rC(:,2),1:5,'Color','k','Marker','o','MarkerFaceColor','w')
plot(-r(:,2),1:5,'Color',INCcolor,'Marker','o','MarkerFaceColor','w')
for k = 1:5
    text(0,k,['ranksum = ' num2str(P(k))])
end
set(gca,'YDir','reverse','XLim',[-0.03 0.01])
set(gca,'XTick',[-0.03 0 0.01],'XTickLabel',{'-0.03';'0';'0.01'},'YLim',[.5 5.5])
title('theta run')
set(gcf,'Position',[1,1,200,420])

% theta rem
figure; hold on
for k = 1:5
    andor_errorplothoriz(k,-rCREM(k,1),-rCREM(k,3),yhalf,'k')
    andor_errorplothoriz(k,-rREM(k,1),-rREM(k,3),yhalf,INCcolor)
end
plot(-rCREM(:,2),1:5,'Color','k','Marker','o','MarkerFaceColor','w')
plot(-rREM(:,2),1:5,'Color',INCcolor,'Marker','o','MarkerFaceColor','w')
for k = 1:5
    text(0,k,['ranksum = ' num2str(PREM(k))])
end
set(gca,'YDir','reverse','XLim',[-0.014 0.014])
set(gca,'XTick',[-0.014 0 0.014],'XTickLabel',{'-0.014';'0';'0.014'},'YLim',[.5 5.5])
title('theta rem')
set(gcf,'Position',[1,1,200,420])

% pulse
figure; hold on
for k = 1:5
    andor_errorplothoriz(k,-rCpulse(k,1),-rCpulse(k,3),yhalf,'k')
    andor_errorplothoriz(k,-rpulse(k,1),-rpulse(k,3),yhalf,INCcolor)
end
plot(-rCpulse(:,2),1:5,'Color','k','Marker','o','MarkerFaceColor','w')
plot(-rpulse(:,2),1:5,'Color',INCcolor,'Marker','o','MarkerFaceColor','w')
for k = 1:5
    text(0,k,['ranksum = ' num2str(Ppulse(k))])
end
set(gca,'YDir','reverse','XLim',[-0.005 0.018])
set(gca,'XTick',[-0.005 0 0.018],'XTickLabel',{'-0.005';'0';'0.018'},'YLim',[.5 5.5])
title('pulse run')
set(gcf,'Position',[1,1,200,420])

% pulse rem
figure; hold on
for k = 1:5
    andor_errorplothoriz(k,-rCpulseREM(k,1),-rCpulseREM(k,3),yhalf,'k')
    andor_errorplothoriz(k,-rpulseREM(k,1),-rpulseREM(k,3),yhalf,INCcolor)
end
plot(-rCpulseREM(:,2),1:5,'Color','k','Marker','o','MarkerFaceColor','w')
plot(-rpulseREM(:,2),1:5,'Color',INCcolor,'Marker','o','MarkerFaceColor','w')
for k = 1:5
    text(0,k,['ranksum = ' num2str(PpulseREM(k))])
end
set(gca,'YDir','reverse','XLim',[-0.005 0.01])
set(gca,'XTick',[-0.005 0 0.01],'XTickLabel',{'-0.005';'0';'0.01'},'YLim',[.5 5.5])
title('pulse rem')
set(gcf,'Position',[1,1,200,420])

%%

filename = '2026';
csdtime = 250;
clim = 0.1;
A = load('INC_2026_HB_PULSEcsd.mat','csdthetaPRE');
A = A.csdthetaPRE;
B = load('INC_2026_LT_PULSEcsd.mat','csdthetaPRE');
B = B.csdthetaPRE;
C = load('INC_2026_HB_PULSEcsd.mat','csdthetaSTIM');
C = C.csdthetaSTIM;
D = load('INC_2026_LT_PULSEcsd.mat','csdthetaSTIM');
D = D.csdthetaSTIM;
E = load('INC_2026_HB_PULSEcsd.mat','GCN');
E = E.GCN;
F = load('INC_2026_LT_PULSEcsd.mat','GCN');
F = F.GCN;

bigdataPRE = [A; B];
bigdataSTIM = [C; D];
GCN = [E; F];
%%
% k = 1;
clim = 0.1;

bigdataPRE = csdthetaPRE;
bigdataSTIM = csdthetaSTIM;
deleteindex = or(cellfun(@isempty,bigdataPRE),cellfun(@isempty,bigdataSTIM));
bigdataPRE(deleteindex) = [];
bigdataSTIM(deleteindex) = [];
% rownames = rowdata(filerows,1);
% rownames = rownames(~deleteindex);
xPRE = []; xSTIM = [];
for k = 1:length(bigdataPRE)
xPRE(:,:,k) = filter(gausswin(10),1,interp1(1:size(bigdataPRE{k,1},1),bigdataPRE{k,1},1:0.01:size(bigdataPRE{k,1},1)));
end
for k = 1:length(bigdataSTIM)
xSTIM(:,:,k) = filter(gausswin(10),1,interp1(1:size(bigdataSTIM{k,1},1),bigdataSTIM{k,1},1:0.01:size(bigdataSTIM{k,1},1)));
end
figure('Name',[filename '  ' num2str(k) '   PRE csd'],'NumberTitle','off');
imagesc((1:size(xPRE,2))-(csdtime+1),1:size(xPRE,1),mean(xPRE,3))
csdyticklabel = arrayfun(@num2str,GCN{k,1},'UniformOutput',false);
% csdyticklabel{ismember(csdyticklabel,num2str(pyrNx(k,1)))} = 'PYR';
set(gca,'CLim',[-clim clim],'YTick',1:100:100*size(bigdataPRE{k,1},1),'YTickLabel',csdyticklabel)
line([0 0],[0.5 size(xPRE,1)+0.5],'Color','w','LineStyle','--','LineWidth',2)
set(gcf,'Position',[1 1 230*2.5 460])
set(gca,'YLim',[110,(size(bigdataPRE{k,1},1)-2)*100+1])
% set(gca,'XLim',[-100 100]);

figure('Name',[filename '  ' num2str(k) '   STIM csd'],'NumberTitle','off');
imagesc((1:size(xSTIM,2))-(csdtime+1),1:size(xSTIM,1),mean(xSTIM,3))
csdyticklabel = arrayfun(@num2str,GCN{k,1},'UniformOutput',false);
% csdyticklabel{ismember(csdyticklabel,num2str(pyrNx(k,1)))} = 'PYR';
set(gca,'CLim',[-clim clim],'YTick',1:100:100*size(bigdataSTIM{k,1},1),'YTickLabel',csdyticklabel)
line([0 0],[0.5 size(xSTIM,1)+0.5],'Color','w','LineStyle','--','LineWidth',2)
set(gcf,'Position',[1 1 230*2.5 460])
set(gca,'YLim',[110,(size(bigdataPRE{k,1},1)-2)*100+1])
% set(gca,'XLim',[-100 100]);

%%
tempPRE = []; tempSTIM = [];
for k = 1:length(eegPRE)
    tempPRE(:,:,k) = eegPRE{k,1}';
    tempSTIM(:,:,k) = eegSTIM{k,1}';
end
tempPRE = mean(tempPRE,3);
tempSTIM = mean(tempSTIM,3);

clim = max(tempSTIM(:));

figure('Name',[filename '  ' num2str(k) '   PRE eeg mean'],'NumberTitle','off');
imagesc((1:size(tempPRE,2))-(csdtime+1),1:size(tempPRE,1),tempPRE);
csdyticklabel = arrayfun(@num2str,GCN{k,1},'UniformOutput',false);
csdyticklabel{ismember(csdyticklabel,num2str(pyrNx(k,1)))} = 'PYR';
set(gca,'CLim',[-clim clim],'YTick',1:size(tempPRE,1),'YTickLabel',csdyticklabel)
line([0 0],[0.5 size(tempPRE,1)+0.5],'Color','w','LineStyle','--','LineWidth',2)


figure('Name',[filename '  ' num2str(k) '   STIM eeg mean'],'NumberTitle','off');
imagesc((1:size(tempSTIM,2))-(csdtime+1),1:size(tempSTIM,1),tempSTIM);
csdyticklabel = arrayfun(@num2str,GCN{k,1},'UniformOutput',false);
csdyticklabel{ismember(csdyticklabel,num2str(pyrNx(k,1)))} = 'PYR';
set(gca,'CLim',[-clim clim],'YTick',1:size(tempSTIM,1),'YTickLabel',csdyticklabel)
line([0 0],[0.5 size(tempSTIM,1)+0.5],'Color','w','LineStyle','--','LineWidth',2)
%%
tempPRE = []; tempSTIM = [];
for k = 1:length(eegPRE)
    tempPRE(:,:,k) = eegPRE{k,1}';
    tempSTIM(:,:,k) = eegSTIM{k,1}';
end
tempPRE = mean(tempPRE,3);
tempSTIM = mean(tempSTIM,3);


figure('Name',[filename '  ' num2str(k) '   PRE eeg mean'],'NumberTitle','off'); hold on
for k = 1:size(tempPRE,1)
    plot((1:size(tempPRE,2))-(csdtime+1),tempPRE(k,:)-(k-1)*500,'Color','k','LineWidth',2)
end
line([0 0],[0.5 size(tempPRE,1)+0.5],'Color','w','LineStyle','--','LineWidth',2)


figure('Name',[filename '  ' num2str(k) '   STIM eeg mean'],'NumberTitle','off'); hold on
for k = 1:size(tempSTIM,1)
    plot((1:size(tempSTIM,2))-(csdtime+1),tempSTIM(k,:)-(k-1)*500,'Color','k','LineWidth',2)
end
line([0 0],[0.5 size(tempSTIM,1)+0.5],'Color','w','LineStyle','--','LineWidth',2)

%% eegAdata

k = 6;
figure; hold on
for kk = 1:size(eegAdata{k,1},2)
    plot((1:size(eegAdata{k,1},1))-stimIndexX(k,3),eegAdata{k,1}(:,kk)-(kk-1)*3500,'Color','k','Linewidth',1)
end
set(gca,'XLim',[-1000,2000])

%%

    

%% beta2 peaks at diff freqs
b1 = 23;
b2 = 40;
for k = 1:size(wave,3)
    Fb1 = knnsearch(freq(k,:)',b1);
    Fb2 = knnsearch(freq(k,:)',b2);
    freqrow = freq(k,Fb2:Fb1);
    for f = 1:length(freqrow)
        base_phase = radtodeg(angle(wave(Fb2+f-1,:,k)));
        base_phasePeak = find(and(base_phase>(0-1.5),base_phase<(0+1.5)));
        for ff = 1:length(freqrow)
            search_phase = radtodeg(angle(wave(Fb2+ff-1,:,k)));
            search_phasePeak = find(and(search_phase>(0-1.5),search_phase<(0+1.5)));
            [tempcrosscorr,binrange] = andor_crosscorr(base_phasePeak,search_phasePeak,1000,50);
            crosscorr{k,1}{f,1}(ff,:) = tempcrosscorr;
        end
    end
end
%%
        



    

%%
theta1 = 12;
theta2 = 5;
theta1_U = 6;
theta2_U = 2.5;
delta1 = 4;
delta2 = 1;
delta1_U = 2;
delta2_U = 1;
thSearchBef = 1000;
theta = NaN(size(power,2),size(power,3));
TDratio = NaN(size(power,2),size(power,3));
for k = 1:size(power,3)
    if ~strcmp(arena,'urethane')
        [theta(:,k), TDratio(:,k)] = andor_detectTheta(power(:,:,k),freq(k,:),theta2,theta1,delta2,delta1,1000);
    else
        [theta(:,k), TDratio(:,k)] = andor_detectTheta(power(:,:,k),freq(k,:),theta2_U,theta1_U,delta2_U,delta1_U,1000);
    end
end
thetaindex = false(size(power,3),1);
nonthetaindex = false(size(power,3),1);
for k = 1:size(power,3)
    thetaindex(k,1) = all(theta(eegindex(k)-thSearchBef-1:eegindex(k)-1,k));
    nonthetaindex(k,1) = all(~theta(eegindex(k)-thSearchBef-1:eegindex(k)-1,k));
end
%% if com_PRE_INC  = amplHist
index = thetaindex;
ytick = fliplr([15 23 35 60 100 250]);
temp = [];
for k = 1:size(com_PRE_INC,1)
    temp(:,:,k) = com_PRE_INC{k,1};
end
temp = mean(temp(:,:,index),3);
figure;
imagesc(temp)
set(gca,'YTick',arrayfun(@(x) knnsearch(freq(1,:)',x),ytick)-knnsearch(freq(1,:)',ytick(1))+1,'YTickLabel',arrayfun(@num2str, ytick,'UniformOutput',false));

temp = [];
for k = 1:size(com_STIM_INC,1)
    temp(:,:,k) = com_STIM_INC{k,1};
end
temp = mean(temp(:,:,index),3);
figure;
imagesc(temp)
set(gca,'YTick',arrayfun(@(x) knnsearch(freq(1,:)',x),ytick)-knnsearch(freq(1,:)',ytick(1))+1,'YTickLabel',arrayfun(@num2str, ytick,'UniformOutput',false));

%%
index = thetaindex;
figure;
temp_pre = [];
temp_Stim = [];
for k = 1:size(pWelch_pre_INC,1)
    temp_pre(k,:) = 10*log10(pWelch_pre_INC{k,pyrN_INC(k)});
    temp_stim(k,:) = 10*log10(pWelch_stim_INC{k,pyrN_INC(k)});
end
xfreq = fWelch_pre_INC{1,pyrN_INC(1)};
plot(xfreq,mean(temp_pre(index,:)),'Color','k','LineWidth',2)
hold on
plot(xfreq,mean(temp_stim(index,:)),'Color','b','LineWidth',2)
set(gca,'XLim',[1 60],'FontSize',20,'LineWidth',2)

t1 = knnsearch(xfreq,4);
t2 = knnsearch(xfreq,13);
thetadom_pre = [];
thetadom_stim = [];
for k = 1:size(pWelch_pre_INC,1)
    [pmax, lmax] = findpeaks(temp_pre(k,t1:t2));
    if ~isempty(lmax)
        lmax = lmax(pmax == max(pmax));
        lmax = lmax+t1-1;
        thetadom_pre(k,1) = xfreq(lmax);
    else
        thetadom_pre(k,1) = NaN;
    end
    
    [pmax, lmax] = findpeaks(temp_stim(k,t1:t2));
    if ~isempty(lmax)
        lmax = lmax(pmax == max(pmax));
        lmax = lmax+t1-1;
        thetadom_stim(k,1) = xfreq(lmax);
    else
        thetadom_stim(k,1) = NaN;
    end
    
%     [~,imax] = max(temp_pre(k,t1:t2));
%     imax = imax+t1-1;
%     thetadom_pre(k,1) = xfreq(imax);
%     
%     [~,imax] = max(temp_stim(k,t1:t2));
%     imax = imax+t1-1;
%     thetadom_stim(k,1) = xfreq(imax);
end
figure;
scatter(thetadom_pre(index),1:length(thetadom_pre(index)),80,[0 0 0],'LineWidth',2)
hold on
scatter(thetadom_stim(index),1:length(thetadom_stim(index)),80,[0 0 1],'LineWidth',2)
set(gca,'FontSize',20,'LineWidth',2)

figure;
scatter(thetadom_stim(index)-thetadom_pre(index),1:length(thetadom_stim(index)),80,[1 0 0],'LineWidth',2)
set(gca,'FontSize',20,'LineWidth',2)
%%
index = thetaindex;
xtick = fliplr([0.9 5 12 23 35]);
ytick = fliplr([15 23 35 60 100 250]);
figure;
imagesc(mean(com_PRE_INC(:,:,index),3))
set(gca,'XTick',arrayfun(@(x) knnsearch(freq(1,:)',x),xtick)-knnsearch(freq(1,:)',xtick(1))+1,'XTickLabel',arrayfun(@num2str, xtick,'UniformOutput',false));
set(gca,'YTick',arrayfun(@(x) knnsearch(freq(1,:)',x),ytick)-knnsearch(freq(1,:)',ytick(1))+1,'YTickLabel',arrayfun(@num2str, ytick,'UniformOutput',false));
figure;
imagesc(mean(com_STIM_INC(:,:,index),3))
set(gca,'XTick',arrayfun(@(x) knnsearch(freq(1,:)',x),xtick)-knnsearch(freq(1,:)',xtick(1))+1,'XTickLabel',arrayfun(@num2str, xtick,'UniformOutput',false));
set(gca,'YTick',arrayfun(@(x) knnsearch(freq(1,:)',x),ytick)-knnsearch(freq(1,:)',ytick(1))+1,'YTickLabel',arrayfun(@num2str, ytick,'UniformOutput',false));
figure;
imagesc(mean(com_STIM_INC(:,:,index),3)-mean(com_PRE_INC(:,:,index),3))
set(gca,'XTick',arrayfun(@(x) knnsearch(freq(1,:)',x),xtick)-knnsearch(freq(1,:)',xtick(1))+1,'XTickLabel',arrayfun(@num2str, xtick,'UniformOutput',false));
set(gca,'YTick',arrayfun(@(x) knnsearch(freq(1,:)',x),ytick)-knnsearch(freq(1,:)',ytick(1))+1,'YTickLabel',arrayfun(@num2str, ytick,'UniformOutput',false));
%%
Ath5505linSEPTUMtheta = mean(com_STIM_INC(:,:,index),3)-mean(com_PRE_INC(:,:,index),3);
%%
Ath5505homeSEPTUMtheta = mean(com_STIM_INC(:,:,index),3)-mean(com_PRE_INC(:,:,index),3);
%%
Ath5505homeSEPTUMnth = mean(com_STIM_INC(:,:,index),3)-mean(com_PRE_INC(:,:,index),3);
%%
figure;
imagesc(A5hzhomeINCnth)
set(gca,'XTick',arrayfun(@(x) knnsearch(freq(1,:)',x),xtick)-knnsearch(freq(1,:)',xtick(1))+1,'XTickLabel',arrayfun(@num2str, xtick,'UniformOutput',false));
set(gca,'YTick',arrayfun(@(x) knnsearch(freq(1,:)',x),ytick)-knnsearch(freq(1,:)',ytick(1))+1,'YTickLabel',arrayfun(@num2str, ytick,'UniformOutput',false));
set(gca,'CLim',[-0.003 0.003],'FontSize',20)
%%

stim = 'INC';
arena = A;
sfreq = F;
select = Control;%

% get data from files
[speedmatrix,eegmatrix,speedindex,speedindex2,eegindex,eegindex2,rowdata,stimFlag,freq,wave,power,scale,pulseIndex,eeg,pyrN,stimIndexA,stimIndexB] = andor_INCfreemov_STEP4_eeg(stim, arena, sfreq, select);

% find theta and states
if ~isempty(freq)
theta1 = 12;
theta2 = 5;
theta1_U = 6;
theta2_U = 2.5;
delta1 = 4;
delta2 = 1;
delta1_U = 2;
delta2_U = 1;
thSearchBef = 1000;
theta = NaN(size(power,2),size(power,3));
TDratio = NaN(size(power,2),size(power,3));
for k = 1:size(power,3)
    if ~strcmp(arena,'urethane')
        [theta(:,k), TDratio(:,k)] = andor_detectTheta(power(:,:,k),freq(k,:),theta2,theta1,delta2,delta1,1000);
    else
        [theta(:,k), TDratio(:,k)] = andor_detectTheta(power(:,:,k),freq(k,:),theta2_U,theta1_U,delta2_U,delta1_U,1000);
    end
end
thetaindex = false(size(power,3),1);
nonthetaindex = false(size(power,3),1);
for k = 1:size(power,3)
    thetaindex(k,1) = all(theta(eegindex(k)-thSearchBef-1:eegindex(k)-1,k));
    nonthetaindex(k,1) = all(~theta(eegindex(k)-thSearchBef-1:eegindex(k)-1,k));
end

[powerM_INC_CTR,power_pre_INC_CTR,power_stim_INC_CTR,power_post_INC_CTR,powerratio_INC_CTR,power_preShort_INC_CTR,power_stimShort_INC_CTR,powerratioShort_INC_CTR,...
    pWelch_pre_INC_CTR,fWelch_pre_INC_CTR,pWelch_stim_INC_CTR,fWelch_stim_INC_CTR,pWelch_post_INC_CTR,fWelch_post_INC_CTR,...
    domfreq_pre_INC_CTR,domfreq_stim_INC_CTR,domfreq_preShort_INC_CTR,domfreq_stimShort_INC_CTR,...com_PRE_INC_CTR,com_STIM_INC_CTR,
    FreqTick_INC_CTR,FreqTickloc_INC_CTR,TimeX_INC_CTR,pyrN_INC_CTR] ...
    = andor_INCfreemov_STEP4_f2(nonthetaindex,thSearchBef,speedmatrix,eegmatrix,speedindex,speedindex2,eegindex,eegindex2,rowdata,stimFlag,freq,wave,power,scale,pulseIndex,eeg,pyrN,stimIndexA,stimIndexB);
else
    powerM_INC_CTR=[];power_pre_INC_CTR=[];power_stim_INC_CTR=[];power_post_INC_CTR=[];powerratio_INC_CTR=[];power_preShort_INC_CTR=[];power_stimShort_INC_CTR=[];powerratioShort_INC_CTR=[];...
    pWelch_pre_INC_CTR=[];fWelch_pre_INC_CTR=[];pWelch_stim_INC_CTR=[];fWelch_stim_INC_CTR=[];pWelch_post_INC_CTR=[];fWelch_post_INC_CTR=[];...
    domfreq_pre_INC_CTR=[];domfreq_stim_INC_CTR=[];domfreq_preShort_INC_CTR=[];domfreq_stimShort_INC_CTR=[];...com_PRE_INC_CTR,com_STIM_INC_CTR,
    FreqTick_INC_CTR=[];FreqTickloc_INC_CTR=[];TimeX_INC_CTR=[];pyrN_INC_CTR=[];
end

% SEPTUM
stim = 'SEPTUM';
arena = A;
sfreq = F;
select = Select{2}; %[Select{3} Select{4}];%

% get data from files
[speedmatrix,eegmatrix,speedindex,speedindex2,eegindex,eegindex2,rowdata,stimFlag,freq,wave,power,scale,pulseIndex,eeg,pyrN,stimIndexA,stimIndexB] = andor_INCfreemov_STEP4_eeg(stim, arena, sfreq, select);

% find theta and states
if ~isempty(freq)
theta1 = 12;
theta2 = 5;
theta1_U = 6;
theta2_U = 2.5;
delta1 = 4;
delta2 = 1;
delta1_U = 2;
delta2_U = 1;
thSearchBef = 1000;
theta = NaN(size(power,2),size(power,3));
TDratio = NaN(size(power,2),size(power,3));
for k = 1:size(power,3)
    if ~strcmp(arena,'urethane')
        [theta(:,k), TDratio(:,k)] = andor_detectTheta(power(:,:,k),freq(k,:),theta2,theta1,delta2,delta1,1000);
    else
        [theta(:,k), TDratio(:,k)] = andor_detectTheta(power(:,:,k),freq(k,:),theta2_U,theta1_U,delta2_U,delta1_U,1000);
    end
end
thetaindex = false(size(power,3),1);
nonthetaindex = false(size(power,3),1);
for k = 1:size(power,3)
    thetaindex(k,1) = all(theta(eegindex(k)-thSearchBef-1:eegindex(k)-1,k));
    nonthetaindex(k,1) = all(~theta(eegindex(k)-thSearchBef-1:eegindex(k)-1,k));
end

[powerM_SEPTUM,power_pre_SEPTUM,power_stim_SEPTUM,power_post_SEPTUM,powerratio_SEPTUM,power_preShort_SEPTUM,power_stimShort_SEPTUM,powerratioShort_SEPTUM,...
    pWelch_pre_SEPTUM,fWelch_pre_SEPTUM,pWelch_stim_SEPTUM,fWelch_stim_SEPTUM,pWelch_post_SEPTUM,fWelch_post_SEPTUM,...
    domfreq_pre_SEPTUM,domfreq_stim_SEPTUM,domfreq_preShort_SEPTUM,domfreq_stimShort_SEPTUM,...com_PRE_SEPTUM,com_STIM_SEPTUM,
    FreqTick_SEPTUM,FreqTickloc_SEPTUM,TimeX_SEPTUM,pyrN_SEPTUM] ...
    = andor_INCfreemov_STEP4_f2(nonthetaindex,thSearchBef,speedmatrix,eegmatrix,speedindex,speedindex2,eegindex,eegindex2,rowdata,stimFlag,freq,wave,power,scale,pulseIndex,eeg,pyrN,stimIndexA,stimIndexB);
else
    powerM_SEPTUM=[];power_pre_SEPTUM=[];power_stim_SEPTUM=[];power_post_SEPTUM=[];powerratio_SEPTUM=[];power_preShort_SEPTUM=[];power_stimShort_SEPTUM=[];powerratioShort_SEPTUM=[];...
    pWelch_pre_SEPTUM=[];fWelch_pre_SEPTUM=[];pWelch_stim_SEPTUM=[];fWelch_stim_SEPTUM=[];pWelch_post_SEPTUM=[];fWelch_post_SEPTUM=[];...
    domfreq_pre_SEPTUM=[];domfreq_stim_SEPTUM=[];domfreq_preShort_SEPTUM=[];domfreq_stimShort_SEPTUM=[];...com_PRE_SEPTUM,com_STIM_SEPTUM,
    FreqTick_SEPTUM=[];FreqTickloc_SEPTUM=[];TimeX_SEPTUM=[];pyrN_SEPTUM=[];
end

stim = 'SEPTUM';
arena = A;
sfreq = F;
select = Control;%

% get data from files
[speedmatrix,eegmatrix,speedindex,speedindex2,eegindex,eegindex2,rowdata,stimFlag,freq,wave,power,scale,pulseIndex,eeg,pyrN,stimIndexA,stimIndexB] = andor_INCfreemov_STEP4_eeg(stim, arena, sfreq, select);

% find theta and states
if ~isempty(freq)
theta1 = 12;
theta2 = 5;
theta1_U = 6;
theta2_U = 2.5;
delta1 = 4;
delta2 = 1;
delta1_U = 2;
delta2_U = 1;
thSearchBef = 1000;
theta = NaN(size(power,2),size(power,3));
TDratio = NaN(size(power,2),size(power,3));
for k = 1:size(power,3)
    if ~strcmp(arena,'urethane')
        [theta(:,k), TDratio(:,k)] = andor_detectTheta(power(:,:,k),freq(k,:),theta2,theta1,delta2,delta1,1000);
    else
        [theta(:,k), TDratio(:,k)] = andor_detectTheta(power(:,:,k),freq(k,:),theta2_U,theta1_U,delta2_U,delta1_U,1000);
    end
end
thetaindex = false(size(power,3),1);
nonthetaindex = false(size(power,3),1);
for k = 1:size(power,3)
    thetaindex(k,1) = all(theta(eegindex(k)-thSearchBef-1:eegindex(k)-1,k));
    nonthetaindex(k,1) = all(~theta(eegindex(k)-thSearchBef-1:eegindex(k)-1,k));
end

[powerM_SEPTUM_CTR,power_pre_SEPTUM_CTR,power_stim_SEPTUM_CTR,power_post_SEPTUM_CTR,powerratio_SEPTUM_CTR,power_preShort_SEPTUM_CTR,power_stimShort_SEPTUM_CTR,powerratioShort_SEPTUM_CTR,...
    pWelch_pre_SEPTUM_CTR,fWelch_pre_SEPTUM_CTR,pWelch_stim_SEPTUM_CTR,fWelch_stim_SEPTUM_CTR,pWelch_post_SEPTUM_CTR,fWelch_post_SEPTUM_CTR,...
    domfreq_pre_SEPTUM_CTR,domfreq_stim_SEPTUM_CTR,domfreq_preShort_SEPTUM_CTR,domfreq_stimShort_SEPTUM_CTR,...com_PRE_SEPTUM_CTR,com_STIM_SEPTUM_CTR,
    FreqTick_SEPTUM_CTR,FreqTickloc_SEPTUM_CTR,TimeX_SEPTUM_CTR,pyrN_SEPTUM_CTR] ...
    = andor_INCfreemov_STEP4_f2(nonthetaindex,thSearchBef,speedmatrix,eegmatrix,speedindex,speedindex2,eegindex,eegindex2,rowdata,stimFlag,freq,wave,power,scale,pulseIndex,eeg,pyrN,stimIndexA,stimIndexB);
else
    powerM_SEPTUM_CTR=[];power_pre_SEPTUM_CTR=[];power_stim_SEPTUM_CTR=[];power_post_SEPTUM_CTR=[];powerratio_SEPTUM_CTR=[];power_preShort_SEPTUM_CTR=[];power_stimShort_SEPTUM_CTR=[];powerratioShort_SEPTUM_CTR=[];...
    pWelch_pre_SEPTUM_CTR=[];fWelch_pre_SEPTUM_CTR=[];pWelch_stim_SEPTUM_CTR=[];fWelch_stim_SEPTUM_CTR=[];pWelch_post_SEPTUM_CTR=[];fWelch_post_SEPTUM_CTR=[];...
    domfreq_pre_SEPTUM_CTR=[];domfreq_stim_SEPTUM_CTR=[];domfreq_preShort_SEPTUM_CTR=[];domfreq_stimShort_SEPTUM_CTR=[];...com_PRE_SEPTUM_CTR,com_STIM_SEPTUM_CTR,
    FreqTick_SEPTUM_CTR=[];FreqTickloc_SEPTUM_CTR=[];TimeX_SEPTUM_CTR=[];pyrN_SEPTUM_CTR=[];
end

% BLIND
stim = 'BLIND';
arena = A;
sfreq = F;
select = Select{3}; %[Select{3} Select{4}];%

% get data from files
[speedmatrix,eegmatrix,speedindex,speedindex2,eegindex,eegindex2,rowdata,stimFlag,freq,wave,power,scale,pulseIndex,eeg,pyrN,stimIndexA,stimIndexB] = andor_INCfreemov_STEP4_eeg(stim, arena, sfreq, select);

% find theta and states
if ~isempty(freq)
theta1 = 12;
theta2 = 5;
theta1_U = 6;
theta2_U = 2.5;
delta1 = 4;
delta2 = 1;
delta1_U = 2;
delta2_U = 1;
thSearchBef = 1000;
theta = NaN(size(power,2),size(power,3));
TDratio = NaN(size(power,2),size(power,3));
for k = 1:size(power,3)
    if ~strcmp(arena,'urethane')
        [theta(:,k), TDratio(:,k)] = andor_detectTheta(power(:,:,k),freq(k,:),theta2,theta1,delta2,delta1,1000);
    else
        [theta(:,k), TDratio(:,k)] = andor_detectTheta(power(:,:,k),freq(k,:),theta2_U,theta1_U,delta2_U,delta1_U,1000);
    end
end
thetaindex = false(size(power,3),1);
nonthetaindex = false(size(power,3),1);
for k = 1:size(power,3)
    thetaindex(k,1) = all(theta(eegindex(k)-thSearchBef-1:eegindex(k)-1,k));
    nonthetaindex(k,1) = all(~theta(eegindex(k)-thSearchBef-1:eegindex(k)-1,k));
end

[powerM_BLIND,power_pre_BLIND,power_stim_BLIND,power_post_BLIND,powerratio_BLIND,power_preShort_BLIND,power_stimShort_BLIND,powerratioShort_BLIND,...
    pWelch_pre_BLIND,fWelch_pre_BLIND,pWelch_stim_BLIND,fWelch_stim_BLIND,pWelch_post_BLIND,fWelch_post_BLIND,...
    domfreq_pre_BLIND,domfreq_stim_BLIND,domfreq_preShort_BLIND,domfreq_stimShort_BLIND,...com_PRE_BLIND,com_STIM_BLIND,
    FreqTick_BLIND,FreqTickloc_BLIND,TimeX_BLIND,pyrN_BLIND] ...
    = andor_INCfreemov_STEP4_f2(nonthetaindex,thSearchBef,speedmatrix,eegmatrix,speedindex,speedindex2,eegindex,eegindex2,rowdata,stimFlag,freq,wave,power,scale,pulseIndex,eeg,pyrN,stimIndexA,stimIndexB);
else
    powerM_BLIND=[];power_pre_BLIND=[];power_stim_BLIND=[];power_post_BLIND=[];powerratio_BLIND=[];power_preShort_BLIND=[];power_stimShort_BLIND=[];powerratioShort_BLIND=[];...
    pWelch_pre_BLIND=[];fWelch_pre_BLIND=[];pWelch_stim_BLIND=[];fWelch_stim_BLIND=[];pWelch_post_BLIND=[];fWelch_post_BLIND=[];...
    domfreq_pre_BLIND=[];domfreq_stim_BLIND=[];domfreq_preShort_BLIND=[];domfreq_stimShort_BLIND=[];...com_PRE_BLIND,com_STIM_BLIND,
    FreqTick_BLIND=[];FreqTickloc_BLIND=[];TimeX_BLIND=[];pyrN_BLIND=[];
end

stim = 'BLIND';
arena = A;
sfreq = F;
select = Control;%

% get data from files
[speedmatrix,eegmatrix,speedindex,speedindex2,eegindex,eegindex2,rowdata,stimFlag,freq,wave,power,scale,pulseIndex,eeg,pyrN,stimIndexA,stimIndexB] = andor_INCfreemov_STEP4_eeg(stim, arena, sfreq, select);

% find theta and states
if ~isempty(freq)
theta1 = 12;
theta2 = 5;
theta1_U = 6;
theta2_U = 2.5;
delta1 = 4;
delta2 = 1;
delta1_U = 2;
delta2_U = 1;
thSearchBef = 1000;
theta = NaN(size(power,2),size(power,3));
TDratio = NaN(size(power,2),size(power,3));
for k = 1:size(power,3)
    if ~strcmp(arena,'urethane')
        [theta(:,k), TDratio(:,k)] = andor_detectTheta(power(:,:,k),freq(k,:),theta2,theta1,delta2,delta1,1000);
    else
        [theta(:,k), TDratio(:,k)] = andor_detectTheta(power(:,:,k),freq(k,:),theta2_U,theta1_U,delta2_U,delta1_U,1000);
    end
end
thetaindex = false(size(power,3),1);
nonthetaindex = false(size(power,3),1);
for k = 1:size(power,3)
    thetaindex(k,1) = all(theta(eegindex(k)-thSearchBef-1:eegindex(k)-1,k));
    nonthetaindex(k,1) = all(~theta(eegindex(k)-thSearchBef-1:eegindex(k)-1,k));
end

[powerM_BLIND_CTR,power_pre_BLIND_CTR,power_stim_BLIND_CTR,power_post_BLIND_CTR,powerratio_BLIND_CTR,power_preShort_BLIND_CTR,power_stimShort_BLIND_CTR,powerratioShort_BLIND_CTR,...
    pWelch_pre_BLIND_CTR,fWelch_pre_BLIND_CTR,pWelch_stim_BLIND_CTR,fWelch_stim_BLIND_CTR,pWelch_post_BLIND_CTR,fWelch_post_BLIND_CTR,...
    domfreq_pre_BLIND_CTR,domfreq_stim_BLIND_CTR,domfreq_preShort_BLIND_CTR,domfreq_stimShort_BLIND_CTR,...com_PRE_BLIND_CTR,com_STIM_BLIND_CTR,
    FreqTick_BLIND_CTR,FreqTickloc_BLIND_CTR,TimeX_BLIND_CTR,pyrN_BLIND_CTR] ...
    = andor_INCfreemov_STEP4_f2(nonthetaindex,thSearchBef,speedmatrix,eegmatrix,speedindex,speedindex2,eegindex,eegindex2,rowdata,stimFlag,freq,wave,power,scale,pulseIndex,eeg,pyrN,stimIndexA,stimIndexB);
else
    powerM_BLIND_CTR=[];power_pre_BLIND_CTR=[];power_stim_BLIND_CTR=[];power_post_BLIND_CTR=[];powerratio_BLIND_CTR=[];power_preShort_BLIND_CTR=[];power_stimShort_BLIND_CTR=[];powerratioShort_BLIND_CTR=[];...
    pWelch_pre_BLIND_CTR=[];fWelch_pre_BLIND_CTR=[];pWelch_stim_BLIND_CTR=[];fWelch_stim_BLIND_CTR=[];pWelch_post_BLIND_CTR=[];fWelch_post_BLIND_CTR=[];...
    domfreq_pre_BLIND_CTR=[];domfreq_stim_BLIND_CTR=[];domfreq_preShort_BLIND_CTR=[];domfreq_stimShort_BLIND_CTR=[];...com_PRE_BLIND_CTR,com_STIM_BLIND_CTR,
    FreqTick_BLIND_CTR=[];FreqTickloc_BLIND_CTR=[];TimeX_BLIND_CTR=[];pyrN_BLIND_CTR=[];
end

%%
figure('Name',[A '   ' F '   ChR2'],'NumberTitle','off');
set(gcf,'Renderer','zbuffer')
set(gcf,'Position',[1 1 1400 900])
FontSize = 20;
CLimPower = [0 400];
CLimDB = [-10 10];
INCcolor = [0 102 255]./255;
SEPTUMcolor = [153 51 255]./255;
BLINDcolor = [102 51 0]./255;

% subplot(2,4,1)
% imagesc(TimeX,1:size(power,1),powerM)
% set(gca,'CLim',CLimPower,'YTick',FreqTickloc,'YTickLabel',arrayfun(@num2str,FreqTick,'UniformOutput',false),'FontSize',FontSize)
% line([0 0],[0.5 size(power,1)+0.5],'Color','w','LineWidth',2,'LineStyle','--')
% line(repmat(max(eegindex2)/1000,1,2)-min(eegindex)/1000,[0.5 size(power,1)+0.5],'Color','w','LineWidth',2,'LineStyle','--')
% xlabel(gca,'time (s)','FontSize',FontSize)
% ylabel(gca,'frequency (Hz)','FontSize',FontSize)
% title(gca,'wavelet power average','FontSize',FontSize)

ax1 = subplot(2,3,1);
imagesc(powerratio_INC);
set(gca,'CLim',CLimDB,'XTick',FreqTickloc_INC,'XTickLabel',arrayfun(@num2str,FreqTick_INC,'UniformOutput',false),'FontSize',FontSize)
set(gca,'XDir','reverse')
set(gca,'XLim',[knnsearch(freqfreq(1,:)',60) knnsearch(freqfreq(1,:)',1)])
title(gca,{'stim/before'; 'power change (dB)'},'FontSize',FontSize)
ylabel(gca,'INC stim No.','FontSize',FontSize)

ax2 = subplot(2,3,4);
plot(mean(powerratio_BLIND_CTR),'Color',BLINDcolor,'LineWidth',2.5,'LineStyle','--'); hold(ax2,'on')
plot(mean(powerratio_BLIND),'Color',BLINDcolor,'LineWidth',2.5); hold(ax2,'on')

plot(mean(powerratio_SEPTUM_CTR),'Color',SEPTUMcolor,'LineWidth',2.5,'LineStyle','--'); hold(ax2,'on')
plot(mean(powerratio_SEPTUM),'Color',SEPTUMcolor,'LineWidth',2.5); hold(ax2,'on')

plot(mean(powerratio_INC_CTR),'Color',INCcolor,'LineWidth',2.5,'LineStyle','--'); hold(ax2,'on')
plot(mean(powerratio_INC),'Color',INCcolor,'LineWidth',2.5); hold(ax2,'on')
set(gca,'LineWidth',2,'FontSize',FontSize,'XTick',FreqTickloc_INC,'XTickLabel',arrayfun(@num2str,FreqTick_INC,'UniformOutput',false),'XLim',[1 163],'YLim',CLimDB)
set(gca,'XDir','reverse','Box','off')
set(gca,'XLim',[knnsearch(freqfreq(1,:)',60) knnsearch(freqfreq(1,:)',1)])
line([1 163],[0 0],'Color','r','LineStyle','--','LineWidth',2.5)
xlabel(gca,'frequency (Hz)','FontSize',FontSize)
ylabel(gca,'power change (dB)','FontSize',FontSize)

tempwelch_pre = [];
tempwelch_stim = [];
welchdiff_INC = [];
for k = 1:size(pWelch_stim_INC,1)
    tempwelch_pre(k,:) = pWelch_pre_INC{k,pyrN_INC(k)};
    tempwelch_stim(k,:) = pWelch_stim_INC{k,pyrN_INC(k)};
    welchdiff_INC(k,:) = 10*log10(tempwelch_stim(k,:))-10*log10(tempwelch_pre(k,:));
end
tempwelch_pre = [];
tempwelch_stim = [];
welchdiff_SEPTUM = [];
for k = 1:size(pWelch_stim_SEPTUM,1)
    tempwelch_pre(k,:) = pWelch_pre_SEPTUM{k,pyrN_SEPTUM(k)};
    tempwelch_stim(k,:) = pWelch_stim_SEPTUM{k,pyrN_SEPTUM(k)};
    welchdiff_SEPTUM(k,:) = 10*log10(tempwelch_stim(k,:))-10*log10(tempwelch_pre(k,:));
end
tempwelch_pre = [];
tempwelch_stim = [];
welchdiff_BLIND = [];
for k = 1:size(pWelch_stim_BLIND,1)
    if ~isempty(pWelch_pre_BLIND{k,pyrN_BLIND(k)})
    tempwelch_pre(k,:) = pWelch_pre_BLIND{k,pyrN_BLIND(k)};
    tempwelch_stim(k,:) = pWelch_stim_BLIND{k,pyrN_BLIND(k)};
    welchdiff_BLIND(k,:) = 10*log10(tempwelch_stim(k,:))-10*log10(tempwelch_pre(k,:));
    end
end
tempwelch_pre = [];
tempwelch_stim = [];
welchdiff_INC_CTR = [];
for k = 1:size(pWelch_stim_INC_CTR,1)
    tempwelch_pre(k,:) = pWelch_pre_INC_CTR{k,pyrN_INC_CTR(k)};
    tempwelch_stim(k,:) = pWelch_stim_INC_CTR{k,pyrN_INC_CTR(k)};
    welchdiff_INC_CTR(k,:) = 10*log10(tempwelch_stim(k,:))-10*log10(tempwelch_pre(k,:));
end
tempwelch_pre = [];
tempwelch_stim = [];
welchdiff_SEPTUM_CTR = [];
for k = 1:size(pWelch_stim_SEPTUM_CTR,1)
    tempwelch_pre(k,:) = pWelch_pre_SEPTUM_CTR{k,pyrN_SEPTUM_CTR(k)};
    tempwelch_stim(k,:) = pWelch_stim_SEPTUM_CTR{k,pyrN_SEPTUM_CTR(k)};
    welchdiff_SEPTUM_CTR(k,:) = 10*log10(tempwelch_stim(k,:))-10*log10(tempwelch_pre(k,:));
end
tempwelch_pre = [];
tempwelch_stim = [];
welchdiff_BLIND_CTR = [];
for k = 1:size(pWelch_stim_BLIND_CTR,1)
    tempwelch_pre(k,:) = pWelch_pre_BLIND_CTR{k,pyrN_BLIND_CTR(k)};
    tempwelch_stim(k,:) = pWelch_stim_BLIND_CTR{k,pyrN_BLIND_CTR(k)};
    welchdiff_BLIND_CTR(k,:) = 10*log10(tempwelch_stim(k,:))-10*log10(tempwelch_pre(k,:));
end

welchXTick = [1 5 12 30 60];
ax3 = subplot(2,3,2);
ftemp = fWelch_pre_INC(~cellfun(@isempty,fWelch_pre_INC));
imagesc(ftemp{1},1:size(welchdiff_INC,1),welchdiff_INC)
set(gca,'CLim',CLimDB,'XLim',[1 60],'FontSize',FontSize)
set(gca,'XTick',welchXTick,'XTickLabel',arrayfun(@num2str,welchXTick,'UniformOutput',false))
title(gca,'stim/pre Welch difference','FontSize',FontSize)

ax4 = subplot(2,3,5);
plot(ftemp{1},mean(welchdiff_BLIND_CTR),'Color',BLINDcolor,'LineWidth',2.5,'LineStyle','--'); hold(ax4,'on')
plot(ftemp{1},mean(welchdiff_BLIND),'Color',BLINDcolor,'LineWidth',2.5); hold(ax4,'on')

plot(ftemp{1},mean(welchdiff_SEPTUM_CTR),'Color',SEPTUMcolor,'LineWidth',2.5,'LineStyle','--'); hold(ax4,'on')
plot(ftemp{1},mean(welchdiff_SEPTUM),'Color',SEPTUMcolor,'LineWidth',2.5); hold(ax4,'on')

plot(ftemp{1},mean(welchdiff_INC_CTR),'Color',INCcolor,'LineWidth',2.5,'LineStyle','--'); hold(ax4,'on')
plot(ftemp{1},mean(welchdiff_INC),'Color',INCcolor,'LineWidth',2.5); hold(ax4,'on')
set(gca,'LineWidth',2,'FontSize',FontSize,'XLim',[1 60],'YLim',CLimDB,'Box','off')
set(gca,'XTick',welchXTick,'XTickLabel',arrayfun(@num2str,welchXTick,'UniformOutput',false))

line([0 60],[0 0],'Color','r','LineStyle','--','LineWidth',2.5)
xlabel(gca,'frequency (Hz)','FontSize',FontSize)

ax5 = subplot(2,3,3);
scatter(domfreq_stimShort_BLIND_CTR-domfreq_preShort_BLIND_CTR,1:size(domfreq_stimShort_BLIND_CTR,1),120,BLINDcolor,'LineWidth',3); hold(ax5,'on')
scatter(domfreq_stimShort_BLIND-domfreq_preShort_BLIND,1:size(domfreq_stimShort_BLIND,1),120,BLINDcolor,'filled','LineWidth',3); hold(ax5,'on')

scatter(domfreq_stimShort_SEPTUM_CTR-domfreq_preShort_SEPTUM_CTR,1:size(domfreq_stimShort_SEPTUM_CTR,1),120,SEPTUMcolor,'LineWidth',3); hold(ax5,'on')
scatter(domfreq_stimShort_SEPTUM-domfreq_preShort_SEPTUM,1:size(domfreq_stimShort_SEPTUM,1),120,SEPTUMcolor,'filled','LineWidth',3); hold(ax5,'on')

scatter(domfreq_stimShort_INC_CTR-domfreq_preShort_INC_CTR,1:size(domfreq_stimShort_INC_CTR,1),120,INCcolor,'LineWidth',3); hold(ax5,'on')
scatter(domfreq_stimShort_INC-domfreq_preShort_INC,1:size(domfreq_stimShort_INC,1),120,INCcolor,'filled','LineWidth',3); hold(ax5,'on')
set(gca,'LineWidth',2,'YDir','reverse','XLim',[-7 7],'FontSize',FontSize,'XTick',[-7 0 7],'XTickLabel',{'-7','0','7'},'YLim',[0.5 max([size(domfreq_stimShort_BLIND,1) size(domfreq_stimShort_SEPTUM,1) size(domfreq_stimShort_INC,1) size(domfreq_stimShort_BLIND_CTR,1) size(domfreq_stimShort_SEPTUM_CTR,1) size(domfreq_stimShort_INC_CTR,1)])+0.5])
line([0 0],[0.5 max([size(domfreq_stimShort_BLIND,1) size(domfreq_stimShort_SEPTUM,1) size(domfreq_stimShort_INC,1) size(domfreq_stimShort_BLIND_CTR,1) size(domfreq_stimShort_SEPTUM_CTR,1) size(domfreq_stimShort_INC_CTR,1)])+0.5],'LineWidth',2.5,'Color','r','LineStyle','--')
title(gca,{'theta';'dominant frequency shift'},'FontSize',FontSize)

ax6 = subplot(2,3,6);
line([0 0],[0 12],'LineWidth',2.5,'Color','r','LineStyle','--')

posA = 1;
line(repmat(mean(domfreq_stimShort_BLIND_CTR-domfreq_preShort_BLIND_CTR),1,2),[(posA-1)*2+1-0.75 (posA-1)*2+1+0.75],'LineWidth',8,'Color',BLINDcolor)
line(repmat(mean(domfreq_stimShort_BLIND_CTR-domfreq_preShort_BLIND_CTR)-std(domfreq_stimShort_BLIND_CTR-domfreq_preShort_BLIND_CTR),1,2),[(posA-1)*2+1-0.5 (posA-1)*2+1+0.5],'LineWidth',2,'Color',BLINDcolor)
line(repmat(mean(domfreq_stimShort_BLIND_CTR-domfreq_preShort_BLIND_CTR)+std(domfreq_stimShort_BLIND_CTR-domfreq_preShort_BLIND_CTR),1,2),[(posA-1)*2+1-0.5 (posA-1)*2+1+0.5],'LineWidth',2,'Color',BLINDcolor)
line([mean(domfreq_stimShort_BLIND_CTR-domfreq_preShort_BLIND_CTR)-std(domfreq_stimShort_BLIND_CTR-domfreq_preShort_BLIND_CTR) mean(domfreq_stimShort_BLIND_CTR-domfreq_preShort_BLIND_CTR)+std(domfreq_stimShort_BLIND_CTR-domfreq_preShort_BLIND_CTR)],[(posA-1)*2+1 (posA-1)*2+1],'LineStyle','--','LineWidth',2,'Color',BLINDcolor)

line(repmat(mean(domfreq_stimShort_BLIND_CTR-domfreq_preShort_BLIND_CTR),1,2),[(posA-1)*2+1-0.6 (posA-1)*2+1+0.6],'LineWidth',4,'Color','w')


posA = 2;
line(repmat(mean(domfreq_stimShort_BLIND-domfreq_preShort_BLIND),1,2),[(posA-1)*2+1-0.75 (posA-1)*2+1+0.75],'LineWidth',8,'Color',BLINDcolor)
line(repmat(mean(domfreq_stimShort_BLIND-domfreq_preShort_BLIND)-std(domfreq_stimShort_BLIND-domfreq_preShort_BLIND),1,2),[(posA-1)*2+1-0.5 (posA-1)*2+1+0.5],'LineWidth',2,'Color',BLINDcolor)
line(repmat(mean(domfreq_stimShort_BLIND-domfreq_preShort_BLIND)+std(domfreq_stimShort_BLIND-domfreq_preShort_BLIND),1,2),[(posA-1)*2+1-0.5 (posA-1)*2+1+0.5],'LineWidth',2,'Color',BLINDcolor)
line([mean(domfreq_stimShort_BLIND-domfreq_preShort_BLIND)-std(domfreq_stimShort_BLIND-domfreq_preShort_BLIND) mean(domfreq_stimShort_BLIND-domfreq_preShort_BLIND)+std(domfreq_stimShort_BLIND-domfreq_preShort_BLIND)],[(posA-1)*2+1 (posA-1)*2+1],'LineStyle','-','LineWidth',2,'Color',BLINDcolor)

posA = 3;
line(repmat(mean(domfreq_stimShort_SEPTUM_CTR-domfreq_preShort_SEPTUM_CTR),1,2),[(posA-1)*2+1-0.75 (posA-1)*2+1+0.75],'LineWidth',8,'Color',SEPTUMcolor)
line(repmat(mean(domfreq_stimShort_SEPTUM_CTR-domfreq_preShort_SEPTUM_CTR)-std(domfreq_stimShort_SEPTUM_CTR-domfreq_preShort_SEPTUM_CTR),1,2),[(posA-1)*2+1-0.5 (posA-1)*2+1+0.5],'LineWidth',2,'Color',SEPTUMcolor)
line(repmat(mean(domfreq_stimShort_SEPTUM_CTR-domfreq_preShort_SEPTUM_CTR)+std(domfreq_stimShort_SEPTUM_CTR-domfreq_preShort_SEPTUM_CTR),1,2),[(posA-1)*2+1-0.5 (posA-1)*2+1+0.5],'LineWidth',2,'Color',SEPTUMcolor)
line([mean(domfreq_stimShort_SEPTUM_CTR-domfreq_preShort_SEPTUM_CTR)-std(domfreq_stimShort_SEPTUM_CTR-domfreq_preShort_SEPTUM_CTR) mean(domfreq_stimShort_SEPTUM_CTR-domfreq_preShort_SEPTUM_CTR)+std(domfreq_stimShort_SEPTUM_CTR-domfreq_preShort_SEPTUM_CTR)],[(posA-1)*2+1 (posA-1)*2+1],'LineStyle','--','LineWidth',2,'Color',SEPTUMcolor)

line(repmat(mean(domfreq_stimShort_SEPTUM_CTR-domfreq_preShort_SEPTUM_CTR),1,2),[(posA-1)*2+1-0.6 (posA-1)*2+1+0.6],'LineWidth',4,'Color','w')


posA = 4;
line(repmat(mean(domfreq_stimShort_SEPTUM-domfreq_preShort_SEPTUM),1,2),[(posA-1)*2+1-0.75 (posA-1)*2+1+0.75],'LineWidth',8,'Color',SEPTUMcolor)
line(repmat(mean(domfreq_stimShort_SEPTUM-domfreq_preShort_SEPTUM)-std(domfreq_stimShort_SEPTUM-domfreq_preShort_SEPTUM),1,2),[(posA-1)*2+1-0.5 (posA-1)*2+1+0.5],'LineWidth',2,'Color',SEPTUMcolor)
line(repmat(mean(domfreq_stimShort_SEPTUM-domfreq_preShort_SEPTUM)+std(domfreq_stimShort_SEPTUM-domfreq_preShort_SEPTUM),1,2),[(posA-1)*2+1-0.5 (posA-1)*2+1+0.5],'LineWidth',2,'Color',SEPTUMcolor)
line([mean(domfreq_stimShort_SEPTUM-domfreq_preShort_SEPTUM)-std(domfreq_stimShort_SEPTUM-domfreq_preShort_SEPTUM) mean(domfreq_stimShort_SEPTUM-domfreq_preShort_SEPTUM)+std(domfreq_stimShort_SEPTUM-domfreq_preShort_SEPTUM)],[(posA-1)*2+1 (posA-1)*2+1],'LineStyle','-','LineWidth',2,'Color',SEPTUMcolor)

posA = 5;
line(repmat(mean(domfreq_stimShort_INC_CTR-domfreq_preShort_INC_CTR),1,2),[(posA-1)*2+1-0.75 (posA-1)*2+1+0.75],'LineWidth',8,'Color',INCcolor)
line(repmat(mean(domfreq_stimShort_INC_CTR-domfreq_preShort_INC_CTR)-std(domfreq_stimShort_INC_CTR-domfreq_preShort_INC_CTR),1,2),[(posA-1)*2+1-0.5 (posA-1)*2+1+0.5],'LineWidth',2,'Color',INCcolor)
line(repmat(mean(domfreq_stimShort_INC_CTR-domfreq_preShort_INC_CTR)+std(domfreq_stimShort_INC_CTR-domfreq_preShort_INC_CTR),1,2),[(posA-1)*2+1-0.5 (posA-1)*2+1+0.5],'LineWidth',2,'Color',INCcolor)
line([mean(domfreq_stimShort_INC_CTR-domfreq_preShort_INC_CTR)-std(domfreq_stimShort_INC_CTR-domfreq_preShort_INC_CTR) mean(domfreq_stimShort_INC_CTR-domfreq_preShort_INC_CTR)+std(domfreq_stimShort_INC_CTR-domfreq_preShort_INC_CTR)],[(posA-1)*2+1 (posA-1)*2+1],'LineStyle','--','LineWidth',2,'Color',INCcolor)

line(repmat(mean(domfreq_stimShort_INC_CTR-domfreq_preShort_INC_CTR),1,2),[(posA-1)*2+1-0.6 (posA-1)*2+1+0.6],'LineWidth',4,'Color','w')


posA = 6;
line(repmat(mean(domfreq_stimShort_INC-domfreq_preShort_INC),1,2),[(posA-1)*2+1-0.75 (posA-1)*2+1+0.75],'LineWidth',8,'Color',INCcolor)
line(repmat(mean(domfreq_stimShort_INC-domfreq_preShort_INC)-std(domfreq_stimShort_INC-domfreq_preShort_INC),1,2),[(posA-1)*2+1-0.5 (posA-1)*2+1+0.5],'LineWidth',2,'Color',INCcolor)
line(repmat(mean(domfreq_stimShort_INC-domfreq_preShort_INC)+std(domfreq_stimShort_INC-domfreq_preShort_INC),1,2),[(posA-1)*2+1-0.5 (posA-1)*2+1+0.5],'LineWidth',2,'Color',INCcolor)
line([mean(domfreq_stimShort_INC-domfreq_preShort_INC)-std(domfreq_stimShort_INC-domfreq_preShort_INC) mean(domfreq_stimShort_INC-domfreq_preShort_INC)+std(domfreq_stimShort_INC-domfreq_preShort_INC)],[(posA-1)*2+1 (posA-1)*2+1],'LineStyle','-','LineWidth',2,'Color',INCcolor)

set(gca,'LineWidth',2,'YLim',[0 12],'YTick',[],'XLim',[-7 7],'XTick',[-7 0 7],'XTickLabel',{'-7','0','7'},'FontSize',FontSize)
set(gca,'YTick',[1 3 5 7 9 11],'YTickLabel',{'CTRL','ChR2','CTRL','ChR2','CTRL','ChR2'})
xlabel(gca,'frequency (Hz)','FontSize',FontSize)


%%


    

%%
figure;
imagesc(mean(com_STIM,3)-mean(com_PRE,3))
%% check pyr layer (with igor)
k = 1;
temp = eeg{k,1}(:,17:32);
tempF = [];
tempH = [];
bvar = fir1(2048,[150/(1000/2) 250/(1000/2)]);
for xx = 1:size(temp,2)
    tempF(:,xx) = filtfilt(bvar,1,temp(:,xx));
    tempH(:,xx) = abs(hilbert(tempF(:,xx)));
end

save('eeg_trial','temp','tempF','tempH','-v7.3')

%%
if strcmp(arena,'urethane')
    th1 = knnsearch(freq(1,:)',6);
    th2 = knnsearch(freq(1,:)',2.5);
else
    th1 = knnsearch(freq(1,:)',12);
    th2 = knnsearch(freq(1,:)',5);
end
temp = 10*log10(powerratio);
tempthetachange = temp(:,th1:th2);
thchindex = false(size(tempthetachange,1),1);
for k = 1:size(tempthetachange,1)
    if mean(tempthetachange(k,:))<0
    thchindex(k) = true;
    end
end

domfreq = NaN(size(power_preShort,1),1);
THdomfreq_pre = NaN(size(power_pre,1),1);
THdomfreq_stim = NaN(size(power_stim,1),1);
for k = 1:size(power_preShort,1)
    [~, temp] = max(power_preShort(k,:));
    domfreq(k,1) = freq(1,temp);
    %     [~, temp] = max(power_pre(k,th1:th2));
    [temppk, templc] = findpeaks(power_pre(k,th1:th2));
    if ~isempty(temppk)
        [~,t] = max(temppk);
        temp = templc(t);
        THdomfreq_pre(k,1) = freq(1,temp+th1-1);
    end
    %     [~, temp] = max(power_stim(k,th1:th2));
    [temppk, templc] = findpeaks(power_stim(k,th1:th2));
    if ~isempty(temppk)
        [~,t] = max(temppk);
        temp = templc(t);
        THdomfreq_stim(k,1) = freq(1,temp+th1-1);
    end
end
if strcmp(arena,'urethane')
    domfreqindex = domfreq>2.5;
else
    domfreqindex = domfreq>5;
end

% binsize = 0.5; % in sec
% binsize = round(binsize*120);
% binnum = 4;
% runlimit = 4; % cm/s
% prestim_speed = NaN(size(speedmatrix,1),binnum);
% for k = 1:binnum;
%     for x = 1:size(speedmatrix,1)
%         prestim_speed(x,k) = mean(speedmatrix(x,(speedindex(x,1)-k*binsize):(speedindex(x,1)-(k-1)*binsize-1)));
%     end
% end
% prestim_speed = fliplr(prestim_speed);
% 
% RUNindex = all(prestim_speed>runlimit,2);
% NoRUNindex = all(prestim_speed<runlimit,2);
%%
askfreq = sfreq;
if ismember('_',askfreq)
    temp = strfind(askfreq,'_');
    askfreq = str2num(askfreq(temp(1)+1:temp(2)-1));
else
    askfreq = str2num(askfreq(regexp(askfreq,'\d')));
end

askfreqN = knnsearch(freq(1,:)',askfreq);
powerratio_STIMFREQ = powerratio(:,askfreqN);

beta2_2 = knnsearch(freq(1,:)',23);
beta2_1 = knnsearch(freq(1,:)',33);
powerratio_BETA2 = sumskipnan(powerratio(:,beta2_1:beta2_2),2)./(beta2_2-beta2_1+1);


    

%%
index = domfreqindex;

figure('Name',[stim '  ' arena '  ' sfreq '   RATIO'],'NumberTitle','off');
xtick = fliplr([0.9 5 12 30 60 150 250]);
xtickloc = arrayfun(@(x) knnsearch(freq(1,:)',x),xtick);

subplot(2,5,4)
imagesc(10*log10(powerratio(index,:)))
set(gca,'CLim',[-10 10],'XTick',xtickloc,'XTickLabel',arrayfun(@num2str,xtick,'UniformOutput',false),'FontSize',20)
title(gca,{'stim/before'; 'power change (dB)'},'FontSize',20)

subplot(2,5,9)
plot(mean(10*log10(powerratio(index,:))),'Color','b','LineWidth',2)
set(gca,'FontSize',20,'XTick',xtickloc,'XTickLabel',arrayfun(@num2str,xtick,'UniformOutput',false),'XLim',[1 163],'YLim',[-5 5])
line([1 163],[0 0],'Color','r','LineStyle','--','LineWidth',1.5)
xlabel(gca,'frequency (Hz)','FontSize',20)
title(gca,'mean power change (dB)','FontSize',20)

subplot(2,5,5)
tempdfs = THdomfreq_stim(index);
tempdfp = THdomfreq_pre(index);
thetashift = tempdfs-tempdfp;
scatter(thetashift,1:size(tempdfs,1),120,[0 0 0],'LineWidth',3)
set(gca,'YDir','reverse','XLim',[-7 7],'FontSize',20,'XTick',[-7 0 7],'XTickLabel',{'-7','0','7'},'YLim',[0.5 size(tempdfs,1)+0.5])
line([0 0],[0.5 size(tempdfs,1)+0.5],'LineWidth',1.5,'Color','r','LineStyle','--')
title(gca,{'theta'; 'dominant frequency shift'},'FontSize',20)
xlabel(gca,'frequency (Hz)','FontSize',20)
% plot(tempdfs-tempdfp,1:size(tempdfs,1),'LineWidth',2,'Color','k')

subplot(2,5,10)
line([0 0],[-3 3],'LineWidth',1.5,'Color','r','LineStyle','--')
line(repmat(mean(thetashift),1,2),[-1 1],'LineWidth',4,'Color','k')
line(repmat(mean(thetashift)-std(thetashift),1,2),[-0.5 0.5],'LineWidth',2,'Color','k')
line(repmat(mean(thetashift)+std(thetashift),1,2),[-0.5 0.5],'LineWidth',2,'Color','k')
line([mean(thetashift)-std(thetashift) mean(thetashift)+std(thetashift)],[0 0],'LineStyle','--','LineWidth',2,'Color','k')
set(gca,'YLim',[-3 3],'YTick',[],'XLim',[-7 7],'XTick',[-7 0 7],'XTickLabel',{'-7','0','7'},'FontSize',20)

subplot(2,5,1)
imagesc(power_pre(index,:))
set(gca,'CLim',[0 600],'XTick',xtickloc,'XTickLabel',arrayfun(@num2str,xtick,'UniformOutput',false),'FontSize',20)
title(gca,'power before stim','FontSize',20)
ylabel(gca,'stim No.','FontSize',20)


% subplot(2,4,5)
% imagesc(speed_pre(index,:))
% 
% subplot(2,4,6)
% imagesc(speed_stim(index,:))

subplot(2,5,2)
imagesc(power_stim(index,:))
set(gca,'CLim',[0 600],'XTick',xtickloc,'XTickLabel',arrayfun(@num2str,xtick,'UniformOutput',false),'FontSize',20)
title(gca,'power during stim','FontSize',20)

subplot(2,5,3)
imagesc(power_post(index,:))
set(gca,'CLim',[0 600],'XTick',xtickloc,'XTickLabel',arrayfun(@num2str,xtick,'UniformOutput',false),'FontSize',20)
title(gca,'power after stim','FontSize',20)


ytick = fliplr([0.9 5 12 30 60 150 250]);
ytickloc = arrayfun(@(x) knnsearch(freq(1,:)',x),ytick);

subplot(2,5,6)
imagesc((1:size(power,2))./1000-min(eegindex)/1000,1:size(power,1),mean(power(:,:,index),3))
set(gca,'CLim',[0 400],'YTick',ytickloc,'YTickLabel',arrayfun(@num2str,ytick,'UniformOutput',false),'FontSize',20)
line([0 0],[0.5 size(power,1)+0.5],'Color','w','LineWidth',2,'LineStyle','--')
line(repmat(max(eegindex2)/1000,1,2)-min(eegindex)/1000,[0.5 size(power,1)+0.5],'Color','w','LineWidth',2,'LineStyle','--')
xlabel(gca,'time (s)','FontSize',20)
ylabel(gca,'frequency (Hz)','FontSize',20)


temphilPhasePulse = hilPhasePulse(index,1);
hilPhasePulse_matrix = cell2mat(temphilPhasePulse);

subplot(2,5,7)
imagesc(((1:size(hilPhasePulse_matrix,2))-psettime-1)./1000,1:size(hilPhasePulse_matrix,1),hilPhasePulse_matrix)
set(gca,'CLim',[-180 180],'FontSize',20)
line([0 0],[0.5 size(hilPhasePulse_matrix,1)+0.5],'Color','w','LineStyle','--','LineWidth',2)
title(gca,'theta')


temphilPhasePulseB = hilPhasePulseB(index,1);
hilPhasePulse_matrixB = cell2mat(temphilPhasePulseB);

subplot(2,5,8)
imagesc(((1:size(hilPhasePulse_matrixB,2))-psettimeB-1)./1000,1:size(hilPhasePulse_matrixB,1),hilPhasePulse_matrixB)
set(gca,'CLim',[-180 180],'FontSize',20)
line([0 0],[0.5 size(hilPhasePulse_matrixB,1)+0.5],'Color','w','LineStyle','--','LineWidth',2)
title(gca,'beta')

set(gcf,'Position',[1 1 2400 1000])

figure('Name',[stim '  ' arena '  ' sfreq '   RATIO'],'NumberTitle','off'); hold on
tempforplot = 10*log10([powerratio_STIMFREQ, powerratio_BETA2]);
tempforplot = tempforplot(index,:);
plot(tempforplot','Marker','o','MarkerSize',50)
plot(mean(tempforplot),'Marker','o','MarkerSize',75,'MarkerFaceColor','w','Color',[0.5 0.5 0.5],'LineWidth',8)
set(gca,'XLim',[0,3],'XTick',[1,2],'XTickLabel',{askfreq, 'beta2'},'FontSize',20,'YLim',[-10 10])

figure('Name',[stim '  ' arena '  ' sfreq '   RATIO'],'NumberTitle','off'); hold on
X = freq(1,t1:t2);
xtick = fliplr([0.9 5 12 23 35]);
Y = freq(1,g1:g2);
ytick = fliplr([15 35 50 100 150 250]);
subplot(2,1,1)
imagesc(mean(com_PRE,3))
set(gca,'CLim',[0 0.01],'FontSize',20,'XTick',arrayfun(@(x) knnsearch(X',x),xtick),'XTickLabel',arrayfun(@num2str,xtick,'UniformOutput',false))
set(gca,'YTick',arrayfun(@(x) knnsearch(Y',x),ytick),'YTickLabel',arrayfun(@num2str,ytick,'UniformOutput',false))

subplot(2,1,2)
imagesc(mean(com_STIM,3))
set(gca,'CLim',[0 0.01],'FontSize',20,'XTick',arrayfun(@(x) knnsearch(X',x),xtick),'XTickLabel',arrayfun(@num2str,xtick,'UniformOutput',false))
set(gca,'YTick',arrayfun(@(x) knnsearch(Y',x),ytick),'YTickLabel',arrayfun(@num2str,ytick,'UniformOutput',false))


figure;
imagesc(mean(com_STIM,3)-mean(com_PRE,3))
set(gca,'CLim',[0 0.005],'FontSize',20,'XTick',arrayfun(@(x) knnsearch(X',x),xtick),'XTickLabel',arrayfun(@num2str,xtick,'UniformOutput',false))
set(gca,'YTick',arrayfun(@(x) knnsearch(Y',x),ytick),'YTickLabel',arrayfun(@num2str,ytick,'UniformOutput',false))


%%
figure;
ytick = fliplr([0.9 5 12 30 60 150 250]);
ytickloc = arrayfun(@(x) knnsearch(freq(1,:)',x),ytick);
imagesc((1:size(power,2))./1000-min(eegindex)/1000,1:size(power,1),mean(power,3))
set(gca,'CLim',[0 400],'YTick',ytickloc,'YTickLabel',arrayfun(@num2str,ytick,'UniformOutput',false),'FontSize',20)
line([0 0],[0.5 size(power,1)+0.5],'Color','w','LineWidth',2,'LineStyle','--')
line(repmat(max(eegindex2)/1000,1,2)-min(eegindex)/1000,[0.5 size(power,1)+0.5],'Color','w','LineWidth',2,'LineStyle','--')
xlabel(gca,'time (s)','FontSize',20)
ylabel(gca,'frequency (Hz)','FontSize',20)
%% theta change (prestim-stim)
settime = eegindex2-eegindex; % data points
HTH = knnsearch(freq(1,:)',12);
LTH = knnsearch(freq(1,:)',5);
HD = knnsearch(freq(1,:)',4);
LD = knnsearch(freq(1,:)',1);
THCh = NaN(size(power,3),1);
for x = 1:size(power,3)
    temp_prestim_thetaP = sum(sumskipnan(power(HTH:LTH,eegindex(x)-settime(x):eegindex(x)-1,x)))/settime(x);
    temp_stim_thetaP = sum(sumskipnan(power(HTH:LTH,eegindex(x):eegindex2(x),x)))/(eegindex2(x)-eegindex(x));
    THCh(x,1) = temp_stim_thetaP./temp_prestim_thetaP;

end
%% detect theta before stim
settime = 2000; % data points
HTH = knnsearch(freq(1,:)',12);
LTH = knnsearch(freq(1,:)',5);
HD = knnsearch(freq(1,:)',4);
LD = knnsearch(freq(1,:)',1);
THD = NaN(size(power,3),settime);
for x = 1:size(power,3)
    temp_prestim_power = power(:,eegindex(x)-settime:eegindex(x)-1,x);
    temp_prestim_thetaP = sumskipnan(temp_prestim_power(HTH:LTH,:));
    temp_prestim_deltaP = sumskipnan(temp_prestim_power(HD:LD,:));
    THD(x,:) = temp_prestim_thetaP./temp_prestim_deltaP;
end
THindex = mean(THD,2)>1;
Dindex = mean(THD,2)<1;
%%
animals = unique(cellfun(@(x) x(1:4),rowdata(:,1),'UniformOutput',false));

indexTHETA = THindex;
indexNONTHETA = Dindex;
RUNindex = all(prestim_speed(:,3:4)>runlimit,2);
NORUNindex = all(prestim_speed<runlimit,2);
indexRUN = RUNindex; % SET
indexREAR = rearingindex;
indexQUIET = NORUNindex;
indexMIX = and(~RUNindex,~NORUNindex);

indexTHincr = THCh>=1;
indexTHmin = and(THCh<1,THCh>=0.9);
indexTHdecr = THCh<0.9;

for a = 1:length(animals)
    dataselection = false(size(power,3),1);
    for d = 1:length(dataselection)
        if isequal(rowdata{d,1}(1:4),animals{a})
            dataselection(d) = true;
        end
    end
    tempPower = power(:,:,dataselection);
    
%     figure('Name',[animals{a} '   ALL'],'NumberTitle','off');
%     ytick = fliplr([0.9 5 12 30 60 150 250]);
%     ytickloc = arrayfun(@(x) knnsearch(freq(1,:)',x),ytick);
%     imagesc((1:size(power,2))./1000-min(eegindex)/1000,1:size(power,1),mean(tempPower,3))
%     set(gca,'CLim',[0 400],'YTick',ytickloc,'YTickLabel',arrayfun(@num2str,ytick,'UniformOutput',false),'FontSize',20)
%     line([0 0],[0.5 size(power,1)+0.5],'Color','w','LineWidth',2,'LineStyle','--')
%     line(repmat(max(eegindex2)/1000,1,2)-min(eegindex)/1000,[0.5 size(power,1)+0.5],'Color','w','LineWidth',2,'LineStyle','--')
%     xlabel(gca,'time (s)','FontSize',20)
%     ylabel(gca,'frequency (Hz)','FontSize',20)
    
    % theta
    andor_INCfreemov_STEP4_f1(power,speedmatrix,eegindex, eegindex2,speedindex,speedindex2,dataselection,indexTHETA,freq,animals{a},'THETA')
    
    % non-theta
    andor_INCfreemov_STEP4_f1(power,speedmatrix,eegindex, eegindex2,speedindex,speedindex2,dataselection,indexNONTHETA,freq,animals{a},'DELTA')
%     
%     % running
%     andor_INCfreemov_STEP4_f1(power,speedmatrix,eegindex, eegindex2,speedindex,speedindex2,dataselection,indexTHdecr,freq,animals{a},'THETA decrease')
    
    % rearing
%     andor_INCfreemov_STEP4_f1(power,speedmatrix,eegindex, eegindex2,speedindex,dataselection,indexREAR,freq,animals{a},'REAR')
    
    % quiet
%     andor_INCfreemov_STEP4_f1(power,speedmatrix,eegindex, eegindex2,speedindex,dataselection,indexQUIET,freq,animals{a},'QUIET')

    % mix
%     andor_INCfreemov_STEP4_f1(power,speedmatrix,eegindex, eegindex2,speedindex,dataselection,indexMIX,freq,animals{a},'MIX')

    
end

%% speed before stim start
binsize = 0.5; % in sec
binsize = round(binsize*120);
binnum = 4;
runlimit = 4; % cm/s
prestim_speed = NaN(size(speedmatrix,1),binnum);
for k = 1:binnum;
    for x = 1:size(speedmatrix,1)
        prestim_speed(x,k) = mean(speedmatrix(x,(speedindex(x,1)-k*binsize):(speedindex(x,1)-(k-1)*binsize-1)));
    end
end
prestim_speed = fliplr(prestim_speed);

RUNindex = all(prestim_speed>runlimit,2);

%% y position before stim start
posY = cell(size(rowdata,1),1);posX = cell(size(rowdata,1),1);posZ = cell(size(rowdata,1),1);
rotX = cell(size(rowdata,1),1);rotY = cell(size(rowdata,1),1);rotZ = cell(size(rowdata,1),1);rotW = cell(size(rowdata,1),1);
allY = cell(size(rowdata,1),1);allX = cell(size(rowdata,1),1);allZ = cell(size(rowdata,1),1);
allRX = cell(size(rowdata,1),1);allRY = cell(size(rowdata,1),1);allRZ = cell(size(rowdata,1),1);allRW = cell(size(rowdata,1),1);
folder = '/Volumes/G31_invivo_data2$/projekt/incertus/analysis';
for k = 1:size(rowdata,1)
    filename = rowdata{k,1};
    load(fullfile(folder,['INC_' filename(1:4) '_speed.mat']),'infoCell','csvSample')
    temprow = find(cellfun(@(x) isequal(filename,x),infoCell(:,1)));
    tempstimno = rowdata{k,2};
    if ~isequal('1868',filename(1:4))
        posY{k,1} = csvSample{temprow,1}{tempstimno,1}(:,6);
        posX{k,1} = csvSample{temprow,1}{tempstimno,1}(:,5);
        posZ{k,1} = csvSample{temprow,1}{tempstimno,1}(:,7);
        rotX{k,1} = csvSample{temprow,1}{tempstimno,1}(:,1);
        rotY{k,1} = csvSample{temprow,1}{tempstimno,1}(:,2);
        rotZ{k,1} = csvSample{temprow,1}{tempstimno,1}(:,3);
        rotW{k,1} = csvSample{temprow,1}{tempstimno,1}(:,4);
    else
        posY{k,1} = csvSample{temprow,1}{rowdata{k,4},1}{tempstimno,1}(:,6);
        posX{k,1} = csvSample{temprow,1}{rowdata{k,4},1}{tempstimno,1}(:,5);
        posZ{k,1} = csvSample{temprow,1}{rowdata{k,4},1}{tempstimno,1}(:,7);
        rotX{k,1} = csvSample{temprow,1}{rowdata{k,4},1}{tempstimno,1}(:,1);
        rotY{k,1} = csvSample{temprow,1}{rowdata{k,4},1}{tempstimno,1}(:,2);
        rotZ{k,1} = csvSample{temprow,1}{rowdata{k,4},1}{tempstimno,1}(:,3);
        rotW{k,1} = csvSample{temprow,1}{rowdata{k,4},1}{tempstimno,1}(:,4);
    end
    
    load(fullfile(folder,['INC_' filename(1:4) '_1116_csv.mat']),'data')
    allY{k,1} = data{temprow,1}(:,6);
    allX{k,1} = data{temprow,1}(:,5);
    allZ{k,1} = data{temprow,1}(:,7);
    allRX{k,1} = data{temprow,1}(:,1);
    allRY{k,1} = data{temprow,1}(:,2);
    allRZ{k,1} = data{temprow,1}(:,3);
    allRW{k,1} = data{temprow,1}(:,4);
end
%%
save('INC_INC_goodINC_linearTrack_f25Hz_position.mat','posY','posX','posZ','rotX','rotY','rotZ','rotW',...
    'allY','allX','allZ','allRX','allRY','allRZ','allRW','rowdata','-v7.3')
%% rearing: Y position > 3.5 cm (0.035 m)
rearingindex = NaN(size(rowdata,1),20);
for k = 1:size(rowdata,1)
    rearingindex(k,:) = posY{k,1}(speedindex(k,1)-19:speedindex(k,1));
end
rearingindex = all(rearingindex > 0.035,2);  

